/**
 *
 * @preferred
 */
import { EVAService } from "../service";
import * as _         from "lodash";

export namespace Barcodes
{
    "use strict";

    export function parseBarcode( barcode: string ): Promise<EVA.Core.Services.ParseBarcodeResponse>
    {
        return new Promise( ( resolve: any, reject: any ) =>
        {
            // Create our service instance
            //
            var service = new EVAService<EVA.Core.Services.ParseBarcode, EVA.Core.Services.ParseBarcodeResponse>( "ParseBarcode" );

            // Build the request data
            // The base class will add things like SessionID so to keep typescript
            // happy we're using an 'any' type object here
            //
            var requestData: EVA.Core.Services.ParseBarcode = <EVA.Core.Services.ParseBarcode>{
                Barcode: barcode
            };

            // Perform the call and capture the resulting promise
            //
            service.call( requestData )
            .then( ( result ) =>
            {
                resolve( _.get( result, "response" ) );
            } )
            .catch( reject );
        } );
    }

    export function getProductByBarcode( barcode: string ): Promise<EVA.Core.Services.GetProductByBarcodeResponse>
    {
        return new Promise( ( resolve: any, reject: any ) =>
        {
            // Create our service instance
            //
            var service = new EVAService<EVA.Core.Services.GetProductByBarcode, EVA.Core.Services.GetProductByBarcodeResponse>( "GetProductByBarcode" );

            // Build the request data
            // The base class will add things like SessionID so to keep typescript
            // happy we're using an 'any' type object here
            //
            var requestData: EVA.Core.Services.GetProductByBarcode = <EVA.Core.Services.GetProductByBarcode>{
                Barcode: barcode
            };

            // Perform the call and capture the resulting promise
            //
            service.call( requestData )
            .then( ( result ) =>
            {
                resolve( _.get( result, "response" ) );
            } )
            .catch( reject );
        } );
    }
}
