"use strict";
/**
 * The CMS Blocks module provides access to content management blocks from the EVA back-end
 * @preferred
 */
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var base_1 = require("./base");
/**
 * Provides access to a list of content blocks available in EVA
 */
var ContentBlockList = /** @class */ (function (_super) {
    __extends(ContentBlockList, _super);
    function ContentBlockList() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    /**
     * Fetches the list of items
     * @return {Promise<IEVAServiceResponse<EVA.CMS.Dto.Blocks.CmsBlockDto, EVA.CMS.GetCmsBlocks, EVA.CMS.GetCmsBlocksResponse>>} A promise resolving when the fetch from the back-end has completed
     */
    ContentBlockList.prototype.fetch = function () {
        // Build the request data
        //
        var requestData = {
            PageConfig: this.getPageConfiguration()
        };
        return _super.prototype.fetch.call(this, "ListCmsBlocks", requestData);
    };
    return ContentBlockList;
}(base_1.FetchablePagedList));
exports.ContentBlockList = ContentBlockList;
