/**
 * The CMS Blocks module provides access to content management blocks from the EVA back-end
 * @preferred
 */

import { FetchablePagedList  } from "./base";
import { IEVAServiceResponse } from "../service";

/**
 * Provides access to a list of content blocks available in EVA
 */
export class ContentBlockList extends FetchablePagedList<EVA.CMS.CmsBlockDto, EVA.CMS.GetCmsBlocks, EVA.CMS.GetCmsBlocksResponse> {
    /**
     * Fetches the list of items
     * @return {Promise<IEVAServiceResponse<EVA.CMS.Dto.Blocks.CmsBlockDto, EVA.CMS.GetCmsBlocks, EVA.CMS.GetCmsBlocksResponse>>} A promise resolving when the fetch from the back-end has completed
     */
    public fetch(): Promise<IEVAServiceResponse<EVA.CMS.GetCmsBlocks, EVA.CMS.GetCmsBlocksResponse>> {

        // Build the request data
        //
        var requestData: EVA.CMS.GetCmsBlocks = <EVA.CMS.GetCmsBlocks>{
            PageConfig: this.getPageConfiguration()
        };

        return super.fetch( "ListCmsBlocks", requestData );
    }
}
