"use strict";
/**
 * The CMS Menu module provides access to content management menus from the EVA back-end
 * @preferred
 */
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var base_1 = require("./base");
/**
 * Provides access to a content menu available in EVA
 */
var ContentMenu = /** @class */ (function (_super) {
    __extends(ContentMenu, _super);
    function ContentMenu() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    /**
     * Fetches the page content
     * @return {Promise<IEVAServiceResponse<EVA.CMS.GetCmsMenuByIdentifier, EVA.CMS.GetCmsMenuByIdentifierResponse>>} A promise resolving when the fetch from the back-end has completed
     */
    ContentMenu.prototype.fetch = function () {
        // Build the request data
        //
        var requestData = {
            Identifier: this.getId()
        };
        return _super.prototype.fetch.call(this, "GetCmsMenuByIdentifier", requestData);
    };
    return ContentMenu;
}(base_1.FetchableItem));
exports.ContentMenu = ContentMenu;
/**
 * Provides access to a list of content menus available in EVA
 */
var ContentMenuList = /** @class */ (function (_super) {
    __extends(ContentMenuList, _super);
    function ContentMenuList() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    /**
     * Fetches the list of items
     * @return {Promise<IEVAServiceResponse<EVA.CMS.CmsMenuDto, EVA.CMS.ListCmsMenu, EVA.CMS.ListCmsMenuResponse>>} A promise resolving when the fetch from the back-end has completed
     */
    ContentMenuList.prototype.fetch = function () {
        // Build the request data
        //
        var requestData = {
            PageConfig: this.getPageConfiguration()
        };
        return _super.prototype.fetch.call(this, "ListCmsMenu", requestData);
    };
    return ContentMenuList;
}(base_1.FetchablePagedList));
exports.ContentMenuList = ContentMenuList;
