/**
 * The CMS Url Rewrite module provides access to CMS Url Rewrites from the EVA back-end
 *
 * @preferred
 */
import { EVAService,
         IEVAServiceResponse    } from "../service";

export namespace CmsRewrite
{
    "use strict";

    /**
     * Check if a certain request path needs rewriting
     * @return {Promise}    A promise resolving when the call to the back-end has completed
     */
    export function rewrite( requestPath: string ): Promise<IEVAServiceResponse<EVA.CMS.RewriteUrl, EVA.CMS.RewriteUrlResponse>>
    {
        // Create the service instance
        //
        var service = new EVAService<EVA.CMS.RewriteUrl, EVA.CMS.RewriteUrlResponse>( "RewriteUrl" );

        // Build the request data
        // The base class will add things like SessionID so keep typescript
        // happy we're using an 'any' type object here
        //
        var requestData: any = {
            Url: requestPath
        };

        return service.call( requestData );
    }
}
