/**
 * The CMS Widget module provides access to content management widgets from the EVA back-end * @preferred
 */
import { FetchableItem } from "./base";
import { IEVAServiceResponse } from "../service";
/**
 * Provides access to a content widget available in EVA
 */
export declare class ContentWidget extends FetchableItem<EVA.CMS.CmsWidgetDto, EVA.CMS.GetCmsWidgetByID, EVA.CMS.GetCmsWidgetByIDResponse> {
    /**
     * Fetches the widget content
     * @return {Promise<IEVAServiceResponse<EVA.CMS.GetCmsWidgetByID, EVA.CMS.GetCmsWidgetByIDResponse>>} A promise resolving when the fetch from the back-end has completed
     */
    fetch(): Promise<IEVAServiceResponse<EVA.CMS.GetCmsWidgetByID, EVA.CMS.GetCmsWidgetByIDResponse>>;
}
