"use strict";
/**
 * The CMS Widget module provides access to content management widgets from the EVA back-end * @preferred
 */
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var base_1 = require("./base");
/**
 * Provides access to a content widget available in EVA
 */
var ContentWidget = /** @class */ (function (_super) {
    __extends(ContentWidget, _super);
    function ContentWidget() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    /**
     * Fetches the widget content
     * @return {Promise<IEVAServiceResponse<EVA.CMS.GetCmsWidgetByID, EVA.CMS.GetCmsWidgetByIDResponse>>} A promise resolving when the fetch from the back-end has completed
     */
    ContentWidget.prototype.fetch = function () {
        // Build the request data
        //
        var requestData = {
            ID: this.getId()
        };
        return _super.prototype.fetch.call(this, "GetCmsWidgetByID", requestData);
    };
    return ContentWidget;
}(base_1.FetchableItem));
exports.ContentWidget = ContentWidget;
