/**
 *
 * @preferred
 */
import { EVAService,
         IEVAServiceResponse } from "../service";

export namespace Cultures
{
    "use strict";

    export function getApplicationCultures(): Promise<Array<EVA.PIM.Core.ListApplicationContentCulture>>
    {
        var service = new EVAService<EVA.PIM.Core.ListApplicationCultures, EVA.PIM.Core.ListApplicationCulturesResponse>( "ListApplicationCultures" );

        return new Promise( ( resolve: any, reject: any ) =>
        {
            // Perform the call and capture the resulting promise
            //
            service.call().then( ( serviceResult: IEVAServiceResponse<EVA.PIM.Core.ListApplicationCultures, EVA.PIM.Core.ListApplicationCulturesResponse> ) =>
            {
                let cultures: Array<EVA.PIM.Core.ListApplicationContentCulture> = serviceResult.response.Result;
                resolve( cultures );
            } )
            .catch( ( error ) =>
            {
                reject( error );
            } );
        } );
    }
}
