/**
 *
 * @preferred
 */
import { EVAService,
         IEVAServiceResponse } from "../service";

export namespace Currencies
{
    "use strict";

    export function getAvailableCurrencies(): Promise<Array<EVA.Core.Services.CurrencyDto>> {
        var service = new EVAService<EVA.Core.Services.GetAvailableCurrencies, EVA.Core.Services.GetAvailableCurrenciesResponse>( "GetAvailableCurrencies" );

        return new Promise( ( resolve: any, reject: any ) =>
        {
            // Perform the call and capture the resulting promise
            //
            service.call().then( ( serviceResult: IEVAServiceResponse<EVA.Core.Services.GetAvailableCurrencies, EVA.Core.Services.GetAvailableCurrenciesResponse> ) =>
            {
                let currencies: Array<EVA.Core.Services.CurrencyDto> = serviceResult.response.Currencies;
                resolve( currencies );
            } )
            .catch( ( error ) =>
            {
                reject( error );
            });
        } );
    }

    export function setOrderCurrency( currencyID: string, orderID: number ) {
        var service = new EVAService<EVA.Core.Services.UpdateOrderCurrency, EVA.Core.EmptyResponseMessage>( "UpdateOrderCurrency" );

        var requestData: EVA.Core.Services.UpdateOrderCurrency = {
            OrderID:    orderID,
            CurrencyID: currencyID,
            SessionID:  null,
            __response: null
        };

        return new Promise( ( resolve: any, reject: any ) =>
        {
            // Perform the call and capture the resulting promise
            //
            service.call( requestData ).then( ( serviceResult: IEVAServiceResponse<EVA.Core.Services.UpdateOrderCurrency, EVA.Core.EmptyResponseMessage> ) =>
            {
                resolve( serviceResult );
            } )
            .catch( ( error ) =>
            {
                reject( error );
            } );
        } );

    }
}
