/**
 * The DMS Blocks module provides access to content management blocks from the EVA back-end
 * @preferred
 */

import { FetchablePagedList  } from "./../base";
import { IEVAServiceResponse } from "../../service";

/**
 * Provides access to a list of content blocks available in EVA
 */
export class DmsBlockList extends FetchablePagedList<EVA.DMS.BlockDto, EVA.DMS.DmsListBlocks, EVA.DMS.DmsListBlocksResponse> {
    /**
     * Fetches the list of items
     * @return {Promise<IEVAServiceResponse<EVA.DMS.Dto.Blocks.BlockDto, EVA.DMS.ListBlocks, EVA.DMS.ListBlocksResponse>>} A promise resolving when the fetch from the back-end has completed
     */
    public fetch(): Promise<IEVAServiceResponse<EVA.DMS.DmsListBlocks, EVA.DMS.DmsListBlocksResponse>> {

        // Build the request data
        //
        var requestData: EVA.DMS.DmsListBlocks = <EVA.DMS.DmsListBlocks>{
            PageConfig: this.getPageConfiguration()
        };

        return super.fetch( "DmsListBlocks", requestData );
    }
}
