/**
 * The DMS Menu module provides access to content management menus from the EVA back-end
 * @preferred
 */
import { FetchableItem } from "./../base";
import { IEVAServiceResponse } from "../../service";
/**
 * Provides access to a content menu available in EVA
 */
export declare class DmsMenu extends FetchableItem<EVA.DMS.MenuDto, EVA.DMS.DmsGetMenuByIdentifier, EVA.DMS.DmsGetMenuByIdentifierResponse> {
    /**
     * The request path to retrieve the page for
     * @type {string}
     */
    private requestPath;
    /**
     * Returns the current request path
     * @return {string}       The configured request path
     */
    getRequestPath(): string;
    /**
     * Set the request path to retrieve the page for
     * @param  {string} query The new request path
     * @return {string}       The configured request path
     */
    setRequestPath(requestPath: string): string;
    /**
     * Fetches the page content
     * @return {Promise<IEVAServiceResponse<EVA.DMS.GetMenuByIdentifier, EVA.DMS.GetMenuByIdentifierResponse>>} A promise resolving when the fetch from the back-end has completed
     */
    fetch(): Promise<IEVAServiceResponse<EVA.DMS.DmsGetMenuByIdentifier, EVA.DMS.DmsGetMenuByIdentifierResponse>>;
}
