"use strict";
/**
 * The DMS Menu module provides access to content management menus from the EVA back-end
 * @preferred
 */
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var base_1 = require("./../base");
/**
 * Provides access to a content menu available in EVA
 */
var DmsMenu = /** @class */ (function (_super) {
    __extends(DmsMenu, _super);
    function DmsMenu() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    /**
     * Returns the current request path
     * @return {string}       The configured request path
     */
    DmsMenu.prototype.getRequestPath = function () {
        return this.requestPath;
    };
    /**
     * Set the request path to retrieve the page for
     * @param  {string} query The new request path
     * @return {string}       The configured request path
     */
    DmsMenu.prototype.setRequestPath = function (requestPath) {
        return this.requestPath = requestPath;
    };
    /**
     * Fetches the page content
     * @return {Promise<IEVAServiceResponse<EVA.DMS.GetMenuByIdentifier, EVA.DMS.GetMenuByIdentifierResponse>>} A promise resolving when the fetch from the back-end has completed
     */
    DmsMenu.prototype.fetch = function () {
        // Build the request data
        //
        var requestData = {
            Path: this.requestPath
        };
        return _super.prototype.fetch.call(this, "DmsGetMenuByIdentifier", requestData);
    };
    return DmsMenu;
}(base_1.FetchableItem));
exports.DmsMenu = DmsMenu;
