/**
 * The DMS Widget module provides access to content management widgets from the EVA back-end * @preferred
 */
import { FetchableItem } from "./../base";
import { IEVAServiceResponse } from "../../service";
/**
 * Provides access to a content widget available in EVA
 */
export declare class DmsWidgetType extends FetchableItem<EVA.DMS.WidgetTypeDto, EVA.DMS.DmsGetWidgetType, EVA.DMS.DmsGetWidgetTypeResponse> {
    /**
     * Fetches the widget content
     * @return {Promise<IEVAServiceResponse<EVA.DMS.DmsGetWidgetType, EVA.DMS.DmsGetWidgetTypeByIDResponse>>} A promise resolving when the fetch from the back-end has completed
     */
    fetch(): Promise<IEVAServiceResponse<EVA.DMS.DmsGetWidgetType, EVA.DMS.DmsGetWidgetTypeResponse>>;
    list(): Promise<IEVAServiceResponse<EVA.DMS.DmsListWidgetTypes, EVA.DMS.DmsListWidgetTypesResponse>>;
}
