"use strict";
/**
 * The DMS Widget module provides access to content management widgets from the EVA back-end * @preferred
 */
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var base_1 = require("./../base");
var service_1 = require("../../service");
/**
 * Provides access to a content widget available in EVA
 */
var DmsWidgetType = /** @class */ (function (_super) {
    __extends(DmsWidgetType, _super);
    function DmsWidgetType() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    /**
     * Fetches the widget content
     * @return {Promise<IEVAServiceResponse<EVA.DMS.DmsGetWidgetType, EVA.DMS.DmsGetWidgetTypeByIDResponse>>} A promise resolving when the fetch from the back-end has completed
     */
    DmsWidgetType.prototype.fetch = function () {
        // Build the request data
        //
        var requestData = {
            ID: this.getId()
        };
        return _super.prototype.fetch.call(this, "DmsGetWidgetType", requestData);
    };
    DmsWidgetType.prototype.list = function () {
        // Create the service instance
        //
        var service = new service_1.EVAService("DmsListWidgetTypes");
        // Build the request data
        //
        var requestData = {};
        // Perform the call and capture the resulting promise
        //
        return service.call(requestData);
    };
    return DmsWidgetType;
}(base_1.FetchableItem));
exports.DmsWidgetType = DmsWidgetType;
