/**
 * The DMS Widget module provides access to content management widgets from the EVA back-end * @preferred
 */

import { FetchableItem                   } from "./../base";
import { EVAService, IEVAServiceResponse } from "../../service";

/**
 * Provides access to a content widget available in EVA
 */
export class DmsWidgetType extends FetchableItem<EVA.DMS.WidgetTypeDto, EVA.DMS.DmsGetWidgetType, EVA.DMS.DmsGetWidgetTypeResponse> {
    /**
     * Fetches the widget content
     * @return {Promise<IEVAServiceResponse<EVA.DMS.DmsGetWidgetType, EVA.DMS.DmsGetWidgetTypeByIDResponse>>} A promise resolving when the fetch from the back-end has completed
     */
    public fetch(): Promise<IEVAServiceResponse<EVA.DMS.DmsGetWidgetType, EVA.DMS.DmsGetWidgetTypeResponse>> {

        // Build the request data
        //
        var requestData: EVA.DMS.DmsGetWidgetType = <EVA.DMS.DmsGetWidgetType>{
            ID: this.getId()
        };

        return super.fetch( "DmsGetWidgetType", requestData );
    }

    public list(): Promise<IEVAServiceResponse<EVA.DMS.DmsListWidgetTypes, EVA.DMS.DmsListWidgetTypesResponse>> {
        // Create the service instance
        //
        var service = new EVAService<EVA.DMS.DmsListWidgetTypes, EVA.DMS.DmsListWidgetTypesResponse>( "DmsListWidgetTypes" );

        // Build the request data
        //
        let requestData: EVA.DMS.DmsListWidgetTypes = <EVA.DMS.DmsListWidgetTypes> {
            // nutting
        };

        // Perform the call and capture the resulting promise
        //
        return service.call( requestData );
    }
}
