/**
 * The DMS Widget module provides access to content management widgets from the EVA back-end * @preferred
 */
import { FetchableItem } from "./../base";
import { IEVAServiceResponse } from "../../service";
/**
 * Provides access to a content widget available in EVA
 */
export declare class DmsWidget extends FetchableItem<EVA.DMS.LiveWidgetDto, EVA.DMS.DmsGetCompiledWidgetByID, EVA.DMS.DmsGetCompiledWidgetByIDResponse> {
    /**
     * Fetches the widget content
     * @return {Promise<IEVAServiceResponse<EVA.DMS.DmsGetCompiledWidgetByID, EVA.DMS.DmsGetCompiledWidgetByIDResponse>>} A promise resolving when the fetch from the back-end has completed
     */
    fetch(): Promise<IEVAServiceResponse<EVA.DMS.DmsGetCompiledWidgetByID, EVA.DMS.DmsGetCompiledWidgetByIDResponse>>;
    create(widget: EVA.DMS.WidgetDto, viewID: number): Promise<IEVAServiceResponse<EVA.DMS.DmsCreateWidget, EVA.Core.CreateResponse>>;
    /**
     * Update the widget
     *
     * @return {Promise} A promise resolving when the call to the back-end has completed
     */
    updateHtml(html: string): Promise<IEVAServiceResponse<EVA.DMS.DmsUpdateWidget, EVA.Core.EmptyResponseMessage>>;
}
