/**
 * The applications module provides access to the applications data from the EVA back-end
 * @preferred
 */
import { IEVAServiceResponse } from "../service";
/**
 * Provides access to a babylon social functions in EVA
 * These are the by identifier versions that can be reused by EVA SDK objects
 */
export declare namespace Feed {
    function getFeedByType(feedType: string, offset?: number | string, limit?: number): Promise<IEVAServiceResponse<EVA.Babylon.GetUserFeed, EVA.Babylon.GetUserFeedResponse>>;
    function getTrendingFeed(skip?: number, limit?: number, type?: EVA.Babylon.TrendingFeedTypes): Promise<IEVAServiceResponse<EVA.Babylon.GetTrendingFeed, EVA.Babylon.GetTrendingFeedResponse>>;
    function getNotificationFeed(offset?: number, limit?: number): Promise<IEVAServiceResponse<EVA.Babylon.GetNotificationFeed, EVA.Babylon.GetNotificationFeedResponse>>;
    function getUnseenNotifications(): Promise<IEVAServiceResponse<EVA.Babylon.GetNotificationFeed, EVA.Babylon.GetNotificationFeedResponse>>;
}
