/**
 *
 * @preferred
 */
import { EVAService } from "../service";
import * as _         from "lodash";

export namespace Functionalities
{
    "use strict";

    export function getSupportedFunctionalities( ): Promise<Array<EVA.Core.Functionalities>>
    {
        return new Promise( ( resolve: any, reject: any ) =>
        {
            // Create our service instance
            //
            var service = new EVAService<EVA.Core.Services.GetSupportedFunctionalities, EVA.Core.Services.GetSupportedFunctionalitiesResponse>( "GetSupportedFunctionalities" );

            // Build the request data
            // The base class will add things like SessionID so to keep typescript
            // happy we're using an 'any' type object here
            //
            var requestData: EVA.Core.Services.GetSupportedFunctionalities = <EVA.Core.Services.GetSupportedFunctionalities>{};

            // Perform the call and capture the resulting promise
            //
            service.call( requestData )
            .then( ( result ) =>
            {
                resolve( _.get( result, "response.Functionalities" ) || [] );
            } )
            .catch( reject );
        } );
    }
}
