"use strict";
/**
 * The applications module provides access to the applications data from the EVA back-end
 * @preferred
 */
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var base_1 = require("./base");
var service_1 = require("../service");
/**
 * Provides access to a babylon social functions in EVA
 * These are the by identifier versions that can be reused by EVA SDK objects
 */
var Gamification;
(function (Gamification) {
    "use strict";
    function getCoverSheetEditorCapabilities() {
        // Create the service instance
        //
        var service = new service_1.EVAService("GetCoverSheetEditorCapabilities");
        // Build the request data
        // The base class will add things like SessionID so keep typescript
        // happy we're using an 'any' type object here
        //
        var requestData = {};
        // Perform the call and capture the resulting promise
        //
        return service.call(requestData);
    }
    Gamification.getCoverSheetEditorCapabilities = getCoverSheetEditorCapabilities;
    function getSocialGetProgressionByID(id) {
        // Create the service instance
        //
        var service = new service_1.EVAService("SocialGetProgressionByID");
        // Build the request data
        // The base class will add things like SessionID so keep typescript
        // happy we're using an 'any' type object here
        //
        var requestData = {
            ID: id
        };
        // Perform the call and capture the resulting promise
        //
        return service.call(requestData);
    }
    Gamification.getSocialGetProgressionByID = getSocialGetProgressionByID;
    function getSocialProgressions(userId, type) {
        // Create the service instance
        //
        var service = new service_1.EVAService("SocialGetProgressions");
        // Build the request data
        // The base class will add things like SessionID so keep typescript
        // happy we're using an 'any' type object here
        //
        var requestData = {
            UserID: userId,
            Type: type
        };
        // Perform the call and capture the resulting promise
        //
        return service.call(requestData);
    }
    Gamification.getSocialProgressions = getSocialProgressions;
    function getSocialProgressionRanking(userId) {
        // Create the service instance
        //
        var service = new service_1.EVAService("SocialGetProgressionRanking");
        // Build the request data
        // The base class will add things like SessionID so keep typescript
        // happy we're using an 'any' type object here
        //
        var requestData = {
            UserID: userId
        };
        // Perform the call and capture the resulting promise
        //
        return service.call(requestData);
    }
    Gamification.getSocialProgressionRanking = getSocialProgressionRanking;
    function getActiveFashionEvent() {
        // Create the service instance
        //
        var service = new service_1.EVAService("GetActiveFashionEvent");
        // Build the request data
        // The base class will add things like SessionID so keep typescript
        // happy we're using an 'any' type object here
        //
        var requestData = {};
        // Perform the call and capture the resulting promise
        //
        return service.call(requestData);
    }
    Gamification.getActiveFashionEvent = getActiveFashionEvent;
    function getBarcodeDataForFashionEvent() {
        // Create the service instance
        //
        var service = new service_1.EVAService("GetBarcodeDataForFashionEvent");
        // Build the request data
        // The base class will add things like SessionID so keep typescript
        // happy we're using an 'any' type object here
        //
        var requestData = {};
        // Perform the call and capture the resulting promise
        //
        return service.call(requestData);
    }
    Gamification.getBarcodeDataForFashionEvent = getBarcodeDataForFashionEvent;
    function scanBarcodeDataForFashionEvent(data) {
        // Create the service instance
        //
        var service = new service_1.EVAService("ScanBarcodeForFashionEvent");
        // Build the request data
        // The base class will add things like SessionID so keep typescript
        // happy we're using an 'any' type object here
        //
        var requestData = {
            Data: data
        };
        // Perform the call and capture the resulting promise
        //
        return service.call(requestData);
    }
    Gamification.scanBarcodeDataForFashionEvent = scanBarcodeDataForFashionEvent;
    function getBarcodeUrlForFashionEvent(data, width, height) {
        if (width === void 0) { width = 500; }
        if (height === void 0) { height = 500; }
        return "https://api.frendz.nl/barcode/qr/" + width + "/" + height + "/" + data;
    }
    Gamification.getBarcodeUrlForFashionEvent = getBarcodeUrlForFashionEvent;
    function getActiveFashionCollectionContests() {
        // Create the service instance
        //
        var service = new service_1.EVAService("GetActiveFashionCollectionContests");
        // Build the request data
        // The base class will add things like SessionID so keep typescript
        // happy we're using an 'any' type object here
        //
        var requestData = {
            __response: undefined
        };
        // Perform the call and capture the resulting promise
        //
        return service.call(requestData);
    }
    Gamification.getActiveFashionCollectionContests = getActiveFashionCollectionContests;
    function getFashionCoinTotalsForUser() {
        // Create the service instance
        //
        var service = new service_1.EVAService("GetFashionCoinTotalsForUser");
        // Build the request data
        // The base class will add things like SessionID so keep typescript
        // happy we're using an 'any' type object here
        //
        var requestData = {
            __response: undefined
        };
        // Perform the call and capture the resulting promise
        //
        return service.call(requestData);
    }
    Gamification.getFashionCoinTotalsForUser = getFashionCoinTotalsForUser;
    function convertFashionCoins(amount, direction) {
        // Create the service instance
        //
        var service = new service_1.EVAService("ConvertFashionCoins");
        // Build the request data
        // The base class will add things like SessionID so keep typescript
        // happy we're using an 'any' type object here
        //
        var requestData = {
            Amount: amount,
            Direction: direction,
            __response: undefined
        };
        // Perform the call and capture the resulting promise
        //
        return service.call(requestData);
    }
    Gamification.convertFashionCoins = convertFashionCoins;
})(Gamification = exports.Gamification || (exports.Gamification = {}));
/**
 * Provides access to a list of fashion collections for a contest available in EVA
 */
var FashionCollectionsForContest = /** @class */ (function (_super) {
    __extends(FashionCollectionsForContest, _super);
    function FashionCollectionsForContest() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    /**
     * Sets the contest id to retrieve the fashion collection list for
     * @param  {number} contestId      The organization identifier
     * @return {void}                  This method doesn't return anything
     */
    FashionCollectionsForContest.prototype.setContestId = function (contestId) {
        this.contestId = contestId;
    };
    /**
     * Fetches the list of items
     * @return {Promise<IEVAServiceResponse<EVA.Babylon.FashionCollectionContestDto, EVA.Babylon.ListFashionCollectionsForContest, EVA.Babylon.ListFashionCollectionsForContestResponse>>} A promise resolving when the fetch from the back-end has completed
     */
    FashionCollectionsForContest.prototype.fetch = function () {
        // Build the request data
        //
        var requestData = {
            PageConfig: this.getPageConfiguration(),
            ContestID: this.contestId,
            __response: undefined
        };
        return _super.prototype.fetch.call(this, "ListFashionCollectionsForContest", requestData);
    };
    return FashionCollectionsForContest;
}(base_1.FetchablePagedList));
exports.FashionCollectionsForContest = FashionCollectionsForContest;
/**
 * Provides access to a list of fashion coin transactions
 */
var FashionCoinTransactions = /** @class */ (function (_super) {
    __extends(FashionCoinTransactions, _super);
    function FashionCoinTransactions() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    /**
     * Fetches the list of items
     * @return {Promise<IEVAServiceResponse<EVA.Babylon.FashionCoinTransaction, EVA.Babylon.ListFashionCoinTransactions, EVA.Babylon.ListFashionCoinTransactionsResponse>>} A promise resolving when the fetch from the back-end has completed
     */
    FashionCoinTransactions.prototype.fetch = function () {
        // Build the request data
        //
        var requestData = {
            PageConfig: this.getPageConfiguration(),
            __response: undefined
        };
        return _super.prototype.fetch.call(this, "ListFashionCoinTransactions", requestData);
    };
    return FashionCoinTransactions;
}(base_1.FetchablePagedList));
exports.FashionCoinTransactions = FashionCoinTransactions;
