import { IEVAServiceResponse } from "../service";
import { FetchablePagedList } from "./base";
export interface IAvailabilityWeek {
    sunday?: EVA.Kijkshop.KijkBijMijAvailabilitySlot[];
    monday?: EVA.Kijkshop.KijkBijMijAvailabilitySlot[];
    tuesday?: EVA.Kijkshop.KijkBijMijAvailabilitySlot[];
    wednesday?: EVA.Kijkshop.KijkBijMijAvailabilitySlot[];
    thursday?: EVA.Kijkshop.KijkBijMijAvailabilitySlot[];
    friday?: EVA.Kijkshop.KijkBijMijAvailabilitySlot[];
    saturday?: EVA.Kijkshop.KijkBijMijAvailabilitySlot[];
    otherDays?: EVA.Kijkshop.KijkBijMijAvailabilitySlot[];
}
/**
 * Provides access to a kijkshop specific functions in EVA
 */
export declare namespace Kijkshop {
    function setExpertForOrderLine(orderLineID: number, expertID: number): Promise<IEVAServiceResponse<EVA.Kijkshop.SetExpertForOrderLine, EVA.Core.EmptyResponseMessage>>;
    function addProductExpertise(productID: number): Promise<IEVAServiceResponse<EVA.Kijkshop.KijkBijMijAddProductExpertise, EVA.Core.EmptyResponseMessage>>;
    function removeProductExpertise(productID: number): Promise<IEVAServiceResponse<EVA.Kijkshop.KijkBijMijRemoveProductExpertise, EVA.Core.EmptyResponseMessage>>;
    function isProductExpert(productID: number): Promise<IEVAServiceResponse<EVA.Kijkshop.KijkBijMijIsExpertOnProduct, EVA.Kijkshop.KijkBijMijIsExpertResponse>>;
    function isMultipleProductExpert(productIDs: number[]): Promise<IEVAServiceResponse<EVA.Kijkshop.KijkBijMijIsExpertOnProducts, EVA.Kijkshop.KijkBijMijIsExpertsResponse>>;
    function getProductExperts(productID: number): Promise<IEVAServiceResponse<EVA.Kijkshop.KijkBijMijProductExperts, EVA.Kijkshop.KijkBijMijProductExpertsResponse>>;
    function getTotalExpertCount(): Promise<IEVAServiceResponse<EVA.Kijkshop.KijkBijMijTotalExpertCount, EVA.Kijkshop.KijkBijMijTotalExpertCountResponse>>;
    function payoutCredits(amount: number): Promise<IEVAServiceResponse<EVA.Kijkshop.KijkBijMijPayoutCredits, EVA.Core.RequestMessageWithEmptyResponse>>;
    function scanMe(userId: number): Promise<IEVAServiceResponse<EVA.Kijkshop.KijkBijMijScanMe, EVA.Core.RequestMessageWithEmptyResponse>>;
    function scanNewApp(): Promise<IEVAServiceResponse<EVA.Kijkshop.KijkBijMijScanNewApp, EVA.Core.RequestMessageWithEmptyResponse>>;
    function getExpertDetails(userIDs: number[]): Promise<IEVAServiceResponse<EVA.Kijkshop.KijkBijMijGetExpertDetails, EVA.Kijkshop.KijkBijMijGetExpertDetailsResponse>>;
    function getProfile(): Promise<IEVAServiceResponse<EVA.Kijkshop.KijkBijMijGetProfile, EVA.Kijkshop.KijkBijMijGetProfileResponse>>;
    function updateProfile(description: string, avatarId: string, languageProficiencies: any): Promise<IEVAServiceResponse<EVA.Kijkshop.KijkBijMijUpdateProfile, EVA.Core.RequestMessageWithEmptyResponse>>;
    function getProductsStats(productIDs: number[]): Promise<IEVAServiceResponse<EVA.Kijkshop.KijkBijMijGetProductsStats, EVA.Kijkshop.KijkBijMijGetProductsStatsResponse>>;
    function likeProduct(productID: number): Promise<IEVAServiceResponse<EVA.Kijkshop.KijkBijMijLikeProduct, EVA.Core.EmptyResponseMessage>>;
    function unlikeProduct(productID: number): Promise<IEVAServiceResponse<EVA.Kijkshop.KijkBijMijUnlikeProduct, EVA.Core.EmptyResponseMessage>>;
    function likesProduct(productID: number): Promise<IEVAServiceResponse<EVA.Kijkshop.KijkBijMijLikesProduct, EVA.Kijkshop.KijkBijMijLikesProductResponse>>;
    function likesProducts(productIDs: number[]): Promise<IEVAServiceResponse<EVA.Kijkshop.KijkBijMijLikesProducts, EVA.Kijkshop.KijkBijMijLikesProductsResponse>>;
    function likedProducts(): Promise<IEVAServiceResponse<EVA.Kijkshop.KijkBijMijLikedProducts, EVA.Kijkshop.KijkBijMijLikedProductsResponse>>;
    function getProductGroups(): Promise<IEVAServiceResponse<EVA.Kijkshop.KijkshopGetProductGroups, EVA.Kijkshop.KijkshopGetProductGroupsResponse>>;
    function getProductGroup(productGroupId: number): Promise<IEVAServiceResponse<EVA.Kijkshop.KijkshopGetProductGroup, EVA.Kijkshop.KijkshopGetProductGroupResponse>>;
    function addProductGroupExpertise(productGroupID: number): Promise<IEVAServiceResponse<EVA.Kijkshop.KijkBijMijAddProductGroupExpertise, EVA.Core.EmptyResponseMessage>>;
    function removeProductGroupExpertise(productGroupID: number): Promise<IEVAServiceResponse<EVA.Kijkshop.KijkBijMijRemoveProductGroupExpertise, EVA.Core.EmptyResponseMessage>>;
    function isProductGroupExpert(productGroupID: number): Promise<IEVAServiceResponse<EVA.Kijkshop.KijkBijMijIsExpertOnProductGroup, EVA.Kijkshop.KijkBijMijIsExpertResponse>>;
    function isMultipleProductGroupExpert(productGroupIDs: number[]): Promise<IEVAServiceResponse<EVA.Kijkshop.KijkBijMijIsExpertOnProductGroups, EVA.Kijkshop.KijkBijMijIsExpertsResponse>>;
    function getAvailability(userID: number): Promise<IEVAServiceResponse<EVA.Kijkshop.KijkBijMijGetAvailability, EVA.Kijkshop.KijkBijMijAvailabilityResponse>>;
    function setAvailability(availability?: IAvailabilityWeek): Promise<IEVAServiceResponse<EVA.Kijkshop.KijkBijMijSetAvailability, EVA.Core.RequestMessageWithEmptyResponse>>;
    function callExpert(userID: number, productID: number, productGroupID: number): Promise<IEVAServiceResponse<EVA.Kijkshop.KijkBijMijCallExpert, EVA.Kijkshop.KijkBijMijCallResponse>>;
    function declineCall(sessionID: string): Promise<IEVAServiceResponse<EVA.Kijkshop.KijkBijMijDeclineCall, EVA.Core.RequestMessageWithEmptyResponse>>;
    function joinCall(sessionID: string): Promise<IEVAServiceResponse<EVA.Kijkshop.KijkBijMijJoinCall, EVA.Kijkshop.KijkBijMijCallExpert>>;
    function rateExpert(userID: number, sessionID: string, rating1: number, rating2: number, rating3: number): Promise<IEVAServiceResponse<EVA.Kijkshop.KijkBijMijRateExpert, EVA.Core.EmptyResponseMessage>>;
    function rateCaller(userID: number, sessionID: string, rating: number): Promise<IEVAServiceResponse<EVA.Kijkshop.KijkBijMijRateCaller, EVA.Core.EmptyResponseMessage>>;
    function reportUser(userID: number, reason: EVA.Kijkshop.KijkBijMijReportReasons, description: string): Promise<IEVAServiceResponse<EVA.Kijkshop.KijkBijMijReportUser, EVA.Core.EmptyResponseMessage>>;
    function subscribeToNotificationType(typeID: number): Promise<IEVAServiceResponse<EVA.Kijkshop.KijkBijMijSubscribeToNotificationType, EVA.Core.RequestMessageWithEmptyResponse>>;
    function unsubscribeFromNotificationType(typeID: number): Promise<IEVAServiceResponse<EVA.Kijkshop.KijkBijMijUnsubscribeFromNotificationType, EVA.Core.RequestMessageWithEmptyResponse>>;
    function getNotificationSubscriptions(): Promise<IEVAServiceResponse<EVA.Kijkshop.KijkBijMijGetNotificationSubscriptions, EVA.Kijkshop.KijkBijMijNotificationSubscriptionsResponse>>;
    function getUnreadNotificationCount(): Promise<IEVAServiceResponse<EVA.Kijkshop.KijkBijMijGetUnreadNotificationCount, EVA.Kijkshop.KijkBijMijUnreadNotificationCountResponse>>;
    function markNotificationAsRead(id: number): Promise<IEVAServiceResponse<EVA.Kijkshop.KijkBijMijMarkNotificationAsRead, EVA.Core.RequestMessageWithEmptyResponse>>;
    function deleteNotification(id: number): Promise<IEVAServiceResponse<EVA.Kijkshop.KijkBijMijDeleteNotification, EVA.Core.RequestMessageWithEmptyResponse>>;
    function blockedUsers(): Promise<IEVAServiceResponse<EVA.Kijkshop.KijkBijMijBlockedUsers, EVA.Kijkshop.KijkBijMijBlockedUsersResponse>>;
    function isUserBlocked(userId: number): Promise<IEVAServiceResponse<EVA.Kijkshop.KijkBijMijBlocksUser, EVA.Kijkshop.KijkBijMijBlocksUserResponse>>;
    function blockUser(userId: number): Promise<IEVAServiceResponse<EVA.Kijkshop.KijkBijMijBlockUser, EVA.Core.RequestMessageWithEmptyResponse>>;
    function unblockUser(userId: number): Promise<IEVAServiceResponse<EVA.Kijkshop.KijkBijMijUnblockUser, EVA.Core.RequestMessageWithEmptyResponse>>;
    function getCreditTotalsForUser(): Promise<IEVAServiceResponse<EVA.Kijkshop.KijkBijMijGetCreditTotalsForUser, EVA.Kijkshop.KijkBijMijGetCreditTotalsForUserResponse>>;
    function listCreditTransactions(): Promise<IEVAServiceResponse<EVA.Kijkshop.KijkBijMijListCreditTransactions, EVA.Kijkshop.KijkBijMijListCreditTransactionsResponse>>;
}
/**
 * Provides access to a list of hall of famers
 */
export declare class KijkBijMijHallOfFameList extends FetchablePagedList<EVA.Kijkshop.RankedUser, EVA.Kijkshop.KijkBijMijListHall, EVA.Kijkshop.KijkBijMijListHallResponse> {
    constructor(limit?: number, start?: number, sortDirection?: EVA.Core.SortDirection, sortProperty?: string);
    /**
     * Fetches the list of items
     * @return {Promise<IEVAServiceResponse<EVA.Kijkshop.RankedUser, EVA.Kijkshop.KijkBijMijListHall, EVA.Kijkshop.KijkBijMijListHallResponse>>} A promise resolving when the fetch from the back-end has completed
     */
    fetch(): Promise<IEVAServiceResponse<EVA.Kijkshop.KijkBijMijListHall, EVA.Kijkshop.KijkBijMijListHallResponse>>;
}
/**
 * Provides access to a list of content blocks available in EVA
 */
export declare class KijkBijMijNotificationsList extends FetchablePagedList<EVA.Kijkshop.KijkBijMijNotification, EVA.Kijkshop.KijkBijMijListNotifications, EVA.Kijkshop.KijkBijMijListNotificationsResponse> {
    constructor(limit?: number, start?: number, sortDirection?: EVA.Core.SortDirection, sortProperty?: string);
    /**
     * Fetches the list of items
     * @return {Promise<IEVAServiceResponse<EVA.Kijkshop.KijkBijMijNotification, EVA.Kijkshop.KijkBijMijListNotifications, EVA.Kijkshop.KijkBijMijListNotificationsResponse>>} A promise resolving when the fetch from the back-end has completed
     */
    fetch(): Promise<IEVAServiceResponse<EVA.Kijkshop.KijkBijMijListNotifications, EVA.Kijkshop.KijkBijMijListNotificationsResponse>>;
}
/**
 * Provides access to a list of product groups experts in EVA
 */
export declare class KijkBijMijProductGroupExperts extends FetchablePagedList<number, EVA.Kijkshop.KijkBijMijProductGroupExpertsPaged, EVA.Kijkshop.KijkBijMijProductGroupExpertsPagedResponse> {
    /**
     * The product group ID to retrieve the experts for
     * @type {number}
     */
    private productGroupId;
    /**
     * Sets the product group id to retrieve the expert list for
     * @param  {number} productGroupId  The product group identifier
     * @return {void}                   This method doesn't return anything
     */
    setProductGroupId(productGroupId: number): void;
    constructor(limit?: number, start?: number, sortDirection?: EVA.Core.SortDirection, sortProperty?: string);
    /**
     * Fetches the list of experts
     * @return {Promise<IEVAServiceResponse<number, EVA.Kijkshop.KijkBijMijProductGroupExpertsPaged, EVA.Kijkshop.KijkBijMijProductGroupExpertsPagedResponse>>} A promise resolving when the fetch from the back-end has completed
     */
    fetch(): Promise<IEVAServiceResponse<EVA.Kijkshop.KijkBijMijProductGroupExpertsPaged, EVA.Kijkshop.KijkBijMijProductGroupExpertsPagedResponse>>;
}
/**
 * Provides access to a list of content blocks available in EVA
 */
export declare class KijkBijMijRatingsList extends FetchablePagedList<EVA.Kijkshop.KijkBijMijRating, EVA.Kijkshop.KijkBijMijListRatings, EVA.Kijkshop.KijkBijMijListRatingsResponse> {
    /**
     * The user to retrieve the ratings for
     * @type {number}
     */
    private userId;
    /**
     * Sets the user id to retrieve the rating list for
     * @param  {number} userId      The user identifier
     * @return {void}               This method doesn't return anything
     */
    setUserId(userId: number): void;
    constructor(limit?: number, start?: number, sortDirection?: EVA.Core.SortDirection, sortProperty?: string);
    /**
     * Fetches the list of items
     * @return {Promise<IEVAServiceResponse<EVA.Kijkshop.KijkBijMijRating, EVA.Kijkshop.KijkBijMijListRatings, EVA.Kijkshop.KijkBijMijListRatingsResponse>>} A promise resolving when the fetch from the back-end has completed
     */
    fetch(): Promise<IEVAServiceResponse<EVA.Kijkshop.KijkBijMijListRatings, EVA.Kijkshop.KijkBijMijListRatingsResponse>>;
}
