"use strict";
/**
 * The rituals module provides access to the Rituals specific call on the EVA back-end
 * @preferred
 */
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var service_1 = require("../service");
var base_1 = require("./base");
/**
 * Provides access to a kijkshop specific functions in EVA
 */
var Kijkshop;
(function (Kijkshop) {
    "use strict";
    ////////////////////////////////////////////////////////////////////////////
    // Orders
    ////////////////////////////////////////////////////////////////////////////
    //
    function setExpertForOrderLine(orderLineID, expertID) {
        // Create the service instance
        //
        var service = new service_1.EVAService("SetExpertForOrderLine");
        // Build the request data
        // The base class will add things like SessionID so keep typescript
        // happy we're using an 'any' type object here
        //
        var requestData = {
            ExpertID: expertID,
            OrderLineID: orderLineID
        };
        // Perform the call and return resulting promise
        //
        return service.call(requestData);
    }
    Kijkshop.setExpertForOrderLine = setExpertForOrderLine;
    ////////////////////////////////////////////////////////////////////////////
    // Products
    ////////////////////////////////////////////////////////////////////////////
    //
    function addProductExpertise(productID) {
        // Create the service instance
        //
        var service = new service_1.EVAService("KijkBijMijAddProductExpertise");
        // Build the request data
        // The base class will add things like SessionID so keep typescript
        // happy we're using an 'any' type object here
        //
        var requestData = {
            ProductID: productID
        };
        // Perform the call and return resulting promise
        //
        return service.call(requestData);
    }
    Kijkshop.addProductExpertise = addProductExpertise;
    function removeProductExpertise(productID) {
        // Create the service instance
        //
        var service = new service_1.EVAService("KijkBijMijRemoveProductExpertise");
        // Build the request data
        // The base class will add things like SessionID so keep typescript
        // happy we're using an 'any' type object here
        //
        var requestData = {
            ProductID: productID
        };
        // Perform the call and return resulting promise
        //
        return service.call(requestData);
    }
    Kijkshop.removeProductExpertise = removeProductExpertise;
    function isProductExpert(productID) {
        // Create the service instance
        //
        var service = new service_1.EVAService("KijkBijMijIsExpertOnProduct");
        // Build the request data
        // The base class will add things like SessionID so keep typescript
        // happy we're using an 'any' type object here
        //
        var requestData = {
            ProductID: productID
        };
        // Perform the call and return resulting promise
        //
        return service.call(requestData);
    }
    Kijkshop.isProductExpert = isProductExpert;
    function isMultipleProductExpert(productIDs) {
        // Create the service instance
        //
        var service = new service_1.EVAService("KijkBijMijIsExpertOnProducts");
        // Build the request data
        // The base class will add things like SessionID so keep typescript
        // happy we're using an 'any' type object here
        //
        var requestData = {
            ProductIDs: productIDs
        };
        // Perform the call and return resulting promise
        //
        return service.call(requestData);
    }
    Kijkshop.isMultipleProductExpert = isMultipleProductExpert;
    function getProductExperts(productID) {
        // Create the service instance
        //
        var service = new service_1.EVAService("KijkBijMijProductExperts");
        // Build the request data
        // The base class will add things like SessionID so keep typescript
        // happy we're using an 'any' type object here
        //
        var requestData = {
            ProductID: productID
        };
        // Perform the call and return resulting promise
        //
        return service.call(requestData);
    }
    Kijkshop.getProductExperts = getProductExperts;
    function getTotalExpertCount() {
        // Create the service instance
        //
        var service = new service_1.EVAService("KijkBijMijTotalExpertCount");
        // Build the request data
        // The base class will add things like SessionID so keep typescript
        // happy we're using an 'any' type object here
        //
        var requestData = {};
        // Perform the call and return resulting promise
        //
        return service.call(requestData);
    }
    Kijkshop.getTotalExpertCount = getTotalExpertCount;
    function payoutCredits(amount) {
        // Create the service instance
        //
        var service = new service_1.EVAService("KijkBijMijPayoutCredits");
        // Build the request data
        // The base class will add things like SessionID so keep typescript
        // happy we're using an 'any' type object here
        //
        var requestData = {
            Amount: amount
        };
        // Perform the call and return resulting promise
        //
        return service.call(requestData);
    }
    Kijkshop.payoutCredits = payoutCredits;
    function scanMe(userId) {
        // Create the service instance
        //
        var service = new service_1.EVAService("KijkBijMijScanMe");
        // Build the request data
        // The base class will add things like SessionID so keep typescript
        // happy we're using an 'any' type object here
        //
        var requestData = {
            ScannedUserID: userId
        };
        // Perform the call and return resulting promise
        //
        return service.call(requestData);
    }
    Kijkshop.scanMe = scanMe;
    function scanNewApp() {
        // Create the service instance
        //
        var service = new service_1.EVAService("KijkBijMijScanNewApp");
        // Build the request data
        // The base class will add things like SessionID so keep typescript
        // happy we're using an 'any' type object here
        //
        var requestData = {};
        // Perform the call and return resulting promise
        //
        return service.call(requestData);
    }
    Kijkshop.scanNewApp = scanNewApp;
    function getExpertDetails(userIDs) {
        // Create the service instance
        //
        var service = new service_1.EVAService("KijkBijMijGetExpertDetails");
        // Build the request data
        // The base class will add things like SessionID so keep typescript
        // happy we're using an 'any' type object here
        //
        var requestData = {
            UserIDs: userIDs
        };
        // Perform the call and return resulting promise
        //
        return service.call(requestData);
    }
    Kijkshop.getExpertDetails = getExpertDetails;
    function getProfile() {
        // Create the service instance
        //
        var service = new service_1.EVAService("KijkBijMijGetProfile");
        // Build the request data
        // The base class will add things like SessionID so keep typescript
        // happy we're using an 'any' type object here
        //
        var requestData = {};
        // Perform the call and return resulting promise
        //
        return service.call(requestData);
    }
    Kijkshop.getProfile = getProfile;
    function updateProfile(description, avatarId, languageProficiencies) {
        // Create the service instance
        //
        var service = new service_1.EVAService("KijkBijMijUpdateProfile");
        // Build the request data
        // The base class will add things like SessionID so keep typescript
        // happy we're using an 'any' type object here
        //
        var requestData = {
            AdvisorDescription: description,
            AvatarID: avatarId,
            LanguageProficiencies: languageProficiencies
        };
        // Perform the call and return resulting promise
        //
        return service.call(requestData);
    }
    Kijkshop.updateProfile = updateProfile;
    function getProductsStats(productIDs) {
        // Create the service instance
        //
        var service = new service_1.EVAService("KijkBijMijGetProductsStats");
        // Build the request data
        // The base class will add things like SessionID so keep typescript
        // happy we're using an 'any' type object here
        //
        var requestData = {
            ProductIDs: productIDs
        };
        // Perform the call and return resulting promise
        //
        return service.call(requestData);
    }
    Kijkshop.getProductsStats = getProductsStats;
    function likeProduct(productID) {
        // Create the service instance
        //
        var service = new service_1.EVAService("KijkBijMijLikeProduct");
        // Build the request data
        // The base class will add things like SessionID so keep typescript
        // happy we're using an 'any' type object here
        //
        var requestData = {
            ProductID: productID
        };
        // Perform the call and return resulting promise
        //
        return service.call(requestData);
    }
    Kijkshop.likeProduct = likeProduct;
    function unlikeProduct(productID) {
        // Create the service instance
        //
        var service = new service_1.EVAService("KijkBijMijUnlikeProduct");
        // Build the request data
        // The base class will add things like SessionID so keep typescript
        // happy we're using an 'any' type object here
        //
        var requestData = {
            ProductID: productID
        };
        // Perform the call and return resulting promise
        //
        return service.call(requestData);
    }
    Kijkshop.unlikeProduct = unlikeProduct;
    function likesProduct(productID) {
        // Create the service instance
        //
        var service = new service_1.EVAService("KijkBijMijLikesProduct");
        // Build the request data
        // The base class will add things like SessionID so keep typescript
        // happy we're using an 'any' type object here
        //
        var requestData = {
            ProductID: productID
        };
        // Perform the call and return resulting promise
        //
        return service.call(requestData);
    }
    Kijkshop.likesProduct = likesProduct;
    function likesProducts(productIDs) {
        // Create the service instance
        //
        var service = new service_1.EVAService("KijkBijMijLikesProducts");
        // Build the request data
        // The base class will add things like SessionID so keep typescript
        // happy we're using an 'any' type object here
        //
        var requestData = {
            ProductIDs: productIDs
        };
        // Perform the call and return resulting promise
        //
        return service.call(requestData);
    }
    Kijkshop.likesProducts = likesProducts;
    function likedProducts() {
        // Create the service instance
        //
        var service = new service_1.EVAService("KijkBijMijLikedProducts");
        // Build the request data
        // The base class will add things like SessionID so keep typescript
        // happy we're using an 'any' type object here
        //
        var requestData = {};
        // Perform the call and return resulting promise
        //
        return service.call(requestData);
    }
    Kijkshop.likedProducts = likedProducts;
    ////////////////////////////////////////////////////////////////////////////
    // Product groups
    ////////////////////////////////////////////////////////////////////////////
    //
    function getProductGroups() {
        // Create the service instance
        //
        var service = new service_1.EVAService("KijkshopGetProductGroups");
        // Build the request data
        // The base class will add things like SessionID so keep typescript
        // happy we're using an 'any' type object here
        //
        var requestData = {};
        // Perform the call and return resulting promise
        //
        return service.call(requestData);
    }
    Kijkshop.getProductGroups = getProductGroups;
    function getProductGroup(productGroupId) {
        // Create the service instance
        //
        var service = new service_1.EVAService("KijkshopGetProductGroup");
        // Build the request data
        // The base class will add things like SessionID so keep typescript
        // happy we're using an 'any' type object here
        //
        var requestData = {
            ID: productGroupId
        };
        // Perform the call and return resulting promise
        //
        return service.call(requestData);
    }
    Kijkshop.getProductGroup = getProductGroup;
    function addProductGroupExpertise(productGroupID) {
        // Create the service instance
        //
        var service = new service_1.EVAService("KijkBijMijAddProductGroupExpertise");
        // Build the request data
        // The base class will add things like SessionID so keep typescript
        // happy we're using an 'any' type object here
        //
        var requestData = {
            ProductGroupID: productGroupID
        };
        // Perform the call and return resulting promise
        //
        return service.call(requestData);
    }
    Kijkshop.addProductGroupExpertise = addProductGroupExpertise;
    function removeProductGroupExpertise(productGroupID) {
        // Create the service instance
        //
        var service = new service_1.EVAService("KijkBijMijRemoveProductGroupExpertise");
        // Build the request data
        // The base class will add things like SessionID so keep typescript
        // happy we're using an 'any' type object here
        //
        var requestData = {
            ProductGroupID: productGroupID
        };
        // Perform the call and return resulting promise
        //
        return service.call(requestData);
    }
    Kijkshop.removeProductGroupExpertise = removeProductGroupExpertise;
    function isProductGroupExpert(productGroupID) {
        // Create the service instance
        //
        var service = new service_1.EVAService("KijkBijMijIsExpertOnProductGroup");
        // Build the request data
        // The base class will add things like SessionID so keep typescript
        // happy we're using an 'any' type object here
        //
        var requestData = {
            ProductGroupID: productGroupID
        };
        // Perform the call and return resulting promise
        //
        return service.call(requestData);
    }
    Kijkshop.isProductGroupExpert = isProductGroupExpert;
    function isMultipleProductGroupExpert(productGroupIDs) {
        // Create the service instance
        //
        var service = new service_1.EVAService("KijkBijMijIsExpertOnProductGroups");
        // Build the request data
        // The base class will add things like SessionID so keep typescript
        // happy we're using an 'any' type object here
        //
        var requestData = {
            ProductGroupIDs: productGroupIDs
        };
        // Perform the call and return resulting promise
        //
        return service.call(requestData);
    }
    Kijkshop.isMultipleProductGroupExpert = isMultipleProductGroupExpert;
    function getAvailability(userID) {
        // Create the service instance
        //
        var service = new service_1.EVAService("KijkBijMijGetAvailability");
        // Build the request data
        // The base class will add things like SessionID so keep typescript
        // happy we're using an 'any' type object here
        //
        var requestData = {
            UserID: userID
        };
        // Perform the call and return resulting promise
        //
        return service.call(requestData);
    }
    Kijkshop.getAvailability = getAvailability;
    function setAvailability(availability) {
        if (availability === void 0) { availability = { monday: null, tuesday: null, wednesday: null, thursday: null, friday: null, saturday: null, sunday: null, otherDays: null }; }
        // Create the service instance
        //
        var service = new service_1.EVAService("KijkBijMijSetAvailability");
        // Build the request data
        // The base class will add things like SessionID so keep typescript
        // happy we're using an 'any' type object here
        //
        var requestData = {
            Monday: availability.monday,
            Tuesday: availability.tuesday,
            Wednesday: availability.wednesday,
            Thursday: availability.thursday,
            Friday: availability.friday,
            Saturday: availability.saturday,
            Sunday: availability.sunday,
            OtherDays: availability.otherDays
        };
        // Perform the call and return resulting promise
        //
        return service.call(requestData);
    }
    Kijkshop.setAvailability = setAvailability;
    ////////////////////////////////////////////////////////////////////////////
    // Calls
    ////////////////////////////////////////////////////////////////////////////
    //
    function callExpert(userID, productID, productGroupID) {
        // Create the service instance
        //
        var service = new service_1.EVAService("KijkBijMijCallExpert");
        // Build the request data
        // The base class will add things like SessionID so keep typescript
        // happy we're using an 'any' type object here
        //
        var requestData = {
            UserID: userID,
            ProductID: productID,
            ProductGroupID: productGroupID
        };
        // Perform the call and return resulting promise
        //
        return service.call(requestData);
    }
    Kijkshop.callExpert = callExpert;
    function declineCall(sessionID) {
        // Create the service instance
        //
        var service = new service_1.EVAService("KijkBijMijDeclineCall");
        // Build the request data
        // The base class will add things like SessionID so keep typescript
        // happy we're using an 'any' type object here
        //
        var requestData = {
            SessionID: sessionID
        };
        // Perform the call and return resulting promise
        //
        return service.call(requestData);
    }
    Kijkshop.declineCall = declineCall;
    function joinCall(sessionID) {
        // Create the service instance
        //
        var service = new service_1.EVAService("KijkBijMijJoinCall");
        // Build the request data
        // The base class will add things like SessionID so keep typescript
        // happy we're using an 'any' type object here
        //
        var requestData = {
            SessionID: sessionID
        };
        // Perform the call and return resulting promise
        //
        return service.call(requestData);
    }
    Kijkshop.joinCall = joinCall;
    function rateExpert(userID, sessionID, rating1, rating2, rating3) {
        // Create the service instance
        //
        var service = new service_1.EVAService("KijkBijMijRateExpert");
        // Build the request data
        // The base class will add things like SessionID so keep typescript
        // happy we're using an 'any' type object here
        //
        var requestData = {
            UserID: userID,
            SessionID: sessionID,
            Rating1: rating1,
            Rating2: rating2,
            Rating3: rating3
        };
        // Perform the call and return resulting promise
        //
        return service.call(requestData);
    }
    Kijkshop.rateExpert = rateExpert;
    function rateCaller(userID, sessionID, rating) {
        // Create the service instance
        //
        var service = new service_1.EVAService("KijkBijMijRateCaller");
        // Build the request data
        // The base class will add things like SessionID so keep typescript
        // happy we're using an 'any' type object here
        //
        var requestData = {
            UserID: userID,
            SessionID: sessionID,
            Rating: rating,
        };
        // Perform the call and return resulting promise
        //
        return service.call(requestData);
    }
    Kijkshop.rateCaller = rateCaller;
    function reportUser(userID, reason, description) {
        // Create the service instance
        //
        var service = new service_1.EVAService("KijkBijMijReportUser");
        // Build the request data
        // The base class will add things like SessionID so keep typescript
        // happy we're using an 'any' type object here
        //
        var requestData = {
            UserID: userID,
            Reason: reason,
            ReasonDescription: description
        };
        // Perform the call and return resulting promise
        //
        return service.call(requestData);
    }
    Kijkshop.reportUser = reportUser;
    ////////////////////////////////////////////////////////////////////////////
    // Notifications
    ////////////////////////////////////////////////////////////////////////////
    //
    function subscribeToNotificationType(typeID) {
        // Create the service instance
        //
        var service = new service_1.EVAService("KijkBijMijSubscribeToNotificationType");
        // Build the request data
        // The base class will add things like SessionID so keep typescript
        // happy we're using an 'any' type object here
        //
        var requestData = {
            TypeID: typeID
        };
        // Perform the call and return resulting promise
        //
        return service.call(requestData);
    }
    Kijkshop.subscribeToNotificationType = subscribeToNotificationType;
    function unsubscribeFromNotificationType(typeID) {
        // Create the service instance
        //
        var service = new service_1.EVAService("KijkBijMijUnsubscribeFromNotificationType");
        // Build the request data
        // The base class will add things like SessionID so keep typescript
        // happy we're using an 'any' type object here
        //
        var requestData = {
            TypeID: typeID
        };
        // Perform the call and return resulting promise
        //
        return service.call(requestData);
    }
    Kijkshop.unsubscribeFromNotificationType = unsubscribeFromNotificationType;
    function getNotificationSubscriptions() {
        // Create the service instance
        //
        var service = new service_1.EVAService("KijkBijMijGetNotificationSubscriptions");
        // Build the request data
        // The base class will add things like SessionID so keep typescript
        // happy we're using an 'any' type object here
        //
        var requestData = {};
        // Perform the call and return resulting promise
        //
        return service.call(requestData);
    }
    Kijkshop.getNotificationSubscriptions = getNotificationSubscriptions;
    function getUnreadNotificationCount() {
        // Create the service instance
        //
        var service = new service_1.EVAService("KijkBijMijGetUnreadNotificationCount");
        // Build the request data
        // The base class will add things like SessionID so keep typescript
        // happy we're using an 'any' type object here
        //
        var requestData = {};
        // Perform the call and return resulting promise
        //
        return service.call(requestData);
    }
    Kijkshop.getUnreadNotificationCount = getUnreadNotificationCount;
    function markNotificationAsRead(id) {
        // Create the service instance
        //
        var service = new service_1.EVAService("KijkBijMijMarkNotificationAsRead");
        // Build the request data
        // The base class will add things like SessionID so keep typescript
        // happy we're using an 'any' type object here
        //
        var requestData = {
            ID: id
        };
        // Perform the call and return resulting promise
        //
        return service.call(requestData);
    }
    Kijkshop.markNotificationAsRead = markNotificationAsRead;
    function deleteNotification(id) {
        // Create the service instance
        //
        var service = new service_1.EVAService("KijkBijMijDeleteNotification");
        // Build the request data
        // The base class will add things like SessionID so keep typescript
        // happy we're using an 'any' type object here
        //
        var requestData = {
            ID: id
        };
        // Perform the call and return resulting promise
        //
        return service.call(requestData);
    }
    Kijkshop.deleteNotification = deleteNotification;
    function blockedUsers() {
        // Create the service instance
        //
        var service = new service_1.EVAService("KijkBijMijBlockedUsers");
        // Build the request data
        // The base class will add things like SessionID so keep typescript
        // happy we're using an 'any' type object here
        //
        var requestData = {};
        // Perform the call and return resulting promise
        //
        return service.call(requestData);
    }
    Kijkshop.blockedUsers = blockedUsers;
    function isUserBlocked(userId) {
        // Create the service instance
        //
        var service = new service_1.EVAService("KijkBijMijBlocksUser");
        // Build the request data
        // The base class will add things like SessionID so keep typescript
        // happy we're using an 'any' type object here
        //
        var requestData = {
            UserID: userId
        };
        // Perform the call and return resulting promise
        //
        return service.call(requestData);
    }
    Kijkshop.isUserBlocked = isUserBlocked;
    function blockUser(userId) {
        // Create the service instance
        //
        var service = new service_1.EVAService("KijkBijMijBlockUser");
        // Build the request data
        // The base class will add things like SessionID so keep typescript
        // happy we're using an 'any' type object here
        //
        var requestData = {
            UserID: userId
        };
        // Perform the call and return resulting promise
        //
        return service.call(requestData);
    }
    Kijkshop.blockUser = blockUser;
    function unblockUser(userId) {
        // Create the service instance
        //
        var service = new service_1.EVAService("KijkBijMijUnblockUser");
        // Build the request data
        // The base class will add things like SessionID so keep typescript
        // happy we're using an 'any' type object here
        //
        var requestData = {
            UserID: userId
        };
        // Perform the call and return resulting promise
        //
        return service.call(requestData);
    }
    Kijkshop.unblockUser = unblockUser;
    ////////////////////////////////////////////////////////////////////////////
    // Credit
    ////////////////////////////////////////////////////////////////////////////
    //
    function getCreditTotalsForUser() {
        // Create the service instance
        //
        var service = new service_1.EVAService("KijkBijMijGetCreditTotalsForUser");
        // Build the request data
        // The base class will add things like SessionID so keep typescript
        // happy we're using an 'any' type object here
        //
        var requestData = {};
        // Perform the call and return resulting promise
        //
        return service.call(requestData);
    }
    Kijkshop.getCreditTotalsForUser = getCreditTotalsForUser;
    function listCreditTransactions() {
        // Create the service instance
        //
        var service = new service_1.EVAService("KijkBijMijListCreditTransactions");
        // Build the request data
        // The base class will add things like SessionID so keep typescript
        // happy we're using an 'any' type object here
        //
        var requestData = {};
        // Perform the call and return resulting promise
        //
        return service.call(requestData);
    }
    Kijkshop.listCreditTransactions = listCreditTransactions;
})(Kijkshop = exports.Kijkshop || (exports.Kijkshop = {}));
/**
 * Provides access to a list of hall of famers
 */
var KijkBijMijHallOfFameList = /** @class */ (function (_super) {
    __extends(KijkBijMijHallOfFameList, _super);
    function KijkBijMijHallOfFameList(limit, start, sortDirection, sortProperty) {
        if (limit === void 0) { limit = 15; }
        if (start === void 0) { start = 0; }
        if (sortDirection === void 0) { sortDirection = 0; }
        if (sortProperty === void 0) { sortProperty = null; }
        return _super.call(this, limit, start, sortDirection, sortProperty) || this;
    }
    /**
     * Fetches the list of items
     * @return {Promise<IEVAServiceResponse<EVA.Kijkshop.RankedUser, EVA.Kijkshop.KijkBijMijListHall, EVA.Kijkshop.KijkBijMijListHallResponse>>} A promise resolving when the fetch from the back-end has completed
     */
    KijkBijMijHallOfFameList.prototype.fetch = function () {
        // Build the request data
        //
        var requestData = {
            PageConfig: this.getPageConfiguration()
        };
        return _super.prototype.fetch.call(this, "KijkBijMijListHall", requestData);
    };
    return KijkBijMijHallOfFameList;
}(base_1.FetchablePagedList));
exports.KijkBijMijHallOfFameList = KijkBijMijHallOfFameList;
/**
 * Provides access to a list of content blocks available in EVA
 */
var KijkBijMijNotificationsList = /** @class */ (function (_super) {
    __extends(KijkBijMijNotificationsList, _super);
    function KijkBijMijNotificationsList(limit, start, sortDirection, sortProperty) {
        if (limit === void 0) { limit = 15; }
        if (start === void 0) { start = 0; }
        if (sortDirection === void 0) { sortDirection = 0; }
        if (sortProperty === void 0) { sortProperty = null; }
        return _super.call(this, limit, start, sortDirection, sortProperty) || this;
    }
    /**
     * Fetches the list of items
     * @return {Promise<IEVAServiceResponse<EVA.Kijkshop.KijkBijMijNotification, EVA.Kijkshop.KijkBijMijListNotifications, EVA.Kijkshop.KijkBijMijListNotificationsResponse>>} A promise resolving when the fetch from the back-end has completed
     */
    KijkBijMijNotificationsList.prototype.fetch = function () {
        // Build the request data
        //
        var requestData = {
            PageConfig: this.getPageConfiguration()
        };
        return _super.prototype.fetch.call(this, "KijkBijMijListNotifications", requestData);
    };
    return KijkBijMijNotificationsList;
}(base_1.FetchablePagedList));
exports.KijkBijMijNotificationsList = KijkBijMijNotificationsList;
/**
 * Provides access to a list of product groups experts in EVA
 */
var KijkBijMijProductGroupExperts = /** @class */ (function (_super) {
    __extends(KijkBijMijProductGroupExperts, _super);
    function KijkBijMijProductGroupExperts(limit, start, sortDirection, sortProperty) {
        if (limit === void 0) { limit = 15; }
        if (start === void 0) { start = 0; }
        if (sortDirection === void 0) { sortDirection = 0; }
        if (sortProperty === void 0) { sortProperty = null; }
        return _super.call(this, limit, start, sortDirection, sortProperty) || this;
    }
    /**
     * Sets the product group id to retrieve the expert list for
     * @param  {number} productGroupId  The product group identifier
     * @return {void}                   This method doesn't return anything
     */
    KijkBijMijProductGroupExperts.prototype.setProductGroupId = function (productGroupId) {
        this.productGroupId = productGroupId;
    };
    /**
     * Fetches the list of experts
     * @return {Promise<IEVAServiceResponse<number, EVA.Kijkshop.KijkBijMijProductGroupExpertsPaged, EVA.Kijkshop.KijkBijMijProductGroupExpertsPagedResponse>>} A promise resolving when the fetch from the back-end has completed
     */
    KijkBijMijProductGroupExperts.prototype.fetch = function () {
        // Build the request data
        //
        var requestData = {
            ProductGroupID: this.productGroupId,
            PageConfig: this.getPageConfiguration()
        };
        return _super.prototype.fetch.call(this, "KijkBijMijProductGroupExpertsPaged", requestData);
    };
    return KijkBijMijProductGroupExperts;
}(base_1.FetchablePagedList));
exports.KijkBijMijProductGroupExperts = KijkBijMijProductGroupExperts;
/**
 * Provides access to a list of content blocks available in EVA
 */
var KijkBijMijRatingsList = /** @class */ (function (_super) {
    __extends(KijkBijMijRatingsList, _super);
    function KijkBijMijRatingsList(limit, start, sortDirection, sortProperty) {
        if (limit === void 0) { limit = 15; }
        if (start === void 0) { start = 0; }
        if (sortDirection === void 0) { sortDirection = 0; }
        if (sortProperty === void 0) { sortProperty = null; }
        return _super.call(this, limit, start, sortDirection, sortProperty) || this;
    }
    /**
     * Sets the user id to retrieve the rating list for
     * @param  {number} userId      The user identifier
     * @return {void}               This method doesn't return anything
     */
    KijkBijMijRatingsList.prototype.setUserId = function (userId) {
        this.userId = userId;
    };
    /**
     * Fetches the list of items
     * @return {Promise<IEVAServiceResponse<EVA.Kijkshop.KijkBijMijRating, EVA.Kijkshop.KijkBijMijListRatings, EVA.Kijkshop.KijkBijMijListRatingsResponse>>} A promise resolving when the fetch from the back-end has completed
     */
    KijkBijMijRatingsList.prototype.fetch = function () {
        // Build the request data
        //
        var requestData = {
            UserID: this.userId,
            PageConfig: this.getPageConfiguration()
        };
        return _super.prototype.fetch.call(this, "KijkBijMijListRatings", requestData);
    };
    return KijkBijMijRatingsList;
}(base_1.FetchablePagedList));
exports.KijkBijMijRatingsList = KijkBijMijRatingsList;
