import { EVAService, IEVAServiceResponse } from "../service";

export function addPushNotificationDevice( deviceToken: string, deviceOS: string, mobileAppID: string, backendSystemID: string )
{
    var service = new EVAService<EVA.Core.Services.AddPushNotificationDevice, EVA.Core.EmptyResponseMessage>( "AddPushNotificationDevice" );

    // Build the request data
    // The base class will add things like SessionID so keep typescript
    // happy we're using an 'any' type object here
    //
    var requestData: EVA.Core.Services.AddPushNotificationDevice = {
        DeviceToken:     deviceToken
    ,   DeviceOS:        deviceOS
    ,   MobileAppID:     mobileAppID
    ,   BackendSystemID: backendSystemID
    ,   __response:  undefined
    };

    // Perform the call and capture the resulting promise
    //
    return service.call( requestData );
}

export function removePushNotificationDevice( deviceToken: string, backendSystemID?: string )
{
    var service = new EVAService<EVA.Core.Services.RemovePushNotificationDevice, EVA.Core.EmptyResponseMessage>( "RemovePushNotificationDevice" );

    // Build the request data
    // The base class will add things like SessionID so keep typescript
    // happy we're using an 'any' type object here
    //
    var requestData: EVA.Core.Services.RemovePushNotificationDevice = {
        DeviceToken: deviceToken
    ,   BackendSystemID: backendSystemID
    ,   __response:  undefined
    };

    // Perform the call and capture the resulting promise
    //
    return service.call( requestData );
}
