"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
/**
 * This module provides methods for BI reporting
 *
 * @preferred
 */
var service_1 = require("../service");
var _ = require("lodash");
var Reporting;
(function (Reporting) {
    "use strict";
    function GetRankings(axis, measure, organizationUnitIDs, fromDate, toDate) {
        var service = new service_1.EVAService("GetRankings");
        if (_.isNumber(organizationUnitIDs)) {
            organizationUnitIDs = [organizationUnitIDs];
        }
        var requestData = {
            OrganizationUnits: organizationUnitIDs,
            FromDate: fromDate,
            ToDate: toDate,
            Axis: axis,
            Measure: measure,
            __response: null
        };
        // Perform the call and capture the resulting promise
        //
        return service.call(requestData);
    }
    Reporting.GetRankings = GetRankings;
    function getRankings(organizationUnitIDs, fromDate, toDate) {
        var service = new service_1.EVAService("GetRankings");
        if (_.isNumber(organizationUnitIDs)) {
            organizationUnitIDs = [organizationUnitIDs];
        }
        var requestData = {
            OrganizationUnits: organizationUnitIDs,
            FromDate: fromDate,
            ToDate: toDate
        };
        // Perform the call and capture the resulting promise
        //
        return service.call(requestData);
    }
    Reporting.getRankings = getRankings;
    function getProductReportingOverview(organizationUnitIDs, fromDate, toDate) {
        var service = new service_1.EVAService("GetProductReportingOverview");
        if (_.isNumber(organizationUnitIDs)) {
            organizationUnitIDs = [organizationUnitIDs];
        }
        var requestData = {
            OrganizationUnits: organizationUnitIDs,
            FromDate: fromDate,
            ToDate: toDate
        };
        // Perform the call and capture the resulting promise
        //
        return service.call(requestData);
    }
    Reporting.getProductReportingOverview = getProductReportingOverview;
    function getTelecomReportingOverview(organizationUnitIDs, fromDate, toDate) {
        var service = new service_1.EVAService("GetTelecomReportingOverview");
        if (_.isNumber(organizationUnitIDs)) {
            organizationUnitIDs = [organizationUnitIDs];
        }
        var requestData = {
            OrganizationUnits: organizationUnitIDs,
            FromDate: fromDate,
            ToDate: toDate
        };
        // Perform the call and capture the resulting promise
        //
        return service.call(requestData);
    }
    Reporting.getTelecomReportingOverview = getTelecomReportingOverview;
    function getReportingCharts(organizationUnitID, fromDate, toDate) {
        var service = new service_1.EVAService("GetReportingCharts");
        var requestData = {
            OrganizationUnitID: organizationUnitID,
            FromDate: fromDate,
            ToDate: toDate
        };
        // Perform the call and capture the resulting promise
        //
        return service.call(requestData);
    }
    Reporting.getReportingCharts = getReportingCharts;
    function getOrderDetails(orderID) {
        var service = new service_1.EVAService("GetOrderDetails");
        var requestData = {
            OrderID: orderID
        };
        // Perform the call and capture the resulting promise
        //
        return service.call(requestData);
    }
    Reporting.getOrderDetails = getOrderDetails;
    function getOrders(organizationUnitID, category, userID, fromDate, toDate) {
        var service = new service_1.EVAService("GetOrders");
        var requestData = {
            UserID: userID,
            OrganizationUnitID: organizationUnitID,
            FromDate: fromDate,
            ToDate: toDate,
            Category: category
        };
        // Perform the call and capture the resulting promise
        //
        return service.call(requestData);
    }
    Reporting.getOrders = getOrders;
    function getReportingOverview(organizationUnitIDs, fromDate, toDate) {
        var service = new service_1.EVAService("GetReportingOverview");
        if (_.isNumber(organizationUnitIDs)) {
            organizationUnitIDs = [organizationUnitIDs];
        }
        var requestData = {
            OrganizationUnits: organizationUnitIDs,
            FromDate: fromDate,
            ToDate: toDate
        };
        // Perform the call and capture the resulting promise
        //
        return service.call(requestData);
    }
    Reporting.getReportingOverview = getReportingOverview;
})(Reporting = exports.Reporting || (exports.Reporting = {}));
