/**
 * The shops module provides access to the shops (organization unit type) data from the EVA back-end
 * @preferred
 */
import { FetchablePagedList } from "./base";
import { IEVAServiceResponse } from "../service";
/**
 * Provides access to a list of shop reviews available in EVA
 */
export declare class ShopReviews extends FetchablePagedList<EVA.Kiyoh.ShopReview, EVA.Kiyoh.ListShopReviews, EVA.Kiyoh.ListShopReviewsResponse> {
    /**
     * Fetches the list of items
     * @return {Promise<IEVAServiceResponse<EVA.Kiyoh.ListShopReviews, EVA.Kiyoh.ListShopReviewsResponse>>} A promise resolving when the fetch from the back-end has completed
     */
    fetch(): Promise<IEVAServiceResponse<EVA.Kiyoh.ListShopReviews, EVA.Kiyoh.ListShopReviewsResponse>>;
}
/**
 * Provides access to a list of product reviews available in EVA
 */
export declare class ProductReviews extends FetchablePagedList<EVA.Kiyoh.ProductReview, EVA.Kiyoh.ListProductReviews, EVA.Kiyoh.ListProductReviewsResponse> {
    /**
     * Fetches the list of items
     * @return {Promise<IEVAServiceResponse<EVA.Kiyoh.ListProductReviews, EVA.Kiyoh.ListProductReviewsResponse>>} A promise resolving when the fetch from the back-end has completed
     */
    fetch(): Promise<IEVAServiceResponse<EVA.Kiyoh.ListProductReviews, EVA.Kiyoh.ListProductReviewsResponse>>;
}
export declare function getShopReviewStats(): Promise<IEVAServiceResponse<EVA.Kiyoh.GetShopReviewStats, EVA.Kiyoh.GetShopReviewStatsResponse>>;
