"use strict";
/**
 * The shops module provides access to the shops (organization unit type) data from the EVA back-end
 * @preferred
 */
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var base_1 = require("./base");
var service_1 = require("../service");
/**
 * Provides access to a list of shop reviews available in EVA
 */
var ShopReviews = /** @class */ (function (_super) {
    __extends(ShopReviews, _super);
    function ShopReviews() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    /**
     * Fetches the list of items
     * @return {Promise<IEVAServiceResponse<EVA.Kiyoh.ListShopReviews, EVA.Kiyoh.ListShopReviewsResponse>>} A promise resolving when the fetch from the back-end has completed
     */
    ShopReviews.prototype.fetch = function () {
        // Build the request data
        //
        var requestData = {
            PageConfig: this.getPageConfiguration()
        };
        return _super.prototype.fetch.call(this, "ListShopReviews", requestData);
    };
    return ShopReviews;
}(base_1.FetchablePagedList));
exports.ShopReviews = ShopReviews;
/**
 * Provides access to a list of product reviews available in EVA
 */
var ProductReviews = /** @class */ (function (_super) {
    __extends(ProductReviews, _super);
    function ProductReviews() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    /**
     * Fetches the list of items
     * @return {Promise<IEVAServiceResponse<EVA.Kiyoh.ListProductReviews, EVA.Kiyoh.ListProductReviewsResponse>>} A promise resolving when the fetch from the back-end has completed
     */
    ProductReviews.prototype.fetch = function () {
        // Build the request data
        //
        var requestData = {
            PageConfig: this.getPageConfiguration()
        };
        return _super.prototype.fetch.call(this, "ListProductReviews", requestData);
    };
    return ProductReviews;
}(base_1.FetchablePagedList));
exports.ProductReviews = ProductReviews;
function getShopReviewStats() {
    "use strict";
    // Create the service instance
    //
    var service = new service_1.EVAService("GetShopReviewStats");
    // Build the request data
    // The base class will add things like SessionID so keep typescript
    // happy we're using an 'any' type object here
    //
    var requestData = {};
    // Perform the call and capture the resulting promise
    //
    return service.call(requestData);
}
exports.getShopReviewStats = getShopReviewStats;
