"use strict";
/**
 * The rituals module provides access to the Rituals specific call on the EVA back-end
 * @preferred
 */
Object.defineProperty(exports, "__esModule", { value: true });
var service_1 = require("../service");
/**
 * Provides access to a Rituals specific functions in EVA
 */
var Rituals;
(function (Rituals) {
    "use strict";
    function createCustomerReturn(orderID, email, lines) {
        // Create the service instance
        //
        var service = new service_1.EVAService("RitualsCreateCustomerReturn");
        // Build the request data
        // The base class will add things like SessionID so keep typescript
        // happy we're using an 'any' type object here
        //
        var requestData = {
            OrderID: orderID,
            Email: email,
            Lines: lines
        };
        // Perform the call and return resulting promise
        //
        return service.call(requestData);
    }
    Rituals.createCustomerReturn = createCustomerReturn;
    function getOrderForReturn(orderID, email) {
        // Create the service instance
        //
        var service = new service_1.EVAService("RitualsGetOrderForReturn");
        // Build the request data
        // The base class will add things like SessionID so keep typescript
        // happy we're using an 'any' type object here
        //
        var requestData = {
            OrderID: orderID,
            Email: email,
            __response: undefined
        };
        // Perform the call and return resulting promise
        //
        return service.call(requestData);
    }
    Rituals.getOrderForReturn = getOrderForReturn;
    function getBlobsForReturn(orderID, email) {
        // Create the service instance
        //
        var service = new service_1.EVAService("RitualsGetBlobsForReturn");
        // Build the request data
        // The base class will add things like SessionID so keep typescript
        // happy we're using an 'any' type object here
        //
        var requestData = {
            OrderID: orderID,
            Email: email
        };
        // Perform the call and return resulting promise
        //
        return service.call(requestData);
    }
    Rituals.getBlobsForReturn = getBlobsForReturn;
    function scanLoyaltyCard(loyaltyId) {
        // Create the service instance
        //
        var service = new service_1.EVAService("RitualsScanLoyaltyCard");
        // Build the request data
        // The base class will add things like SessionID so keep typescript
        // happy we're using an 'any' type object here
        //
        var requestData = {
            LoyaltyID: loyaltyId
        };
        // Perform the call and return resulting promise
        //
        return service.call(requestData);
    }
    Rituals.scanLoyaltyCard = scanLoyaltyCard;
})(Rituals = exports.Rituals || (exports.Rituals = {}));
