
import { SettingsManager                   } from "../settings";
import { FetchableItem, FetchablePagedList } from "./base";
import { EVAService, IEVAServiceResponse   } from "../service";
import { EXMLHttpRequestMethod             } from "../xhr";
import * as _                                from "lodash";

export class SuggestionList extends FetchablePagedList<EVA.Core.SuggestionModel, EVA.Core.Services.GetProductSearchSuggestions, EVA.Core.Services.GetProductSearchSuggestionsResponse>
{
    public maxSuggestions: number = 1;

    private query: string = "";

    public setQuery( query: string ): string
    {
        return this.query = query;
    }

    public setData( response: any ): EVA.Core.SuggestionModel[]
    {
        // Set and return the page items
        //
        return this.data = response.Suggestions;
    }

    public fetch(): Promise<IEVAServiceResponse<EVA.Core.Services.GetProductSearchSuggestions, EVA.Core.Services.GetProductSearchSuggestionsResponse>> {

        // Build the request data
        //
        var requestData: EVA.Core.Services.GetProductSearchSuggestions = <EVA.Core.Services.GetProductSearchSuggestions> {
            Text:                   this.query || "",
            MaxSuggestions:         this.maxSuggestions || 1,
            __response:             undefined
        };

        return super.fetch( "GetProductSearchSuggestions", requestData );
    }
}
