"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
/**
 *
 * @preferred
 */
var service_1 = require("../service");
var _ = require("lodash");
var Webshop;
(function (Webshop) {
    "use strict";
    function sendContactFrom(type, properties) {
        return new Promise(function (resolve, reject) {
            // Create our service instance
            //
            var service = new service_1.EVAService("SendContactForm");
            // Build the request data
            // The base class will add things like SessionID so to keep typescript
            // happy we're using an 'any' type object here
            //
            var requestData = {
                Type: type,
                Properties: properties,
                __response: null
            };
            // Perform the call and capture the resulting promise
            //
            service.call(requestData)
                .then(function (result) {
                resolve(_.get(result, "response"));
            })
                .catch(reject);
        });
    }
    Webshop.sendContactFrom = sendContactFrom;
})(Webshop = exports.Webshop || (exports.Webshop = {}));
