/**
 *
 * @preferred
 */
import { EVAService } from "../service";
import * as _         from "lodash";

export namespace Webshop
{
    "use strict";

    export function sendContactFrom( type: string, properties: any ): Promise<EVA.Core.Services.SendContactForm>
    {
        return new Promise( ( resolve: any, reject: any ) =>
        {
            // Create our service instance
            //
            var service = new EVAService<EVA.Core.Services.SendContactForm, EVA.Core.EmptyResponseMessage>( "SendContactForm" );

            // Build the request data
            // The base class will add things like SessionID so to keep typescript
            // happy we're using an 'any' type object here
            //
            var requestData: EVA.Core.Services.SendContactForm = <EVA.Core.Services.SendContactForm>{
                Type:       type,
                Properties: properties,
                __response: null
            };

            // Perform the call and capture the resulting promise
            //
            service.call( requestData )
            .then( ( result ) =>
            {
                resolve( _.get( result, "response" ) );
            } )
            .catch( reject );
        } );
    }
}
