/* tslint:disable */
declare module EVA.BI.Reporting {
  
  export enum ReportStyle {
    Daily = 0,
    Weekly = 1,
    Monthly = 2,
  }
  
  export class GetOrderDetails extends EVA.Core.RequestMessageGeneric<EVA.BI.Reporting.GetOrderDetailsResponse> {
    OrderID : number; // Int32
    __response : EVA.BI.Reporting.GetOrderDetailsResponse;
  }
  
  export class GetOrderDetailsResponse extends EVA.Core.ResponseMessage {
    Data : any; 
  }
  
  export class GetOrders extends EVA.Core.RequestMessageGeneric<EVA.BI.Reporting.GetOrdersResponse> {
    UserID : number; // Int32, nullable
    OrganizationUnitID : number; // Int32
    FromDate : string; // DateTime, nullable
    ToDate : string; // DateTime, nullable
    Offset : number; // Int32, nullable
    Category : string; 
    __response : EVA.BI.Reporting.GetOrdersResponse;
  }
  
  export class GetOrdersResponse extends EVA.Core.ResponseMessage {
    Orders : EVA.BI.Reporting.OrderOverview[]; 
    Offset : number; // Int32, nullable
  }
  
  export class OrderOverview {
    sales : number; // Decimal
    salesType : string; 
    date : string; // DateTime
    name : string; 
    order_id : number; // Int32
    sales_in_tax : number; // Decimal
    time : any; // TimeSpan
    contract_count : number; // Int32
    margin : number; // Decimal
    insurable_lines : number; // Int32
    gross_margin_percentage : number; // Decimal
    product_id : number; // Int32, nullable
  }
  
  export class GetReportingOverview extends EVA.Core.RequestMessageGeneric<EVA.BI.Reporting.GetReportingOverviewResponse> {
    OrganizationUnits : number[]; 
    FromDate : string; // DateTime, nullable
    ToDate : string; // DateTime, nullable
    __response : EVA.BI.Reporting.GetReportingOverviewResponse;
  }
  
  export class GetReportingOverviewResponse extends EVA.Core.ResponseMessage {
    ResponseID : number; // Int32
    Data : any; 
  }
  
  export class GetProductReportingOverview extends EVA.Core.RequestMessageGeneric<EVA.BI.Reporting.GetProductReportingOverviewResponse> {
    OrganizationUnits : number[]; 
    FromDate : string; // DateTime, nullable
    ToDate : string; // DateTime, nullable
    __response : EVA.BI.Reporting.GetProductReportingOverviewResponse;
  }
  
  export class GetProductReportingOverviewResponse extends EVA.Core.ResponseMessage {
    ResponseID : number; // Int32
    Data : any; 
  }
  
  export class GetRankings extends EVA.Core.RequestMessageGeneric<EVA.BI.Reporting.GetRankingsResponse> {
    OrganizationUnits : number[]; 
    FromDate : string; // DateTime, nullable
    ToDate : string; // DateTime, nullable
    __response : EVA.BI.Reporting.GetRankingsResponse;
  }
  
  export class GetRankingsResponse extends EVA.Core.ResponseMessage {
    Rankings : EVA.BI.Reporting.ReportOverview[]; 
  }
  
  export class ReportOverview implements EVA.BI.Reporting.IPopulateNames {
    id : number; // Int32
    applicationId : number; // Int32
    organizationUnitId : number; // Int32
    name : string; 
    groupingId : number[]; 
    type : number; // Int32
    loss : number; // Decimal, nullable
    sales : number; // Decimal
    apple_sales : number; // Decimal
    visitors : number; // Int32, nullable
    visitor_value : number; // Decimal, nullable
    people_outside : number; // Int32
    outside_conversion : number; // Decimal
    order_count : number; // Int32
    conversion_rate : number; // Decimal, nullable
    margin : number; // Decimal
    insurance_rate : number; // Decimal
    insurable_lines : number; // Decimal
    units_sold : number; // Int32
    telco_lines : number; // Int32
    contract_count : number; // Int32
    sales_per_type : EVA.BI.Reporting.SalesPerType[]; 
    task_data : EVA.BI.Reporting.TaskInfo[]; 
    budget : EVA.BI.Reporting.BudgetInfo; 
    kpis : EVA.BI.Reporting.KpiInfo[]; 
    worked_hours : number; // Decimal
    cpus : number; // Int32
    fullName : string; 
    service_sales : number; // Decimal, nullable
    margin_percentage : number; // Decimal
    productivity : number; // Decimal
    sales_minutes : number; // Decimal
    budget_rate : number; // Decimal
    average_order_value : number; // Decimal
    attach_rate : number; // Decimal
    photo : number; // Int32
    my_organizations : boolean; 
    drillDown : boolean; 
    telecom : any; 
    margin_per_unit : number; // Decimal, nullable
  }
  
  export class SalesPerType {
    sales : number; // Decimal
    sales_percentage : number; // Decimal
    salesType : string; 
  }
  
  export class TaskInfo {
    type : string; 
    groupingId : number; // Int32
    count : number; // Int32
  }
  
  export class BudgetInfo {
    service : number; // Decimal
    sales : number; // Decimal
    margin : number; // Decimal
    shop_to_web_rate : number; // Decimal
    worked_hours : number; // Decimal
    insurance_rate : number; // Decimal
    telco : number; // Int32
    conversion_rate : number; // Decimal, nullable
    units_per_order : number; // Decimal, nullable
    margin_per_unit : number; // Decimal, nullable
    units_sold : number; // Decimal, nullable
    quantity_sold : number; // Decimal, nullable
    post_pay : number; // Decimal, nullable
    attach_rate : number; // Decimal
  }
  
  export class KpiInfo {
    type : string; 
    name : string; 
    formula : string; 
  }
  
  export interface IPopulateNames {
    id : number; // Int32
    organizationUnitId : number; // Int32
    name : string; 
    type : number; // Int32
  }
  
  export class GetReportingCharts extends EVA.Core.RequestMessageGeneric<EVA.BI.Reporting.GetReportingChartsResponse> {
    OrganizationUnitID : number; // Int32
    FromDate : string; // DateTime, nullable
    ToDate : string; // DateTime, nullable
    __response : EVA.BI.Reporting.GetReportingChartsResponse;
  }
  
  export class GetReportingChartsResponse extends EVA.Core.ResponseMessage {
    Data : any; 
  }
  
  export class GetStockOverview extends EVA.Core.RequestMessageGeneric<EVA.BI.Reporting.GetStockOverviewResponse> {
    OrganizationUnits : number[]; 
    ToDate : string; // DateTime, nullable
    Axis : string; 
    Measure : string; 
    __response : EVA.BI.Reporting.GetStockOverviewResponse;
  }
  
  export class GetStockOverviewResponse extends EVA.Core.ResponseMessage {
    ResponseID : number; // Int32
    Data : any; 
  }
  
  export class GetTelecomReportingOverview extends EVA.Core.RequestMessageGeneric<EVA.BI.Reporting.GetTelecomReportingOverviewResponse> {
    OrganizationUnits : number[]; 
    FromDate : string; // DateTime, nullable
    ToDate : string; // DateTime, nullable
    __response : EVA.BI.Reporting.GetTelecomReportingOverviewResponse;
  }
  
  export class GetTelecomReportingOverviewResponse extends EVA.Core.ResponseMessage {
    ResponseID : number; // Int32
    Data : any; 
  }
  
  export class GetDailyStats extends EVA.Core.RequestMessageGeneric<EVA.BI.Reporting.GetDailyStatsResponse> {
    __response : EVA.BI.Reporting.GetDailyStatsResponse;
  }
  
  export class GetDailyStatsResponse extends EVA.Core.ResponseMessage {
    Orders : number; // Int32
    Exported : number; // Int32
    Shipped : number; // Int32
    Products : number; // Int32
  }
  
  export class GetOrderCounts extends EVA.Core.RequestMessageGeneric<EVA.BI.Reporting.GetOrderCountsResponse> {
    StartDate : string; // DateTime, nullable
    EndDate : string; // DateTime, nullable
    __response : EVA.BI.Reporting.GetOrderCountsResponse;
  }
  
  export class GetOrderCountsResponse extends EVA.Core.ResponseMessage {
    Days : EVA.BI.Reporting.GetOrderCountsResponseDayWithCount[]; 
  }
  
  export class GetOrderCountsResponseDayWithCount {
    Day : string; // DateTime
    Count : number; // Int32
  }
  
  export class GetPopularProducts extends EVA.Core.RequestMessageGeneric<EVA.BI.Reporting.GetPopularProductsResponse> {
    StartDate : string; // DateTime, nullable
    EndDate : string; // DateTime, nullable
    Amount : number; // Int32, nullable
    __response : EVA.BI.Reporting.GetPopularProductsResponse;
  }
  
  export class GetPopularProductsResponse extends EVA.Core.ResponseMessage {
    Products : EVA.BI.Reporting.GetPopularProductsResponseProductWithCount[]; 
  }
  
  export class GetPopularProductsResponseProductWithCount {
    ID : number; // Int32
    Name : string; 
    Count : number; // Int32
  }
  
}