/* tslint:disable */
declare module EVA.Babylon {
  
  export enum StreamApiLocation {
    USEast = 0,
    USWest = 1,
    EUWest = 2,
    AsiaJapan = 3,
  }
  
  export class AddFashionUserMediaBase extends EVA.Core.RequestMessageWithEmptyResponse {
    BlobID : string; 
    Name : string; 
    Description : string; 
    __response : EVA.Core.EmptyResponseMessage;
  }
  
  export class AddFashionUserMediaToProduct extends EVA.Babylon.AddFashionUserMediaBase {
    ProductID : number; // Int32
    __response : EVA.Core.EmptyResponseMessage;
  }
  
  export class AddFashionUserMediaToFashionCollection extends EVA.Babylon.AddFashionUserMediaBase {
    CollectionID : number; // Int32
    __response : EVA.Core.EmptyResponseMessage;
  }
  
  export class DeleteFashionUserMedia extends EVA.Core.RequestMessageWithEmptyResponse {
    UserMediaID : number; // Int32
    __response : EVA.Core.EmptyResponseMessage;
  }
  
  export class GetFashionUserMediaByID extends EVA.Core.RequestMessageGeneric<EVA.Babylon.GetFashionUserMediaByIDResponse> {
    UserMediaID : number; // Int32
    __response : EVA.Babylon.GetFashionUserMediaByIDResponse;
  }
  
  export class GetFashionUserMediaByIDResponse extends EVA.Core.ResponseMessage {
    UserMedia : EVA.Babylon.FashionUserMediaByID; 
  }
  
  export class FashionUserMediaByID {
    UserID : number; // Int32
    ProductID : number; // Int32, nullable
    CollectionID : number; // Int32, nullable
    BlobID : string; 
    Sequence : number; // Int32
    Name : string; 
    Description : string; 
  }
  
  export class ListFashionUserMediaForProduct extends EVA.Core.PagedResultRequest<EVA.Babylon.ListFashionUserMediaResponse> {
    ProductID : number; // Int32
    UserID : number; // Int32, nullable
    __response : EVA.Babylon.ListFashionUserMediaResponse;
  }
  
  export class ListFashionUserMediaResponse extends EVA.Core.PagedResultResponse<EVA.Babylon.FashionUserMedia> {
  }
  
  export class FashionUserMedia {
    ID : number; // Int32
    BlobID : string; 
    CreationTime : string; // DateTime
    UserID : number; // Int32
    User : EVA.Babylon.FashionUserMediaUser; 
    Name : string; 
    Description : string; 
    SocialStats : EVA.Babylon.SocialStats; 
    Width : number; // Int32
    Height : number; // Int32
  }
  
  export class FashionUserMediaUser {
    FirstName : string; 
    ID : number; // Int32
    Name : string; 
    Nickname : string; 
    CombinedCurrentLevel : number; // Int32, nullable
    CurrentLevel : number; // Int32, nullable
    CurrentPrestigeLevel : number; // Int32, nullable
  }
  
  export class SocialStats {
    ID : string; 
    Likes : number; // Int32
    Comments : number; // Int32
    Views : number; // Int32
    AlreadyLiked : boolean; 
    AlreadyClipped : boolean; 
    AlreadyFollowing : boolean; 
  }
  
  export class ListFashionUserMediaForCollection extends EVA.Core.PagedResultRequest<EVA.Babylon.ListFashionUserMediaResponse> {
    CollectionID : number; // Int32
    UserID : number; // Int32, nullable
    __response : EVA.Babylon.ListFashionUserMediaResponse;
  }
  
  export enum SupplierStatuses {
    Pending = 0,
    Approved = 1,
  }
  
  export enum ProductManagementMethods {
    None = 0,
    Manual = 1,
    EffectConnect = 2,
    TradeByte = 3,
    Channable = 4,
  }
  
  export enum FullfillmentMethods {
    None = 0,
    Manual = 1,
    EffectConnect = 2,
    TradeByte = 3,
    Channable = 4,
  }
  
  export enum Modules {
    None = 0,
    ShipmentAndReturns = 1,
    ProductMedia = 2,
  }
  
  export class GenerateSupplierContract extends EVA.Core.RequestMessageGeneric<EVA.Babylon.GenerateSupplierContractResponse> {
    Company : EVA.Core.CompanyDto; 
    ProductManagementMethodID : number; // Int32
    FullfillmentMethodID : number; // Int32
    ModulesID : number; // Int32
    StatusID : number; // Int32
    ContractUser : EVA.Core.UserDto; 
    ContractUserFunction : string; 
    __response : EVA.Babylon.GenerateSupplierContractResponse;
  }
  
  export class GenerateSupplierContractResponse extends EVA.Core.ResponseMessage {
    Url : string; 
  }
  
  export class GetFashionSupplierData extends EVA.Core.RequestMessageGeneric<EVA.Babylon.GetFashionSupplierDataResponse> {
    SupplierID : number; // Int32
    __response : EVA.Babylon.GetFashionSupplierDataResponse;
  }
  
  export class GetFashionSupplierDataResponse extends EVA.Core.ResponseMessage {
    SupplierData : EVA.Babylon.FashionSupplierDataDto; 
  }
  
  export class FashionSupplierDataDto {
    SupplierID : number; // Int32
    ProductManagementMethod : EVA.Babylon.ProductManagementMethods; 
    FullfillmentMethod : EVA.Babylon.FullfillmentMethods; 
    Modules : EVA.Babylon.Modules; 
    Status : EVA.Babylon.SupplierStatuses; 
    UserCompanyFunction : string; 
    UserID : number; // Int32
    ReturnsPolicy : string; 
    ReturnDays : number; // Int32, nullable
    ReturnCostsAmount : number; // Decimal, nullable
    ReturnsCarrierName : string; 
    ShippingCostsCutoffAmount : number; // Decimal, nullable
    ShippingCostsPolicy : string; 
    ShippingCostsAmount : number; // Decimal, nullable
    ShippingCarrierName : string; 
    ReturnsAddress : EVA.Core.AddressDto; 
    ContactEmailAddress : string; 
    ContactPhoneNumber : string; 
    SupplierName : string; 
  }
  
  export class ListSuppliers extends EVA.Core.PagedResultRequest<EVA.Babylon.ListSuppliersResponse> {
    __response : EVA.Babylon.ListSuppliersResponse;
  }
  
  export class ListSuppliersResponse extends EVA.Core.PagedResultResponse<EVA.Babylon.ListSuppliersResponseModel> {
  }
  
  export class ListSuppliersResponseModel {
    SupplierID : number; // Int32
    User : EVA.Core.UserDto; 
  }
  
  export class UploadCompanyLogo extends EVA.Core.RequestMessageGeneric<EVA.Babylon.UploadCompanyLogoResponse> {
    OriginalName : string; 
    MimeType : string; 
    Data : number[]; 
    __response : EVA.Babylon.UploadCompanyLogoResponse;
  }
  
  export class UploadCompanyLogoResponse extends EVA.Core.ResponseMessage {
    BlobID : string; 
  }
  
  export class UpdateSupplier extends EVA.Core.RequestMessageWithEmptyResponse {
    SupplierID : number; // Int32
    ProductManagementMethodID : number; // Int32
    FullfillmentMethodID : number; // Int32
    ModulesID : number; // Int32
    StatusID : number; // Int32
    __response : EVA.Core.EmptyResponseMessage;
  }
  
  export class CreateSupplier extends EVA.Core.RequestMessageGeneric<EVA.Babylon.CreateSupplierResponse> {
    Company : EVA.Core.CompanyDto; 
    CompanyTradeName : string; 
    WebshopTypeName : string; 
    ProductManagementMethodID : number; // Int32
    FullfillmentMethodID : number; // Int32
    ModulesID : number; // Int32
    StatusID : number; // Int32
    ContractUser : EVA.Core.UserDto; 
    ContractUserFunction : string; 
    Password : string; 
    Nickname : string; 
    __response : EVA.Babylon.CreateSupplierResponse;
  }
  
  export class CreateSupplierResponse extends EVA.Core.ResponseMessage {
    ID : number; // Int32
  }
  
  export enum ReportedContentActions {
    Delete = 0,
    Ignore = 1,
  }
  
  export enum ContentTypes {
    User = 0,
    Product = 1,
    UserMedia = 2,
    CoverSheet = 3,
  }
  
  export enum SocialMediaPlatform {
    Facebook = 0,
    Twitter = 1,
  }
  
  export class SocialGetFollowSuggestions extends EVA.Core.RequestMessageGeneric<EVA.Babylon.SocialGetFollowSuggestionsResponse> {
    SuggestionCount : number; // Int32
    __response : EVA.Babylon.SocialGetFollowSuggestionsResponse;
  }
  
  export class SocialGetFollowSuggestionsResponse extends EVA.Core.ResponseMessage {
    Result : EVA.Babylon.SocialFollowSuggestion[]; 
  }
  
  export class SocialFollowSuggestion {
    UserID : number; // Int32
    FirstName : string; 
    Nickname : string; 
    RecommendationType : string; 
  }
  
  export enum CommentedOnObjectTypes {
    Product = 0,
    FashionCollection = 1,
    UserMedia = 2,
  }
  
  export enum SocialReportContentTypes {
    None = 0,
    FashionCollection = 1,
    UserMedia = 2,
    User = 3,
    Comment = 4,
    Product = 5,
    CoverSheet = 6,
  }
  
  export enum SocialReportReasons {
    None = 0,
    Spam = 1,
    Offensive = 2,
    Inappropriate = 3,
    NonFashion = 4,
    CopyrightInfringement = 5,
    Automatic = 6,
  }
  
  export enum SocialReportContentStatuses {
    New = 0,
    ContentRemoved = 1,
    Ignored = 2,
  }
  
  export enum ProductCreationResultTypes {
    Product = 0,
    UserMedia = 1,
  }
  
  export class DeleteReportedContent extends EVA.Core.RequestMessageWithEmptyResponse {
    ID : number; // Int32
    __response : EVA.Core.EmptyResponseMessage;
  }
  
  export class IgnoreReportedContent extends EVA.Core.RequestMessageWithEmptyResponse {
    ID : number; // Int32
    __response : EVA.Core.EmptyResponseMessage;
  }
  
  export class BlockUser extends EVA.Core.RequestMessageWithEmptyResponse {
    UserID : number; // Int32
    __response : EVA.Core.EmptyResponseMessage;
  }
  
  export class UnblockUser extends EVA.Core.RequestMessageWithEmptyResponse {
    UserID : number; // Int32
    __response : EVA.Core.EmptyResponseMessage;
  }
  
  export class SocialListBlockedFollowers extends EVA.Core.PagedResultRequest<EVA.Babylon.SocialListBlockedFollowersResponse> {
    UserID : number; // Int32
    __response : EVA.Babylon.SocialListBlockedFollowersResponse;
  }
  
  export class SocialListBlockedFollowersResponse extends EVA.Core.PagedResultResponse<EVA.Babylon.BlockedUser> {
  }
  
  export class BlockedUser {
    UserID : number; // Int32
    Nickname : string; 
    FirstName : string; 
    CombinedCurrentLevel : number; // Int32, nullable
    CurrentLevel : number; // Int32, nullable
    CurrentPrestigeLevel : number; // Int32, nullable
  }
  
  export class GetReportedContentByID extends EVA.Core.RequestMessageGeneric<EVA.Babylon.GetReportedContentByIDResponse> {
    ID : number; // Int32
    __response : EVA.Babylon.GetReportedContentByIDResponse;
  }
  
  export class GetReportedContentByIDResponse extends EVA.Core.ResponseMessage {
    Result : EVA.Babylon.GetReportedContentByIDResponseReportedContentDto; 
  }
  
  export class GetReportedContentByIDResponseReportedContentDto {
    ContentID : string; 
    ContentType : EVA.Babylon.SocialReportContentTypes; 
    ReportedByUserID : number; // Int32
    ReportedByUser : EVA.Core.UserDto; 
    ReportDescription : string; 
    ReportReason : EVA.Babylon.SocialReportReasons; 
    Status : EVA.Babylon.SocialReportContentStatuses; 
  }
  
  export class ListReportedContent extends EVA.Core.PagedResultRequest<EVA.Babylon.ListReportedContentResponse> {
    __response : EVA.Babylon.ListReportedContentResponse;
  }
  
  export class ListReportedContentResponse extends EVA.Core.PagedResultResponse<EVA.Babylon.ListReportedContentResponseReportedContentDto> {
  }
  
  export class ListReportedContentResponseReportedContentDto {
    ID : number; // Int32
    ContentID : string; 
    ContentType : EVA.Babylon.SocialReportContentTypes; 
    ReportedByUserID : number; // Int32
    ReportedByUser : EVA.Core.UserDto; 
    ReportDescription : string; 
    ReportReason : EVA.Babylon.SocialReportReasons; 
    Status : EVA.Babylon.SocialReportContentStatuses; 
  }
  
  export class SocialReportContent extends EVA.Core.RequestMessageWithEmptyResponse {
    Type : EVA.Babylon.SocialReportContentTypes; 
    Reason : EVA.Babylon.SocialReportReasons; 
    ID : string; 
    Description : string; 
    __response : EVA.Core.EmptyResponseMessage;
  }
  
  export class ShareProductWithUsers extends EVA.Core.RequestMessageWithEmptyResponse {
    ProductID : number; // Int32
    Message : string; 
    UserIDs : number[]; 
    __response : EVA.Core.EmptyResponseMessage;
  }
  
  export class ShareFashionCollectionWithUsers extends EVA.Core.RequestMessageWithEmptyResponse {
    CollectionID : number; // Int32
    Message : string; 
    UserIDs : number[]; 
    __response : EVA.Core.EmptyResponseMessage;
  }
  
  export class SocialProductSharedExternally extends EVA.Core.RequestMessageWithEmptyResponse {
    ProductID : number; // Int32
    Platform : EVA.Babylon.SocialMediaPlatform; 
    __response : EVA.Core.EmptyResponseMessage;
  }
  
  export class SocialFashionCollectionSharedExternally extends EVA.Core.RequestMessageWithEmptyResponse {
    CollectionID : number; // Int32
    Platform : EVA.Babylon.SocialMediaPlatform; 
    __response : EVA.Core.EmptyResponseMessage;
  }
  
  export class SocialGetProgressionRanking extends EVA.Core.RequestMessageGeneric<EVA.Babylon.SocialGetProgressionRankingResponse> {
    UserID : number; // Int32
    __response : EVA.Babylon.SocialGetProgressionRankingResponse;
  }
  
  export class SocialGetProgressionRankingResponse extends EVA.Core.ResponseMessage {
    GlobalRank : number; // Int32
    FriendsRank : number; // Int32
    UserCount : number; // Int32
    FriendsCount : number; // Int32
  }
  
  export class SocialInviteFriends extends EVA.Core.RequestMessageWithEmptyResponse {
    Invites : EVA.Babylon.InviteFriendsDto[]; 
    __response : EVA.Core.EmptyResponseMessage;
  }
  
  export class InviteFriendsDto {
    EmailAddress : string; 
    FirstName : string; 
    LastName : string; 
    Message : string; 
  }
  
  export class SocialListFacebookFriends extends EVA.Core.PagedResultRequest<EVA.Babylon.SocialListFacebookFriendsResponse> {
    __response : EVA.Babylon.SocialListFacebookFriendsResponse;
  }
  
  export class SocialListFacebookFriendsResponse extends EVA.Core.PagedResultResponse<EVA.Babylon.FacebookFriend> {
  }
  
  export class FacebookFriend {
    UserID : number; // Int32
    Nickname : string; 
    FirstName : string; 
    AlreadyFollowing : boolean; 
    AlreadyBlocked : boolean; 
    CombinedCurrentLevel : number; // Int32, nullable
    CurrentLevel : number; // Int32, nullable
    CurrentPrestigeLevel : number; // Int32, nullable
  }
  
  export class SocialListProductsCreationsByUser extends EVA.Core.PagedResultRequest<EVA.Babylon.SocialListProductsCreationsByUserResponse> {
    UserID : number; // Int32
    __response : EVA.Babylon.SocialListProductsCreationsByUserResponse;
  }
  
  export class SocialListProductsCreationsByUserResponse extends EVA.Core.PagedResultResponse<EVA.Babylon.ProductCreationByUserResult> {
  }
  
  export class ProductCreationByUserResult {
    ID : number; // Int32
    Name : string; 
    Type : EVA.Babylon.ProductCreationResultTypes; 
    Price : number; // Decimal, nullable
    SocialStats : EVA.Babylon.SocialStats; 
    CreationTime : string; // DateTime
    BlobID : string; 
    FullName : string; 
    ImageSize : string; 
    ProductID : number; // Int32, nullable
    CollectionID : number; // Int32, nullable
    ProductType : string; 
    OrganizationUnitID : number; // Int32, nullable
    FashionCoinsPrice : number; // Decimal, nullable
    BabylonProductType : string; 
    BrandName : string; 
    FashionCoinsReward : number; // Int32, nullable
    OriginalPrice : number; // Decimal, nullable
  }
  
  export class SocialUpdateGuidedTourProgress extends EVA.Core.RequestMessageWithEmptyResponse {
    TourID : string; 
    CurrentStep : number; // Int32
    __response : EVA.Core.EmptyResponseMessage;
  }
  
  export class SocialGetGuidedTourProgress extends EVA.Core.RequestMessageGeneric<EVA.Babylon.SocialGetGuidedTourProgressResponse> {
    TourID : string; 
    __response : EVA.Babylon.SocialGetGuidedTourProgressResponse;
  }
  
  export class SocialGetGuidedTourProgressResponse extends EVA.Core.ResponseMessage {
    CurrentStep : number; // Int32
  }
  
  export class SocialAddCommentToProduct extends EVA.Core.RequestMessageGeneric<EVA.Babylon.AddCommentResponse> {
    CommentText : string; 
    ProductID : number; // Int32
    __response : EVA.Babylon.AddCommentResponse;
  }
  
  export class AddCommentResponse extends EVA.Core.ResponseMessage {
    ID : string; 
  }
  
  export class SocialListCommentsBase extends EVA.Core.PagedResultRequest<EVA.Babylon.SocialListCommentsResponse> {
  }
  
  export class SocialListCommentsResponse extends EVA.Core.PagedResultResponse<EVA.Babylon.Comment> {
  }
  
  export class Comment {
    Text : string; 
    UserID : number; // Int32
    UserName : string; 
    CreationTime : string; // DateTime
    ID : string; 
    Nickname : string; 
    FirstName : string; 
    CanDelete : boolean; 
    SocialStats : EVA.Babylon.SocialStats; 
    Mentions : EVA.Babylon.CommentMention[]; 
    CombinedCurrentLevel : number; // Int32, nullable
    CurrentLevel : number; // Int32, nullable
    CurrentPrestigeLevel : number; // Int32, nullable
    CommentOnType : string; 
    CommentOnID : number; // Int32, nullable
  }
  
  export class CommentMention {
    UserID : number; // Int32
    FirstName : string; 
    Nickname : string; 
    CombinedCurrentLevel : number; // Int32, nullable
    CurrentLevel : number; // Int32, nullable
    CurrentPrestigeLevel : number; // Int32, nullable
  }
  
  export class SocialListCommentsForProduct extends EVA.Babylon.SocialListCommentsBase {
    ProductID : number; // Int32
    __response : EVA.Babylon.SocialListCommentsResponse;
  }
  
  export class SocialAddCommentToFashionCollection extends EVA.Core.RequestMessageGeneric<EVA.Babylon.AddCommentResponse> {
    CommentText : string; 
    CollectionID : number; // Int32
    __response : EVA.Babylon.AddCommentResponse;
  }
  
  export class SocialAddCommentToFashionUserMedia extends EVA.Core.RequestMessageGeneric<EVA.Babylon.AddCommentResponse> {
    CommentText : string; 
    UserMediaID : number; // Int32
    __response : EVA.Babylon.AddCommentResponse;
  }
  
  export class SocialListCommentsForFashionCollection extends EVA.Babylon.SocialListCommentsBase {
    CollectionID : number; // Int32
    __response : EVA.Babylon.SocialListCommentsResponse;
  }
  
  export class SocialListCommentsForFashionUserMedia extends EVA.Babylon.SocialListCommentsBase {
    UserMediaID : number; // Int32
    __response : EVA.Babylon.SocialListCommentsResponse;
  }
  
  export class SocialDeleteComment extends EVA.Core.RequestMessageWithEmptyResponse {
    CommentID : string; 
    __response : EVA.Core.EmptyResponseMessage;
  }
  
  export class SocialGetComment extends EVA.Core.RequestMessageGeneric<EVA.Babylon.SocialGetCommentResponse> {
    CommentID : string; 
    __response : EVA.Babylon.SocialGetCommentResponse;
  }
  
  export class SocialGetCommentResponse extends EVA.Core.ResponseMessage {
    Comment : EVA.Babylon.Comment; 
  }
  
  export enum SocialInteracionTypes {
    None = 0,
    Likes = 1,
    Commented = 2,
    Clipped = 3,
  }
  
  export class SocialListInteractionsSummaryBase extends EVA.Core.RequestMessageGeneric<EVA.Babylon.SocialListInteractionsSummaryResponse> {
    InteractionType : EVA.Babylon.SocialInteracionTypes; 
    __response : EVA.Babylon.SocialListInteractionsSummaryResponse;
  }
  
  export class SocialListInteractionsSummaryResponse extends EVA.Core.ResponseMessage {
    UserIDs : number[]; 
  }
  
  export class SocialListInteractionDetailsBase extends EVA.Core.RequestMessageGeneric<EVA.Babylon.SocialInteractionDetailsResponse> {
    PageConfig : EVA.Babylon.PageConfigDateTimeOffset; 
    InteractionType : EVA.Babylon.SocialInteracionTypes; 
    __response : EVA.Babylon.SocialInteractionDetailsResponse;
  }
  
  export class SocialInteractionDetailsResponse extends EVA.Core.ResponseMessage {
    Interactions : EVA.Babylon.PagedDateTimeOffsetResult<EVA.Babylon.SocialInteraction>; 
  }
  
  export class PagedDateTimeOffsetResult<TResult> {
    Page : TResult[]; 
    NextOffset : string; // DateTime, nullable
    Limit : number; // Int32
  }
  
  export class SocialInteraction {
    UserID : number; // Int32
    Name : string; 
    Type : EVA.Babylon.SocialInteracionTypes; 
    Following : boolean; 
    CreationTime : string; // DateTime
    FirstName : string; 
    Nickname : string; 
    CoverPhotoID : string; 
    CombinedCurrentLevel : number; // Int32, nullable
    CurrentLevel : number; // Int32, nullable
    CurrentPrestigeLevel : number; // Int32, nullable
  }
  
  export class PageConfigDateTimeOffset {
    Offset : string; // DateTime, nullable
    Limit : number; // Int32
  }
  
  export class SocialListInteractionsSummaryForProduct extends EVA.Babylon.SocialListInteractionsSummaryBase {
    ProductID : number; // Int32
    __response : EVA.Babylon.SocialListInteractionsSummaryResponse;
  }
  
  export class SocialListInteractionDetailsForProduct extends EVA.Babylon.SocialListInteractionDetailsBase {
    ProductID : number; // Int32
    __response : EVA.Babylon.SocialInteractionDetailsResponse;
  }
  
  export class SocialListInteractionsSummaryForFashionCollection extends EVA.Babylon.SocialListInteractionsSummaryBase {
    CollectionID : number; // Int32
    __response : EVA.Babylon.SocialListInteractionsSummaryResponse;
  }
  
  export class SocialListInteractionDetailsForFashionCollection extends EVA.Babylon.SocialListInteractionDetailsBase {
    CollectionID : number; // Int32
    __response : EVA.Babylon.SocialInteractionDetailsResponse;
  }
  
  export class SocialListInteractionsSummaryForUser extends EVA.Babylon.SocialListInteractionsSummaryBase {
    UserID : number; // Int32
    __response : EVA.Babylon.SocialListInteractionsSummaryResponse;
  }
  
  export class SocialListInteractionDetailsForUser extends EVA.Babylon.SocialListInteractionDetailsBase {
    UserID : number; // Int32
    __response : EVA.Babylon.SocialInteractionDetailsResponse;
  }
  
  export class SocialListLikedObjects extends EVA.Core.RequestMessageGeneric<EVA.Babylon.SocialListLikedObjectsResponse> {
    PageConfig : EVA.Babylon.PageConfigDateTimeOffset; 
    __response : EVA.Babylon.SocialListLikedObjectsResponse;
  }
  
  export class SocialListLikedObjectsResponse extends EVA.Core.ResponseMessage {
    LikedObjects : EVA.Babylon.PagedDateTimeOffsetResult<EVA.Babylon.LikedObject>; 
  }
  
  export class LikedObject {
    ObjectID : string; 
    ObjectType : string; 
    Name : string; 
    CreationTime : string; // DateTime
    CollectionTopProductIDs : number[]; 
    SocialStats : EVA.Babylon.SocialObjectStats; 
    Actor : EVA.Babylon.FeedItemActor; 
    CoverSheetBlobID : string; 
    FullName : string; 
    ImageSize : string; 
    UserMediaBlobID : string; 
    FirstName : string; 
    Nickname : string; 
    CommentText : string; 
    OrganizationUnitID : number; // Int32, nullable
    FashionCoinsPrice : number; // Decimal, nullable
    BabylonProductType : string; 
    FashionCoinsReward : number; // Int32, nullable
  }
  
  export class SocialObjectStats {
    ObjectID : string; 
    ObjectType : string; 
    Likes : number; // Int32
    Comments : number; // Int32
    Views : number; // Int32
    AlreadyLiked : boolean; 
    AlreadyClipped : boolean; 
  }
  
  export class FeedItemActor {
    FirstName : string; 
    ID : number; // Int32
    Name : string; 
    Nickname : string; 
    Type : string; 
    CombinedCurrentLevel : number; // Int32, nullable
    CurrentLevel : number; // Int32, nullable
    CurrentPrestigeLevel : number; // Int32, nullable
  }
  
  export class SocialGetProductsStats extends EVA.Core.RequestMessageGeneric<EVA.Babylon.SocialStatsResponse> {
    ProductIDs : number[]; 
    __response : EVA.Babylon.SocialStatsResponse;
  }
  
  export class SocialStatsResponse extends EVA.Core.ResponseMessage {
    Stats : EVA.Babylon.SocialStats[]; 
  }
  
  export class SocialGetFashionCollectionsStats extends EVA.Core.RequestMessageGeneric<EVA.Babylon.SocialStatsResponse> {
    CollectionIDs : number[]; 
    __response : EVA.Babylon.SocialStatsResponse;
  }
  
  export class SocialGetUserMediaStats extends EVA.Core.RequestMessageGeneric<EVA.Babylon.SocialStatsResponse> {
    UserMediaIDs : number[]; 
    __response : EVA.Babylon.SocialStatsResponse;
  }
  
  export class SocialGetStatsForFeedObjects extends EVA.Core.RequestMessageGeneric<EVA.Babylon.SocialObjectStatsResponse> {
    ObjectIDs : EVA.Babylon.FeedObjectDto[]; 
    __response : EVA.Babylon.SocialObjectStatsResponse;
  }
  
  export class SocialObjectStatsResponse extends EVA.Core.ResponseMessage {
    Stats : EVA.Babylon.SocialObjectStats[]; 
  }
  
  export class FeedObjectDto {
    ObjectType : string; 
    ObjectID : string; 
  }
  
  export class SocialListFollowing extends EVA.Core.PagedResultRequest<EVA.Babylon.SocialListFollowingResponse> {
    UserID : number; // Int32
    __response : EVA.Babylon.SocialListFollowingResponse;
  }
  
  export class SocialListFollowingResponse extends EVA.Core.PagedResultResponse<EVA.Babylon.Following> {
  }
  
  export class Following {
    UserID : number; // Int32
    Nickname : string; 
    FirstName : string; 
    AlreadyFollowing : boolean; 
    AlreadyBlocked : boolean; 
    CombinedCurrentLevel : number; // Int32, nullable
    CurrentLevel : number; // Int32, nullable
    CurrentPrestigeLevel : number; // Int32, nullable
  }
  
  export class SocialListFollowers extends EVA.Core.PagedResultRequest<EVA.Babylon.SocialListFollowersResponse> {
    UserID : number; // Int32
    __response : EVA.Babylon.SocialListFollowersResponse;
  }
  
  export class SocialListFollowersResponse extends EVA.Core.PagedResultResponse<EVA.Babylon.Follower> {
  }
  
  export class Follower {
    UserID : number; // Int32
    Nickname : string; 
    FirstName : string; 
    AlreadyFollowing : boolean; 
    AlreadyBlocked : boolean; 
    CombinedCurrentLevel : number; // Int32, nullable
    CurrentLevel : number; // Int32, nullable
    CurrentPrestigeLevel : number; // Int32, nullable
  }
  
  export class SocialGetUserProfile extends EVA.Core.RequestMessageGeneric<EVA.Babylon.SocialGetUserProfileResponse> {
    UserID : number; // Int32
    __response : EVA.Babylon.SocialGetUserProfileResponse;
  }
  
  export class SocialGetUserProfileResponse extends EVA.Core.ResponseMessage {
    Profile : EVA.Babylon.SocialUserProfile; 
  }
  
  export class SocialUserProfile {
    UserID : number; // Int32
    Name : string; 
    FirstName : string; 
    LastName : string; 
    Gender : string; 
    Nickname : string; 
    DateOfBirth : string; // DateTime, nullable
    Collections : number; // Int32
    Followers : number; // Int32
    Following : number; // Int32
    Biography : string; 
    AvatarID : string; 
    CoverPhotoID : string; 
    ThingsLiked : number; // Int32
    Views : number; // Int32
    ProductCreationsCount : number; // Int32
    AlreadyFollowing : boolean; 
    AlreadyBlocked : boolean; 
    CanEditProfile : boolean; 
    Likes : number; // Int32
    CombinedCurrentLevel : number; // Int32, nullable
    CurrentLevel : number; // Int32, nullable
    CurrentPrestigeLevel : number; // Int32, nullable
  }
  
  export class SocialGetUserProfileByNickname extends EVA.Core.RequestMessageGeneric<EVA.Babylon.SocialGetUserProfileResponse> {
    Nickname : string; 
    __response : EVA.Babylon.SocialGetUserProfileResponse;
  }
  
  export class SocialUpdateUserProfile extends EVA.Core.RequestMessageWithEmptyResponse {
    Profile : EVA.Babylon.SocialUpdateUserProfileModel; 
    __response : EVA.Core.EmptyResponseMessage;
  }
  
  export class SocialUpdateUserProfileModel {
    Biography : string; 
    Avatar : string; 
    CoverPhoto : string; 
    DateOfBirth : string; // DateTime, nullable
    FirstName : string; 
    LastName : string; 
    Gender : string; 
    Nickname : string; 
  }
  
  export class SocialUnlikeProduct extends EVA.Core.RequestMessageWithEmptyResponse {
    ProductID : number; // Int32
    __response : EVA.Core.EmptyResponseMessage;
  }
  
  export class SocialUnlikeFashionCollection extends EVA.Core.RequestMessageWithEmptyResponse {
    CollectionID : number; // Int32
    __response : EVA.Core.EmptyResponseMessage;
  }
  
  export class SocialUnlikeUser extends EVA.Core.RequestMessageWithEmptyResponse {
    UserID : number; // Int32
    __response : EVA.Core.EmptyResponseMessage;
  }
  
  export class SocialUnlikeFashionUserMedia extends EVA.Core.RequestMessageWithEmptyResponse {
    UserMediaID : number; // Int32
    __response : EVA.Core.EmptyResponseMessage;
  }
  
  export class SocialUnlikeComment extends EVA.Core.RequestMessageWithEmptyResponse {
    CommentID : string; 
    __response : EVA.Core.EmptyResponseMessage;
  }
  
  export class SocialUnfollowUser extends EVA.Core.RequestMessageWithEmptyResponse {
    UserID : number; // Int32
    __response : EVA.Core.EmptyResponseMessage;
  }
  
  export class SocialFollowUser extends EVA.Core.RequestMessageWithEmptyResponse {
    UserID : number; // Int32
    __response : EVA.Core.EmptyResponseMessage;
  }
  
  export class SocialIsFollowing extends EVA.Core.RequestMessageGeneric<EVA.Babylon.SocialIsFollowingResponse> {
    UserID : number; // Int32
    __response : EVA.Babylon.SocialIsFollowingResponse;
  }
  
  export class SocialIsFollowingResponse extends EVA.Core.ResponseMessage {
    IsFollowing : boolean; 
  }
  
  export class SocialIsFollowingUsers extends EVA.Core.RequestMessageGeneric<EVA.Babylon.SocialIsFollowingUsersResponse> {
    UserIDs : number[]; 
    __response : EVA.Babylon.SocialIsFollowingUsersResponse;
  }
  
  export class SocialIsFollowingUsersResponse extends EVA.Core.ResponseMessage {
    Results : EVA.Babylon.IsFollowingUserResult[]; 
  }
  
  export class IsFollowingUserResult {
    UserID : number; // Int32
    IsFollowing : boolean; 
    IsBlocked : boolean; 
  }
  
  export class SocialLikeProduct extends EVA.Core.RequestMessageWithEmptyResponse {
    ProductID : number; // Int32
    __response : EVA.Core.EmptyResponseMessage;
  }
  
  export class SocialLikeFashionCollection extends EVA.Core.RequestMessageWithEmptyResponse {
    CollectionID : number; // Int32
    __response : EVA.Core.EmptyResponseMessage;
  }
  
  export class SocialLikeUser extends EVA.Core.RequestMessageWithEmptyResponse {
    UserID : number; // Int32
    __response : EVA.Core.EmptyResponseMessage;
  }
  
  export class SocialLikeFashionUserMedia extends EVA.Core.RequestMessageWithEmptyResponse {
    UserMediaID : number; // Int32
    __response : EVA.Core.EmptyResponseMessage;
  }
  
  export class SocialLikeComment extends EVA.Core.RequestMessageWithEmptyResponse {
    CommentID : string; 
    __response : EVA.Core.EmptyResponseMessage;
  }
  
  export class CoverSheetProductsSearch extends EVA.Core.RequestMessageGeneric<EVA.Babylon.CoverSheetProductsSearchResponse> {
    Query : string; 
    PageSize : number; // Int32, nullable
    LikedProductsPage : number; // Int32, nullable
    CreatedProductsPage : number; // Int32, nullable
    __response : EVA.Babylon.CoverSheetProductsSearchResponse;
  }
  
  export class CoverSheetProductsSearchResponse extends EVA.Core.ResponseMessage {
    CreatedProducts : EVA.Babylon.CreatedProductsForCoverSheet; 
    LikedProducts : EVA.Babylon.LikedProductsForCoverSheet; 
    PageSize : number; // Int32
  }
  
  export class CreatedProductsForCoverSheet {
    Products : any[]; 
    Total : number; // Int64
    CreatedProductsPage : number; // Int32, nullable
  }
  
  export class LikedProductsForCoverSheet {
    Products : any[]; 
    Total : number; // Int64
    LikedProductsPage : number; // Int32, nullable
  }
  
  export class QuickSearchFashionItems extends EVA.Core.RequestMessageGeneric<EVA.Babylon.QuickSearchFashionItemsResponse> {
    FashionCollectionSize : number; // Int32, nullable
    ProductSize : number; // Int32, nullable
    ActorSize : number; // Int32, nullable
    Query : string; 
    OnlyAutocompleteProducts : boolean; 
    __response : EVA.Babylon.QuickSearchFashionItemsResponse;
  }
  
  export class QuickSearchFashionItemsResponse extends EVA.Core.ResponseMessage {
    FashionCollectionResults : EVA.Babylon.FashionCollectionSearchResultset; 
    ProductResults : EVA.Babylon.FashionProductSearchResultset; 
    ActorResults : EVA.Babylon.ActorSearchResultset; 
    ProductAutocompleteSuggestions : EVA.Core.SuggestionModel[]; 
  }
  
  export class FashionCollectionSearchResultset {
    Collections : EVA.Babylon.FashionCollectionSearchResult[]; 
    Page : number; // Int32
    PageSize : number; // Int32
    Total : number; // Int64
  }
  
  export class FashionCollectionSearchResult {
    ID : number; // Int32
    Name : string; 
    Description : string; 
    User : EVA.Babylon.FashionCollectionSearchResultCreator; 
    Supplier : EVA.Babylon.FashionCollectionSearchResultCreator; 
    TopProducts : EVA.Babylon.FashionCollectionSearchResultTopProduct[]; 
    CoverSheetBlobID : string; 
    SocialStats : EVA.Babylon.SocialStats; 
  }
  
  export class FashionCollectionSearchResultCreator {
    ID : number; // Int32
    Name : string; 
  }
  
  export class FashionCollectionSearchResultTopProduct {
    ProductID : number; // Int32
    DisplayValue : string; 
  }
  
  export class FashionProductSearchResultset {
    Products : any[]; 
  }
  
  export class ActorSearchResultset {
    Actors : EVA.Babylon.ActorSearchResult[]; 
    Page : number; // Int32
    PageSize : number; // Int32
    Total : number; // Int64
  }
  
  export class ActorSearchResult {
    ID : number; // Int32
    FirstName : string; 
    Nickname : string; 
    SupplierName : string; 
    Type : EVA.Babylon.ActorTypes; 
    AlreadyFollowing : boolean; 
    AlreadyBlocked : boolean; 
    CombinedCurrentLevel : number; // Int32, nullable
    CurrentLevel : number; // Int32, nullable
    CurrentPrestigeLevel : number; // Int32, nullable
  }
  
  export enum ActorTypes {
    User = 0,
    Supplier = 1,
  }
  
  export class SearchFashionProducts extends EVA.Core.Services.SearchProducts {
    __response : EVA.Core.Services.SearchProductsResponse;
  }
  
  export class SocialUserSearch extends EVA.Core.RequestMessageGeneric<EVA.Babylon.SocialUserSearchResponse> {
    Page : number; // Int32, nullable
    PageSize : number; // Int32, nullable
    Query : string; 
    __response : EVA.Babylon.SocialUserSearchResponse;
  }
  
  export class SocialUserSearchResponse extends EVA.Core.ResponseMessage {
    Results : EVA.Babylon.ActorSearchResultset; 
  }
  
  export class SocialSearchFriends extends EVA.Core.RequestMessageGeneric<EVA.Babylon.SocialSearchFriendsResponse> {
    Page : number; // Int32, nullable
    PageSize : number; // Int32, nullable
    Query : string; 
    __response : EVA.Babylon.SocialSearchFriendsResponse;
  }
  
  export class SocialSearchFriendsResponse extends EVA.Core.ResponseMessage {
    Results : EVA.Babylon.ActorSearchResultset; 
  }
  
  export class BabylonPushNotificationTest extends EVA.Core.RequestMessageWithEmptyResponse {
    UserID : number; // Int32
    Title : string; 
    Body : string; 
    Data : any; 
    __response : EVA.Core.EmptyResponseMessage;
  }
  
  export class BabylonSendPushNotificationBatch extends EVA.Core.RequestMessageWithEmptyResponse {
    Title : string; 
    Message : string; 
    UserIDs : number[]; 
    Payload : any; 
    __response : EVA.Core.EmptyResponseMessage;
  }
  
  export class GetProductImagesForCoverSheet extends EVA.Core.RequestMessageGeneric<EVA.Babylon.GetProductImagesForCoverSheetResponse> {
    ProductID : number; // Int32
    __response : EVA.Babylon.GetProductImagesForCoverSheetResponse;
  }
  
  export class GetProductImagesForCoverSheetResponse extends EVA.Core.ResponseMessage {
    Images : EVA.Babylon.ProductCoverSheetImage[]; 
  }
  
  export class ProductCoverSheetImage {
    BlobID : string; 
    IsTransparent : boolean; 
    Name : string; 
    Sequence : number; // Int32
    Type : string; 
  }
  
  export class GetBabylonCsvImportTemplate extends EVA.Core.RequestMessageGeneric<EVA.Babylon.GetBabylonCsvImportTemplateResponse> {
    __response : EVA.Babylon.GetBabylonCsvImportTemplateResponse;
  }
  
  export class GetBabylonCsvImportTemplateResponse extends EVA.Core.ResponseMessage {
    Url : string; 
  }
  
  export class GetCsvImportStatus extends EVA.Core.RequestMessageGeneric<EVA.Babylon.GetCsvImportStatusResponse> {
    StatusID : string; 
    __response : EVA.Babylon.GetCsvImportStatusResponse;
  }
  
  export class GetCsvImportStatusResponse extends EVA.Core.ResponseMessage {
    StatusLabel : string; 
    RevisionID : number; // Int32
  }
  
  export class GetFashionProductCreator extends EVA.Core.RequestMessageGeneric<EVA.Babylon.GetFashionProductCreatorResponse> {
    ProductID : number; // Int32
    __response : EVA.Babylon.GetFashionProductCreatorResponse;
  }
  
  export class GetFashionProductCreatorResponse extends EVA.Core.ResponseMessage {
    UserID : number; // Int32, nullable
    UserName : string; 
    FirstName : string; 
    Nickname : string; 
    CreationTime : string; // DateTime
    AlreadyFollowing : boolean; 
    AlreadyBlocked : boolean; 
    Type : EVA.Babylon.ProductCreatorTypes; 
    CombinedCurrentLevel : number; // Int32, nullable
    CurrentLevel : number; // Int32, nullable
    CurrentPrestigeLevel : number; // Int32, nullable
  }
  
  export enum ProductCreatorTypes {
    User = 1,
    Supplier = 2,
  }
  
  export class ImportProductsFromCsv extends EVA.Core.RequestMessageGeneric<EVA.Babylon.ImportProductsFromCsvResponse> {
    Data : number[]; 
    SupplierID : number; // Int32, nullable
    __response : EVA.Babylon.ImportProductsFromCsvResponse;
  }
  
  export class ImportProductsFromCsvResponse extends EVA.Core.ResponseMessage {
    Errors : EVA.Babylon.ImportProductsFromCsvError[]; 
    StatusID : string; 
  }
  
  export class ImportProductsFromCsvError {
    Row : number; // Int32
    Message : string; 
  }
  
  export class GetFashionProductCategories extends EVA.Core.RequestMessageGeneric<EVA.Babylon.GetFashionProductCategoriesResponse> {
    __response : EVA.Babylon.GetFashionProductCategoriesResponse;
  }
  
  export class GetFashionProductCategoriesResponse extends EVA.Core.ResponseMessage {
    Categories : EVA.Babylon.FashionProductCategoryDto[]; 
  }
  
  export class FashionProductCategoryDto {
    ID : number; // Int32
    ParentID : number; // Int32, nullable
    CategoryProductID : number; // Int32, nullable
    Key : string; 
    Level : number; // Int32
    Sequence : number; // Int32
    Name : string; 
    ProductCount : number; // Int64
    SubCategories : EVA.Babylon.FashionProductCategoryDto[]; 
  }
  
  export class ListBabylonStock extends EVA.Core.RequestMessageGeneric<EVA.Babylon.ListBabylonStockResponse> {
    ProductID : number; // Int32, nullable
    BackendID : string; 
    CustomID : string; 
    Query : string; 
    PageSize : number; // Int32, nullable
    Page : number; // Int32, nullable
    __response : EVA.Babylon.ListBabylonStockResponse;
  }
  
  export class ListBabylonStockResponse extends EVA.Core.ResponseMessage {
    Result : EVA.Babylon.ListBabylonStockResponseModel[]; 
    Page : number; // Int32
    PageSize : number; // Int32
    Total : number; // Int64
  }
  
  export class ListBabylonStockResponseModel {
    ProductID : number; // Int32
    BackendID : string; 
    CustomID : string; 
    DisplayName : string; 
    Size : string; 
    PrimaryColor : string; 
    UnitCost : number; // Decimal
    UnitPriceInTax : number; // Decimal
    QuantityOnHand : number; // Int32
  }
  
  export class ListInvalidProducts extends EVA.Core.RequestMessageGeneric<EVA.Babylon.ListInvalidProductsResponse> {
    Page : number; // Int32
    PageSize : number; // Int32, nullable
    __response : EVA.Babylon.ListInvalidProductsResponse;
  }
  
  export class ListInvalidProductsResponse extends EVA.Core.ResponseMessage {
    ProductIDs : number[]; 
    Page : number; // Int32
    PageSize : number; // Int32
    Total : number; // Int64
  }
  
  export class ListRecentlyViewedProducts extends EVA.Core.PagedResultRequest<EVA.Babylon.ListRecentlyViewedProductsResponse> {
    __response : EVA.Babylon.ListRecentlyViewedProductsResponse;
  }
  
  export class ListRecentlyViewedProductsResponse extends EVA.Core.PagedResultResponse<EVA.Babylon.RecentlyViewedProduct> {
  }
  
  export class RecentlyViewedProduct {
    Product : any; 
    ProductID : number; // Int32
    SocialStats : EVA.Babylon.SocialStats; 
  }
  
  export class UpdateBabylonStock extends EVA.Core.RequestMessageGeneric<EVA.Core.EmptyResponseMessage> {
    ProductID : number; // Int32
    QuantityAvailable : number; // Int32
    __response : EVA.Core.EmptyResponseMessage;
  }
  
  export class CreateFashionBrand extends EVA.Core.RequestMessageGeneric<EVA.Babylon.CreateFashionBrandResponse> {
    Name : string; 
    __response : EVA.Babylon.CreateFashionBrandResponse;
  }
  
  export class CreateFashionBrandResponse extends EVA.Core.ResponseMessage {
    BrandID : number; // Int32
  }
  
  export class CreateFashionProduct extends EVA.Core.RequestMessageGeneric<EVA.Babylon.CreateFashionProductResponse> {
    Name : string; 
    ShortDescription : string; 
    LongDescription : string; 
    UnitPriceInTax : number; // Decimal, nullable
    Brand : string; 
    Images : string[]; 
    ExternalLink : string; 
    Tags : string[]; 
    DominantColors : string[]; 
    __response : EVA.Babylon.CreateFashionProductResponse;
  }
  
  export class CreateFashionProductResponse extends EVA.Core.ResponseMessage {
    ProductID : number; // Int32
  }
  
  export class UpdateFashionProduct extends EVA.Core.RequestMessageWithEmptyResponse {
    ProductID : number; // Int32
    Name : string; 
    ShortDescription : string; 
    LongDescription : string; 
    UnitPriceInTax : number; // Decimal, nullable
    Brand : string; 
    Images : string[]; 
    ExternalLink : string; 
    Tags : string[]; 
    DominantColors : string[]; 
    __response : EVA.Core.EmptyResponseMessage;
  }
  
  export class DeleteFashionProduct extends EVA.Core.RequestMessageWithEmptyResponse {
    ProductID : number; // Int32
    __response : EVA.Core.EmptyResponseMessage;
  }
  
  export class GetFashionSupplierDataForOrder extends EVA.Core.RequestMessageGeneric<EVA.Babylon.GetFashionSupplierDataForOrderResponse> {
    OrderID : number; // Int32
    __response : EVA.Babylon.GetFashionSupplierDataForOrderResponse;
  }
  
  export class GetFashionSupplierDataForOrderResponse extends EVA.Core.ResponseMessage {
    SupplierData : EVA.Babylon.FashionSupplierDataDto[]; 
  }
  
  export class SetFashionCollectionOriginForOrderLine extends EVA.Core.RequestMessageWithEmptyResponse {
    OrderLineID : number; // Int32
    CollectionID : number; // Int32
    __response : EVA.Core.EmptyResponseMessage;
  }
  
  export class FashionPredictClothingColor extends EVA.Core.RequestMessageGeneric<EVA.Babylon.FashionPredictClothingColorResponse> {
    BlobID : string; 
    __response : EVA.Babylon.FashionPredictClothingColorResponse;
  }
  
  export class FashionPredictClothingColorResponse extends EVA.Core.ResponseMessage {
    Predictions : EVA.Babylon.ColorPrediction[]; 
  }
  
  export class ColorPrediction {
    Name : string; 
    Score : number; // Double
  }
  
  export enum TrendingFeedTypes {
    All = 0,
    Products = 1,
    Collections = 2,
  }
  
  export enum FeedTypes {
    Timeline = 0,
    Collections = 1,
    Discovery = 2,
    TrendingCollections = 3,
    Social = 4,
  }
  
  export class GetNotificationFeed extends EVA.Core.RequestMessageGeneric<EVA.Babylon.GetNotificationFeedResponse> {
    OffsetID : string; 
    Limit : number; // Int32, nullable
    __response : EVA.Babylon.GetNotificationFeedResponse;
  }
  
  export class GetNotificationFeedResponse extends EVA.Core.ResponseMessage {
    FeedItems : EVA.Babylon.FeedItem[]; 
    OffsetID : string; 
    UnseenCount : number; // Int32
  }
  
  export class FeedItem {
    ID : string; 
    Verb : string; 
    Object : EVA.Babylon.FeedItemObject; 
    Actor : EVA.Babylon.FeedItemActor; 
    Time : string; // DateTime, nullable
    Target : EVA.Babylon.FeedItemObject; 
    SocialStats : EVA.Babylon.FeedItemSocialStats; 
    Activity : EVA.Babylon.Activity; 
    Data : any; 
    Aggregation : EVA.Babylon.FeedItemAggregation; 
    Score : number; // Double, nullable
  }
  
  export class FeedItemObject {
    ID : string; 
    Type : string; 
    Data : any; 
    Object : EVA.Babylon.FeedObject; 
  }
  
  export class FeedObject {
    ObjectID : string; 
    ObjectType : string; 
    Value : string; 
  }
  
  export class FeedItemSocialStats {
    Likes : number; // Int32
    Comments : number; // Int32
    AlreadyLiked : boolean; 
    AlreadyClipped : boolean; 
    Views : number; // Int32
  }
  
  export class Activity {
    Data : any; 
    Id : string; 
    Actor : string; 
    Verb : string; 
    Object : string; 
    Target : string; 
    Time : string; // DateTime, nullable
    ForeignId : string; 
    To : string[]; 
    Score : number; // Double, nullable
  }
  
  export class FeedItemAggregation {
    ActorCount : number; // Int32
    CreatedAt : string; // DateTime, nullable
    FeedItems : EVA.Babylon.FeedItem[]; 
    Group : string; 
    UpdatedAt : string; // DateTime, nullable
    Actors : EVA.Babylon.ActorActivityGroup[]; 
  }
  
  export class ActorActivityGroup {
    Actor : EVA.Babylon.FeedItemActor; 
    Verb : string; 
    Time : string; // DateTime, nullable
  }
  
  export class GetUnseenNotificationCount extends EVA.Core.RequestMessageGeneric<EVA.Babylon.GetUnseenNotificationCountResponse> {
    __response : EVA.Babylon.GetUnseenNotificationCountResponse;
  }
  
  export class GetUnseenNotificationCountResponse extends EVA.Core.ResponseMessage {
    UnseenCount : number; // Int32
  }
  
  export class GetSocialFeed extends EVA.Core.RequestMessageGeneric<EVA.Babylon.GetSocialFeedResponse> {
    OffsetID : string; 
    Limit : number; // Int32, nullable
    __response : EVA.Babylon.GetSocialFeedResponse;
  }
  
  export class GetSocialFeedResponse extends EVA.Core.ResponseMessage {
    FeedItems : EVA.Babylon.FeedItem[]; 
    OffsetID : string; 
  }
  
  export class GetTrendingFeed extends EVA.Core.RequestMessageGeneric<EVA.Babylon.GetTrendingFeedResponse> {
    ScoreOffset : number; // Double, nullable
    Limit : number; // Int32, nullable
    Type : EVA.Babylon.TrendingFeedTypes; 
    __response : EVA.Babylon.GetTrendingFeedResponse;
  }
  
  export class GetTrendingFeedResponse extends EVA.Core.ResponseMessage {
    FeedItems : EVA.Babylon.FeedItem[]; 
    ScoreOffset : number; // Double
  }
  
  export class GetUserFeed extends EVA.Core.RequestMessageGeneric<EVA.Babylon.GetUserFeedResponse> {
    OffsetID : string; 
    Limit : number; // Int32, nullable
    FeedType : EVA.Babylon.FeedTypes; 
    __response : EVA.Babylon.GetUserFeedResponse;
  }
  
  export class GetUserFeedResponse extends EVA.Core.ResponseMessage {
    FeedItems : EVA.Babylon.FeedItem[]; 
    OffsetID : string; 
  }
  
  export enum FashionCoinsTypes {
    Silver = 0,
    Gold = 1,
  }
  
  export class ConvertFashionCoins extends EVA.Core.RequestMessageGeneric<EVA.Babylon.ConvertFashionCoinsResponse> {
    Amount : number; // Decimal
    Direction : EVA.Babylon.FashionCoinConversionDirection; 
    __response : EVA.Babylon.ConvertFashionCoinsResponse;
  }
  
  export class ConvertFashionCoinsResponse extends EVA.Core.ResponseMessage {
    ConvertedAmount : number; // Decimal
  }
  
  export enum FashionCoinConversionDirection {
    CurrencyToFashionCoins = 0,
    FashionCoinsToCurrency = 1,
  }
  
  export class GetFashionCoinTotalsForUser extends EVA.Core.RequestMessageGeneric<EVA.Babylon.GetFashionCoinTotalsForUserResponse> {
    __response : EVA.Babylon.GetFashionCoinTotalsForUserResponse;
  }
  
  export class GetFashionCoinTotalsForUserResponse extends EVA.Core.ResponseMessage {
    SilverFashionCoinsTotal : number; // Int32
    GoldFashionCoinsTotal : number; // Int32
  }
  
  export class ListFashionCoinTransactions extends EVA.Core.PagedResultRequest<EVA.Babylon.ListFashionCoinTransactionsResponse> {
    __response : EVA.Babylon.ListFashionCoinTransactionsResponse;
  }
  
  export class ListFashionCoinTransactionsResponse extends EVA.Core.PagedResultResponse<EVA.Babylon.FashionCoinTransaction> {
  }
  
  export class FashionCoinTransaction {
    CreationTime : string; // DateTime
    Amount : number; // Decimal
    Description : string; 
    Status : EVA.Core.UserCardMutationStatuses; 
    StartDate : string; // DateTime, nullable
    FashionCoinType : EVA.Babylon.FashionCoinsTypes; 
  }
  
  export class UploadFashionCoinRewards extends EVA.Core.RequestMessageWithEmptyResponse {
    Data : number[]; 
    __response : EVA.Core.EmptyResponseMessage;
  }
  
  export class GetActiveFashionEvent extends EVA.Core.RequestMessageGeneric<EVA.Babylon.GetActiveFashionEventResponse> {
    __response : EVA.Babylon.GetActiveFashionEventResponse;
  }
  
  export class GetActiveFashionEventResponse extends EVA.Core.ResponseMessage {
    ActiveEvent : EVA.Babylon.FashionEventDto; 
  }
  
  export class FashionEventDto {
    ID : number; // Int32
    Name : string; 
    Description : string; 
  }
  
  export class GetBarcodeDataForFashionEvent extends EVA.Core.RequestMessageGeneric<EVA.Babylon.GetBarcodeDataForFashionEventResponse> {
    __response : EVA.Babylon.GetBarcodeDataForFashionEventResponse;
  }
  
  export class GetBarcodeDataForFashionEventResponse extends EVA.Core.ResponseMessage {
    Data : string; 
  }
  
  export class ScanBarcodeForFashionEvent extends EVA.Core.RequestMessageGeneric<EVA.Babylon.ScanBarcodeForFashionEventResponse> {
    Data : string; 
    __response : EVA.Babylon.ScanBarcodeForFashionEventResponse;
  }
  
  export class ScanBarcodeForFashionEventResponse extends EVA.Core.ResponseMessage {
    Success : boolean; 
  }
  
  export class ExtractUrlInformation extends EVA.Core.RequestMessageGeneric<EVA.Babylon.ExtractUrlInformationResponse> {
    Url : string; 
    __response : EVA.Babylon.ExtractUrlInformationResponse;
  }
  
  export class ExtractUrlInformationResponse extends EVA.Core.ResponseMessage {
    Success : boolean; 
    Data : EVA.Babylon.ExtractedUrlInformation; 
  }
  
  export class ExtractedUrlInformation {
    Description : string; 
    Title : string; 
    Safe : boolean; 
    Images : EVA.Babylon.ExtractedUrlInformationImage[]; 
    Keywords : EVA.Babylon.ExtractedUrlInformationKeyword[]; 
  }
  
  export class ExtractedUrlInformationImage {
    Caption : string; 
    Url : string; 
    Height : number; // Int32
    Width : number; // Int32
  }
  
  export class ExtractedUrlInformationKeyword {
    Name : string; 
  }
  
  export class GetCoverSheetEditorCapabilities extends EVA.Core.RequestMessageGeneric<EVA.Babylon.GetCoverSheetEditorCapabilitiesResponse> {
    __response : EVA.Babylon.GetCoverSheetEditorCapabilitiesResponse;
  }
  
  export class GetCoverSheetEditorCapabilitiesResponse extends EVA.Core.ResponseMessage {
    Capabilities : EVA.Babylon.CoverSheetCapability[]; 
  }
  
  export class CoverSheetCapability {
    Name : string; 
    Description : string; 
    Capability : string; 
    BlobID : string; 
    IsAvailable : boolean; 
    RequiredLevel : number; // Int32, nullable
  }
  
  export class GetFashionCollectionCoverSheet extends EVA.Core.RequestMessageGeneric<EVA.Babylon.GetFashionCollectionCoverSheetResponse> {
    CollectionID : number; // Int32
    __response : EVA.Babylon.GetFashionCollectionCoverSheetResponse;
  }
  
  export class GetFashionCollectionCoverSheetResponse extends EVA.Core.ResponseMessage {
    CoverSheet : EVA.Babylon.CoverSheetDocument; 
  }
  
  export class CoverSheetDocument {
    Items : EVA.Babylon.CoverSheetItem[]; 
    BackgroundBlobID : string; 
  }
  
  export class CoverSheetItem {
    IsActive : boolean; 
    Left : number; // Double, nullable
    Top : number; // Double, nullable
    ScaleX : number; // Double, nullable
    ScaleY : number; // Double, nullable
    Width : number; // Double, nullable
    Height : number; // Double, nullable
    RotationAngle : number; // Double, nullable
    BlobID : string; 
    ProductID : number; // Int32, nullable
    Type : string; 
    Text : string; 
  }
  
  export class GetImageCutoutSuggestions extends EVA.Core.RequestMessageGeneric<EVA.Babylon.GetImageCutoutSuggestionsResponse> {
    BlobID : string; 
    __response : EVA.Babylon.GetImageCutoutSuggestionsResponse;
  }
  
  export class GetImageCutoutSuggestionsResponse extends EVA.Core.ResponseMessage {
    Suggestions : EVA.Babylon.ImageCutoutSuggestion[]; 
  }
  
  export class ImageCutoutSuggestion {
    BlobID : string; 
    ExpiresOn : string; // DateTime
  }
  
  export class SaveFashionCollectionCoverSheet extends EVA.Core.RequestMessageWithEmptyResponse {
    CollectionID : number; // Int32
    CoverSheet : EVA.Babylon.CoverSheetDocument; 
    __response : EVA.Core.EmptyResponseMessage;
  }
  
  export enum FashionCollectionSearchModelSortOptions {
    Newest = 0,
    Popular = 1,
  }
  
  export class GetActiveFashionCollectionContests extends EVA.Core.RequestMessageGeneric<EVA.Babylon.GetActiveFashionCollectionContestsResponse> {
    __response : EVA.Babylon.GetActiveFashionCollectionContestsResponse;
  }
  
  export class GetActiveFashionCollectionContestsResponse extends EVA.Core.ResponseMessage {
    Contests : EVA.Babylon.FashionCollectionContestDto[]; 
  }
  
  export class FashionCollectionContestDto {
    Name : string; 
    Description : string; 
    StartDate : string; // DateTime
    EndDate : string; // DateTime
    WinningUserID : number; // Int32, nullable
    ImageBlobID : string; 
    ID : number; // Int32
  }
  
  export class GetFashionCoinEarningsForCollections extends EVA.Core.RequestMessageGeneric<EVA.Babylon.GetFashionCoinEarningsForCollectionsResponse> {
    __response : EVA.Babylon.GetFashionCoinEarningsForCollectionsResponse;
  }
  
  export class GetFashionCoinEarningsForCollectionsResponse extends EVA.Core.ResponseMessage {
    Result : EVA.Babylon.FashionCollectionSummaryWithEarnings[]; 
  }
  
  export class FashionCollectionSummaryWithEarnings {
    ID : number; // Int32
    ContestID : number; // Int32, nullable
    Name : string; 
    Description : string; 
    TopProductIDs : number[]; 
    CoverSheetBlobID : string; 
    PreviewCoverSheetBlobID : string; 
    CreationTime : string; // DateTime
    ProductCount : number; // Int32
    FashionCoinsEarned : number; // Int32
    SocialStats : EVA.Babylon.SocialStats; 
  }
  
  export class GetFashionCollectionStatsOverTime extends EVA.Core.RequestMessageGeneric<EVA.Babylon.GetFashionCollectionStatsOverTimeResponse> {
    CollectionID : number; // Int32
    Granularity : EVA.Babylon.CollectionStatsGranularity; 
    __response : EVA.Babylon.GetFashionCollectionStatsOverTimeResponse;
  }
  
  export class GetFashionCollectionStatsOverTimeResponse extends EVA.Core.ResponseMessage {
    Stats : EVA.Babylon.CollectionStatsItem[]; 
  }
  
  export class CollectionStatsItem {
    DateTime : string; // DateTime
    Likes : number; // Int32
  }
  
  export enum CollectionStatsGranularity {
    Hour = 0,
    Day = 1,
    Week = 2,
  }
  
  export class GetTopFashionCollections extends EVA.Core.RequestMessageGeneric<EVA.Babylon.GetTopFashionCollectionsResponse> {
    TopCount : number; // Int32
    UserID : number; // Int32, nullable
    CreationTime : string; // DateTime, nullable
    __response : EVA.Babylon.GetTopFashionCollectionsResponse;
  }
  
  export class GetTopFashionCollectionsResponse extends EVA.Core.ResponseMessage {
    Result : EVA.Babylon.FashionCollectionSummary[]; 
  }
  
  export class FashionCollectionSummary {
    ID : number; // Int32
    ContestID : number; // Int32, nullable
    Name : string; 
    Description : string; 
    TopProductIDs : number[]; 
    CoverSheetBlobID : string; 
    PreviewCoverSheetBlobID : string; 
    User : EVA.Babylon.FashionCollectionSummaryCreator; 
    SocialStats : EVA.Babylon.SocialStats; 
    CreationTime : string; // DateTime
    ProductCount : number; // Int32
    Tags : string[]; 
  }
  
  export class FashionCollectionSummaryCreator {
    ID : number; // Int32
    Name : string; 
    FirstName : string; 
    Nickname : string; 
    CombinedCurrentLevel : number; // Int32, nullable
    CurrentLevel : number; // Int32, nullable
    CurrentPrestigeLevel : number; // Int32, nullable
  }
  
  export class ListFashionCollectionContests extends EVA.Core.PagedResultRequest<EVA.Babylon.ListFashionCollectionContestsResponse> {
    __response : EVA.Babylon.ListFashionCollectionContestsResponse;
  }
  
  export class ListFashionCollectionContestsResponse extends EVA.Core.PagedResultResponse<EVA.Babylon.FashionCollectionContestDto> {
  }
  
  export class ListFashionCollectionsForContest extends EVA.Core.PagedResultRequest<EVA.Babylon.ListFashionCollectionsForContestResponse> {
    ContestID : number; // Int32
    __response : EVA.Babylon.ListFashionCollectionsForContestResponse;
  }
  
  export class ListFashionCollectionsForContestResponse extends EVA.Core.PagedResultResponse<EVA.Babylon.FashionCollectionSummary> {
  }
  
  export class ListTrendingFashionCollections extends EVA.Core.RequestMessageGeneric<EVA.Babylon.ListTrendingFashionCollectionsResponse> {
    PageConfig : EVA.Core.PageConfig; 
    __response : EVA.Babylon.ListTrendingFashionCollectionsResponse;
  }
  
  export class ListTrendingFashionCollectionsResponse extends EVA.Core.PagedResultResponse<EVA.Babylon.FashionCollectionSummary> {
  }
  
  export class ListProductsForCollection extends EVA.Core.PagedResultRequest<EVA.Babylon.ListProductsForCollectionResponse> {
    CollectionID : number; // Int32
    __response : EVA.Babylon.ListProductsForCollectionResponse;
  }
  
  export class ListProductsForCollectionResponse extends EVA.Core.PagedResultResponse<EVA.Babylon.FashionCollectionProductDetails> {
  }
  
  export class FashionCollectionProductDetails {
    Product : any; 
    ProductID : number; // Int32
    SocialStats : EVA.Babylon.SocialStats; 
  }
  
  export class SearchFashionCollections extends EVA.Core.RequestMessageGeneric<EVA.Babylon.SearchFashionCollectionsResponse> {
    Query : string; 
    PageSize : number; // Int32, nullable
    Page : number; // Int32, nullable
    SupplierName : string; 
    SortOptions : EVA.Babylon.FashionCollectionSearchModelSortOptions; 
    __response : EVA.Babylon.SearchFashionCollectionsResponse;
  }
  
  export class SearchFashionCollectionsResponse extends EVA.Core.ResponseMessage {
    Page : number; // Int32
    PageSize : number; // Int32
    Total : number; // Int64
    Collections : EVA.Babylon.FashionCollectionSearchResult[]; 
  }
  
  export class CreateFashionCollection extends EVA.Core.RequestMessageGeneric<EVA.Babylon.CreateFashionCollectionResponse> {
    Collection : EVA.Babylon.CreateFashionCollectionRequestModel; 
    __response : EVA.Babylon.CreateFashionCollectionResponse;
  }
  
  export class CreateFashionCollectionResponse extends EVA.Core.ResponseMessage {
    ID : number; // Int32
  }
  
  export class CreateFashionCollectionRequestModel {
    Description : string; 
    Name : string; 
    ProductIDs : number[]; 
    Tags : string[]; 
    ContestID : number; // Int32, nullable
    TargetAudience : string; 
  }
  
  export class GetFashionCollectionDetailsByID extends EVA.Core.RequestMessageGeneric<EVA.Babylon.GetFashionCollectionDetailsByIdResponse> {
    CollectionID : number; // Int32
    __response : EVA.Babylon.GetFashionCollectionDetailsByIdResponse;
  }
  
  export class GetFashionCollectionDetailsByIdResponse extends EVA.Core.ResponseMessage {
    Collection : EVA.Babylon.FashionCollectionDetail; 
  }
  
  export class FashionCollectionDetail {
    ID : number; // Int32
    ContestID : number; // Int32, nullable
    Name : string; 
    Description : string; 
    TopProductIDs : number[]; 
    CoverSheetBlobID : string; 
    PreviewCoverSheetBlobID : string; 
    User : EVA.Babylon.FashionCollectionDetailCreator; 
    Supplier : EVA.Babylon.FashionCollectionDetailCreator; 
    SocialStats : EVA.Babylon.SocialStats; 
    CreationTime : string; // DateTime
    ProductCount : number; // Int32
    Tags : string[]; 
  }
  
  export class FashionCollectionDetailCreator {
    ID : number; // Int32
    Name : string; 
    FirstName : string; 
    Nickname : string; 
    AlreadyFollowing : boolean; 
    CombinedCurrentLevel : number; // Int32, nullable
    CurrentLevel : number; // Int32, nullable
    CurrentPrestigeLevel : number; // Int32, nullable
  }
  
  export class AddProductsToFashionCollection extends EVA.Core.RequestMessageWithEmptyResponse {
    CollectionID : number; // Int32
    ProductIDs : number[]; 
    __response : EVA.Core.EmptyResponseMessage;
  }
  
  export class DeleteProductFromFashionCollection extends EVA.Core.RequestMessageWithEmptyResponse {
    CollectionID : number; // Int32
    ProductID : number; // Int32
    __response : EVA.Core.EmptyResponseMessage;
  }
  
  export class DeleteFashionCollection extends EVA.Core.RequestMessageWithEmptyResponse {
    CollectionID : number; // Int32
    __response : EVA.Core.EmptyResponseMessage;
  }
  
  export class ListFashionCollectionsForUser extends EVA.Core.RequestMessageGeneric<EVA.Babylon.ListFashionCollectionsForUserResponse> {
    PageConfig : EVA.Core.PageConfig; 
    UserID : number; // Int32
    FilterCoverSheetExists : boolean; 
    __response : EVA.Babylon.ListFashionCollectionsForUserResponse;
  }
  
  export class ListFashionCollectionsForUserResponse extends EVA.Core.PagedResultResponse<EVA.Babylon.FashionCollectionSummary> {
  }
  
  export class ListFashionCollectionsForProduct extends EVA.Core.RequestMessageGeneric<EVA.Babylon.ListFashionCollectionsForProductResponse> {
    PageConfig : EVA.Core.PageConfig; 
    ProductID : number; // Int32
    UserID : number; // Int32, nullable
    __response : EVA.Babylon.ListFashionCollectionsForProductResponse;
  }
  
  export class ListFashionCollectionsForProductResponse extends EVA.Core.PagedResultResponse<EVA.Babylon.FashionCollectionSummary> {
  }
  
  export class UpdateFashionCollection extends EVA.Core.RequestMessageWithEmptyResponse {
    CollectionID : number; // Int32
    Name : string; 
    Description : string; 
    CoverSheetBlobID : string; 
    Tags : string[]; 
    PropertiesToDelete : string[]; 
    ContestID : number; // Int32, nullable
    TargetAudience : string; 
    __response : EVA.Core.EmptyResponseMessage;
  }
  
  export class GetFashionCollectionProductDetails extends EVA.Core.RequestMessageGeneric<EVA.Babylon.GetFashionCollectionProductDetailsResponse> {
    CollectionID : number; // Int32
    ProductID : number; // Int32
    __response : EVA.Babylon.GetFashionCollectionProductDetailsResponse;
  }
  
  export class GetFashionCollectionProductDetailsResponse extends EVA.Core.ResponseMessage {
    CollectionProduct : EVA.Babylon.FashionCollectionProductDetail; 
  }
  
  export class FashionCollectionProductDetail {
    CollectionID : number; // Int32
    ProductID : number; // Int32
    Sequence : number; // Int32
    CreationTime : string; // DateTime
  }
  
  export class UpdateFashionCollectionProductSequence extends EVA.Core.RequestMessageWithEmptyResponse {
    CollectionID : number; // Int32
    ProductID : number; // Int32
    Sequence : number; // Int32
    __response : EVA.Core.EmptyResponseMessage;
  }
  
  export class CountFashionCollectionsForProduct extends EVA.Core.RequestMessageGeneric<EVA.Babylon.CountFashionCollectionsForProductResponse> {
    ProductID : number; // Int32
    __response : EVA.Babylon.CountFashionCollectionsForProductResponse;
  }
  
  export class CountFashionCollectionsForProductResponse extends EVA.Core.ResponseMessage {
    CollectionCount : number; // Int32
  }
  
  export enum ChannableOrderLineTypes {
    Product = 0,
    ShippingCosts = 1,
  }
  
  export class ListOpenChannableOrdersForSupplier extends EVA.Core.PagedResultRequest<EVA.Babylon.ListOpenChannableOrdersForSupplierResponse> {
    SupplierID : number; // Int32
    __response : EVA.Babylon.ListOpenChannableOrdersForSupplierResponse;
  }
  
  export class ListOpenChannableOrdersForSupplierResponse extends EVA.Core.PagedResultResponse<EVA.Babylon.ChannableOrder> {
  }
  
  export class ChannableOrder {
    OrderID : number; // Int32
    ShippingAddress : EVA.Babylon.ChannableOrderAddress; 
    BillingAddress : EVA.Babylon.ChannableOrderAddress; 
    Customer : EVA.Babylon.ChannableOrderCustomer; 
    Lines : EVA.Babylon.ChannableOrderLine[]; 
    Payments : EVA.Babylon.ChannableOrderPayment[]; 
    Amounts : EVA.Babylon.ChannableOrderAmounts; 
  }
  
  export class ChannableOrderAddress {
    Street : string; 
    HouseNumber : string; 
    HouseNumberExtension : string; 
    CountryCode : string; 
    ZipCode : string; 
    City : string; 
    Region : string; 
  }
  
  export class ChannableOrderCustomer {
    EmailAddress : string; 
    Gender : string; 
    PhoneNumber : string; 
    FirstName : string; 
    LastName : string; 
  }
  
  export class ChannableOrderLine {
    Description : string; 
    OrderLineID : number; // Int32
    UnitPrice : number; // Decimal
    TaxRate : number; // Decimal
    UnitPriceInTax : number; // Decimal
    QuantityOrdered : number; // Int32
    EAN : string; 
    ProductID : string; 
    Type : string; 
  }
  
  export class ChannableOrderPayment {
    Currency : string; 
    PaymentMethod : string; 
    PaidAmount : number; // Decimal
  }
  
  export class ChannableOrderAmounts {
    TotalAmount : number; // Decimal
    TotalAmountInTax : number; // Decimal
    PaidAmount : number; // Decimal
    Taxes : EVA.Core.TaxAmount[]; 
  }
  
  export enum BIActivityLedgerTypes {
    None = 0,
    Like = 1,
    Follow = 2,
    View = 3,
    Comment = 4,
  }
  
}