/* tslint:disable */
declare module EVA.Blobs {
  
  export class CreateBlob extends EVA.Core.RequestMessageGeneric<EVA.Blobs.CreateBlobResponse> {
    Category : string; 
    OriginalName : string; 
    MimeType : string; 
    LifeTime : any; // TimeSpan, nullable
    __response : EVA.Blobs.CreateBlobResponse;
  }
  
  export class CreateBlobResponse extends EVA.Core.ResponseMessage {
    Guid : string; 
    Url : string; 
  }
  
  export class DeleteBlob extends EVA.Core.RequestMessageWithEmptyResponse {
    BlobID : string; 
    __response : EVA.Core.EmptyResponseMessage;
  }
  
  export class GetBlobInfo extends EVA.Core.RequestMessageGeneric<EVA.Blobs.GetBlobInfoResponse> {
    Guid : string; 
    Category : string; 
    OriginalName : string; 
    __response : EVA.Blobs.GetBlobInfoResponse;
  }
  
  export class GetBlobInfoResponse extends EVA.Core.ResponseMessage {
    Guid : string; 
    MimeType : string; 
    OriginalName : string; 
    Category : string; 
    ExpireDate : string; // DateTime, nullable
    LastModificationTimeUtc : string; // DateTime
    Size : number; // Int64
    Url : string; 
  }
  
  export class GetProductImagePlaceholder extends EVA.Core.RequestMessageGeneric<EVA.Blobs.GetPlaceholderResponse> {
    __response : EVA.Blobs.GetPlaceholderResponse;
  }
  
  export class GetPlaceholderResponse extends EVA.Core.ResponseMessage {
    Guid : string; 
    Url : string; 
  }
  
  export class GetBrandImagePlaceholder extends EVA.Core.RequestMessageGeneric<EVA.Blobs.GetPlaceholderResponse> {
    __response : EVA.Blobs.GetPlaceholderResponse;
  }
  
  export class GetApplicationImagePlaceholder extends EVA.Core.RequestMessageGeneric<EVA.Blobs.GetPlaceholderResponse> {
    __response : EVA.Blobs.GetPlaceholderResponse;
  }
  
  export class ListBlobs extends EVA.Core.PagedResultRequest<EVA.Blobs.ListBlobsResponse> {
    __response : EVA.Blobs.ListBlobsResponse;
  }
  
  export class ListBlobsResponse extends EVA.Core.PagedResultResponse<EVA.Blobs.BlobDto> {
  }
  
  export class BlobDto {
    ID : string; 
    OriginalName : string; 
    MimeType : string; 
    Category : string; 
    ExpireDate : string; // DateTime, nullable
    LocationType : string; 
    Url : string; 
  }
  
  export class ProcessDocument extends EVA.Core.RequestMessageGeneric<EVA.Blobs.ProcessDocumentResponse> {
    Data : number[]; 
    Type : string; 
    __response : EVA.Blobs.ProcessDocumentResponse;
  }
  
  export class ProcessDocumentResponse extends EVA.Core.ResponseMessage {
    ProcessedData : number[]; 
    ExtractedText : { [ key : string ] : any }; 
    Success : boolean; 
  }
  
  export class SetProductImagePlaceholder extends EVA.Core.RequestMessageGeneric<EVA.Blobs.SetPlaceholderResponse> {
    MimeType : string; 
    Data : number[]; 
    __response : EVA.Blobs.SetPlaceholderResponse;
  }
  
  export class SetPlaceholderResponse extends EVA.Core.ResponseMessage {
    Guid : string; 
    Url : string; 
  }
  
  export class SetBrandImagePlaceholder extends EVA.Core.RequestMessageGeneric<EVA.Blobs.SetPlaceholderResponse> {
    MimeType : string; 
    Data : number[]; 
    __response : EVA.Blobs.SetPlaceholderResponse;
  }
  
  export class SetApplicationImagePlaceholder extends EVA.Core.RequestMessageGeneric<EVA.Blobs.SetPlaceholderResponse> {
    MimeType : string; 
    Data : number[]; 
    __response : EVA.Blobs.SetPlaceholderResponse;
  }
  
  export class StoreBlob extends EVA.Core.RequestMessageGeneric<EVA.Blobs.StoreBlobResponse> {
    Category : string; 
    OriginalName : string; 
    MimeType : string; 
    Data : number[]; 
    LifeTime : any; // TimeSpan, nullable
    __response : EVA.Blobs.StoreBlobResponse;
  }
  
  export class StoreBlobResponse extends EVA.Core.ResponseMessage {
    Guid : string; 
    Url : string; 
  }
  
}