/* tslint:disable */
declare module EVA.BuildersAndPerformers {
  
  export class BPSendInvoice extends EVA.Core.RequestMessageWithEmptyResponse {
    Sender : string; 
    Invoicee : string; 
    InvoiceNumber : string; 
    InvoiceDate : string; // DateTime
    CurrencyCode : string; 
    Discounts : EVA.BuildersAndPerformers.BPSendInvoiceAdditionalCost[]; 
    Charges : EVA.BuildersAndPerformers.BPSendInvoiceAdditionalCost[]; 
    Lines : EVA.BuildersAndPerformers.BPSendInvoiceInvoiceLine[]; 
    Totals : EVA.Core.InvoiceTotalsModel; 
    __response : EVA.Core.EmptyResponseMessage;
  }
  
  export class BPSendInvoiceAdditionalCost {
    Amount : number; // Decimal
    IsDutyFree : boolean; 
  }
  
  export class BPSendInvoiceInvoiceLine {
    Reference : string; 
    BackendID : string; 
    DeliveredQuantity : number; // Int32
    InvoicedQuantity : number; // Int32
    UnitPrice : number; // Decimal
    TaxRate : number; // Decimal
    UnitPriceInTax : number; // Decimal
    Discounts : EVA.BuildersAndPerformers.BPSendInvoiceAdditionalCost[]; 
    Charges : EVA.BuildersAndPerformers.BPSendInvoiceAdditionalCost[]; 
  }
  
  export class BPSendOrderConfirmation extends EVA.Core.RequestMessageWithEmptyResponse {
    Sender : string; 
    Reference : string; 
    OrderDate : string; // DateTime
    CurrencyCode : string; 
    Lines : EVA.BuildersAndPerformers.BPSendOrderConfirmationOrderConfirmationLine[]; 
    __response : EVA.Core.EmptyResponseMessage;
  }
  
  export class BPSendOrderConfirmationOrderConfirmationLine {
    BackendID : string; 
    DeliveryDate : string; // DateTime
    UnitPrice : number; // Decimal
    UnitPriceInTax : number; // Decimal
    TotalAmount : number; // Decimal
    OrderedQuantity : number; // Int32
    BackOrderQuantity : number; // Int32
    CancelledQuantity : number; // Int32
    DeliveredQuantity : number; // Int32
  }
  
  export class BPSendProducts extends EVA.Core.RequestMessageWithEmptyResponse {
    Sender : string; 
    CatalogDate : string; // DateTime
    Products : EVA.BuildersAndPerformers.BPSendProductsCatalogProduct[]; 
    __response : EVA.Core.EmptyResponseMessage;
  }
  
  export class BPSendProductsCatalogProduct {
    BackendID : string; 
    Barcode : string; 
    Brand : string; 
    Description : string; 
    PurchasePrice : number; // Decimal
    CurrencyCode : string; 
  }
  
  export class BPSendShipmentConfirmation extends EVA.Core.RequestMessageWithEmptyResponse {
    Sender : string; 
    Reference : string; 
    OrderDate : string; // DateTime
    ShipmentDate : string; // DateTime
    CurrencyCode : string; 
    Carrier : EVA.BuildersAndPerformers.BPSendShipmentConfirmationOrderShipmentCarrier; 
    Shipments : EVA.BuildersAndPerformers.BPSendShipmentConfirmationOrderShipment[]; 
    __response : EVA.Core.EmptyResponseMessage;
  }
  
  export class BPSendShipmentConfirmationOrderShipmentCarrier {
    ID : string; 
    Name : string; 
  }
  
  export class BPSendShipmentConfirmationOrderShipment {
    Tracking : EVA.BuildersAndPerformers.BPSendShipmentConfirmationOrderShipmentTracking; 
    Lines : EVA.BuildersAndPerformers.BPSendShipmentConfirmationOrderShipmentLine[]; 
  }
  
  export class BPSendShipmentConfirmationOrderShipmentTracking {
    ID : string; 
    Link : string; 
  }
  
  export class BPSendShipmentConfirmationOrderShipmentLine {
    BackendID : string; 
    Barcode : string; 
    OrderedQuantity : number; // Int32
    DeliveredQuantity : number; // Int32
  }
  
  export class BPSendStockUpdate extends EVA.Core.RequestMessageWithEmptyResponse {
    Sender : string; 
    InventoryDate : string; // DateTime
    Products : EVA.BuildersAndPerformers.BPSendStockUpdateStockUpdateEntry[]; 
    __response : EVA.Core.EmptyResponseMessage;
  }
  
  export class BPSendStockUpdateStockUpdateEntry {
    BackendID : string; 
    QuantityOnHand : number; // Int32
  }
  
}