/* tslint:disable */
declare module EVA.CMS {
  
  export class GetSiteMap extends EVA.Core.RequestMessageGeneric<EVA.CMS.GetSiteMapResponse> {
    __response : EVA.CMS.GetSiteMapResponse;
  }
  
  export class GetSiteMapResponse extends EVA.Core.GetResponse<EVA.CMS.CmsSiteMapNode[]> {
    CmsEntityTypes : EVA.CMS.CmsEntityTypeDto[]; 
    CmsWidgetTypes : EVA.CMS.CmsWidgetTypeDto[]; 
  }
  
  export class CmsSiteMapNode {
    CmsPageID : number; // Int32, nullable
    Title : string; 
    IsActive : boolean; 
    Children : EVA.CMS.CmsSiteMapNode[]; 
    PageTypeID : number; // Int32
    RequestPath : string; 
  }
  
  export class CmsEntityTypeDto extends EVA.Core.EnumDtoBase {
  }
  
  export class CmsWidgetTypeDto extends EVA.Core.EnumDtoBase {
  }
  
  export class CreateCmsWidget extends EVA.Core.CreateRequest<EVA.CMS.CmsWidgetDto> implements EVA.Core.IRequestRespondsAs<EVA.Core.CreateResponse> {
    __response : EVA.Core.CreateResponse;
  }
  
  export class CmsWidgetDto {
    ID : number; // Int32
    ParentID : number; // Int32, nullable
    Parent : EVA.CMS.CmsWidgetDto; 
    CmsEntityID : number; // Int32
    CmsEntity : EVA.CMS.CmsEntityDto; 
    TypeID : number; // Int32
    Type : EVA.CMS.CmsWidgetTypeDto; 
    Identifier : string; 
    StartDate : string; // DateTime, nullable
    EndDate : string; // DateTime, nullable
    Data : string; 
    IsActive : boolean; 
    Children : EVA.CMS.CmsWidgetDto[]; 
  }
  
  export class CmsEntityDto {
    ID : number; // Int32
    Title : string; 
    BrowserTitle : string; 
    TitleOverride : boolean; 
    MetaDescription : string; 
    RequestPath : string; 
    Background : string; 
    TypeID : number; // Int32
    Type : EVA.CMS.CmsEntityTypeDto; 
    ParentID : number; // Int32, nullable
    Parent : EVA.CMS.CmsEntityDto; 
    Children : EVA.CMS.CmsEntityDto[]; 
    Views : EVA.CMS.CmsWidgetDto[]; 
    Position : number; // Int32
    IsActive : boolean; 
  }
  
  export class UpdateCmsWidget extends EVA.Core.UpdateRequest<EVA.CMS.CmsWidgetDto> implements EVA.Core.IRequestRespondsAs<EVA.Core.EmptyResponseMessage> {
    __response : EVA.Core.EmptyResponseMessage;
  }
  
  export class DeleteCmsWidget extends EVA.Core.DeleteRequest implements EVA.Core.IRequestRespondsAs<EVA.Core.EmptyResponseMessage> {
    __response : EVA.Core.EmptyResponseMessage;
  }
  
  export class GetCmsWidgetByID extends EVA.Core.GetRequestGeneric<EVA.CMS.GetCmsWidgetByIDResponse> {
    __response : EVA.CMS.GetCmsWidgetByIDResponse;
  }
  
  export class GetCmsWidgetByIDResponse extends EVA.Core.GetResponse<EVA.CMS.CmsWidgetDto> {
  }
  
  export class CreateUrlRewrite extends EVA.Core.CreateRequest<EVA.CMS.CmsUrlRewriteDto> implements EVA.Core.IRequestRespondsAs<EVA.Core.CreateResponse> {
    __response : EVA.Core.CreateResponse;
  }
  
  export class CmsUrlRewriteDto {
    ID : number; // Int32
    RequestPath : string; 
    TargetPath : string; 
    UrlRewriteType : EVA.CMS.CmsUrlRewriteTypes; 
    Description : string; 
    IsActive : boolean; 
    IsRegex : boolean; 
  }
  
  export enum CmsUrlRewriteTypes {
    MovedPermanently = 301,
    MovedTemporarily = 302,
    TemporaryRedirect = 307,
    PermanentRedirect = 308,
    Gone = 410,
    Silent = 999,
  }
  
  export class DeleteUrlRewrite extends EVA.Core.DeleteRequest implements EVA.Core.IRequestRespondsAs<EVA.Core.EmptyResponseMessage> {
    __response : EVA.Core.EmptyResponseMessage;
  }
  
  export class GetUrlRewriteByID extends EVA.Core.RequestMessageGeneric<EVA.CMS.GetUrlRewriteByIDResponse> {
    ID : number; // Int32
    __response : EVA.CMS.GetUrlRewriteByIDResponse;
  }
  
  export class GetUrlRewriteByIDResponse extends EVA.Core.ResponseMessage {
    Rewrite : EVA.CMS.CmsUrlRewriteDto; 
  }
  
  export class GetUrlRewrites extends EVA.Core.RequestMessageGeneric<EVA.CMS.GetUrlRewritesResponse> {
    __response : EVA.CMS.GetUrlRewritesResponse;
  }
  
  export class GetUrlRewritesResponse extends EVA.Core.ResponseMessage {
    Rewrites : EVA.CMS.CmsUrlRewriteDto[]; 
  }
  
  export class ListUrlRewrites extends EVA.Core.PagedResultRequest<EVA.CMS.ListUrlRewritesResponse> {
    __response : EVA.CMS.ListUrlRewritesResponse;
  }
  
  export class ListUrlRewritesResponse extends EVA.Core.PagedResultResponse<EVA.CMS.CmsUrlRewriteDto> {
  }
  
  export class RewriteUrl extends EVA.Core.RequestMessageGeneric<EVA.CMS.RewriteUrlResponse> {
    Url : string; 
    __response : EVA.CMS.RewriteUrlResponse;
  }
  
  export class RewriteUrlResponse extends EVA.Core.ResponseMessage {
    Url : string; 
  }
  
  export class UpdateUrlRewrite extends EVA.Core.UpdateRequest<EVA.CMS.CmsUrlRewriteDto> implements EVA.Core.IRequestRespondsAs<EVA.Core.EmptyResponseMessage> {
    __response : EVA.Core.EmptyResponseMessage;
  }
  
  export class GetCmsPageByRequestPath extends EVA.Core.RequestMessageGeneric<EVA.CMS.GetCmsPageByRequestPathResponse> {
    Path : string; 
    __response : EVA.CMS.GetCmsPageByRequestPathResponse;
  }
  
  export class GetCmsPageByRequestPathResponse extends EVA.Core.GetResponse<EVA.CMS.CmsPageDto> {
  }
  
  export class CmsPageDto {
    ID : number; // Int32
    Title : string; 
    BrowserTitle : string; 
    TitleOverride : boolean; 
    MetaDescription : string; 
    RequestPath : string; 
    Background : string; 
    TypeID : number; // Int32
    Type : EVA.CMS.CmsEntityTypeDto; 
    DisplayTypeID : number; // Int32
    DisplayType : EVA.CMS.CmsWidgetTypeDto; 
    ParentID : number; // Int32, nullable
    Parent : EVA.CMS.CmsPageDto; 
    Children : EVA.CMS.CmsPageDto[]; 
    Data : string; 
    DisplayData : any; 
    Widgets : EVA.CMS.CmsPageWidgetDto[]; 
    Position : number; // Int32
  }
  
  export class CmsPageWidgetDto {
    ID : number; // Int32
    ParentID : number; // Int32, nullable
    Parent : EVA.CMS.CmsPageWidgetDto; 
    Children : EVA.CMS.CmsPageWidgetDto[]; 
    TypeID : number; // Int32
    Type : EVA.CMS.CmsWidgetTypeDto; 
    Identifier : string; 
    Data : string; 
    DisplayData : any; 
  }
  
  export class GetCmsPagesByRequestPath extends EVA.Core.RequestMessageGeneric<EVA.CMS.GetCmsPagesByRequestPathResponse> {
    Path : string; 
    __response : EVA.CMS.GetCmsPagesByRequestPathResponse;
  }
  
  export class GetCmsPagesByRequestPathResponse extends EVA.Core.ResponseMessage {
    Pages : { [ key : string ] : string }; 
  }
  
  export class GetCmsPage extends EVA.Core.GetRequestGeneric<EVA.CMS.GetCmsPageResponse> {
    __response : EVA.CMS.GetCmsPageResponse;
  }
  
  export class GetCmsPageResponse extends EVA.Core.GetResponse<EVA.CMS.CmsPageDto> {
  }
  
  export class GetCmsPages extends EVA.Core.RequestMessageGeneric<EVA.CMS.GetCmsPagesResponse> {
    __response : EVA.CMS.GetCmsPagesResponse;
  }
  
  export class GetCmsPagesResponse extends EVA.Core.GetResponse<EVA.CMS.CmsPageDto[]> {
  }
  
  export class ListCmsPages extends EVA.Core.PagedResultRequest<EVA.CMS.ListCmsPagesResponse> {
    __response : EVA.CMS.ListCmsPagesResponse;
  }
  
  export class ListCmsPagesResponse extends EVA.Core.PagedResultResponse<EVA.CMS.CmsPageDto> {
  }
  
  export class CreateCmsMenuItem extends EVA.Core.CreateRequest<EVA.CMS.CmsMenuItemDto> implements EVA.Core.IRequestRespondsAs<EVA.Core.CreateResponse> {
    __response : EVA.Core.CreateResponse;
  }
  
  export class CmsMenuItemDto {
    ID : number; // Int32
    MenuID : number; // Int32
    Title : string; 
    ParentID : number; // Int32, nullable
    Parent : EVA.CMS.CmsMenuDto; 
    Depth : number; // Int32
    Lineage : string; 
    Position : number; // Int32
    EntityID : number; // Int32, nullable
    Entity : EVA.CMS.CmsEntityDto; 
    Url : string; 
    Children : EVA.CMS.CmsMenuItemDto[]; 
  }
  
  export class CmsMenuDto {
    ID : number; // Int32
    Identifier : string; 
    Children : EVA.CMS.CmsMenuItemDto[]; 
  }
  
  export class CreateCmsMenu extends EVA.Core.CreateRequest<EVA.CMS.CmsMenuDto> implements EVA.Core.IRequestRespondsAs<EVA.Core.CreateResponse> {
    __response : EVA.Core.CreateResponse;
  }
  
  export class DeleteCmsMenuItem extends EVA.Core.DeleteRequest implements EVA.Core.IRequestRespondsAs<EVA.Core.EmptyResponseMessage> {
    __response : EVA.Core.EmptyResponseMessage;
  }
  
  export class DeleteCmsMenu extends EVA.Core.DeleteRequest implements EVA.Core.IRequestRespondsAs<EVA.Core.EmptyResponseMessage> {
    __response : EVA.Core.EmptyResponseMessage;
  }
  
  export class GetCmsMenuByIdentifier extends EVA.Core.RequestMessageGeneric<EVA.CMS.GetCmsMenuByIdentifierResponse> {
    Identifier : string; 
    __response : EVA.CMS.GetCmsMenuByIdentifierResponse;
  }
  
  export class GetCmsMenuByIdentifierResponse extends EVA.Core.GetResponse<EVA.CMS.CmsMenuDto> {
  }
  
  export class GetCmsMenuByID extends EVA.Core.GetRequestGeneric<EVA.CMS.GetCmsMenuByIDResponse> {
    __response : EVA.CMS.GetCmsMenuByIDResponse;
  }
  
  export class GetCmsMenuByIDResponse extends EVA.Core.GetResponse<EVA.CMS.CmsMenuDto> {
  }
  
  export class GetFlatHierarchyByMenuID extends EVA.Core.GetRequestGeneric<EVA.CMS.GetFlatHierarchyByMenuIDResponse> {
    __response : EVA.CMS.GetFlatHierarchyByMenuIDResponse;
  }
  
  export class GetFlatHierarchyByMenuIDResponse extends EVA.Core.GetResponse<EVA.CMS.CmsMenuItemDto[]> {
  }
  
  export class ListCmsMenu extends EVA.Core.PagedResultRequest<EVA.CMS.ListCmsMenuResponse> {
    __response : EVA.CMS.ListCmsMenuResponse;
  }
  
  export class ListCmsMenuResponse extends EVA.Core.PagedResultResponse<EVA.CMS.CmsMenuDto> {
  }
  
  export class ListCmsMenus extends EVA.Core.RequestMessageGeneric<EVA.CMS.ListCmsMenusResponse> {
    __response : EVA.CMS.ListCmsMenusResponse;
  }
  
  export class ListCmsMenusResponse extends EVA.Core.GetResponse<EVA.CMS.CmsMenuDto[]> {
  }
  
  export class UpdateCmsMenuItem extends EVA.Core.UpdateRequest<EVA.CMS.CmsMenuItemDto> implements EVA.Core.IRequestRespondsAs<EVA.Core.EmptyResponseMessage> {
    __response : EVA.Core.EmptyResponseMessage;
  }
  
  export class UpdateCmsMenu extends EVA.Core.UpdateRequest<EVA.CMS.CmsMenuDto> implements EVA.Core.IRequestRespondsAs<EVA.Core.EmptyResponseMessage> {
    __response : EVA.Core.EmptyResponseMessage;
  }
  
  export class CreateCmsEntity extends EVA.Core.CreateRequest<EVA.CMS.CmsEntityDto> implements EVA.Core.IRequestRespondsAs<EVA.Core.CreateResponse> {
    __response : EVA.Core.CreateResponse;
  }
  
  export class UpdateCmsEntity extends EVA.Core.UpdateRequest<EVA.CMS.CmsEntityDto> implements EVA.Core.IRequestRespondsAs<EVA.Core.EmptyResponseMessage> {
    __response : EVA.Core.EmptyResponseMessage;
  }
  
  export class DeleteCmsEntity extends EVA.Core.DeleteRequest implements EVA.Core.IRequestRespondsAs<EVA.Core.EmptyResponseMessage> {
    __response : EVA.Core.EmptyResponseMessage;
  }
  
  export class GetCmsEntityByID extends EVA.Core.GetRequestGeneric<EVA.CMS.GetCmsEntityByIDResponse> {
    __response : EVA.CMS.GetCmsEntityByIDResponse;
  }
  
  export class GetCmsEntityByIDResponse extends EVA.Core.GetResponse<EVA.CMS.CmsEntityDto> {
  }
  
  export class ListCmsEntities extends EVA.Core.RequestMessageGeneric<EVA.CMS.ListCmsEntitiesResponse> {
    __response : EVA.CMS.ListCmsEntitiesResponse;
  }
  
  export class ListCmsEntitiesResponse extends EVA.Core.GetResponse<EVA.CMS.CmsEntityDto[]> {
  }
  
  export class MoveCmsEntity extends EVA.Core.RequestMessageGeneric<EVA.CMS.MoveCmsEntityResponse> {
    ID : number; // Int32
    ParentID : number; // Int32
    Position : number; // Int32
    __response : EVA.CMS.MoveCmsEntityResponse;
  }
  
  export class MoveCmsEntityResponse extends EVA.Core.ResponseMessage {
  }
  
  export class GetCmsBlocks extends EVA.Core.PagedResultRequest<EVA.CMS.GetCmsBlocksResponse> {
    __response : EVA.CMS.GetCmsBlocksResponse;
  }
  
  export class GetCmsBlocksResponse extends EVA.Core.GetResponse<EVA.CMS.CmsBlockDto[]> {
  }
  
  export class CmsBlockDto {
    ID : number; // Int32
    Identifier : string; 
    DisplayTypeID : number; // Int32
    DisplayType : EVA.CMS.CmsWidgetTypeDto; 
    Data : string; 
    DisplayData : any; 
    Widgets : EVA.CMS.CmsPageWidgetDto[]; 
  }
  
  export class ListCmsBlocks extends EVA.Core.PagedResultRequest<EVA.CMS.ListCmsBlocksResponse> {
    __response : EVA.CMS.ListCmsBlocksResponse;
  }
  
  export class ListCmsBlocksResponse extends EVA.Core.PagedResultResponse<EVA.CMS.CmsPageDto> {
  }
  
  export class CreateCmsBanner extends EVA.Core.CreateRequest<EVA.CMS.CmsBannerDto> implements EVA.Core.IRequestRespondsAs<EVA.CMS.CreateCmsBannerResponse> {
    __response : EVA.CMS.CreateCmsBannerResponse;
  }
  
  export class CmsBannerDto {
    ID : string; 
    Url : string; 
    ImageGuid : string; 
    Name : string; 
    Title : string; 
    Alt : string; 
    StartDate : string; // DateTime, nullable
    EndDate : string; // DateTime, nullable
    Enabled : boolean; 
    Target : EVA.CMS.CmsBannerTargets; 
    Pages : EVA.CMS.CmsEntityDto[]; 
  }
  
  export enum CmsBannerTargets {
    Self = 0,
    NewWindow = 1,
  }
  
  export class CreateCmsBannerResponse extends EVA.Core.CreateResponse {
    UniqueIdentifier : string; 
  }
  
  export class GetCmsBanner extends EVA.Core.RequestMessageGeneric<EVA.CMS.GetCmsBannerResponse> {
    ID : string; 
    __response : EVA.CMS.GetCmsBannerResponse;
  }
  
  export class GetCmsBannerResponse extends EVA.Core.GetResponse<EVA.CMS.CmsBannerDto> {
  }
  
  export class UpdateCmsBanner extends EVA.Core.UpdateRequest<EVA.CMS.CmsBannerDto> implements EVA.Core.IRequestRespondsAs<EVA.Core.EmptyResponseMessage> {
    __response : EVA.Core.EmptyResponseMessage;
  }
  
  export class DeleteCmsBanner extends EVA.Core.DeleteRequest implements EVA.Core.IRequestRespondsAs<EVA.Core.EmptyResponseMessage> {
    UniqueIdentifier : string; 
    __response : EVA.Core.EmptyResponseMessage;
  }
  
  export class ListCmsBanners extends EVA.Core.PagedResultRequest<EVA.CMS.ListCmsBannersResponse> {
    __response : EVA.CMS.ListCmsBannersResponse;
  }
  
  export class ListCmsBannersResponse extends EVA.Core.PagedResultResponse<EVA.CMS.CmsBannerDto> {
  }
  
}