/* tslint:disable */
declare module EVA.CRM.Core {
  
  export enum RefundMethod {
    UserCard = 1,
    Automatic = 2,
  }
  
  export class CreateCustomerReturn extends EVA.Core.RequestMessageGeneric<EVA.Core.ShoppingCartResponse> {
    OrderID : number; // Int32
    SessionID : string; 
    Lines : EVA.CRM.Core.CustomerReturnLine[]; 
    ReturnWithoutProducts : boolean; 
    __response : EVA.Core.ShoppingCartResponse;
  }
  
  export class CustomerReturnLine {
    OrderLineID : number; // Int32
    Quantity : number; // Int32
    Reason : string; 
  }
  
  export class GetRefundOptionsForOrder extends EVA.Core.RequestMessageGeneric<EVA.CRM.Core.GetRefundOptionsForOrderResponse> {
    OrderID : number; // Int32
    __response : EVA.CRM.Core.GetRefundOptionsForOrderResponse;
  }
  
  export class GetRefundOptionsForOrderResponse extends EVA.Core.ResponseMessage {
    IsRefundAvailable : boolean; 
    AmountAvailableToRefund : number; // Decimal
    Reason : string; 
  }
  
  export class GetReturnOrdersForOrder extends EVA.Core.RequestMessageGeneric<EVA.CRM.Core.GetReturnOrdersForOrderResponse> {
    OrderID : number; // Int32
    __response : EVA.CRM.Core.GetReturnOrdersForOrderResponse;
  }
  
  export class GetReturnOrdersForOrderResponse extends EVA.Core.ResponseMessage {
    Orders : EVA.CRM.Core.ReturnOrder[]; 
  }
  
  export class ReturnOrder {
    ID : number; // Int32
    IsReturnWithoutProducts : boolean; 
    CreationTime : string; // DateTime
    TotalAmountInTax : number; // Decimal
    ForeignTotalAmountInTax : number; // Decimal
    CurrencyID : string; 
    IsPaid : boolean; 
    IsCompleted : boolean; 
    IsShipped : boolean; 
    PaidAmount : number; // Decimal
    ForeignPaidAmount : number; // Decimal
  }
  
  export class ReceiveReturnOrder extends EVA.Core.RequestMessageGeneric<EVA.CRM.Core.ReceiveReturnOrderResponse> {
    OrderID : number; // Int32
    Lines : EVA.CRM.Core.ReceiveReturnOrderReturnedLine[]; 
    __response : EVA.CRM.Core.ReceiveReturnOrderResponse;
  }
  
  export class ReceiveReturnOrderResponse extends EVA.Core.ResponseMessage {
    Messages : EVA.Core.ConfirmShipmentResultMessage[]; 
  }
  
  export class ReceiveReturnOrderReturnedLine {
    OrderLineID : number; // Int32
    Remark : string; 
    Quantity : number; // Int32
  }
  
  export class RefundAmountFromUserCard extends EVA.Core.RequestMessageGeneric<EVA.CRM.Core.RefundAmountFromUserCardResponse> {
    UserCardID : number; // Int32
    Amount : number; // Decimal
    RefundPaymentTypeCode : string; 
    PaymentTransactionID : number; // Int32, nullable
    RefundOptions : any; 
    __response : EVA.CRM.Core.RefundAmountFromUserCardResponse;
  }
  
  export class RefundAmountFromUserCardResponse extends EVA.Core.ResponseMessage {
    ActualRefundedAmount : number; // Decimal
    RefundStatus : EVA.Core.PaymentStatuses; 
    Message : EVA.Core.RefundAttemptMessage; 
  }
  
  export class RefundOrder extends EVA.Core.RequestMessageWithEmptyResponse {
    OrderID : number; // Int32
    Reason : string; 
    AmountToRefund : number; // Decimal, nullable
    __response : EVA.Core.EmptyResponseMessage;
  }
  
  export class ReturnOrderLines extends EVA.Core.RequestMessageGeneric<EVA.Core.ShoppingCartResponse> {
    OrderID : number; // Int32, nullable
    Lines : EVA.CRM.Core.ReturnLineDto[]; 
    SessionID : string; 
    ForceCreate : boolean; 
    LineActionType : EVA.Core.LineActionTypes; 
    ReturnToSameStockOrganizationUnit : boolean; 
    __response : EVA.Core.ShoppingCartResponse;
  }
  
  export class ReturnLineDto {
    OrderLineID : number; // Int32, nullable
    ProductID : number; // Int32, nullable
    Quantity : number; // Int32
    ResourceID : number; // Int32, nullable
    Remark : string; 
    ReturnStockLabel : number; // Int32
  }
  
  export class SetReturnOrderRefundCorrection extends EVA.Core.RequestMessageWithEmptyResponse {
    OrderID : number; // Int32
    NewOpenAmount : number; // Decimal
    Reason : string; 
    __response : EVA.Core.EmptyResponseMessage;
  }
  
  export class GetUserInteractionByID extends EVA.Core.RequestMessageGeneric<EVA.CRM.Core.GetUserInteractionByIDResponse> {
    ID : number; // Int32
    __response : EVA.CRM.Core.GetUserInteractionByIDResponse;
  }
  
  export class GetUserInteractionByIDResponse extends EVA.Core.ResponseMessage {
    ID : number; // Int32
    UserID : number; // Int32
    User : EVA.CRM.Core.GetUserInteractionByIDResponseUserDto; 
    Text : string; 
    OrderID : number; // Int32, nullable
    UserTaskID : number; // Int32, nullable
    CreationTime : string; // DateTime
  }
  
  export class GetUserInteractionByIDResponseUserDto {
    FirstName : string; 
    LastName : string; 
    EmailAddress : string; 
  }
  
  export class CreateUserInteraction extends EVA.Core.RequestMessageGeneric<EVA.CRM.Core.CreateUserInteractionResponse> {
    UserID : number; // Int32
    Text : string; 
    OrderID : number; // Int32, nullable
    UserTaskID : number; // Int32, nullable
    __response : EVA.CRM.Core.CreateUserInteractionResponse;
  }
  
  export class CreateUserInteractionResponse extends EVA.Core.ResponseMessage {
    ID : number; // Int32
  }
  
  export class UpdateUserInteraction extends EVA.Core.RequestMessageWithEmptyResponse {
    ID : number; // Int32
    UserID : number; // Int32
    Text : string; 
    OrderID : number; // Int32, nullable
    UserTaskID : number; // Int32, nullable
    __response : EVA.Core.EmptyResponseMessage;
  }
  
  export class DeleteUserInteraction extends EVA.Core.RequestMessageWithEmptyResponse {
    ID : number; // Int32
    __response : EVA.Core.EmptyResponseMessage;
  }
  
  export class ListUserInteractions extends EVA.Core.PagedResultRequest<EVA.CRM.Core.ListUserInteractionsResponse> {
    __response : EVA.CRM.Core.ListUserInteractionsResponse;
  }
  
  export class ListUserInteractionsResponse extends EVA.Core.PagedResultResponse<EVA.CRM.Core.ListUserInteractionsResponseUserInteractionDto> {
  }
  
  export class ListUserInteractionsResponseUserInteractionDto {
    ID : number; // Int32
    UserID : number; // Int32
    User : EVA.CRM.Core.ListUserInteractionsResponseUserInteractionDtoUserDto; 
    CreatedByID : number; // Int32
    CreatedBy : EVA.CRM.Core.ListUserInteractionsResponseUserInteractionDtoUserDto; 
    Text : string; 
    OrderID : number; // Int32, nullable
    UserTaskID : number; // Int32, nullable
    CreationTime : string; // DateTime
  }
  
  export class ListUserInteractionsResponseUserInteractionDtoUserDto {
    FirstName : string; 
    LastName : string; 
    EmailAddress : string; 
  }
  
  export class CompleteOrderInterventionTask extends EVA.Core.RequestMessageWithEmptyResponse {
    WorkSet : EVA.CRM.Core.OrderInterventionWorkSet; 
    __response : EVA.Core.EmptyResponseMessage;
  }
  
  export class OrderInterventionWorkSet {
    UserTaskID : number; // Int32
    OrderInterventionTaskID : number; // Int32
    OrderID : number; // Int32
    Reason : string; 
    Comment : string; 
  }
  
  export class ListOrderInterventionTasks extends EVA.Core.RequestMessageGeneric<EVA.CRM.Core.ListOrderInterventionTasksResponse> {
    PageConfig : EVA.Core.PageConfig; 
    __response : EVA.CRM.Core.ListOrderInterventionTasksResponse;
  }
  
  export class ListOrderInterventionTasksResponse extends EVA.Core.ResponseMessage {
    Result : EVA.Core.PagedResultGeneric<EVA.CRM.Core.OrderInterventionTaskDto>; 
  }
  
  export class OrderInterventionTaskDto {
    ID : number; // Int32
    UserTaskID : number; // Int32
    Reason : string; 
    Comment : string; 
    OrderID : number; // Int32
    CreationTime : string; // DateTime
    AssignedToUser : string; 
  }
  
  export class StartOrderInterventionTask extends EVA.Core.RequestMessageGeneric<EVA.CRM.Core.StartOrderInterventionTaskResponse> {
    UserTaskID : number; // Int32
    __response : EVA.CRM.Core.StartOrderInterventionTaskResponse;
  }
  
  export class StartOrderInterventionTaskResponse extends EVA.Core.ResponseMessage {
    WorkSet : EVA.CRM.Core.OrderInterventionWorkSet; 
  }
  
  export class CompleteCustomerInteractionTask extends EVA.Core.RequestMessageWithEmptyResponse {
    WorkSet : EVA.CRM.Core.CustomerInteractionWorkSet; 
    __response : EVA.Core.EmptyResponseMessage;
  }
  
  export class CustomerInteractionWorkSet {
    UserTaskID : number; // Int32
    UserTask : EVA.Core.UserTaskDto; 
    TypeID : number; // Int32
    TypeName : string; 
    CustomerID : number; // Int32
    Customer : EVA.CRM.Core.CustomerInteractionWorkSetCustomerDto; 
    Priority : EVA.CRM.Core.CustomerInteractionTaskPriorities; 
  }
  
  export class CustomerInteractionWorkSetCustomerDto {
    FirstName : string; 
    LastName : string; 
    EmailAddress : string; 
    PhoneNumber : string; 
  }
  
  export enum CustomerInteractionTaskPriorities {
    None = 0,
    Low = 1,
    Normal = 2,
    High = 3,
    Immediate = 4,
  }
  
  export class GetCustomerInteractionTaskByID extends EVA.Core.RequestMessageGeneric<EVA.CRM.Core.GetCustomerInteractionTaskByIDResponse> {
    ID : number; // Int32
    __response : EVA.CRM.Core.GetCustomerInteractionTaskByIDResponse;
  }
  
  export class GetCustomerInteractionTaskByIDResponse extends EVA.Core.ResponseMessage {
    ID : number; // Int32
    Priority : EVA.CRM.Core.CustomerInteractionTaskPriorities; 
    Type : EVA.CRM.Core.CustomerInteractionTaskTypeDto; 
    Customer : EVA.CRM.Core.CustomerInteractionUserDto; 
    CustomerID : number; // Int32
    UserTask : EVA.CRM.Core.CustomerInteractionUserTaskDto; 
    UserTaskID : number; // Int32
  }
  
  export class CustomerInteractionTaskTypeDto {
    ID : number; // Int32
    Name : string; 
    Description : string; 
    FollowUpTypeID : number; // Int32, nullable
    FollowUpTypeName : string; 
  }
  
  export class CustomerInteractionUserDto {
    FullName : string; 
    PhoneNumber : string; 
    EmailAddress : string; 
  }
  
  export class CustomerInteractionUserTaskDto {
    StartTime : string; // DateTime, nullable
    DeadLine : string; // DateTime, nullable
    Description : string; 
    UserID : number; // Int32, nullable
    User : EVA.CRM.Core.CustomerInteractionUserDto; 
    OrganizationUnitID : number; // Int32
    OrganizationUnitName : string; 
    IsActive : boolean; 
    IsCompleted : boolean; 
  }
  
  export class CreateCustomerInteractionTask extends EVA.Core.RequestMessageGeneric<EVA.CRM.Core.CreateCustomerInteractionTaskResponse> {
    Priority : EVA.CRM.Core.CustomerInteractionTaskPriorities; 
    TypeID : number; // Int32
    CustomerID : number; // Int32
    UserTask : EVA.CRM.Core.CustomerInteractionUserTaskDto; 
    __response : EVA.CRM.Core.CreateCustomerInteractionTaskResponse;
  }
  
  export class CreateCustomerInteractionTaskResponse extends EVA.Core.ResponseMessage {
    ID : number; // Int32
  }
  
  export class DeleteCustomerInteractionTask extends EVA.Core.RequestMessageWithEmptyResponse {
    ID : number; // Int32
    __response : EVA.Core.EmptyResponseMessage;
  }
  
  export class ListCustomerInteractionTasks extends EVA.Core.PagedResultRequest<EVA.CRM.Core.ListCustomerInteractionTasksResponse> {
    __response : EVA.CRM.Core.ListCustomerInteractionTasksResponse;
  }
  
  export class ListCustomerInteractionTasksResponse extends EVA.Core.PagedResultResponse<EVA.CRM.Core.ListCustomerInteractionTasksResponseCustomerInteractionTaskDto> {
  }
  
  export class ListCustomerInteractionTasksResponseCustomerInteractionTaskDto {
    ID : number; // Int32
    Priority : EVA.CRM.Core.CustomerInteractionTaskPriorities; 
    Type : EVA.CRM.Core.CustomerInteractionTaskTypeDto; 
    Customer : EVA.CRM.Core.CustomerInteractionUserDto; 
    CustomerID : number; // Int32
    UserTask : EVA.CRM.Core.CustomerInteractionUserTaskDto; 
    UserTaskID : number; // Int32
  }
  
  export class GetCustomerInteractionTaskTypeByID extends EVA.Core.RequestMessageGeneric<EVA.CRM.Core.GetCustomerInteractionTaskTypeByIDResponse> {
    ID : number; // Int32
    __response : EVA.CRM.Core.GetCustomerInteractionTaskTypeByIDResponse;
  }
  
  export class GetCustomerInteractionTaskTypeByIDResponse extends EVA.Core.ResponseMessage {
    ID : number; // Int32
    Name : string; 
    Description : string; 
    FollowUpTypeID : number; // Int32, nullable
    FollowUpTypeName : string; 
  }
  
  export class CreateCustomerInteractionTaskType extends EVA.Core.RequestMessageGeneric<EVA.CRM.Core.CreateCustomerInteractionTaskTypeResponse> {
    Name : string; 
    Description : string; 
    FollowUpTypeID : number; // Int32, nullable
    __response : EVA.CRM.Core.CreateCustomerInteractionTaskTypeResponse;
  }
  
  export class CreateCustomerInteractionTaskTypeResponse extends EVA.Core.ResponseMessage {
    ID : number; // Int32
  }
  
  export class UpdateCustomerInteractionTaskType extends EVA.Core.RequestMessageWithEmptyResponse {
    ID : number; // Int32
    Description : string; 
    FollowUpTypeID : number; // Int32, nullable
    __response : EVA.Core.EmptyResponseMessage;
  }
  
  export class DeleteCustomerInteractionTaskType extends EVA.Core.RequestMessageWithEmptyResponse {
    ID : number; // Int32
    __response : EVA.Core.EmptyResponseMessage;
  }
  
  export class GetCustomerInteractionTaskTypes extends EVA.Core.RequestMessageGeneric<EVA.CRM.Core.GetCustomerInteractionTaskTypesResponse> {
    __response : EVA.CRM.Core.GetCustomerInteractionTaskTypesResponse;
  }
  
  export class GetCustomerInteractionTaskTypesResponse extends EVA.Core.ResponseMessage {
    CustomerInteractionTaskTypes : EVA.CRM.Core.CustomerInteractionTaskTypeDto[]; 
  }
  
  export class DetachFromCustomerInteractionTask extends EVA.Core.RequestMessageWithEmptyResponse {
    UserTaskID : number; // Int32
    __response : EVA.Core.EmptyResponseMessage;
  }
  
  export class StartCustomerInteractionTask extends EVA.Core.RequestMessageGeneric<EVA.CRM.Core.StartCustomerInteractionTaskResponse> {
    UserTaskID : number; // Int32
    __response : EVA.CRM.Core.StartCustomerInteractionTaskResponse;
  }
  
  export class StartCustomerInteractionTaskResponse extends EVA.Core.ResponseMessage {
    WorkSet : EVA.CRM.Core.CustomerInteractionWorkSet; 
  }
  
}