/* tslint:disable */
declare module EVA.Carrier.PostNL {
  
  export enum LocationOptions {
    Daytime = 1,
    Evening = 2,
    Morning = 4,
    Noon = 8,
    Sunday = 16,
    Sameday = 32,
    Afternoon = 64,
  }
  
  export enum TimeframeOptions {
    Daytime = 1,
    Evening = 2,
    Morning = 4,
    Noon = 8,
    Sunday = 16,
    Sameday = 32,
    Afternoon = 64,
    All = 127,
  }
  
  export class PostNLGetAvailablePickUpLocationsForArea extends EVA.Core.RequestMessageGeneric<EVA.Carrier.PostNL.PostNLGetAvailablePickUpLocationsForAreaResponse> {
    OrderID : number; // Int32
    NorthWest : EVA.Carrier.PostNL.PostNLGetAvailablePickUpLocationsForAreaCoordinate; 
    SouthEast : EVA.Carrier.PostNL.PostNLGetAvailablePickUpLocationsForAreaCoordinate; 
    __response : EVA.Carrier.PostNL.PostNLGetAvailablePickUpLocationsForAreaResponse;
  }
  
  export class PostNLGetAvailablePickUpLocationsForAreaResponse extends EVA.Core.ResponseMessage {
    Locations : EVA.Carrier.PostNL.AvailableLocation[]; 
  }
  
  export class AvailableLocation {
    ID : string; 
    Name : string; 
    Longitude : number; // Decimal
    Latitude : number; // Decimal
    Distance : number; // Int32
    Street : string; 
    HouseNumber : string; 
    ZipCode : string; 
    City : string; 
    CountryID : string; 
    PhoneNumber : string; 
    Remark : string; 
    OpeningHours : EVA.Carrier.PostNL.LocationOpeningHours; 
    Area : string; 
    BuildingName : string; 
    Department : string; 
    Floor : string; 
    Doorcode : string; 
    HouseNumberExt : string; 
  }
  
  export class LocationOpeningHours {
    Sunday : string[]; 
    Monday : string[]; 
    Tuesday : string[]; 
    Wednesday : string[]; 
    Thursday : string[]; 
    Friday : string[]; 
    Saturday : string[]; 
  }
  
  export class PostNLGetAvailablePickUpLocationsForAreaCoordinate {
    Latitude : number; // Decimal
    Longitude : number; // Decimal
  }
  
  export class PostNLGetAvailablePickUpLocationsForOrder extends EVA.Core.RequestMessageGeneric<EVA.Carrier.PostNL.PostNLGetAvailablePickUpLocationsForOrderResponse> {
    OrderID : number; // Int32
    __response : EVA.Carrier.PostNL.PostNLGetAvailablePickUpLocationsForOrderResponse;
  }
  
  export class PostNLGetAvailablePickUpLocationsForOrderResponse extends EVA.Core.ResponseMessage {
    Locations : EVA.Carrier.PostNL.AvailableLocation[]; 
  }
  
  export class PostNLGetAvailableTimeframesForOrder extends EVA.Core.RequestMessageGeneric<EVA.Carrier.PostNL.PostNLGetAvailableTimeframesForOrderResponse> {
    OrderID : number; // Int32
    StartDate : string; // DateTime
    EndDate : string; // DateTime
    __response : EVA.Carrier.PostNL.PostNLGetAvailableTimeframesForOrderResponse;
  }
  
  export class PostNLGetAvailableTimeframesForOrderResponse extends EVA.Core.ResponseMessage {
    Frames : EVA.Carrier.PostNL.AvailableTimeframeDate[]; 
  }
  
  export class AvailableTimeframeDate {
    Date : string; // DateTime
    Timeframes : EVA.Carrier.PostNL.AvailableTimeframe[]; 
  }
  
  export class AvailableTimeframe {
    Option : EVA.Carrier.PostNL.TimeframeOptions; 
    StartDateTime : string; // DateTime
    EndDateTime : string; // DateTime
    Costs : number; // Decimal
  }
  
  export class PostNLGetShippingOptionsForOrder extends EVA.Core.RequestMessageGeneric<EVA.Carrier.PostNL.PostNLGetShippingOptionsForOrderResponse> {
    OrderID : number; // Int32
    __response : EVA.Carrier.PostNL.PostNLGetShippingOptionsForOrderResponse;
  }
  
  export class PostNLGetShippingOptionsForOrderResponse extends EVA.Core.ResponseMessage {
    Date : string; // DateTime, nullable
    TimeframeOptions : EVA.Carrier.PostNL.TimeframeOptions; 
    PickUpLocationID : string; 
  }
  
  export class PostNLUpdateShippingOptionsForOrder extends EVA.Core.RequestMessageWithEmptyResponse {
    OrderID : number; // Int32
    Date : string; // DateTime, nullable
    TimeframeOptions : EVA.Carrier.PostNL.TimeframeOptions; 
    PickUpLocationID : string; 
    __response : EVA.Core.EmptyResponseMessage;
  }
  
}