/* tslint:disable */
declare module EVA.Cookbook {
  
  export class CreateAccountingRecipe extends EVA.Core.RequestMessageGeneric<EVA.Cookbook.CreateAccountingRecipeResponse> {
    Recipe : string; 
    IsActive : boolean; 
    Name : string; 
    __response : EVA.Cookbook.CreateAccountingRecipeResponse;
  }
  
  export class CreateOrUpdateRecipeResponse extends EVA.Core.ResponseMessage {
    HasErrors : boolean; 
    Errors : EVA.Cookbook.ParseRecipeError[]; 
  }
  
  export class CreateAccountingRecipeResponse extends EVA.Cookbook.CreateOrUpdateRecipeResponse {
    ID : number; // Int32
  }
  
  export class ParseRecipeError {
    Type : EVA.Cookbook.ParsingErrorType; 
    Message : string; 
    SourceLine : string; 
    SourceLineNumber : number; // Int32
  }
  
  export enum ParsingErrorType {
    InvalidSyntax = 0,
    UnknownVariable = 1,
    InvalidComparison = 2,
    InvalidOperator = 3,
    MissingCredit = 4,
    MissingDebit = 5,
    AmountMustBeNumerical = 6,
    InvalidBookOnOrganizationUnit = 7,
  }
  
  export class GetAccountingRecipe extends EVA.Core.RequestMessageGeneric<EVA.Cookbook.GetAccountingRecipeResponse> {
    ID : number; // Int32
    __response : EVA.Cookbook.GetAccountingRecipeResponse;
  }
  
  export class GetAccountingRecipeResponse extends EVA.Core.ResponseMessage {
    Recipe : EVA.Cookbook.AccountingRecipeDto; 
  }
  
  export class AccountingRecipeDto {
    Recipe : string; 
    Name : string; 
    EventType : EVA.Core.FinancialEventTypes; 
    IsActive : boolean; 
  }
  
  export class ListAccountingRecipes extends EVA.Core.PagedResultRequest<EVA.Cookbook.ListAccountingRecipesResponse> {
    IsActive : boolean; 
    Type : EVA.Core.FinancialEventTypes; 
    __response : EVA.Cookbook.ListAccountingRecipesResponse;
  }
  
  export class ListAccountingRecipesResponse extends EVA.Core.PagedResultResponse<EVA.Cookbook.AccountingRecipeDto> {
  }
  
  export class PreviewAccountingRecipe extends EVA.Core.RequestMessageGeneric<EVA.Cookbook.PreviewAccountingRecipeResponse> {
    Recipes : EVA.Cookbook.AccountingRecipeToPreview[]; 
    FinancialEventIDs : number[]; 
    OrderID : number; // Int32, nullable
    __response : EVA.Cookbook.PreviewAccountingRecipeResponse;
  }
  
  export class PreviewAccountingRecipeResponse extends EVA.Cookbook.CreateOrUpdateRecipeResponse {
    BookingPreviewSummaries : EVA.Cookbook.AccountBookingPreview[]; 
    Warnings : string[]; 
    BookingPreviewDetails : EVA.Cookbook.AccountBookingDetails[]; 
  }
  
  export class AccountBookingPreview {
    Date : string; // DateTime
    BookedOnOrganizationUnitID : number; // Int32
    BookedOnOrganizationUnitName : string; 
    BookedOnAccountID : number; // Int32
    BookedOnAccountNumber : string; 
    BookedOnAccountName : string; 
    Amount : number; // Decimal
  }
  
  export class AccountBookingDetails {
    Amount : number; // Decimal
    BookedOnOrganizationUnitID : number; // Int32
    BookedOnOrganizationUnitName : string; 
    BookedOnAccountID : number; // Int32
    BookedOnAccountNumber : string; 
    BookedOnAccountName : string; 
    AccountingRecipeID : number; // Int32
    Date : string; // DateTime
    Description : string; 
  }
  
  export class AccountingRecipeToPreview {
    ID : number; // Int32, nullable
    Recipe : string; 
  }
  
  export class UpdateAccountingRecipe extends EVA.Core.RequestMessageGeneric<EVA.Cookbook.UpdateAccountingRecipeResponse> {
    ID : number; // Int32
    Recipe : string; 
    IsActive : boolean; 
    Name : string; 
    __response : EVA.Cookbook.UpdateAccountingRecipeResponse;
  }
  
  export class UpdateAccountingRecipeResponse extends EVA.Cookbook.CreateOrUpdateRecipeResponse {
  }
  
  export enum ActionBlockModifier {
    None = 0,
    Else = 1,
    Also = 2,
  }
  
  export enum OperatorTypes {
    Equals = 0,
    NotEquals = 1,
    GreaterThan = 2,
    LessThan = 3,
    GreaterThanOrEquals = 4,
    LessThanOrEquals = 5,
    HasValue = 6,
    HasNoValue = 7,
  }
  
}