/* tslint:disable */
declare module EVA.Core.Services {

  export class StockResourceTypeDto {
    Name : string;
    IsUnique : boolean;
  }

  export class SearchProducts extends EVA.Core.RequestMessageGeneric<EVA.Core.Services.SearchProductsResponse> {
    Query : string;
    Filters : { [ key : string ] : EVA.Core.FilterModel };
    IncludeAggregations : boolean;
    AggregationState : string;
    AggregationOptions : { [ key : string ] : EVA.Core.AggregationFilterModel };
    PageSize : number; // Int32, nullable
    Page : number; // Int32, nullable
    Sort : EVA.Core.SortFieldDescriptor[];
    ExcludedFields : string[];
    ExcludedFieldsOption : EVA.Core.ExcludedFieldOptions;
    IncludedFields : string[];
    __response : EVA.Core.Services.SearchProductsResponse;
  }

  export class SearchProductsResponse extends EVA.Core.ResponseMessage {
    Products : any[];
    AggregationState : string;
    Aggregations : any;
    AggregationOptions : { [ key : string ] : EVA.Core.AggregationFilterModel };
    Page : number; // Int32
    PageSize : number; // Int32
    Total : number; // Int64
    Sort : EVA.Core.SortFieldDescriptor[];
  }

  export class AddWishListToOrder extends EVA.Core.RequestMessageGeneric<EVA.Core.ShoppingCartResponse> {
    SessionID : string;
    WishListID : number; // Int32, nullable
    WishListToken : string;
    LineActionType : EVA.Core.LineActionTypes;
    __response : EVA.Core.ShoppingCartResponse;
  }

  export class GetWishListByID extends EVA.Core.RequestMessageGeneric<EVA.Core.Services.GetWishListResponse> {
    ID : number; // Int32
    __response : EVA.Core.Services.GetWishListResponse;
  }

  export class GetWishListResponse extends EVA.Core.ResponseMessage {
    ID : number; // Int32
    Name : string;
    UserID : number; // Int32
    UserFullName : string;
    PublicAccessToken : string;
    Lines : EVA.Core.Services.WishListLineDto[];
    CreationTime : string; // DateTime
  }

  export class WishListLineDto {
    ProductID : number; // Int32
    ProductCustomID : string;
    Description : string;
    Quantity : number; // Int32
    CreationTime : string; // DateTime
  }

  export class GetWishListByToken extends EVA.Core.RequestMessageGeneric<EVA.Core.Services.GetWishListResponse> {
    Token : string;
    __response : EVA.Core.Services.GetWishListResponse;
  }

  export class CreateWishList extends EVA.Core.RequestMessageGeneric<EVA.Core.Services.CreateWishListResponse> {
    Name : string;
    __response : EVA.Core.Services.CreateWishListResponse;
  }

  export class CreateWishListResponse extends EVA.Core.ResponseMessage {
    ID : number; // Int32
  }

  export class UpdateWishList extends EVA.Core.RequestMessageWithEmptyResponse {
    ID : number; // Int32
    Name : string;
    __response : EVA.Core.EmptyResponseMessage;
  }

  export class DeleteWishList extends EVA.Core.RequestMessageWithEmptyResponse {
    ID : number; // Int32
    __response : EVA.Core.EmptyResponseMessage;
  }

  export class GetWishListLineByID extends EVA.Core.RequestMessageGeneric<EVA.Core.Services.GetWishListLineByIDResponse> {
    ID : number; // Int32
    __response : EVA.Core.Services.GetWishListLineByIDResponse;
  }

  export class GetWishListLineByIDResponse extends EVA.Core.ResponseMessage {
    ID : number; // Int32
    WishListID : number; // Int32
    ProductID : number; // Int32
    ProductCustomID : string;
    Description : string;
    Quantity : number; // Int32
    CreationTime : string; // DateTime
  }

  export class CreateWishListLine extends EVA.Core.RequestMessageGeneric<EVA.Core.Services.CreateWishListLineResponse> {
    WishListID : number; // Int32
    ProductID : number; // Int32
    Quantity : number; // Int32, nullable
    __response : EVA.Core.Services.CreateWishListLineResponse;
  }

  export class CreateWishListLineResponse extends EVA.Core.ResponseMessage {
    ID : number; // Int32
  }

  export class UpdateWishListLine extends EVA.Core.RequestMessageWithEmptyResponse {
    ID : number; // Int32
    Quantity : number; // Int32
    __response : EVA.Core.EmptyResponseMessage;
  }

  export class DeleteWishListLine extends EVA.Core.RequestMessageWithEmptyResponse {
    ID : number; // Int32
    __response : EVA.Core.EmptyResponseMessage;
  }

  export class ListWishLists extends EVA.Core.PagedResultRequest<EVA.Core.Services.ListWishListsResponse> {
    __response : EVA.Core.Services.ListWishListsResponse;
  }

  export class ListWishListsResponse extends EVA.Core.PagedResultResponse<EVA.Core.Services.ListWishListsResponseWishListDto> {
  }

  export class ListWishListsResponseWishListDto {
    ID : number; // Int32
    Name : string;
    UserID : number; // Int32
    UserFullName : string;
    PublicAccessToken : string;
    Lines : EVA.Core.Services.WishListLineDto[];
    CreationTime : string; // DateTime
  }

  export class GetRobotsTxt extends EVA.Core.RequestMessageGeneric<EVA.Core.Services.GetRobotsTxtResponse> {
    __response : EVA.Core.Services.GetRobotsTxtResponse;
  }

  export class GetRobotsTxtResponse extends EVA.Core.ResponseMessage {
    Robots : string;
  }

  export class UpdateRobotsTxt extends EVA.Core.RequestMessageWithEmptyResponse {
    Robots : string;
    __response : EVA.Core.EmptyResponseMessage;
  }

  export class SendContactForm extends EVA.Core.RequestMessageWithEmptyResponse {
    Type : string;
    Properties : { [ key : string ] : string };
    __response : EVA.Core.EmptyResponseMessage;
  }

  export class ChangeUserPassword extends EVA.Core.RequestMessageGeneric<EVA.Core.Services.ChangeUserPasswordResponse> {
    UserID : number; // Int32
    NewPassword : string;
    OldPassword : string;
    __response : EVA.Core.Services.ChangeUserPasswordResponse;
  }

  export class ChangeUserPasswordResponse extends EVA.Core.ResponseMessage {
    Success : boolean;
    Result : EVA.Core.PasswordValidationResults;
  }

  export class CheckEmailAddressAvailability extends EVA.Core.RequestMessageGeneric<EVA.Core.Services.CheckEmailAddressAvailabilityResponse> {
    EmailAddress : string;
    __response : EVA.Core.Services.CheckEmailAddressAvailabilityResponse;
  }

  export class CheckEmailAddressAvailabilityResponse extends EVA.Core.ResponseMessage {
    IsAvailable : boolean;
    IsValid : boolean;
    IsMigrated : boolean;
    IsIncomplete : boolean;
  }

  export class CheckNicknameAvailability extends EVA.Core.RequestMessageGeneric<EVA.Core.Services.CheckNicknameAvailabilityResponse> {
    Nickname : string;
    __response : EVA.Core.Services.CheckNicknameAvailabilityResponse;
  }

  export class CheckNicknameAvailabilityResponse extends EVA.Core.ResponseMessage {
    IsAvailable : boolean;
    IsValid : boolean;
  }

  export enum CreateApiKeysFunctionalities {
    ManageApiKeys = 0,
    CreatePermanentApiKeys = 1,
  }

  export class CreateApiKey extends EVA.Core.RequestMessageGeneric<EVA.Core.Services.CreateApiKeyResponse> {
    UserID : number; // Int32
    ApplicationID : number; // Int32, nullable
    OrganizationUnitID : number; // Int32, nullable
    RequestPermanentApiKey : boolean;
    __response : EVA.Core.Services.CreateApiKeyResponse;
  }

  export class CreateApiKeyResponse extends EVA.Core.ResponseMessage {
    ApiKey : string;
    ExpirationDate : string; // DateTime, nullable
  }

  export class CreateCustomer extends EVA.Core.RequestMessageGeneric<EVA.Core.Services.CreateCustomerResponse> {
    User : EVA.Core.Services.CustomerDto;
    SessionID : string;
    NoAccount : boolean;
    AutoLogin : boolean;
    __response : EVA.Core.Services.CreateCustomerResponse;
  }

  export class CreateCustomerResponse extends EVA.Core.ResponseMessage {
    User : EVA.Core.LoggedInUserDto;
    Result : EVA.Core.Services.CreateCustomerResults;
  }

  export enum CreateCustomerResults {
    CreatedCustomer = 0,
    InvalidEmail = 1,
    UsedIncompleteAccount = 2,
    EmailAlreadyInUse = 3,
    NicknameAlreadyInUse = 4,
  }

  export class CustomerDto {
    ID : number; // Int32
    EmailAddress : string;
    Gender : string;
    Initials : string;
    FirstName : string;
    LastName : string;
    PhoneNumber : string;
    SubscriptionType : EVA.Core.SubscriptionTypes;
    DateOfBirth : string; // DateTime, nullable
    PlaceOfBirth : string;
    BankAccount : string;
    Nickname : string;
    Password : string;
    LanguageID : string;
    ShippingAddress : EVA.Core.AddressDto;
    BillingAddress : EVA.Core.AddressDto;
  }

  export class CreateCustomerWithCompany extends EVA.Core.RequestMessageWithEmptyResponse {
    Nickname : string;
    EmailAddress : string;
    Gender : string;
    Initials : string;
    FirstName : string;
    LastName : string;
    PhoneNumber : string;
    LanguageID : string;
    Company : EVA.Core.Services.CustomerCompany;
    __response : EVA.Core.EmptyResponseMessage;
  }

  export class CustomerCompany {
    Name : string;
    RegistrationNumber : string;
    RegistrationCity : string;
    RegistrationCountryID : string;
    VatNumber : string;
    LegalForm : EVA.Core.LegalForms;
    EstablishedDate : string; // DateTime, nullable
    VisitorsAddress : EVA.Core.AddressDto;
    DeliveryAddress : EVA.Core.AddressDto;
    ReturnsAddress : EVA.Core.AddressDto;
    InvoiceAddress : EVA.Core.AddressDto;
    InvoiceEmailAddress : string;
    ContactEmailAddress : string;
    ContactPhoneNumber : string;
    AccountHolderName : string;
    IBAN : string;
    BIC : string;
    LogoID : string;
  }

  export class CreateEmployeeUser extends EVA.Core.CreateRequest<EVA.Core.UserDto> implements EVA.Core.IRequestRespondsAs<EVA.Core.Services.CreateEmployeeUserResponse> {
    Password : string;
    __response : EVA.Core.Services.CreateEmployeeUserResponse;
  }

  export class CreateEmployeeUserResponse extends EVA.Core.CreateResponse {
    UserID : number; // Int32
    IdentificationCode : string;
  }

  export class DeleteUser extends EVA.Core.RequestMessageWithEmptyResponse {
    ID : number; // Int32
    __response : EVA.Core.EmptyResponseMessage;
  }

  export class GenerateIdentificationCodeForEmployee extends EVA.Core.RequestMessageGeneric<EVA.Core.Services.GenerateIdentificationCodeForEmployeeResponse> {
    __response : EVA.Core.Services.GenerateIdentificationCodeForEmployeeResponse;
  }

  export class GenerateIdentificationCodeForEmployeeResponse extends EVA.Core.ResponseMessage {
    Result : EVA.Core.Services.UserIdWithIdentificationCodeDto;
  }

  export class UserIdWithIdentificationCodeDto {
    UserId : number; // Int32
    IdentificationCode : string;
  }

  export class GenerateTemporaryPasswordForUser extends EVA.Core.RequestMessageGeneric<EVA.Core.Services.GenerateTemporaryPasswordForUserResponse> {
    UserID : number; // Int32
    __response : EVA.Core.Services.GenerateTemporaryPasswordForUserResponse;
  }

  export class GenerateTemporaryPasswordForUserResponse extends EVA.Core.ResponseMessage {
    Password : string;
  }

  export class GetCurrentUser extends EVA.Core.RequestMessageGeneric<EVA.Core.Services.GetCurrentUserResponse> {
    __response : EVA.Core.Services.GetCurrentUserResponse;
  }

  export class GetCurrentUserResponse extends EVA.Core.ResponseMessage {
    User : EVA.Core.LoggedInUserDto;
  }

  export class GetOrganizationUnitsForUser extends EVA.Core.RequestMessageGeneric<EVA.Core.Services.GetOrganizationUnitsForUserResponse> {
    IncludeNonLoginOrganizationUnits : boolean;
    __response : EVA.Core.Services.GetOrganizationUnitsForUserResponse;
  }

  export class GetOrganizationUnitsForUserResponse extends EVA.Core.ResponseMessage {
    Result : EVA.Core.OrganizationUnitDto[];
  }

  export class GetUserIdentificationByID extends EVA.Core.GetRequestGeneric<EVA.Core.Services.GetUserIdentificationByIDResponse> {
    __response : EVA.Core.Services.GetUserIdentificationByIDResponse;
  }

  export class GetUserIdentificationByIDResponse extends EVA.Core.GetResponse<EVA.Core.Services.IdentificationDto> {
  }

  export class IdentificationDto {
    ID : number; // Int32
    Type : EVA.Core.IdentificationTypes;
    Number : string;
    ValidTo : string; // DateTime
    IssuingDate : string; // DateTime, nullable
    IssuingCity : string;
    IssuingCountryID : string;
    OriginatingCountryID : string;
    DocumentID : string;
  }

  export class GetUser extends EVA.Core.GetRequestGeneric<EVA.Core.Services.GetUserResponse> {
    IncludeFunctionalities : boolean;
    __response : EVA.Core.Services.GetUserResponse;
  }

  export class GetUserResponse extends EVA.Core.GetResponse<EVA.Core.UserDto> {
  }

  export class ListAvailableTimeZones extends EVA.Core.RequestMessageGeneric<EVA.Core.Services.ListAvailableTimeZonesResponse> {
    __response : EVA.Core.Services.ListAvailableTimeZonesResponse;
  }

  export class ListAvailableTimeZonesResponse extends EVA.Core.ResponseMessage {
    Result : EVA.Core.Services.ListAvailableTimeZonesResponseModel[];
  }

  export class ListAvailableTimeZonesResponseModel {
    ID : string;
    CountryID : string;
    CountryName : string;
  }

  export class ListUserIdentifications extends EVA.Core.RequestMessageGeneric<EVA.Core.Services.ListUserIdentificationsResponse> {
    UserID : number; // Int32
    __response : EVA.Core.Services.ListUserIdentificationsResponse;
  }

  export class ListUserIdentificationsResponse extends EVA.Core.ResponseMessage {
    Identifications : EVA.Core.Services.IdentificationDto[];
  }

  export class ListUsersWithBadgesByIDs extends EVA.Core.RequestMessageGeneric<EVA.Core.Services.ListUsersWithBadgesByIDsResponse> {
    UserIDs : number[];
    __response : EVA.Core.Services.ListUsersWithBadgesByIDsResponse;
  }

  export class ListUsersWithBadgesByIDsResponse extends EVA.Core.ResponseMessage {
    Users : EVA.Core.UserDto[];
  }

  export class RequestPasswordResetToken extends EVA.Core.RequestMessageWithEmptyResponse {
    EmailAddress : string;
    Context : string;
    ApplicationID : number; // Int32, nullable
    __response : EVA.Core.EmptyResponseMessage;
  }

  export class ResetUserPassword extends EVA.Core.RequestMessageGeneric<EVA.Core.Services.ResetUserPasswordResponse> {
    Token : string;
    NewPassword : string;
    __response : EVA.Core.Services.ResetUserPasswordResponse;
  }

  export class ResetUserPasswordResponse extends EVA.Core.ResponseMessage {
    EmailAddress : string;
  }

  export class SearchUsers extends EVA.Core.PagedResultRequest<EVA.Core.Services.SearchUsersResponse> {
    EmailAddress : string;
    Name : string;
    SearchQuery : string;
    Types : EVA.Core.UserTypes;
    ZipCode : string;
    PhoneNumber : string;
    __response : EVA.Core.Services.SearchUsersResponse;
  }

  export class SearchUsersResponse extends EVA.Core.PagedResultResponse<EVA.Core.UserDto> {
  }

  export class UpdateUserEmailAddress extends EVA.Core.RequestMessageWithEmptyResponse {
    ID : number; // Int32
    NewEmailAddress : string;
    __response : EVA.Core.EmptyResponseMessage;
  }

  export class UpdateUser extends EVA.Core.UpdateRequest<EVA.Core.UserDto> implements EVA.Core.IRequestRespondsAs<EVA.Core.Services.UpdateUserResponse> {
    __response : EVA.Core.Services.UpdateUserResponse;
  }

  export class UpdateUserResponse extends EVA.Core.ResponseMessage {
    User : EVA.Core.UserDto;
  }

  export class GetUserDebtorData extends EVA.Core.RequestMessageGeneric<EVA.Core.Services.GetUserDebtorDataResponse> {
    UserID : number; // Int32
    __response : EVA.Core.Services.GetUserDebtorDataResponse;
  }

  export class GetUserDebtorDataResponse extends EVA.Core.ResponseMessage {
    PaymentTerms : string;
    CreditLimit : number; // Decimal, nullable
  }

  export class UpdateUserDebtorData extends EVA.Core.RequestMessageWithEmptyResponse {
    UserID : number; // Int32
    PaymentTerms : string;
    CreditLimit : number; // Decimal, nullable
    __response : EVA.Core.EmptyResponseMessage;
  }

  export class GetUserGroupByID extends EVA.Core.RequestMessageGeneric<EVA.Core.Services.GetUserGroupByIDResponse> {
    ID : number; // Int32
    __response : EVA.Core.Services.GetUserGroupByIDResponse;
  }

  export class GetUserGroupByIDResponse extends EVA.Core.ResponseMessage {
    Name : string;
  }

  export class CreateUserGroup extends EVA.Core.RequestMessageGeneric<EVA.Core.CreateResponse> {
    Name : string;
    __response : EVA.Core.CreateResponse;
  }

  export class UpdateUserGroup extends EVA.Core.RequestMessageWithEmptyResponse {
    ID : number; // Int32
    Name : string;
    __response : EVA.Core.EmptyResponseMessage;
  }

  export class DeleteUserGroup extends EVA.Core.RequestMessageWithEmptyResponse {
    ID : number; // Int32
    __response : EVA.Core.EmptyResponseMessage;
  }

  export class ListUserGroups extends EVA.Core.PagedResultRequest<EVA.Core.Services.ListUserGroupsResponse> {
    __response : EVA.Core.Services.ListUserGroupsResponse;
  }

  export class ListUserGroupsResponse extends EVA.Core.PagedResultResponse<EVA.Core.Services.UserGroupDto> {
  }

  export class UserGroupDto {
    ID : number; // Int32
    Name : string;
  }

  export class AddUserToGroup extends EVA.Core.RequestMessageWithEmptyResponse {
    UserID : number; // Int32
    GroupID : number; // Int32
    __response : EVA.Core.EmptyResponseMessage;
  }

  export class RemoveUserFromGroup extends EVA.Core.RequestMessageWithEmptyResponse {
    UserID : number; // Int32
    GroupID : number; // Int32
    __response : EVA.Core.EmptyResponseMessage;
  }

  export class ListUserGroupsForUser extends EVA.Core.PagedResultRequest<EVA.Core.Services.ListUserGroupsForUserResponse> {
    UserID : number; // Int32
    __response : EVA.Core.Services.ListUserGroupsForUserResponse;
  }

  export class ListUserGroupsForUserResponse extends EVA.Core.PagedResultResponse<EVA.Core.Services.UserGroupDto> {
  }

  export class ListUsersForUserGroup extends EVA.Core.PagedResultRequest<EVA.Core.Services.ListUsersForUserGroupResponse> {
    UserGroupID : number; // Int32
    __response : EVA.Core.Services.ListUsersForUserGroupResponse;
  }

  export class ListUsersForUserGroupResponse extends EVA.Core.PagedResultResponse<EVA.Core.Services.SimpleUserDto> {
  }

  export class SimpleUserDto {
    ID : number; // Int32
    FirstName : string;
    LastName : string;
  }

  export class CreateCompanyForUser extends EVA.Core.RequestMessageWithEmptyResponse {
    UserID : number; // Int32
    Name : string;
    RegistrationNumber : string;
    RegistrationCity : string;
    RegistrationCountryID : string;
    VatNumber : string;
    LegalFormID : number; // Int32
    EstablishedDate : string; // DateTime, nullable
    ContactEmailAddress : string;
    ContactPhoneNumber : string;
    AccountHolderName : string;
    IBAN : string;
    BIC : string;
    __response : EVA.Core.EmptyResponseMessage;
  }

  export class DetachCompanyFromUser extends EVA.Core.RequestMessageWithEmptyResponse {
    UserID : number; // Int32
    __response : EVA.Core.EmptyResponseMessage;
  }

  export class GetCompanyForUser extends EVA.Core.RequestMessageGeneric<EVA.Core.Services.GetCompanyForUserResponse> {
    UserID : number; // Int32
    __response : EVA.Core.Services.GetCompanyForUserResponse;
  }

  export class GetCompanyForUserResponse extends EVA.Core.ResponseMessage {
    Result : EVA.Core.CompanyDto;
  }

  export class UpdateCompanyForUser extends EVA.Core.RequestMessageWithEmptyResponse {
    UserID : number; // Int32
    Name : string;
    RegistrationNumber : string;
    RegistrationCity : string;
    RegistrationCountryID : string;
    VatNumber : string;
    LegalFormID : number; // Int32
    EstablishedDate : string; // DateTime, nullable
    ContactEmailAddress : string;
    ContactPhoneNumber : string;
    AccountHolderName : string;
    IBAN : string;
    BIC : string;
    DeliveryAddress : EVA.Core.AddressDto;
    InvoiceAddress : EVA.Core.AddressDto;
    ReturnsAddress : EVA.Core.AddressDto;
    VisitorsAddress : EVA.Core.AddressDto;
    __response : EVA.Core.EmptyResponseMessage;
  }

  export class ConfirmSubscribe extends EVA.Core.RequestMessageGeneric<EVA.Core.Services.ConfirmSubscribeResponse> {
    Token : string;
    Type : EVA.Core.SubscriptionTypes;
    __response : EVA.Core.Services.ConfirmSubscribeResponse;
  }

  export class ConfirmSubscribeResponse extends EVA.Core.ResponseMessage {
    Success : boolean;
  }

  export class HasSubscription extends EVA.Core.RequestMessageGeneric<EVA.Core.Services.HasSubscriptionResponse> {
    EmailAddress : string;
    Type : EVA.Core.SubscriptionTypes;
    __response : EVA.Core.Services.HasSubscriptionResponse;
  }

  export class HasSubscriptionResponse extends EVA.Core.ResponseMessage {
    IsSubscribed : boolean;
  }

  export class Subscribe extends EVA.Core.RequestMessageGeneric<EVA.Core.Services.SubscribeResponse> {
    EmailAddress : string;
    MobileNumber : string;
    Type : EVA.Core.SubscriptionTypes;
    UserID : number; // Int32, nullable
    __response : EVA.Core.Services.SubscribeResponse;
  }

  export class SubscribeResponse extends EVA.Core.ResponseMessage {
    Success : boolean;
  }

  export class Unsubscribe extends EVA.Core.RequestMessageGeneric<EVA.Core.Services.UnsubscribeResponse> {
    EmailAddress : string;
    MobileNumber : string;
    Type : EVA.Core.SubscriptionTypes;
    UserID : number; // Int32, nullable
    __response : EVA.Core.Services.UnsubscribeResponse;
  }

  export class UnsubscribeResponse extends EVA.Core.ResponseMessage {
    Success : boolean;
  }

  export class AttachStockResourceToStock extends EVA.Core.RequestMessageWithEmptyResponse {
    ResourceID : number; // Int32
    StockLabel : number; // Int32
    OrganizationUnitID : number; // Int32
    ProductID : number; // Int32
    QuantityOnHand : number; // Int32
    __response : EVA.Core.EmptyResponseMessage;
  }

  export class CreateStockResource extends EVA.Core.RequestMessageGeneric<EVA.Core.Services.CreateStockResourceResponse> {
    Resources : { [ key : string ] : string };
    __response : EVA.Core.Services.CreateStockResourceResponse;
  }

  export class CreateStockResourceResponse extends EVA.Core.ResponseMessage {
    ResourceID : number; // Int32
  }

  export class FindStockResource extends EVA.Core.RequestMessageGeneric<EVA.Core.Services.FindStockResourceResponse> {
    Type : string;
    Value : string;
    __response : EVA.Core.Services.FindStockResourceResponse;
  }

  export class FindStockResourceResponse extends EVA.Core.ResponseMessage {
    Resource : EVA.Core.Services.StockResourceDto;
  }

  export class StockResourceDto {
    ID : number; // Int32
    Lines : EVA.Core.Services.StockResourceLineDto[];
  }

  export class StockResourceLineDto {
    Type : string;
    Value : string;
  }

  export class GetStockResource extends EVA.Core.RequestMessageGeneric<EVA.Core.Services.GetStockResourceResponse> {
    ResourceID : number; // Int32
    __response : EVA.Core.Services.GetStockResourceResponse;
  }

  export class GetStockResourceResponse extends EVA.Core.ResponseMessage {
    Resource : EVA.Core.Services.StockResourceDto;
  }

  export class ListRequiredStockResourceTypes extends EVA.Core.RequestMessageGeneric<EVA.Core.Services.ListRequiredStockResourceTypesResponse> {
    ProductID : number; // Int32
    __response : EVA.Core.Services.ListRequiredStockResourceTypesResponse;
  }

  export class ListRequiredStockResourceTypesResponse extends EVA.Core.ResponseMessage {
    RequiredStockResourceTypes : EVA.Core.Services.StockResourceTypeDto[];
  }

  export class ListStockResourcesByProduct extends EVA.Core.PagedResultRequest<EVA.Core.Services.ListStockResourcesByProductResponse> {
    ProductID : number; // Int32
    OrganizationUnitIDs : number[];
    __response : EVA.Core.Services.ListStockResourcesByProductResponse;
  }

  export class ListStockResourcesByProductResponse extends EVA.Core.PagedResultResponse<EVA.Core.Services.ProductWithResourceDto> {
  }

  export class ProductWithResourceDto {
    Product : any;
    StockLabelID : number; // Int32
    StockLabel : number; // Int32
    QuantityOnHand : number; // Int32
    ResourceID : number; // Int32
    Type : string;
    Value : string;
    CreationTime : string; // DateTime
    OrganizationUnit : EVA.Core.OrganizationUnitDto;
  }

  export class ListStockResourceStockMutations extends EVA.Core.PagedResultRequest<EVA.Core.Services.ListStockResourceStockMutationsResponse> {
    __response : EVA.Core.Services.ListStockResourceStockMutationsResponse;
  }

  export class ListStockResourceStockMutationsResponse extends EVA.Core.PagedResultResponse<EVA.Core.StockMutationDto> {
  }

  export class ListStockResourceTypes extends EVA.Core.RequestMessageGeneric<EVA.Core.Services.ListStockResourceTypesResponse> {
    __response : EVA.Core.Services.ListStockResourceTypesResponse;
  }

  export class ListStockResourceTypesResponse extends EVA.Core.ResponseMessage {
    StockResourceTypes : EVA.Core.IStockResourceType[];
  }

  export class AdjustStock extends EVA.Core.RequestMessageWithEmptyResponse {
    ProductID : number; // Int32
    OrganizationUnitID : number; // Int32
    SourceLabel : number; // Int32
    Quantity : number; // Int32
    ResourceID : number; // Int32, nullable
    Reason : EVA.Core.StockMutationReasons;
    Remark : string;
    __response : EVA.Core.EmptyResponseMessage;
  }

  export class GetAvailabilityIndication extends EVA.Core.RequestMessageGeneric<EVA.Core.Services.GetAvailabilityIndicationResponse> {
    OrganizationUnitIDs : number[];
    Products : EVA.Core.ProductQuantityDto[];
    FastestPickupShopOnly : boolean;
    DetailedShopInformation : boolean;
    IncludeAvailabilityTexts : boolean;
    __response : EVA.Core.Services.GetAvailabilityIndicationResponse;
  }

  export class GetAvailabilityIndicationResponse extends EVA.Core.ResponseMessage {
    Products : EVA.Core.ProductAvailabilityIndication[];
  }

  export class GetStockDetailsForProduct extends EVA.Core.RequestMessageGeneric<EVA.Core.Services.GetStockDetailsForProductResponse> {
    ProductID : number; // Int32
    __response : EVA.Core.Services.GetStockDetailsForProductResponse;
  }

  export class GetStockDetailsForProductResponse extends EVA.Core.ResponseMessage {
    Product : EVA.Core.Services.GetStockDetailsForProductResponseProductWithDeliveryPromisedDelivery;
    QuantityOnHand : number; // Int32
    SellableQuantityAvailable : number; // Int32
    StockPerLabel : { [ key : number ] : number };
    StockInTransit : EVA.Core.Services.GetStockDetailsForProductResponseInTransit[];
    SellableStockInStoresWithinApplication : number; // Int32
    SellableStockInWarehouses : EVA.Core.Services.GetStockDetailsForProductResponseOrganizationUnitWithStock[];
  }

  export class GetStockDetailsForProductResponseProductWithDeliveryPromisedDelivery extends EVA.Core.ProductDto {
    PromisedDeliveryDate : string; // DateTime
    PromisedDeliveryStatus : EVA.Core.ProductPromisedDeliveryStatuses;
    PromisedDeliveryQuantity : number; // Int32
    PromisedDeliveryStatusID : number; // Int32
  }

  export class GetStockDetailsForProductResponseInTransit {
    DeliveryNoteNumber : string;
    CarrierReferenceID : string;
    QuantityOrdered : number; // Int32
  }

  export class GetStockDetailsForProductResponseOrganizationUnitWithStock {
    ID : number; // Int32
    Name : string;
    SellableStock : number; // Int32
  }

  export class GetStockLabels extends EVA.Core.RequestMessageGeneric<EVA.Core.Services.GetStockLabelsResponse> {
    __response : EVA.Core.Services.GetStockLabelsResponse;
  }

  export class GetStockLabelsResponse extends EVA.Core.ResponseMessage {
    StockLabels : EVA.Core.Services.GetStockLabelsResponseStockLabelDto[];
  }

  export class GetStockLabelsResponseStockLabelDto {
    ID : number; // Int32
    Name : string;
    AllowedTypes : string[];
    AllowedDirections : string[];
    Description : string;
  }

  export class ListStockForOrganizationUnits extends EVA.Core.PagedResultRequest<EVA.Core.Services.ListStockForOrganizationUnitsResponse> {
    DateTime : string; // DateTime, nullable
    OrganizationUnitIDs : number[];
    DownloadOverview : boolean;
    Query : string;
    __response : EVA.Core.Services.ListStockForOrganizationUnitsResponse;
  }

  export class ListStockForOrganizationUnitsResponse extends EVA.Core.PagedResultResponse<EVA.Core.Services.ListStockForOrganizationUnitsResponseStockDto> {
    Products : { [ key : number ] : EVA.Core.Services.ListStockForOrganizationUnitsResponseProductDto };
    Url : string;
  }

  export class ListStockForOrganizationUnitsResponseStockDto {
    ProductID : number; // Int32
    QuantityOnHand : number; // Int32
    QuantityCommitted : number; // Int32
    QuantityAvailable : number; // Int32
    StockLabel : number; // Int32
    OrganizationUnitID : number; // Int32
    OrganizationUnitName : string;
  }

  export class ListStockForOrganizationUnitsResponseProductDto {
    Product : any;
    TaxRate : number; // Decimal
    TaxCodeID : number; // Int32
    UnitCost : number; // Decimal
    UnitPrice : number; // Decimal
  }

  export class ListStockMutations extends EVA.Core.PagedResultRequest<EVA.Core.Services.ListStockMutationsResponse> {
    __response : EVA.Core.Services.ListStockMutationsResponse;
  }

  export class ListStockMutationsResponse extends EVA.Core.PagedResultResponse<EVA.Core.Services.StockMutationWithFinancialPeriodDto> {
  }

  export class StockMutationWithFinancialPeriodDto extends EVA.Core.StockMutationDto {
    FinancialPeriod : EVA.Core.FinancialPeriodDto;
  }

  export class MoveStock extends EVA.Core.RequestMessageWithEmptyResponse {
    ProductID : number; // Int32
    OrganizationUnitID : number; // Int32
    SourceLabel : number; // Int32
    DestinationLabel : number; // Int32
    Quantity : number; // Int32
    SourceResourceID : number; // Int32, nullable
    DestinationResourceID : number; // Int32, nullable
    Remark : string;
    Reason : EVA.Core.StockMutationReasons;
    __response : EVA.Core.EmptyResponseMessage;
  }

  export class SearchStockByFields extends EVA.Core.PagedResultRequest<EVA.Core.Services.SearchStockResponse> {
    Query : string;
    ProductID : number; // Int32, nullable
    BackendID : string;
    CustomID : string;
    __response : EVA.Core.Services.SearchStockResponse;
  }

  export class SearchStockResponse extends EVA.Core.PagedResultResponse<EVA.Core.Services.ProductWithStockDto> {
  }

  export class ProductWithStockDto extends EVA.Core.ProductDto {
    Stocks : EVA.Core.Services.StockDto[];
    TotalQuantityOnHand : number; // Int32
  }

  export class StockDto {
    ProductID : number; // Int32
    Product : EVA.Core.ProductDto;
    OrganizationUnitID : number; // Int32
    StockLabel : number; // Int32
    StockLabelID : number; // Int32
    ResourceID : number; // Int32, nullable
    QuantityOnHand : number; // Int32
    QuantityCommitted : number; // Int32
    QuantityAvailable : number; // Int32
    Remark : string;
  }

  export class UpdateStock extends EVA.Core.RequestMessageWithEmptyResponse {
    OrganizationUnitID : number; // Int32, nullable
    Stock : { [ key : number ] : number };
    __response : EVA.Core.EmptyResponseMessage;
  }

  export class GetPurchaseOrderShipment extends EVA.Core.RequestMessageGeneric<EVA.Core.Services.GetPurchaseOrderShipmentResponse> {
    ShipmentID : number; // Int32
    __response : EVA.Core.Services.GetPurchaseOrderShipmentResponse;
  }

  export class GetPurchaseOrderShipmentResponse extends EVA.Core.ResponseMessage {
    Shipment : EVA.Core.PurchaseOrderShipmentDto;
  }

  export class GetShipmentLines extends EVA.Core.RequestMessageGeneric<EVA.Core.Services.GetShipmentLinesResponse> {
    ShipmentID : number; // Int32
    __response : EVA.Core.Services.GetShipmentLinesResponse;
  }

  export class GetShipmentLinesResponse extends EVA.Core.ResponseMessage {
    Result : EVA.Core.Services.GetShipmentLinesResponseModel[];
  }

  export class GetShipmentLinesResponseModel {
    ID : number; // Int32
    ProductID : number; // Int32
    Description : string;
    QuantityShipped : number; // Int32
    CurrencyID : string;
    UnitPrice : number; // Decimal
    ExchangeRate : number; // Decimal
    ForeignUnitPrice : number; // Decimal
    ForeignTotalAmount : number; // Decimal
  }

  export class ListPurchaseOrderShipmentLines extends EVA.Core.PagedResultRequest<EVA.Core.Services.ListPurchaseOrderShipmentLinesResponse> {
    ShipmentID : number; // Int32
    __response : EVA.Core.Services.ListPurchaseOrderShipmentLinesResponse;
  }

  export class ListPurchaseOrderShipmentLinesResponse extends EVA.Core.PagedResultResponse<EVA.Core.PurchaseOrderShipmentLineDto> {
  }

  export class ListPurchaseOrderShipments extends EVA.Core.PagedResultRequest<EVA.Core.Services.ListPurchaseOrderShipmentsResponse> {
    OrganizationUnitID : number; // Int32, nullable
    BackendID : string;
    TrackingCode : string;
    IsCompleted : boolean;
    __response : EVA.Core.Services.ListPurchaseOrderShipmentsResponse;
  }

  export class ListPurchaseOrderShipmentsResponse extends EVA.Core.PagedResultResponse<EVA.Core.PurchaseOrderShipmentDto> {
  }

  export class ProducePackingSlip extends EVA.Core.RequestMessageGeneric<EVA.Core.ResourceResponseMessage> {
    StationID : number; // Int32, nullable
    Download : boolean;
    Print : boolean;
    ShipmentID : number; // Int32
    __response : EVA.Core.ResourceResponseMessage;
  }

  export class ProducePickSlip extends EVA.Core.RequestMessageGeneric<EVA.Core.ResourceResponseMessage> {
    StationID : number; // Int32, nullable
    Download : boolean;
    Print : boolean;
    OrderID : number; // Int32
    __response : EVA.Core.ResourceResponseMessage;
  }

  export class GetSetting extends EVA.Core.RequestMessageGeneric<EVA.Core.Services.GetSettingResponse> {
    OrganizationUnitID : number; // Int32, nullable
    Key : string;
    __response : EVA.Core.Services.GetSettingResponse;
  }

  export class GetSettingResponse extends EVA.Core.ResponseMessage {
    Value : string;
  }

  export class ListSettings extends EVA.Core.RequestMessageGeneric<EVA.Core.Services.ListSettingsResponse> {
    OrganizationUnitID : number; // Int32
    KeyPrefix : string;
    __response : EVA.Core.Services.ListSettingsResponse;
  }

  export class ListSettingsResponse extends EVA.Core.ResponseMessage {
    Settings : { [ key : string ] : string };
  }

  export class SetSetting extends EVA.Core.RequestMessageGeneric<EVA.Core.Services.SetSettingResponse> {
    OrganizationUnitID : number; // Int32, nullable
    Key : string;
    Value : string;
    __response : EVA.Core.Services.SetSettingResponse;
  }

  export class SetSettingResponse extends EVA.Core.ResponseMessage {
  }

  export class UnsetSetting extends EVA.Core.RequestMessageGeneric<EVA.Core.Services.UnsetSettingResponse> {
    OrganizationUnitID : number; // Int32, nullable
    Key : string;
    __response : EVA.Core.Services.UnsetSettingResponse;
  }

  export class UnsetSettingResponse extends EVA.Core.ResponseMessage {
  }

  export class ApprovePendingUser extends EVA.Core.RequestMessageWithEmptyResponse {
    UserID : number; // Int32
    __response : EVA.Core.EmptyResponseMessage;
  }

  export class GetRole extends EVA.Core.GetRequestGeneric<EVA.Core.Services.GetRoleResponse> {
    __response : EVA.Core.Services.GetRoleResponse;
  }

  export class GetRoleResponse extends EVA.Core.ResponseMessage {
    Result : EVA.Core.Services.GetRoleResponseRoleWithFunctionalitiesDto;
  }

  export class RoleDto {
    ID : number; // Int32
    Name : string;
    UserTypeID : number; // Int32
    ApplicationID : number; // Int32
    Code : string;
  }

  export class GetRoleResponseRoleWithFunctionalitiesDto extends EVA.Core.Services.RoleDto {
    Functionalities : string[];
  }

  export class ListRoles extends EVA.Core.PagedResultRequest<EVA.Core.Services.ListRolesResponse> {
    __response : EVA.Core.Services.ListRolesResponse;
  }

  export class ListRolesResponse extends EVA.Core.PagedResultResponse<EVA.Core.Services.RoleDto> {
  }

  export class CreateRole extends EVA.Core.CreateRequest<EVA.Core.Services.RoleDto> implements EVA.Core.IRequestRespondsAs<EVA.Core.CreateResponse> {
    __response : EVA.Core.CreateResponse;
  }

  export class UpdateRole extends EVA.Core.UpdateRequest<EVA.Core.Services.RoleDto> implements EVA.Core.IRequestRespondsAs<EVA.Core.EmptyResponseMessage> {
    __response : EVA.Core.EmptyResponseMessage;
  }

  export class DeleteRole extends EVA.Core.DeleteRequest implements EVA.Core.IRequestRespondsAs<EVA.Core.EmptyResponseMessage> {
    __response : EVA.Core.EmptyResponseMessage;
  }

  export class AttachFunctionalitiesToRole extends EVA.Core.RequestMessageGeneric<EVA.Core.EmptyResponseMessage> {
    RoleID : number; // Int32
    Functionalities : string[];
    __response : EVA.Core.EmptyResponseMessage;
  }

  export class DetachFunctionalitiesFromRole extends EVA.Core.RequestMessageGeneric<EVA.Core.EmptyResponseMessage> {
    RoleID : number; // Int32
    Functionalities : string[];
    __response : EVA.Core.EmptyResponseMessage;
  }

  export class GetAvailableRoles extends EVA.Core.RequestMessageGeneric<EVA.Core.Services.GetAvailableRolesResponse> {
    UserID : number; // Int32
    __response : EVA.Core.Services.GetAvailableRolesResponse;
  }

  export class GetAvailableRolesResponse extends EVA.Core.ResponseMessage {
    AvailableRoles : EVA.Core.Services.RoleDto[];
  }

  export class GetFlattenedFunctionalityByUserID extends EVA.Core.RequestMessageGeneric<EVA.Core.Services.GetFlattenedFunctionalityByUserIDResponse> {
    UserID : number; // Int32
    OrganizationUnitID : number; // Int32
    __response : EVA.Core.Services.GetFlattenedFunctionalityByUserIDResponse;
  }

  export class GetFlattenedFunctionalityByUserIDResponse extends EVA.Core.ResponseMessage {
    Functionalities : string[];
  }

  export class GetFunctionalitiesByUserID extends EVA.Core.RequestMessageGeneric<EVA.Core.Services.GetFunctionalitiesByUserIDResponse> {
    UserID : number; // Int32
    OrganizationUnitID : number; // Int32
    __response : EVA.Core.Services.GetFunctionalitiesByUserIDResponse;
  }

  export class GetFunctionalitiesByUserIDResponse extends EVA.Core.ResponseMessage {
    AvailableFunctionalities : string[];
    CurrentFunctionalities : string[];
    CurrentFunctionalitiesExtended : EVA.Core.Services.FunctionalityDto[];
  }

  export class FunctionalityDto {
    Functionality : string;
    EndDate : string; // DateTime, nullable
    DisableHierarchy : boolean;
    OrganizationUnitID : number; // Int32
    OrganizationUnitName : string;
    RoleID : number; // Int32, nullable
    RoleName : string;
  }

  export class GetSupportedFunctionalities extends EVA.Core.RequestMessageGeneric<EVA.Core.Services.GetSupportedFunctionalitiesResponse> {
    __response : EVA.Core.Services.GetSupportedFunctionalitiesResponse;
  }

  export class GetSupportedFunctionalitiesResponse extends EVA.Core.ResponseMessage {
    Functionalities : string[];
  }

  export class GetUserRolesByUserID extends EVA.Core.PagedResultRequest<EVA.Core.Services.GetUserRolesByUserIDResponse> {
    UserID : number; // Int32
    OrganizationUnitID : number; // Int32
    __response : EVA.Core.Services.GetUserRolesByUserIDResponse;
  }

  export class GetUserRolesByUserIDResponse extends EVA.Core.ResponseMessage {
    Result : EVA.Core.Services.GetUserRolesByUserIDResponseUserRoleDto[];
  }

  export class GetUserRolesByUserIDResponseUserRoleDto {
    ID : number; // Int32
    UserID : number; // Int32
    OrganizationUnitID : number; // Int32
    RoleID : number; // Int32
    EndDate : string; // DateTime, nullable
    DisableHierarchy : boolean;
    Pending : boolean;
    Role : EVA.Core.Services.RoleDto;
  }

  export class ListPendingUsers extends EVA.Core.PagedResultRequest<EVA.Core.Services.ListPendingUsersResponse> {
    __response : EVA.Core.Services.ListPendingUsersResponse;
  }

  export class ListPendingUsersResponse extends EVA.Core.PagedResultResponse<EVA.Core.Services.PendingUser> {
  }

  export class PendingUser {
    ID : number; // Int32
    FullName : string;
    EmailAddress : string;
    GravatarHash : string;
  }

  export class UpdateUserFunctionalities extends EVA.Core.RequestMessageWithEmptyResponse {
    Data : EVA.Core.Services.UpdatedUserFunctionalitiesDto[];
    __response : EVA.Core.EmptyResponseMessage;
  }

  export class UpdatedUserFunctionalitiesDto {
    UserID : number; // Int32
    OrganizationUnitID : number; // Int32
    Functionalities : EVA.Core.Services.UpdatedFunctionalityDto[];
  }

  export class UpdatedFunctionalityDto {
    Functionality : string;
    IsRemoved : boolean;
    EndDate : string; // DateTime, nullable
    DisableHierarchy : boolean;
  }

  export class UpdateUserRoles extends EVA.Core.RequestMessageWithEmptyResponse {
    RoleID : number; // Int32
    OrganizationUnitID : number; // Int32
    IsRemoved : boolean;
    UserID : number; // Int32
    EndDate : string; // DateTime, nullable
    UserType : EVA.Core.UserTypes;
    DisableHierarchy : boolean;
    Pending : boolean;
    __response : EVA.Core.EmptyResponseMessage;
  }

  export class CompleteReturnRequest extends EVA.Core.RequestMessageWithEmptyResponse {
    ID : number; // Int32
    __response : EVA.Core.EmptyResponseMessage;
  }

  export class CreateCMA extends EVA.Core.RequestMessageGeneric<EVA.Core.EmptyResponseMessage> {
    ReturnRequest : EVA.Core.Services.CMARequest;
    __response : EVA.Core.EmptyResponseMessage;
  }

  export class CMARequest {
    ID : number; // Int32
    Reference : string;
    Lines : EVA.Core.Services.CMARequestLine[];
  }

  export class CMARequestLine {
    ID : number; // Int32
    ProductID : number; // Int32
    Quantity : number; // Int32
    ResourceID : number; // Int32, nullable
    Reason : string;
  }

  export class CreateRMA extends EVA.Core.RequestMessageWithEmptyResponse {
    Lines : EVA.Core.Services.RMARequestLine[];
    __response : EVA.Core.EmptyResponseMessage;
  }

  export class RMARequestLine {
    Reference : string;
    ReturnRequestLineID : number; // Int32
  }

  export class DeleteRMALines extends EVA.Core.RequestMessageWithEmptyResponse {
    ReturnRequestLineIDs : number[];
    __response : EVA.Core.EmptyResponseMessage;
  }

  export class DeleteRMA extends EVA.Core.RequestMessageWithEmptyResponse {
    ReturnRequestID : number; // Int32
    ReturnRequestLineIDs : number[];
    __response : EVA.Core.EmptyResponseMessage;
  }

  export class GetReturnRequest extends EVA.Core.GetRequestGeneric<EVA.Core.Services.GetReturnRequestResponse> {
    __response : EVA.Core.Services.GetReturnRequestResponse;
  }

  export class GetReturnRequestResponse extends EVA.Core.GetResponse<EVA.Core.Services.ReturnRequestDto> {
  }

  export class ReturnRequestDto {
    ID : number; // Int32
    Lines : EVA.Core.Services.ReturnRequestLineDto[];
    Reference : string;
    Number : string;
    Status : EVA.Core.ReturnRequestStatus;
    Type : EVA.Core.ReturnRequestTypes;
    CreationTime : string; // DateTime
    OrganizationUnitID : number; // Int32
  }

  export class ReturnRequestLineDto {
    ID : number; // Int32
    Product : EVA.Core.ProductDto;
    ProductID : number; // Int32
    Quantity : number; // Int32
    ResourceID : number; // Int32, nullable
    Reason : string;
    StockMutationID : number; // Int32, nullable
  }

  export class ListAvailableRMA extends EVA.Core.RequestMessageGeneric<EVA.Core.Services.ListAvailableRMAResponse> {
    __response : EVA.Core.Services.ListAvailableRMAResponse;
  }

  export class ListAvailableRMAResponse extends EVA.Core.ResponseMessage {
    Lines : EVA.Core.Services.ReturnRequestLineDto[];
  }

  export class ListReturnRequest extends EVA.Core.PagedResultRequest<EVA.Core.Services.ListReturnRequestResponse> {
    __response : EVA.Core.Services.ListReturnRequestResponse;
  }

  export class ListReturnRequestResponse extends EVA.Core.PagedResultResponse<EVA.Core.Services.ReturnRequestDto> {
  }

  export class ProduceReturnRequestDocument extends EVA.Core.RequestMessageGeneric<EVA.Core.ResourceResponseMessage> {
    ReturnRequestID : number; // Int32
    StationID : number; // Int32, nullable
    DownloadDocument : boolean;
    __response : EVA.Core.ResourceResponseMessage;
  }

  export class UpdateCMA extends EVA.Core.RequestMessageWithEmptyResponse {
    ReturnRequest : EVA.Core.Services.CMARequest;
    __response : EVA.Core.EmptyResponseMessage;
  }

  export class CreateRecurringTask extends EVA.Core.RequestMessageWithEmptyResponse {
    ID : string;
    FullName : string;
    Cron : string;
    Arguments : { [ key : string ] : string };
    __response : EVA.Core.EmptyResponseMessage;
  }

  export class DeleteRecurringTask extends EVA.Core.RequestMessageWithEmptyResponse {
    ID : string;
    __response : EVA.Core.EmptyResponseMessage;
  }

  export class EnqueueTask extends EVA.Core.RequestMessageWithEmptyResponse {
    FullName : string;
    Arguments : { [ key : string ] : string };
    __response : EVA.Core.EmptyResponseMessage;
  }

  export class ListAvailableRecurringTasks extends EVA.Core.RequestMessageGeneric<EVA.Core.Services.ListAvailableRecurringTasksResponse> {
    __response : EVA.Core.Services.ListAvailableRecurringTasksResponse;
  }

  export class ListAvailableRecurringTasksResponse extends EVA.Core.ResponseMessage {
    Tasks : EVA.Core.Services.ListAvailableRecurringTasksResponseTaskPluginDto[];
  }

  export class ListAvailableRecurringTasksResponseTaskPluginDto {
    Name : string;
    FullName : string;
    Description : string;
    AvailableSettings : EVA.Core.Services.TaskPluginSettings[];
    DefaultName : string;
    DefaultCron : string;
  }

  export class TaskPluginSettings {
    Key : string;
    Description : string;
    Required : boolean;
    Default : any;
  }

  export class ListRecurringTasks extends EVA.Core.RequestMessageGeneric<EVA.Core.Services.ListRecurringTasksResponse> {
    __response : EVA.Core.Services.ListRecurringTasksResponse;
  }

  export class ListRecurringTasksResponse extends EVA.Core.ResponseMessage {
    Tasks : EVA.Core.RecurringTask[];
  }

  export class ListRecurringTasks2 extends EVA.Core.PagedResultRequest<EVA.Core.Services.ListRecurringTasks2Response> {
    __response : EVA.Core.Services.ListRecurringTasks2Response;
  }

  export class ListRecurringTasks2Response extends EVA.Core.PagedResultResponse<EVA.Core.RecurringTask> {
  }

  export class ManualTriggerRecurringTask extends EVA.Core.RequestMessageWithEmptyResponse {
    Token : string;
    __response : EVA.Core.EmptyResponseMessage;
  }

  export class TriggerRecurringTask extends EVA.Core.RequestMessageWithEmptyResponse {
    ID : string;
    __response : EVA.Core.EmptyResponseMessage;
  }

  export class UpdateRecurringTask extends EVA.Core.RequestMessageWithEmptyResponse {
    ID : string;
    FullName : string;
    Cron : string;
    Arguments : { [ key : string ] : string };
    __response : EVA.Core.EmptyResponseMessage;
  }

  export class AddPushNotificationDevice extends EVA.Core.RequestMessageWithEmptyResponse {
    DeviceToken : string;
    DeviceOS : string;
    MobileAppID : string;
    BackendSystemID : string;
    __response : EVA.Core.EmptyResponseMessage;
  }

  export class RemovePushNotificationDevice extends EVA.Core.RequestMessageWithEmptyResponse {
    DeviceToken : string;
    BackendSystemID : string;
    __response : EVA.Core.EmptyResponseMessage;
  }

  export class SendPushNotificationBatch extends EVA.Core.RequestMessageWithEmptyResponse {
    Title : string;
    Message : string;
    UserIDs : number[];
    Priority : EVA.Core.PushNotificationPriority;
    TimeToLive : number; // Int32, nullable
    Sound : string;
    SilentNotification : boolean;
    Payload : any;
    __response : EVA.Core.EmptyResponseMessage;
  }

  export class AddLineToPurchaseOrder extends EVA.Core.RequestMessageGeneric<EVA.Core.Services.AddLineToPurchaseOrderResponse> {
    OrderID : number; // Int32
    ProductID : number; // Int32
    Quantity : number; // Int32
    UnitPrice : number; // Decimal
    RequestedDate : string; // DateTime, nullable
    Reference : string;
    __response : EVA.Core.Services.AddLineToPurchaseOrderResponse;
  }

  export class AddLineToPurchaseOrderResponse extends EVA.Core.ResponseMessage {
    Result : EVA.Core.Services.AddLineToPurchaseOrderResponseModel;
  }

  export class AddLineToPurchaseOrderResponseModel {
    ID : number; // Int32
    ProductID : number; // Int32
    Quantity : number; // Int32
    UnitPrice : number; // Decimal
    RequestedDate : string; // DateTime, nullable
    Reference : string;
  }

  export class CreatePurchaseOrder extends EVA.Core.RequestMessageGeneric<EVA.Core.Services.CreatePurchaseOrderResponse> {
    OrganizationUnitID : number; // Int32
    SupplierID : number; // Int32, nullable
    SupplierReference : string;
    __response : EVA.Core.Services.CreatePurchaseOrderResponse;
  }

  export class CreatePurchaseOrderResponse extends EVA.Core.ResponseMessage {
    Success : boolean;
    ID : number; // Int32
  }

  export class DeletePurchaseOrderLine extends EVA.Core.RequestMessageWithEmptyResponse {
    ID : number; // Int32
    __response : EVA.Core.EmptyResponseMessage;
  }

  export class ExportUnshippedPurchaseOrdersToExcel extends EVA.Core.RequestMessageGeneric<EVA.Core.Services.ExportUnshippedPurchaseOrdersToExcelResponse> {
    ShipFromOrganizationUnitID : number; // Int32
    __response : EVA.Core.Services.ExportUnshippedPurchaseOrdersToExcelResponse;
  }

  export class ExportUnshippedPurchaseOrdersToExcelResponse extends EVA.Core.ResponseMessage {
    DownloadUrl : string;
  }

  export class FullyReceiveDeliveryNoteNumber extends EVA.Core.RequestMessageGeneric<EVA.Core.Services.FullyReceiveDeliveryNoteNumberResponse> {
    DeliveryNoteNumber : string;
    __response : EVA.Core.Services.FullyReceiveDeliveryNoteNumberResponse;
  }

  export class FullyReceiveDeliveryNoteNumberResponse extends EVA.Core.ResponseMessage {
    ReservedOrdersCount : number; // Int32
  }

  export class FullyShipPurchaseOrder extends EVA.Core.RequestMessageWithEmptyResponse {
    PurchaseOrderID : number; // Int32
    ShipmentBackendID : string;
    BackendSystemID : string;
    TrackingCode : string;
    __response : EVA.Core.EmptyResponseMessage;
  }

  export class GetOrganizationUnitCreditBalance extends EVA.Core.RequestMessageGeneric<EVA.Core.Services.GetOrganizationUnitCreditBalanceResponse> {
    OrganizationUnitID : number; // Int32
    __response : EVA.Core.Services.GetOrganizationUnitCreditBalanceResponse;
  }

  export class GetOrganizationUnitCreditBalanceResponse extends EVA.Core.ResponseMessage {
    CreditBalance : number; // Decimal
  }

  export class GetShipmentDetails2 extends EVA.Core.RequestMessageGeneric<EVA.Core.Services.GetShipmentDetails2Response> {
    DeliveryNoteNumber : string;
    __response : EVA.Core.Services.GetShipmentDetails2Response;
  }

  export class GetShipmentDetails2Response extends EVA.Core.ResponseMessage {
    ReceiveMethod : EVA.Core.Services.PurchaseOrderReceiveMethods;
    WorkSet : EVA.Core.Services.ReceiveShipmentWorkSet;
  }

  export enum PurchaseOrderReceiveMethods {
    Manual = 0,
    Automatic = 1,
  }

  export class ReceiveShipmentWorkSet {
    DeliveryNoteNumber : string;
    Lines : EVA.Core.Services.ReceiveShipmentWorkSetLine[];
  }

  export class ReceiveShipmentWorkSetLine {
    ProductID : number; // Int32
    ProductPrimitiveName : string;
    QuantityOrdered : number; // Int32
    Receipts : EVA.Core.Services.ReceiveShipmentWorkSetLineReceipt[];
    RequiredResourceTypes : EVA.Core.Services.StockResourceTypeDto[];
    QuantityAlreadyReceived : number; // Int32
    QuantityShipped : number; // Int32
  }

  export class ReceiveShipmentWorkSetLineReceipt {
    QuantityReceived : number; // Int32
    Resource : EVA.Core.Services.ReceiveShipmentWorkSetLineResource;
  }

  export class ReceiveShipmentWorkSetLineResource {
    ResourceID : number; // Int32, nullable
    Resources : { [ key : string ] : string };
  }

  export class GetSupplierStockForProduct extends EVA.Core.RequestMessageGeneric<EVA.Core.Services.GetSupplierStockForProductResponse> {
    OrganizationUnitID : number; // Int32
    SupplierID : number; // Int32
    ProductID : number; // Int32
    __response : EVA.Core.Services.GetSupplierStockForProductResponse;
  }

  export class GetSupplierStockForProductResponse extends EVA.Core.ResponseMessage {
    AvailableStock : number; // Int32
  }

  export class ModifyPurchaseOrderLine extends EVA.Core.RequestMessageWithEmptyResponse {
    ID : number; // Int32
    UnitPrice : number; // Decimal, nullable
    RequestedDate : string; // DateTime, nullable
    Reference : string;
    __response : EVA.Core.EmptyResponseMessage;
  }

  export class PlacePurchaseOrder extends EVA.Core.RequestMessageWithEmptyResponse {
    OrderID : number; // Int32
    __response : EVA.Core.EmptyResponseMessage;
  }

  export class ProcessUnshippedPurchaseOrdersFromExcel extends EVA.Core.RequestMessageWithEmptyResponse {
    Data : number[];
    __response : EVA.Core.EmptyResponseMessage;
  }

  export class GeneratePurchaseOrderExcelSample extends EVA.Core.RequestMessageGeneric<EVA.Core.ResourceResponseMessage> {
    __response : EVA.Core.ResourceResponseMessage;
  }

  export class UploadPurchaseOrderExcel extends EVA.Core.RequestMessageWithEmptyResponse {
    Data : number[];
    __response : EVA.Core.EmptyResponseMessage;
  }

  export class ReceivePurchaseOrderShipment extends EVA.Core.RequestMessageGeneric<EVA.Core.Services.ReceivePurchaseOrderShipmentResponse> {
    ShipmentID : number; // Int32
    QuantityReceived : { [ key : number ] : number };
    __response : EVA.Core.Services.ReceivePurchaseOrderShipmentResponse;
  }

  export class ReceivePurchaseOrderShipmentResponse extends EVA.Core.ResponseMessage {
    Success : boolean;
    Result : EVA.Core.ReceiveShipmentResult;
  }

  export class ReceiveShipment extends EVA.Core.RequestMessageWithEmptyResponse {
    WorkSet : EVA.Core.Services.ReceiveShipmentWorkSet;
    CompleteShipment : boolean;
    __response : EVA.Core.EmptyResponseMessage;
  }

  export class ShipPurchaseOrder extends EVA.Core.RequestMessageGeneric<EVA.Core.Services.ShipPurchaseOrderResponse> {
    OrderID : number; // Int32
    BackendID : string;
    TrackingCode : string;
    ShipmentDate : string; // DateTime
    Lines : EVA.Core.Services.ShipPurchaseOrderLine[];
    __response : EVA.Core.Services.ShipPurchaseOrderResponse;
  }

  export class ShipPurchaseOrderResponse extends EVA.Core.ResponseMessage {
    ShipmentID : number; // Int32
  }

  export class ShipPurchaseOrderLine {
    OrderLineID : number; // Int32
    QuantityToShip : number; // Int32
  }

  export class GetConfigurableProductDetail extends EVA.Core.GetRequestGeneric<EVA.Core.Services.GetConfigurableProductDetailResponse> {
    Includes : string[];
    __response : EVA.Core.Services.GetConfigurableProductDetailResponse;
  }

  export class GetConfigurableProductDetailResponse extends EVA.Core.ResponseMessage {
    Configurable : EVA.PIM.Core.ConfigurableProductDto;
  }

  export class GetConfigurableProductsDetail extends EVA.Core.RequestMessageGeneric<EVA.Core.Services.GetConfigurableProductsDetailResponse> {
    ProductIDs : number[];
    Includes : string[];
    __response : EVA.Core.Services.GetConfigurableProductsDetailResponse;
  }

  export class GetConfigurableProductsDetailResponse extends EVA.Core.ResponseMessage {
    Configurables : { [ key : number ] : EVA.PIM.Core.ConfigurableProductDto };
  }

  export class GetProductByBarcode extends EVA.Core.RequestMessageGeneric<EVA.Core.Services.GetProductByBarcodeResponse> {
    Barcode : string;
    __response : EVA.Core.Services.GetProductByBarcodeResponse;
  }

  export class GetProductByBarcodeResponse extends EVA.Core.ResponseMessage {
    Result : any;
  }

  export class GetProductDetail extends EVA.Core.GetRequestGeneric<EVA.Core.Services.GetProductDetailResponse> {
    __response : EVA.Core.Services.GetProductDetailResponse;
  }

  export class GetProductDetailResponse extends EVA.Core.GetResponse<any> {
  }

  export class GetProductImage extends EVA.Core.RequestMessageGeneric<EVA.Core.Services.GetProductImageResponse> {
    ProductID : number; // Int32
    SequenceID : number; // Int32
    Width : number; // Int32
    Height : number; // Int32
    Format : string;
    __response : EVA.Core.Services.GetProductImageResponse;
  }

  export class GetProductImageResponse extends EVA.Core.ResponseMessage {
    Format : string;
    Path : string;
    Description : string;
    Stream : number[];
  }

  export class GetProductPrices extends EVA.Core.RequestMessageGeneric<EVA.Core.Services.GetProductPricesResponse> {
    ProductIDs : number[];
    __response : EVA.Core.Services.GetProductPricesResponse;
  }

  export class GetProductPricesResponse extends EVA.Core.ResponseMessage {
    Prices : EVA.Core.Services.PriceInfo[];
  }

  export class PriceInfo {
    ProductID : number; // Int32
    PriceListID : number; // Int32
    PriceListUsageTypeID : number; // Int32
    PriceListUsageTypeName : string;
    CurrencyID : string;
    TaxRate : number; // Decimal
    Price : number; // Decimal
    PriceInTax : number; // Decimal
    OriginalPrice : number; // Decimal, nullable
    OriginalPriceInTax : number; // Decimal, nullable
  }

  export class GetProductPricing extends EVA.Core.RequestMessageGeneric<EVA.Core.Services.GetProductPricingResponse> {
    ProductID : number; // Int32
    __response : EVA.Core.Services.GetProductPricingResponse;
  }

  export class GetProductPricingResponse extends EVA.Core.ResponseMessage {
    UnitPrice : number; // Decimal
    OriginalUnitPrice : number; // Decimal, nullable
    TaxRate : number; // Decimal
    UnitPriceInTax : number; // Decimal
    OriginalUnitPriceInTax : number; // Decimal, nullable
    UnitCost : number; // Decimal, nullable
  }

  export class GetProductSearchSuggestions extends EVA.Core.RequestMessageGeneric<EVA.Core.Services.GetProductSearchSuggestionsResponse> {
    Text : string;
    MaxSuggestions : number; // Int32, nullable
    __response : EVA.Core.Services.GetProductSearchSuggestionsResponse;
  }

  export class GetProductSearchSuggestionsResponse extends EVA.Core.ResponseMessage {
    Suggestions : EVA.Core.SuggestionModel[];
  }

  export class ListBrandsPaged extends EVA.Core.PagedResultRequest<EVA.Core.Services.ListBrandsPagedResponse> {
    __response : EVA.Core.Services.ListBrandsPagedResponse;
  }

  export class ListBrandsPagedResponse extends EVA.Core.PagedResultResponse<EVA.Core.Services.BrandDto> {
  }

  export class BrandDto {
    ID : number; // Int32
    Name : string;
    BackendID : string;
  }

  export class ListBrands extends EVA.Core.RequestMessageGeneric<EVA.Core.Services.ListBrandsResponse> {
    __response : EVA.Core.Services.ListBrandsResponse;
  }

  export class ListBrandsResponse extends EVA.Core.ResponseMessage {
    Result : EVA.Core.Services.BrandDto[];
  }

  export class CreateProductAvailabilityData extends EVA.Core.CreateRequest<EVA.Core.ProductAvailabilityDataDto> implements EVA.Core.IRequestRespondsAs<EVA.Core.EmptyResponseMessage> {
    __response : EVA.Core.EmptyResponseMessage;
  }

  export class DeleteProductAvailabilityData extends EVA.Core.DeleteRequest implements EVA.Core.IRequestRespondsAs<EVA.Core.EmptyResponseMessage> {
    __response : EVA.Core.EmptyResponseMessage;
  }

  export class GetProductAvailabilityData extends EVA.Core.GetRequestGeneric<EVA.Core.Services.GetProductAvailabilityDataResponse> {
    __response : EVA.Core.Services.GetProductAvailabilityDataResponse;
  }

  export class GetProductAvailabilityDataResponse extends EVA.Core.GetResponse<EVA.Core.ProductAvailabilityDataDto> {
  }

  export class ListProductAvailabilityData extends EVA.Core.RequestMessageGeneric<EVA.Core.Services.ListProductAvailabilityDataResponse> {
    __response : EVA.Core.Services.ListProductAvailabilityDataResponse;
  }

  export class ListProductAvailabilityDataResponse extends EVA.Core.ResponseMessage {
    Result : EVA.Core.ProductAvailabilityDataDto[];
  }

  export class UpdateProductAvailabilityData extends EVA.Core.UpdateRequest<EVA.Core.ProductAvailabilityDataDto> implements EVA.Core.IRequestRespondsAs<EVA.Core.EmptyResponseMessage> {
    __response : EVA.Core.EmptyResponseMessage;
  }

  export class SearchBrands extends EVA.Core.RequestMessageGeneric<EVA.Core.Services.SearchBrandsResponse> {
    PageSize : number; // Int32, nullable
    Query : string;
    __response : EVA.Core.Services.SearchBrandsResponse;
  }

  export class SearchBrandsResponse extends EVA.Core.ResponseMessage {
    Brands : EVA.Core.BrandNameInfo[];
  }

  export class UploadSupplierProductsBase extends EVA.Core.RequestMessageGeneric<EVA.Core.Services.UploadSupplierProductsResponse> {
    OrganizationUnitID : number; // Int32, nullable
    Data : number[];
  }

  export class UploadSupplierProductsResponse extends EVA.Core.ResponseMessage {
    TotalProductCount : number; // Int32
    FailedCount : number; // Int32
    Messages : { [ key : string ] : string };
    DeletedCount : number; // Int32
  }

  export class UploadSupplierProducts extends EVA.Core.Services.UploadSupplierProductsBase {
    __response : EVA.Core.Services.UploadSupplierProductsResponse;
  }

  export class UploadSupplierProductsStock extends EVA.Core.Services.UploadSupplierProductsBase {
    __response : EVA.Core.Services.UploadSupplierProductsResponse;
  }

  export class UploadSupplierProductsPricing extends EVA.Core.Services.UploadSupplierProductsBase {
    __response : EVA.Core.Services.UploadSupplierProductsResponse;
  }

  export class DownloadSupplierProductsSample extends EVA.Core.RequestMessageWithResourceResponse {
    __response : EVA.Core.ResourceResponseMessage;
  }

  export class DownloadSupplierProductsStockSample extends EVA.Core.RequestMessageWithResourceResponse {
    __response : EVA.Core.ResourceResponseMessage;
  }

  export class DownloadSupplierProductsPricingSample extends EVA.Core.RequestMessageWithResourceResponse {
    __response : EVA.Core.ResourceResponseMessage;
  }

  export class UpdateProductPricing extends EVA.Core.RequestMessageWithEmptyResponse {
    ProductID : number; // Int32
    UnitPrice : number; // Decimal, nullable
    UnitCost : number; // Decimal, nullable
    __response : EVA.Core.EmptyResponseMessage;
  }

  export class GetPriceListAdjustmentByID extends EVA.Core.RequestMessageGeneric<EVA.Core.Services.GetPriceListAdjustmentByIDResponse> {
    ID : number; // Int32
    __response : EVA.Core.Services.GetPriceListAdjustmentByIDResponse;
  }

  export class GetPriceListAdjustmentByIDResponse extends EVA.Core.ResponseMessage {
    ID : number; // Int32
    PriceListID : number; // Int32
    PriceList : EVA.Core.Services.GetPriceListAdjustmentByIDResponsePriceListDto;
    Sequence : number; // Int32
    Name : string;
    Target : EVA.Core.PriceListAdjustmentTargets;
    EffectiveDate : string; // DateTime
    ExpireDate : string; // DateTime, nullable
    OverridePrice : boolean;
    Type : string;
    Data : any;
  }

  export class GetPriceListAdjustmentByIDResponsePriceListDto {
    Name : string;
    CurrencyID : string;
  }

  export class CreatePriceListAdjustment extends EVA.Core.RequestMessageGeneric<EVA.Core.Services.CreatePriceListAdjustmentResponse> {
    PriceListID : number; // Int32
    Sequence : number; // Int32
    Name : string;
    Target : EVA.Core.PriceListAdjustmentTargets;
    EffectiveDate : string; // DateTime
    ExpireDate : string; // DateTime, nullable
    OverridePrice : boolean;
    Type : string;
    Data : any;
    __response : EVA.Core.Services.CreatePriceListAdjustmentResponse;
  }

  export class CreatePriceListAdjustmentResponse extends EVA.Core.ResponseMessage {
    ID : number; // Int32
  }

  export class UpdatePriceListAdjustment extends EVA.Core.RequestMessageWithEmptyResponse {
    ID : number; // Int32
    PriceListID : number; // Int32
    Sequence : number; // Int32
    Name : string;
    Target : EVA.Core.PriceListAdjustmentTargets;
    EffectiveDate : string; // DateTime
    ExpireDate : string; // DateTime, nullable
    OverridePrice : boolean;
    Type : string;
    Data : any;
    __response : EVA.Core.EmptyResponseMessage;
  }

  export class DeletePriceListAdjustment extends EVA.Core.RequestMessageWithEmptyResponse {
    ID : number; // Int32
    __response : EVA.Core.EmptyResponseMessage;
  }

  export class ListPriceListAdjustments extends EVA.Core.PagedResultRequest<EVA.Core.Services.ListPriceListAdjustmentsResponse> {
    __response : EVA.Core.Services.ListPriceListAdjustmentsResponse;
  }

  export class ListPriceListAdjustmentsResponse extends EVA.Core.PagedResultResponse<EVA.Core.Services.ListPriceListAdjustmentsResponsePriceListAdjustmentDto> {
  }

  export class ListPriceListAdjustmentsResponsePriceListAdjustmentDto {
    ID : number; // Int32
    PriceListID : number; // Int32
    PriceList : EVA.Core.Services.ListPriceListAdjustmentsResponsePriceListAdjustmentDtoPriceListDto;
    Sequence : number; // Int32
    Name : string;
    Target : EVA.Core.PriceListAdjustmentTargets;
    EffectiveDate : string; // DateTime
    ExpireDate : string; // DateTime, nullable
    OverridePrice : boolean;
    Type : string;
    Data : any;
  }

  export class ListPriceListAdjustmentsResponsePriceListAdjustmentDtoPriceListDto {
    Name : string;
    CurrencyID : string;
  }

  export class GetPriceListByID extends EVA.Core.RequestMessageGeneric<EVA.Core.Services.GetPriceListByIDResponse> {
    ID : number; // Int32
    __response : EVA.Core.Services.GetPriceListByIDResponse;
  }

  export class GetPriceListByIDResponse extends EVA.Core.ResponseMessage {
    ID : number; // Int32
    Name : string;
    CurrencyID : string;
    IsActive : boolean;
  }

  export class CreatePriceList extends EVA.Core.RequestMessageGeneric<EVA.Core.Services.CreatePriceListResponse> {
    Name : string;
    CurrencyID : string;
    IsActive : boolean;
    __response : EVA.Core.Services.CreatePriceListResponse;
  }

  export class CreatePriceListResponse extends EVA.Core.ResponseMessage {
    ID : number; // Int32
  }

  export class UpdatePriceList extends EVA.Core.RequestMessageWithEmptyResponse {
    ID : number; // Int32
    Name : string;
    CurrencyID : string;
    IsActive : boolean;
    __response : EVA.Core.EmptyResponseMessage;
  }

  export class DeletePriceList extends EVA.Core.RequestMessageWithEmptyResponse {
    ID : number; // Int32
    __response : EVA.Core.EmptyResponseMessage;
  }

  export class ListPriceLists extends EVA.Core.PagedResultRequest<EVA.Core.Services.ListPriceListsResponse> {
    __response : EVA.Core.Services.ListPriceListsResponse;
  }

  export class ListPriceListsResponse extends EVA.Core.PagedResultResponse<EVA.Core.Services.ListPriceListsResponsePriceListDto> {
  }

  export class ListPriceListsResponsePriceListDto {
    ID : number; // Int32
    Name : string;
    CurrencyID : string;
    IsActive : boolean;
  }

  export class GetPriceListOrganizationUnitByID extends EVA.Core.RequestMessageGeneric<EVA.Core.Services.GetPriceListOrganizationUnitByIDResponse> {
    ID : number; // Int32
    __response : EVA.Core.Services.GetPriceListOrganizationUnitByIDResponse;
  }

  export class GetPriceListOrganizationUnitByIDResponse extends EVA.Core.ResponseMessage {
    ID : number; // Int32
    OrganizationUnitID : number; // Int32
    OrganizationUnitName : string;
    PriceListID : number; // Int32
    PriceList : EVA.Core.Services.GetPriceListOrganizationUnitByIDResponsePriceListDto;
    PriceListUsageTypeID : number; // Int32
    PriceListUsageTypeName : string;
  }

  export class GetPriceListOrganizationUnitByIDResponsePriceListDto {
    Name : string;
    CurrencyID : string;
  }

  export class CreatePriceListOrganizationUnit extends EVA.Core.RequestMessageGeneric<EVA.Core.Services.CreatePriceListOrganizationUnitResponse> {
    OrganizationUnitID : number; // Int32
    PriceListID : number; // Int32
    PriceListUsageTypeID : number; // Int32
    __response : EVA.Core.Services.CreatePriceListOrganizationUnitResponse;
  }

  export class CreatePriceListOrganizationUnitResponse extends EVA.Core.ResponseMessage {
    ID : number; // Int32
  }

  export class UpdatePriceListOrganizationUnit extends EVA.Core.RequestMessageWithEmptyResponse {
    ID : number; // Int32
    OrganizationUnitID : number; // Int32
    PriceListID : number; // Int32
    PriceListUsageTypeID : number; // Int32
    __response : EVA.Core.EmptyResponseMessage;
  }

  export class DeletePriceListOrganizationUnit extends EVA.Core.RequestMessageWithEmptyResponse {
    ID : number; // Int32
    __response : EVA.Core.EmptyResponseMessage;
  }

  export class ListPriceListOrganizationUnits extends EVA.Core.PagedResultRequest<EVA.Core.Services.ListPriceListOrganizationUnitsResponse> {
    __response : EVA.Core.Services.ListPriceListOrganizationUnitsResponse;
  }

  export class ListPriceListOrganizationUnitsResponse extends EVA.Core.PagedResultResponse<EVA.Core.Services.ListPriceListOrganizationUnitsResponsePriceListOrganizationUnitDto> {
  }

  export class ListPriceListOrganizationUnitsResponsePriceListOrganizationUnitDto {
    ID : number; // Int32
    OrganizationUnitID : number; // Int32
    OrganizationUnitName : string;
    PriceListID : number; // Int32
    PriceList : EVA.Core.Services.ListPriceListOrganizationUnitsResponsePriceListOrganizationUnitDtoPriceListDto;
    PriceListUsageTypeID : number; // Int32
    PriceListUsageTypeName : string;
  }

  export class ListPriceListOrganizationUnitsResponsePriceListOrganizationUnitDtoPriceListDto {
    Name : string;
    CurrencyID : string;
  }

  export class GetPriceListUsageTypeByID extends EVA.Core.RequestMessageGeneric<EVA.Core.Services.GetPriceListUsageTypeByIDResponse> {
    ID : number; // Int32
    __response : EVA.Core.Services.GetPriceListUsageTypeByIDResponse;
  }

  export class GetPriceListUsageTypeByIDResponse extends EVA.Core.ResponseMessage {
    ID : number; // Int32
    Name : string;
    Description : string;
  }

  export class CreatePriceListUsageType extends EVA.Core.RequestMessageGeneric<EVA.Core.Services.CreatePriceListUsageTypeResponse> {
    Name : string;
    Description : string;
    __response : EVA.Core.Services.CreatePriceListUsageTypeResponse;
  }

  export class CreatePriceListUsageTypeResponse extends EVA.Core.ResponseMessage {
    ID : number; // Int32
  }

  export class UpdatePriceListUsageType extends EVA.Core.RequestMessageWithEmptyResponse {
    ID : number; // Int32
    Description : string;
    __response : EVA.Core.EmptyResponseMessage;
  }

  export class DeletePriceListUsageType extends EVA.Core.RequestMessageWithEmptyResponse {
    ID : number; // Int32
    __response : EVA.Core.EmptyResponseMessage;
  }

  export class GetPriceListUsageTypes extends EVA.Core.RequestMessageGeneric<EVA.Core.Services.GetPriceListUsageTypesResponse> {
    __response : EVA.Core.Services.GetPriceListUsageTypesResponse;
  }

  export class GetPriceListUsageTypesResponse extends EVA.Core.ResponseMessage {
    PriceListUsageTypes : EVA.Core.Services.GetPriceListUsageTypesResponsePriceListUsageTypeDto[];
  }

  export class GetPriceListUsageTypesResponsePriceListUsageTypeDto {
    ID : number; // Int32
    Name : string;
    Description : string;
  }

  export class CreatePayment extends EVA.Core.RequestMessageGeneric<EVA.Core.Services.CreatePaymentResponse> {
    OrderID : number; // Int32
    Code : string;
    Amount : number; // Decimal, nullable
    Properties : any;
    __response : EVA.Core.Services.CreatePaymentResponse;
  }

  export class CreatePaymentResponse extends EVA.Core.ResponseMessage {
    PaymentTransaction : EVA.Core.PaymentTransactionDto;
    OpenAmount : number; // Decimal
    Properties : any;
  }

  export class FinalizePayment extends EVA.Core.RequestMessageGeneric<EVA.Core.Services.FinalizePaymentResponse> {
    PaymentTransactionID : number; // Int32
    Amount : number; // Decimal, nullable
    __response : EVA.Core.Services.FinalizePaymentResponse;
  }

  export class FinalizePaymentResponse extends EVA.Core.ResponseMessage {
    PaymentTransaction : EVA.Core.PaymentTransactionDto;
    OpenAmount : number; // Decimal
  }

  export class GetActivePaymentTypes extends EVA.Core.RequestMessageGeneric<EVA.Core.Services.GetActivePaymentTypesResponse> {
    __response : EVA.Core.Services.GetActivePaymentTypesResponse;
  }

  export class GetActivePaymentTypesResponse extends EVA.Core.ResponseMessage {
    Result : string[];
  }

  export class ListPaymentTypes extends EVA.Core.RequestMessageGeneric<EVA.Core.Services.ListPaymentTypesResponse> {
    __response : EVA.Core.Services.ListPaymentTypesResponse;
  }

  export class ListPaymentTypesResponse extends EVA.Core.ResponseMessage {
    Result : string[];
  }

  export class GetAvailablePaymentMethods extends EVA.Core.RequestMessageGeneric<EVA.Core.Services.GetAvailablePaymentMethodsResponse> {
    OrderID : number; // Int32
    __response : EVA.Core.Services.GetAvailablePaymentMethodsResponse;
  }

  export class GetAvailablePaymentMethodsResponse extends EVA.Core.ResponseMessage {
    PaymentMethods : string[];
  }

  export class GetAvailableRefundPaymentMethods extends EVA.Core.RequestMessageGeneric<EVA.Core.Services.GetAvailableRefundPaymentMethodsResponse> {
    UserID : number; // Int32
    CurrencyID : string;
    __response : EVA.Core.Services.GetAvailableRefundPaymentMethodsResponse;
  }

  export class GetAvailableRefundPaymentMethodsResponse extends EVA.Core.ResponseMessage {
    Methods : EVA.Core.Services.GetAvailableRefundPaymentMethodsResponsePaymentMethod[];
  }

  export class GetAvailableRefundPaymentMethodsResponsePaymentMethod {
    Code : string;
    Transactions : EVA.Core.Services.GetAvailableRefundPaymentMethodsResponseRefundablePaymentTransaction[];
  }

  export class GetAvailableRefundPaymentMethodsResponseRefundablePaymentTransaction {
    ID : number; // Int32
    BackendID : string;
    PaidAmount : number; // Decimal
    RefundableAmount : number; // Decimal
    Type : string;
  }

  export class GetPaymentTransaction extends EVA.Core.RequestMessageGeneric<EVA.Core.Services.GetPaymentTransactionResponse> {
    PaymentTransactionID : number; // Int32
    __response : EVA.Core.Services.GetPaymentTransactionResponse;
  }

  export class GetPaymentTransactionResponse extends EVA.Core.ResponseMessage {
    PaymentTransaction : EVA.Core.PaymentTransactionDto;
  }

  export class GetPaymentTypeByID extends EVA.Core.RequestMessageGeneric<EVA.Core.Services.GetPaymentTypeByIDResponse> {
    ID : number; // Int32
    __response : EVA.Core.Services.GetPaymentTypeByIDResponse;
  }

  export class GetPaymentTypeByIDResponse extends EVA.Core.ResponseMessage {
    ID : number; // Int32
    Name : string;
    Code : string;
    IsActive : boolean;
    HasChange : boolean;
    IsRoundingType : boolean;
    IncludeInCashJournal : boolean;
    IsExternal : boolean;
    ReturnAction : EVA.Core.PaymentReturnActions;
    LedgerClassID : string;
    PrintOnDocuments : boolean;
    ExtraCostProductID : number; // Int32, nullable
    BackendRelationID : string;
    BookPaymentMethodInvoice : boolean;
    KickbackRuleID : number; // Int32, nullable
    DelayFinancialBooking : boolean;
    CanBeUsedForAuthorization : boolean;
    Category : EVA.Core.PaymentTypeCategory;
  }

  export class CreatePaymentType extends EVA.Core.RequestMessageGeneric<EVA.Core.Services.CreatePaymentTypeResponse> {
    Name : string;
    Code : string;
    IsActive : boolean;
    HasChange : boolean;
    IsRoundingType : boolean;
    IncludeInCashJournal : boolean;
    IsExternal : boolean;
    ReturnAction : EVA.Core.PaymentReturnActions;
    LedgerClassID : string;
    PrintOnDocuments : boolean;
    ExtraCostProductID : number; // Int32, nullable
    BackendRelationID : string;
    BookPaymentMethodInvoice : boolean;
    KickbackRuleID : number; // Int32, nullable
    DelayFinancialBooking : boolean;
    CanBeUsedForAuthorization : boolean;
    Category : EVA.Core.PaymentTypeCategory;
    __response : EVA.Core.Services.CreatePaymentTypeResponse;
  }

  export class CreatePaymentTypeResponse extends EVA.Core.ResponseMessage {
    ID : number; // Int32
  }

  export class UpdatePaymentType extends EVA.Core.RequestMessageWithEmptyResponse {
    ID : number; // Int32
    Name : string;
    Code : string;
    IsActive : boolean;
    HasChange : boolean;
    IsRoundingType : boolean;
    IncludeInCashJournal : boolean;
    IsExternal : boolean;
    ReturnAction : EVA.Core.PaymentReturnActions;
    LedgerClassID : string;
    PrintOnDocuments : boolean;
    ExtraCostProductID : number; // Int32, nullable
    BackendRelationID : string;
    BookPaymentMethodInvoice : boolean;
    KickbackRuleID : number; // Int32, nullable
    DelayFinancialBooking : boolean;
    CanBeUsedForAuthorization : boolean;
    Category : EVA.Core.PaymentTypeCategory;
    __response : EVA.Core.EmptyResponseMessage;
  }

  export class DeletePaymentType extends EVA.Core.RequestMessageWithEmptyResponse {
    ID : number; // Int32
    __response : EVA.Core.EmptyResponseMessage;
  }

  export class ListPaymentTypes2 extends EVA.Core.PagedResultRequest<EVA.Core.Services.ListPaymentTypes2Response> {
    __response : EVA.Core.Services.ListPaymentTypes2Response;
  }

  export class ListPaymentTypes2Response extends EVA.Core.PagedResultResponse<EVA.Core.Services.ListPaymentTypes2ResponsePaymentTypeDto> {
  }

  export class ListPaymentTypes2ResponsePaymentTypeDto {
    ID : number; // Int32
    Name : string;
    Code : string;
    IsActive : boolean;
    HasChange : boolean;
    IsRoundingType : boolean;
    IncludeInCashJournal : boolean;
    IsExternal : boolean;
    ReturnAction : EVA.Core.PaymentReturnActions;
    LedgerClassID : string;
    PrintOnDocuments : boolean;
    ExtraCostProductID : number; // Int32, nullable
    BackendRelationID : string;
    BookPaymentMethodInvoice : boolean;
    KickbackRuleID : number; // Int32, nullable
    DelayFinancialBooking : boolean;
    CanBeUsedForAuthorization : boolean;
    Category : EVA.Core.PaymentTypeCategory;
  }

  export class RequestPaymentUpdate extends EVA.Core.RequestMessageGeneric<EVA.Core.Services.RequestPaymentUpdateResponse> {
    PaymentTransactionID : number; // Int32
    __response : EVA.Core.Services.RequestPaymentUpdateResponse;
  }

  export class RequestPaymentUpdateResponse extends EVA.Core.ResponseMessage {
    PaymentTransaction : EVA.Core.PaymentTransactionDto;
  }

  export class CreateOrganizationOpeningHours extends EVA.Core.CreateRequest<EVA.Core.OpeningHoursDto> implements EVA.Core.IRequestRespondsAs<EVA.Core.CreateResponse> {
    OpeningHoursDto : EVA.Core.OpeningHoursDto[];
    __response : EVA.Core.CreateResponse;
  }

  export class CreateOrganizationUnit extends EVA.Core.CreateRequest<EVA.Core.OrganizationUnitDto> implements EVA.Core.IRequestRespondsAs<EVA.Core.CreateResponse> {
    __response : EVA.Core.CreateResponse;
  }

  export class DeleteOrganizationOpeningHours extends EVA.Core.DeleteRequest implements EVA.Core.IRequestRespondsAs<EVA.Core.EmptyResponseMessage> {
    __response : EVA.Core.EmptyResponseMessage;
  }

  export class DeleteOrganizationUnit extends EVA.Core.RequestMessageWithEmptyResponse {
    OrganizationUnitID : number; // Int32
    __response : EVA.Core.EmptyResponseMessage;
  }

  export class GetOrganizationUnitDetailed extends EVA.Core.RequestMessageGeneric<EVA.Core.Services.GetOrganizationUnitDetailedResponse> {
    ID : number; // Int32
    __response : EVA.Core.Services.GetOrganizationUnitDetailedResponse;
  }

  export class GetOrganizationUnitDetailedResponse extends EVA.Core.ResponseMessage {
    ID : number; // Int32
    ParentID : number; // Int32, nullable
    Name : string;
    Description : string;
    AddressID : number; // Int32, nullable
    Address : EVA.Core.AddressDto;
    EmailAddress : string;
    PhoneNumber : string;
    Type : EVA.Core.OrganizationUnitTypes;
    Status : EVA.Core.OrganizationUnitStatus;
    OpeningHours : EVA.Core.OpeningHoursDto[];
    Subnet : string;
    RegisterCashLimit : number; // Decimal
    SafeCashLimit : number; // Decimal
    VisibleByApplicationID : number; // Int32
    Latitude : number; // Double, nullable
    Longitude : number; // Double, nullable
    CocNumber : string;
    VatNumber : string;
    BankAccount : string;
    CurrencyID : string;
    TimeZone : string;
  }

  export class GetOrganizationUnitOpeningHoursForPeriod extends EVA.Core.RequestMessageGeneric<EVA.Core.Services.GetOrganizationUnitOpeningHoursForPeriodResponse> {
    OrganizationUnitID : number; // Int32
    From : string; // DateTime
    To : string; // DateTime
    __response : EVA.Core.Services.GetOrganizationUnitOpeningHoursForPeriodResponse;
  }

  export class GetOrganizationUnitOpeningHoursForPeriodResponse extends EVA.Core.ResponseMessage {
    OpeningHours : { [ key : string ] : EVA.Core.OpeningClosingHourPair };
  }

  export class GetOrganizationUnit extends EVA.Core.RequestMessageGeneric<EVA.Core.Services.GetOrganizationUnitResponse> {
    OrganizationUnitID : number; // Int32
    __response : EVA.Core.Services.GetOrganizationUnitResponse;
  }

  export class GetOrganizationUnitResponse extends EVA.Core.ResponseMessage {
    Result : EVA.Core.OrganizationUnitDto;
  }

  export class GetOrganizationUnitSettings extends EVA.Core.RequestMessageGeneric<EVA.Core.Services.GetOrganizationUnitSettingsResponse> {
    OrganizationUnitID : number; // Int32
    __response : EVA.Core.Services.GetOrganizationUnitSettingsResponse;
  }

  export class GetOrganizationUnitSettingsResponse extends EVA.Core.ResponseMessage {
    ID : number; // Int32
    ParentID : number; // Int32, nullable
    BackendID : string;
    BackendRelationID : string;
    BackendCompanyID : string;
    BranchNumber : string;
    GlobalLocationNumber : string;
    RegisterCashLimit : number; // Decimal
    SafeCashLimit : number; // Decimal
    TypeID : number; // Int32
    Subnet : string;
    UseForAccounting : boolean;
    AttachedToUserID : number; // Int32, nullable
    IpAddress : string;
    CountryID : string;
    CurrencyID : string;
    TimeZone : string;
  }

  export class ListOrganizationUnitByProximity extends EVA.Core.PagedResultRequest<EVA.Core.Services.ListOrganizationUnitByProximityResponse> {
    Latitude : number; // Double
    Longitude : number; // Double
    __response : EVA.Core.Services.ListOrganizationUnitByProximityResponse;
  }

  export class ListOrganizationUnitByProximityResponse extends EVA.Core.PagedResultResponse<EVA.Core.OrganizationUnitDto> {
  }

  export class ListOrganizationUnitsByType extends EVA.Core.PagedResultRequest<EVA.Core.Services.ListOrganizationUnitsByTypeResponse> {
    OrganizationUnitTypes : EVA.Core.OrganizationUnitTypes;
    IncludeParentApplications : boolean;
    __response : EVA.Core.Services.ListOrganizationUnitsByTypeResponse;
  }

  export class ListOrganizationUnitsByTypeResponse extends EVA.Core.PagedResultResponse<EVA.Core.OrganizationUnitDto> {
  }

  export class ListOrganizationUnits extends EVA.Core.PagedResultRequest<EVA.Core.Services.ListOrganizationUnitsResponse> {
    __response : EVA.Core.Services.ListOrganizationUnitsResponse;
  }

  export class ListOrganizationUnitsResponse extends EVA.Core.PagedResultResponse<EVA.Core.OrganizationUnitDto> {
  }

  export class UpdateOrganizationOpeningHours extends EVA.Core.UpdateRequest<EVA.Core.OpeningHoursDto> implements EVA.Core.IRequestRespondsAs<EVA.Core.Services.UpdateOrganizationOpeningHoursResponse> {
    openingHoursDto : EVA.Core.OpeningHoursDto[];
    __response : EVA.Core.Services.UpdateOrganizationOpeningHoursResponse;
  }

  export class UpdateOrganizationOpeningHoursResponse extends EVA.Core.ResponseMessage {
    Success : boolean;
  }

  export class UpdateOrganizationUnit2 extends EVA.Core.RequestMessageWithEmptyResponse {
    ID : number; // Int32
    Name : string;
    Description : string;
    OpeningHours : EVA.Core.OpeningHoursDto[];
    AddressID : number; // Int32, nullable
    Address : EVA.Core.AddressDto;
    StatusID : number; // Int32
    Latitude : number; // Double
    Longitude : number; // Double
    BankAccount : string;
    CocNumber : string;
    VatNumber : string;
    EmailAddress : string;
    PhoneNumber : string;
    CompanyID : number; // Int32, nullable
    __response : EVA.Core.EmptyResponseMessage;
  }

  export class UpdateOrganizationUnit extends EVA.Core.UpdateRequest<EVA.Core.OrganizationUnitDto> implements EVA.Core.IRequestRespondsAs<EVA.Core.EmptyResponseMessage> {
    OrganizationUnits : EVA.Core.OrganizationUnitDto[];
    AllowTypeUpdate : boolean;
    __response : EVA.Core.EmptyResponseMessage;
  }

  export class UpdateOrganizationUnitSettings extends EVA.Core.RequestMessageWithEmptyResponse {
    ID : number; // Int32
    ParentID : number; // Int32, nullable
    BackendID : string;
    BackendRelationID : string;
    BackendCompanyID : string;
    BranchNumber : string;
    GlobalLocationNumber : string;
    RegisterCashLimit : number; // Decimal
    SafeCashLimit : number; // Decimal
    TypeID : number; // Int32
    Subnet : string;
    UseForAccounting : boolean;
    AttachedToUserID : number; // Int32, nullable
    IpAddress : string;
    CountryID : string;
    CurrencyID : string;
    TimeZone : string;
    __response : EVA.Core.EmptyResponseMessage;
  }

  export class AddDiscountToOrder extends EVA.Core.RequestMessageGeneric<EVA.Core.ShoppingCartResponse> {
    SessionID : string;
    CouponCode : string;
    DiscountID : number; // Int32
    DiscountAmount : number; // Decimal
    CurrencyID : string;
    Reason : string;
    OrderLines : EVA.Core.OrderLineWithQuantity[];
    Password : string;
    ForceCreate : boolean;
    __response : EVA.Core.ShoppingCartResponse;
  }

  export class AddInsuranceItemToOrderLine extends EVA.Core.RequestMessageGeneric<EVA.Core.ShoppingCartResponse> {
    OrderLineID : number; // Int32
    InsuranceItemID : number; // Int32
    __response : EVA.Core.ShoppingCartResponse;
  }

  export class AddProductToOrder extends EVA.Core.RequestMessageGeneric<EVA.Core.Services.AddProductToOrderResponse> {
    SessionID : string;
    ForceCreate : boolean;
    Barcode : string;
    ProductID : number; // Int32, nullable
    QuantityOrdered : number; // Int32, nullable
    LineActionType : EVA.Core.LineActionTypes;
    StockLabel : number; // Int32
    CustomOrderLineType : string;
    ParentID : number; // Int32, nullable
    ResourceID : number; // Int32, nullable
    GroupID : string;
    __response : EVA.Core.Services.AddProductToOrderResponse;
  }

  export class AddProductToOrderResponse extends EVA.Core.ShoppingCartResponse {
    OrderLineID : number; // Int32
  }

  export class AddServiceProductToOrder extends EVA.Core.RequestMessageGeneric<EVA.Core.Services.AddServiceProductToOrderResponse> {
    SessionID : string;
    ForceCreate : boolean;
    ProductID : number; // Int32
    Description : string;
    UnitPrice : number; // Decimal, nullable
    UnitCost : number; // Decimal, nullable
    __response : EVA.Core.Services.AddServiceProductToOrderResponse;
  }

  export class AddServiceProductToOrderResponse extends EVA.Core.ShoppingCartResponse {
    OrderLineID : number; // Int32
  }

  export class ApprovePayment extends EVA.Core.RequestMessageGeneric<EVA.Core.Services.ApprovePaymentResponse> {
    PaymentID : number; // Int32
    __response : EVA.Core.Services.ApprovePaymentResponse;
  }

  export class ApprovePaymentResponse extends EVA.Core.ResponseMessage {
    HasBeenApproved : boolean;
    Reason : EVA.Core.Services.ApprovementFailureReasons;
  }

  export enum ApprovementFailureReasons {
    Unknown = 0,
    AlreadyApproved = 1,
    OrderAlreadyPaid = 2,
  }

  export class AttachCustomerToOrder extends EVA.Core.RequestMessageWithEmptyResponse {
    UserID : number; // Int32, nullable
    OrderID : number; // Int32
    __response : EVA.Core.EmptyResponseMessage;
  }

  export class AttachIdentificationToOrder extends EVA.Core.RequestMessageGeneric<EVA.Core.Services.AttachIdentificationToOrderResponse> {
    OrderID : number; // Int32
    Type : EVA.Core.IdentificationTypes;
    Number : string;
    ValidTo : string; // DateTime
    IssuingDate : string; // DateTime, nullable
    IssuingCity : string;
    IssuingCountryID : string;
    OriginatingCountryID : string;
    DocumentMimeType : string;
    Document : number[];
    __response : EVA.Core.Services.AttachIdentificationToOrderResponse;
  }

  export class AttachIdentificationToOrderResponse extends EVA.Core.ResponseMessage {
    IdentificationID : number; // Int32
  }

  export class AttachOrderToSession extends EVA.Core.RequestMessageGeneric<EVA.Core.EmptyResponseMessage> {
    OrderID : number; // Int32
    SessionID : string;
    __response : EVA.Core.EmptyResponseMessage;
  }

  export class CancelOrderLine extends EVA.Core.RequestMessageGeneric<EVA.Core.Services.CancelOrderLineResponse> {
    OrderLineID : number; // Int32
    __response : EVA.Core.Services.CancelOrderLineResponse;
  }

  export class CancelOrderLineResponse extends EVA.Core.ResponseMessage {
    Result : EVA.Core.OrderCancellationOptions;
  }

  export class CreateOrderFromShoppingCart extends EVA.Core.RequestMessageGeneric<EVA.Core.Services.CreateOrderFromShoppingCartResponse> {
    SessionID : string;
    CartID : number; // Int32, nullable
    __response : EVA.Core.Services.CreateOrderFromShoppingCartResponse;
  }

  export class CreateOrderFromShoppingCartResponse extends EVA.Core.ResponseMessage {
    Order : EVA.Core.OrderDto;
    TotalAmountInTax : number; // Decimal
    OpenAmount : number; // Decimal
  }

  export class DetachOrderFromSession extends EVA.Core.RequestMessageGeneric<EVA.Core.EmptyResponseMessage> {
    SessionID : string;
    OrderID : number; // Int32, nullable
    __response : EVA.Core.EmptyResponseMessage;
  }

  export class GetConfigurableOrderView extends EVA.Core.RequestMessageGeneric<EVA.Core.Services.GetConfigurableOrderViewResponse> {
    OrderID : number; // Int32
    LogicalLevel : string;
    GroupByPropertyType : string;
    IncludeAllChildren : boolean;
    ProductProperties : string[];
    __response : EVA.Core.Services.GetConfigurableOrderViewResponse;
  }

  export class GetConfigurableOrderViewResponse extends EVA.Core.ResponseMessage {
    PropertyGroups : EVA.Core.Services.PropertyGroup[];
    OtherLines : { [ key : string ] : EVA.Core.Services.SimpleOrderLine[] };
    TotalAmount : number; // Decimal
    TotalAmountInTax : number; // Decimal
  }

  export class PropertyGroup {
    PropertyValue : any;
    TotalAmount : number; // Decimal
    TotalAmountInTax : number; // Decimal
    Quantity : number; // Int32
    ChildGroups : EVA.Core.Services.ConfigurableGroup[];
  }

  export class ConfigurableGroup {
    ProductID : number; // Int32
    Properties : any;
    LogicalLevel : string;
    ConfigurableProperty : string;
    Value : any;
    Values : any[];
    TotalAmount : number; // Decimal
    TotalAmountInTax : number; // Decimal
    Quantity : number; // Int32
    Children : EVA.Core.Services.ConfigurableGroup[];
    OrderLines : EVA.Core.Services.ConfigurableOrderLine[];
  }

  export class ConfigurableOrderLine {
    OrderLineID : number; // Int32
    Quantity : number; // Int32
    TotalAmount : number; // Decimal
    TotalAmountInTax : number; // Decimal
  }

  export class SimpleOrderLine {
    OrderLineID : number; // Int32
    Description : string;
    Quantity : number; // Int32
    TotalAmount : number; // Decimal
    TotalAmountInTax : number; // Decimal
  }

  export class GetCustomOrderData extends EVA.Core.RequestMessageGeneric<EVA.Core.Services.GetCustomOrderDataResponse> {
    OrderID : number; // Int32, nullable
    SessionID : string;
    Key : string;
    __response : EVA.Core.Services.GetCustomOrderDataResponse;
  }

  export class GetCustomOrderDataResponse extends EVA.Core.ResponseMessage {
    Values : any[];
  }

  export class GetCustomOrderLineData extends EVA.Core.RequestMessageGeneric<EVA.Core.Services.GetCustomOrderLineDataResponse> {
    OrderLineID : number; // Int32
    Key : string;
    __response : EVA.Core.Services.GetCustomOrderLineDataResponse;
  }

  export class GetCustomOrderLineDataResponse extends EVA.Core.ResponseMessage {
    Values : string[];
  }

  export class GetOrder extends EVA.Core.RequestMessageGeneric<EVA.Core.Services.GetOrderResponse> {
    OrderID : number; // Int32
    IncludeFailedPayments : boolean;
    __response : EVA.Core.Services.GetOrderResponse;
  }

  export class GetOrderResponse extends EVA.Core.GetResponse<EVA.Core.OrderDto> {
    TotalAmountInTax : number; // Decimal
    OpenAmount : number; // Decimal
    HasMoreLines : boolean;
  }

  export class GetOrderStatistics extends EVA.Core.RequestMessageGeneric<EVA.Core.Services.GetOrderStatisticsResponse> {
    OrderID : number; // Int32
    __response : EVA.Core.Services.GetOrderStatisticsResponse;
  }

  export class GetOrderStatisticsResponse extends EVA.Core.ResponseMessage {
    Statistics : EVA.Core.OrderStatistics;
  }

  export class GetRequiredDataForOrder extends EVA.Core.RequestMessageGeneric<EVA.Core.Services.GetRequiredDataForOrderResponse> {
    OrderID : number; // Int32
    RequiredFor : EVA.Core.RequiredFor;
    __response : EVA.Core.Services.GetRequiredDataForOrderResponse;
  }

  export class GetRequiredDataForOrderResponse extends EVA.Core.ResponseMessage {
    RequiredData : EVA.Core.RequiredData;
  }

  export class GetReturnableStatusForOrder extends EVA.Core.RequestMessageGeneric<EVA.Core.Services.GetReturnableStatusForOrderResponse> {
    OrderID : number; // Int32
    __response : EVA.Core.Services.GetReturnableStatusForOrderResponse;
  }

  export class GetReturnableStatusForOrderResponse extends EVA.Core.ResponseMessage {
    Result : EVA.Core.Services.ReturnableStatusForOrderLine[];
  }

  export class ReturnableStatusForOrderLine {
    OrderLineID : number; // Int32
    ReturnableQuantity : number; // Int32
    IsReturnable : boolean;
    IsReturnableWithParent : boolean;
  }

  export class GetShippingMethodsForOrder extends EVA.Core.RequestMessageGeneric<EVA.Core.Services.GetShippingMethodsForOrderResponse> {
    SessionID : string;
    OrderID : number; // Int32, nullable
    __response : EVA.Core.Services.GetShippingMethodsForOrderResponse;
  }

  export class GetShippingMethodsForOrderResponse extends EVA.Core.ResponseMessage {
    ShippingMethods : EVA.Core.ShippingMethodByOrderLineDto[];
  }

  export class ListAvailableInsurancesForOrderLine extends EVA.Core.RequestMessageGeneric<EVA.Core.Services.ListAvailableInsurancesForOrderLineResponse> {
    OrderLineID : number; // Int32
    __response : EVA.Core.Services.ListAvailableInsurancesForOrderLineResponse;
  }

  export class ListAvailableInsurancesForOrderLineResponse extends EVA.Core.ResponseMessage {
    Insurances : EVA.Core.InsuranceItemDto[];
  }

  export class ListAvailableShippingDates extends EVA.Core.RequestMessageGeneric<EVA.Core.Services.ListAvailableShippingDatesResponse> {
    SessionID : string;
    OrderID : number; // Int32, nullable
    ShippingMethodID : number; // Int32
    __response : EVA.Core.Services.ListAvailableShippingDatesResponse;
  }

  export class ListAvailableShippingDatesResponse extends EVA.Core.ResponseMessage {
    AvailableDeliveryDates : string[];
  }

  export class ListAvailableShippingMethods extends EVA.Core.RequestMessageGeneric<EVA.Core.Services.ListAvailableShippingMethodsResponse> {
    SessionID : string;
    OrderID : number; // Int32, nullable
    OrderLineIDs : number[];
    __response : EVA.Core.Services.ListAvailableShippingMethodsResponse;
  }

  export class ListAvailableShippingMethodsResponse extends EVA.Core.ResponseMessage {
    AvailableShippingMethods : EVA.Core.ShippingMethodByOrderLineDto[];
  }

  export class ListExternalOrderStatusForOrder extends EVA.Core.RequestMessageGeneric<EVA.Core.Services.ListExternalOrderStatusForOrderResponse> {
    OrderID : number; // Int32
    __response : EVA.Core.Services.ListExternalOrderStatusForOrderResponse;
  }

  export class ListExternalOrderStatusForOrderResponse extends EVA.Core.ResponseMessage {
    Result : EVA.Core.Services.ListExternalOrderStatusForOrderResponseExternalOrderStatus[];
  }

  export class ListExternalOrderStatusForOrderResponseExternalOrderStatus {
    Name : string;
    Status : string;
    CanPollStatus : boolean;
  }

  export class ListInvoicesForOrder extends EVA.Core.RequestMessageGeneric<EVA.Core.Services.ListInvoicesForOrderResponse> {
    OrderID : number; // Int32
    __response : EVA.Core.Services.ListInvoicesForOrderResponse;
  }

  export class ListInvoicesForOrderResponse extends EVA.Core.ResponseMessage {
    Result : EVA.Core.Services.InvoiceDto[];
  }

  export class InvoiceDto {
    ID : number; // Int32
    InvoiceNumber : string;
    InvoiceDate : string; // DateTime, nullable
    CreatedByID : number; // Int32
    CreationTime : string; // DateTime
  }

  export class ListOrderLedgerForOrder extends EVA.Core.RequestMessageGeneric<EVA.Core.Services.ListOrderLedgerForOrderResponse> {
    OrderID : number; // Int32
    __response : EVA.Core.Services.ListOrderLedgerForOrderResponse;
  }

  export class ListOrderLedgerForOrderResponse extends EVA.Core.ResponseMessage {
    Ledgers : EVA.Core.Services.OrderLedgerDto[];
  }

  export class OrderLedgerDto {
    ID : number; // Int32
    OrderID : number; // Int32
    OrderLineID : number; // Int32, nullable
    Type : EVA.Core.Services.OrderLedgerTypeDto;
    TypeID : number; // Int32
    OldValue : string;
    NewValue : string;
    Description : string;
    CreatedByID : number; // Int32
    CreationTime : string; // DateTime
    CreatedBy : EVA.Core.UserDto;
    Client : EVA.Core.Clients;
  }

  export class OrderLedgerTypeDto extends EVA.Core.EnumDtoBase {
  }

  export class ListOrderLines extends EVA.Core.PagedResultRequest<EVA.Core.Services.ListOrderLinesResponse> {
    OrderID : number; // Int32
    __response : EVA.Core.Services.ListOrderLinesResponse;
  }

  export class ListOrderLinesResponse extends EVA.Core.PagedResultResponse<EVA.Core.OrderLineDto> {
  }

  export class ListOrdersForCustomer extends EVA.Core.PagedResultRequest<EVA.Core.Services.ListOrdersForCustomerResponse> {
    ID : number; // Int32
    OpenOrdersOnly : boolean;
    __response : EVA.Core.Services.ListOrdersForCustomerResponse;
  }

  export class ListOrdersForCustomerResponse extends EVA.Core.PagedResultResponse<EVA.Core.OrderDto> {
  }

  export class ListOrderShipments extends EVA.Core.RequestMessageGeneric<EVA.Core.Services.ListOrderShipmentsResponse> {
    OrderID : number; // Int32
    __response : EVA.Core.Services.ListOrderShipmentsResponse;
  }

  export class ListOrderShipmentsResponse extends EVA.Core.ResponseMessage {
    Result : EVA.Core.Services.ListOrderShipmentsResponseModel[];
  }

  export class ListOrderShipmentsResponseModel {
    ID : number; // Int32
    BackendID : string;
    ShipmentDate : string; // DateTime
    TrackingCode : string;
    TrackingLink : string;
    OrganizationUnit : EVA.Core.OrganizationUnitDto;
    ShippedFromOrganizationUnit : EVA.Core.OrganizationUnitDto;
    TotalQuantityShipped : number; // Int32, nullable
  }

  export class ListOrdersWithReference extends EVA.Core.PagedResultRequest<EVA.Core.Services.ListOrdersWithReferenceResponse> {
    __response : EVA.Core.Services.ListOrdersWithReferenceResponse;
  }

  export class ListOrdersWithReferenceResponse extends EVA.Core.PagedResultResponse<EVA.Core.OrderWithReference> {
  }

  export class ModifyLineActionType extends EVA.Core.RequestMessageGeneric<EVA.Core.ShoppingCartResponse> {
    OrderLineID : number; // Int32
    LineActionType : EVA.Core.LineActionTypes;
    __response : EVA.Core.ShoppingCartResponse;
  }

  export class ModifyOrderLinePrice extends EVA.Core.RequestMessageGeneric<EVA.Core.ShoppingCartResponse> {
    OrderLineID : number; // Int32
    UnitPriceInTax : number; // Decimal
    UnitCost : number; // Decimal, nullable
    __response : EVA.Core.ShoppingCartResponse;
  }

  export class ModifyQuantityOrdered extends EVA.Core.RequestMessageGeneric<EVA.Core.Services.ModifyQuantityOrderedResponse> {
    OrderLineID : number; // Int32
    NewQuantityOrdered : number; // Int32
    __response : EVA.Core.Services.ModifyQuantityOrderedResponse;
  }

  export class ModifyQuantityOrderedResponse extends EVA.Core.ShoppingCartResponse {
    Messages : EVA.Core.Services.ModifyQuantityOrderedResponseQuantityMutationResultMessage[];
  }

  export class ModifyQuantityOrderedResponseQuantityMutationResultMessage {
    Code : string;
    Message : string;
  }

  export class ModifyStockOrganizationUnit extends EVA.Core.RequestMessageGeneric<EVA.Core.ShoppingCartResponse> {
    OrderLineID : number; // Int32
    StockOrganizationUnitID : number; // Int32
    LineActionType : EVA.Core.LineActionTypes;
    __response : EVA.Core.ShoppingCartResponse;
  }

  export class PlaceOrder extends EVA.Core.RequestMessageGeneric<EVA.Core.Services.PlaceOrderResponse> {
    OrderID : number; // Int32
    __response : EVA.Core.Services.PlaceOrderResponse;
  }

  export class PlaceOrderResponse extends EVA.Core.ResponseMessage {
    ValidationResult : EVA.Core.OrderExportValidationResult;
  }

  export class PollExternalOrderStatus extends EVA.Core.RequestMessageGeneric<EVA.Core.EmptyResponseMessage> {
    OrderID : number; // Int32
    Name : string;
    __response : EVA.Core.EmptyResponseMessage;
  }

  export class ProduceDocuments extends EVA.Core.RequestMessageGeneric<EVA.Core.Services.ProduceDocumentsResponse> {
    PrintInvoice : boolean;
    EmailInvoice : boolean;
    PrintReceipt : boolean;
    DownloadInvoice : boolean;
    StationID : number; // Int32, nullable
    OrderID : number; // Int32
    EmailAddress : string;
    InvoiceID : number; // Int32, nullable
    __response : EVA.Core.Services.ProduceDocumentsResponse;
  }

  export class ProduceDocumentsResponse extends EVA.Core.ResponseMessage {
    InvoiceUrl : string;
  }

  export class ProduceInvoice extends EVA.Core.RequestMessageGeneric<EVA.Core.ResourceResponseMessage> {
    OrderID : number; // Int32
    EmailAddress : string;
    StationID : number; // Int32, nullable
    EmailInvoice : boolean;
    DownloadInvoice : boolean;
    PrintInvoice : boolean;
    InvoiceID : number; // Int32, nullable
    __response : EVA.Core.ResourceResponseMessage;
  }

  export class ProduceReceipt extends EVA.Core.RequestMessageGeneric<EVA.Core.Services.ProduceReceiptResponse> {
    OrderID : number; // Int32
    StationID : number; // Int32, nullable
    InvoiceID : number; // Int32, nullable
    __response : EVA.Core.Services.ProduceReceiptResponse;
  }

  export class ProduceReceiptResponse extends EVA.Core.ResponseMessage {
    PrintSuccessful : boolean;
  }

  export class ProduceShipmentDocuments extends EVA.Core.RequestMessageGeneric<EVA.Core.Services.ProduceShipmentDocumentsResponse> {
    OrderID : number; // Int32
    LinesToShip : EVA.Core.Services.ProduceShipmentDocumentsOrderLine[];
    StationID : number; // Int32, nullable
    __response : EVA.Core.Services.ProduceShipmentDocumentsResponse;
  }

  export class ProduceShipmentDocumentsResponse extends EVA.Core.ResponseMessage {
    ShipmentDocuments : EVA.Core.Services.ProduceShipmentDocumentsResponseModel[];
  }

  export class ProduceShipmentDocumentsResponseModel {
    Type : string;
    Url : string;
  }

  export class ProduceShipmentDocumentsOrderLine {
    ID : number; // Int32
    ProductID : number; // Int32
    QuantityToShip : number; // Int32
    TrackAndTraceCode : string;
    TrackAndTraceLink : string;
  }

  export class ProduceTrackingInformation extends EVA.Core.RequestMessageGeneric<EVA.Core.Services.ProduceTrackingInformationResponse> {
    OrderID : number; // Int32
    __response : EVA.Core.Services.ProduceTrackingInformationResponse;
  }

  export class ProduceTrackingInformationResponse extends EVA.Core.ResponseMessage {
    Result : EVA.Core.Services.ProduceTrackingInformationResponseTrackingInformation;
  }

  export class ProduceTrackingInformationResponseTrackingInformation {
    Link : string;
    Code : string;
  }

  export class SearchOrders extends EVA.Core.PagedResultRequest<EVA.Core.Services.SearchOrdersResponse> {
    Query : string;
    IsPaid : boolean;
    IsShipped : boolean;
    IsCompleted : boolean;
    StartTime : string; // DateTime, nullable
    EndTime : string; // DateTime, nullable
    OrderIDs : number[];
    OrderLineID : number; // Int32, nullable
    InvoiceNumber : string;
    CompanyName : string;
    ProductID : number; // Int32, nullable
    IsReserved : boolean;
    IsOrder : boolean;
    IsInvoiced : boolean;
    PaymentTypeID : number; // Int32, nullable
    PaymentTypeName : string;
    OrganizationUnitID : number; // Int32, nullable
    MinTotalAmountInTax : number; // Decimal, nullable
    MaxTotalAmountInTax : number; // Decimal, nullable
    ProductVariation : { [ key : string ] : string[] };
    HasReturns : boolean;
    HasCustomer : boolean;
    OrderType : EVA.Core.OrderTypes;
    ShipFromOrganizationUnitID : number; // Int32, nullable
    CustomerID : number; // Int32, nullable
    CustomerReference : string;
    ShipToOrganizationUnitID : number; // Int32, nullable
    SoldFromOrganizationUnitID : number; // Int32, nullable
    SoldToOrganizationUnitID : number; // Int32, nullable
    OriginatingOrganizationUnitID : number; // Int32, nullable
    PickupOrganizationUnitID : number; // Int32, nullable
    Properties : number[];
    CustomStatus : number[];
    __response : EVA.Core.Services.SearchOrdersResponse;
  }

  export class SearchOrdersResponse extends EVA.Core.ResponseMessage {
    Result : EVA.Core.PagedResultGeneric<EVA.Core.OrderSearchResultItem>;
    ProductVariations : { [ key : string ] : { [ key : string ] : number } };
  }

  export class SetCustomerReferenceOnOrder extends EVA.Core.RequestMessageWithEmptyResponse {
    OrderID : number; // Int32
    Reference : string;
    __response : EVA.Core.EmptyResponseMessage;
  }

  export class SetCustomOrderData extends EVA.Core.RequestMessageGeneric<EVA.Core.EmptyResponseMessage> {
    OrderID : number; // Int32
    SessionID : string;
    Key : string;
    Value : any;
    IfKeyAlreadyExistsOption : EVA.Core.Services.ExistingKeyOptions;
    __response : EVA.Core.EmptyResponseMessage;
  }

  export enum ExistingKeyOptions {
    Replace = 0,
    Add = 1,
    Error = 2,
  }

  export class SetCustomOrderLineData extends EVA.Core.RequestMessageGeneric<EVA.Core.EmptyResponseMessage> {
    OrderLineID : number; // Int32
    Key : string;
    Value : any;
    IfKeyAlreadyExistsOption : EVA.Core.Services.ExistingKeyOptions;
    __response : EVA.Core.EmptyResponseMessage;
  }

  export class SetPickupOrganizationUnit extends EVA.Core.RequestMessageGeneric<EVA.Core.ShoppingCartResponse> {
    OrderID : number; // Int32, nullable
    SessionID : string;
    OrganizationUnitID : number; // Int32
    __response : EVA.Core.ShoppingCartResponse;
  }

  export class SetRemarkOnOrder extends EVA.Core.RequestMessageWithEmptyResponse {
    OrderID : number; // Int32
    Remark : string;
    __response : EVA.Core.EmptyResponseMessage;
  }

  export class SetShippingMethod extends EVA.Core.RequestMessageGeneric<EVA.Core.ShoppingCartResponse> {
    SessionID : string;
    OrderID : number; // Int32, nullable
    OrderLineID : number; // Int32, nullable
    ShippingMethodID : number; // Int32
    RequestedDeliveryDate : string; // DateTime, nullable
    __response : EVA.Core.ShoppingCartResponse;
  }

  export class ShipOrder extends EVA.Core.RequestMessageGeneric<EVA.Core.Services.ShipOrderResponse> {
    SessionID : string;
    OrderID : number; // Int32, nullable
    Lines : EVA.Core.Services.ShipOrderShipmentOrderLine[];
    Force : boolean;
    __response : EVA.Core.Services.ShipOrderResponse;
  }

  export class ShipOrderResponse extends EVA.Core.ResponseMessage {
    ShipmentIDs : number[];
    ShippedOrderLineIDs : number[];
    Messages : EVA.Core.ConfirmShipmentResultMessage[];
  }

  export class ShipOrderShipmentOrderLine {
    OrderLineID : number; // Int32
    QuantityShipped : number; // Int32, nullable
    DeliveryNoteNumber : string;
    TrackingCode : string;
    TrackingLink : string;
  }

  export class TransferOrder extends EVA.Core.RequestMessageWithEmptyResponse {
    SessionID : string;
    __response : EVA.Core.EmptyResponseMessage;
  }

  export class UpdateContractNumber extends EVA.Core.RequestMessageWithEmptyResponse {
    OrderLineID : number; // Int32
    ContractNumber : string;
    __response : EVA.Core.EmptyResponseMessage;
  }

  export class GetContractNumber extends EVA.Core.RequestMessageGeneric<EVA.Core.Services.GetContractNumberResponse> {
    OrderLineID : number; // Int32
    __response : EVA.Core.Services.GetContractNumberResponse;
  }

  export class GetContractNumberResponse extends EVA.Core.ResponseMessage {
    ContractNumber : string;
  }

  export class UpdateOrderAddresses extends EVA.Core.RequestMessageGeneric<EVA.Core.Services.UpdateOrderAddressesResponse> {
    SessionID : string;
    OrderID : number; // Int32, nullable
    CopyShippingAddressFromCustomer : boolean;
    CopyBillingAddressFromCustomer : boolean;
    ShipToAddress : EVA.Core.AddressDto;
    BillToAddress : EVA.Core.AddressDto;
    __response : EVA.Core.Services.UpdateOrderAddressesResponse;
  }

  export class UpdateOrderAddressesResponse extends EVA.Core.ResponseMessage {
    CreditcardAllowed : boolean;
    ShipToAddress : EVA.Core.AddressDto;
    BillToAddress : EVA.Core.AddressDto;
  }

  export class UpdateOrderShippingAddress extends EVA.Core.RequestMessageGeneric<EVA.Core.Services.UpdateOrderAddressResponse> {
    SessionID : string;
    OrderID : number; // Int32, nullable
    Address : EVA.Core.AddressDto;
    AddressBookID : number; // Int32, nullable
    __response : EVA.Core.Services.UpdateOrderAddressResponse;
  }

  export class UpdateOrderAddressResponse extends EVA.Core.ResponseMessage {
    ShippingAddress : EVA.Core.AddressDto;
    BillingAddress : EVA.Core.AddressDto;
  }

  export class UpdateOrderBillingAddress extends EVA.Core.RequestMessageGeneric<EVA.Core.Services.UpdateOrderAddressResponse> {
    SessionID : string;
    OrderID : number; // Int32, nullable
    Address : EVA.Core.AddressDto;
    AddressBookID : number; // Int32, nullable
    __response : EVA.Core.Services.UpdateOrderAddressResponse;
  }

  export class UpdateOrderCurrency extends EVA.Core.RequestMessageWithEmptyResponse {
    OrderID : number; // Int32, nullable
    SessionID : string;
    CurrencyID : string;
    __response : EVA.Core.EmptyResponseMessage;
  }

  export class UpdateSerialNumber extends EVA.Core.RequestMessageWithEmptyResponse {
    OrderLineID : number; // Int32
    SerialNumber : string;
    __response : EVA.Core.EmptyResponseMessage;
  }

  export class GetSerialNumber extends EVA.Core.RequestMessageGeneric<EVA.Core.Services.GetSerialNumberResponse> {
    OrderLineID : number; // Int32
    __response : EVA.Core.Services.GetSerialNumberResponse;
  }

  export class GetSerialNumberResponse extends EVA.Core.ResponseMessage {
    SerialNumber : string;
  }

  export class ValidateRequiredDataForOrder extends EVA.Core.RequestMessageGeneric<EVA.Core.Services.ValidateRequiredDataForOrderResponse> {
    OrderID : number; // Int32
    RequiredFor : EVA.Core.RequiredFor;
    __response : EVA.Core.Services.ValidateRequiredDataForOrderResponse;
  }

  export class ValidateRequiredDataForOrderResponse extends EVA.Core.ResponseMessage {
    ValidatedData : EVA.Core.RequiredDataValidationResult;
  }

  export enum VerifyCustomerFunctionalities {
    ReleasePaidPickupOrders = 0,
  }

  export class VerifyCustomer extends EVA.Core.RequestMessageWithEmptyResponse {
    OrderID : number; // Int32
    VerificationCode : string;
    ManualRelease : boolean;
    IdentificationCode : string;
    __response : EVA.Core.EmptyResponseMessage;
  }

  export class GetDataModelForTemplateHandler extends EVA.Core.RequestMessageGeneric<EVA.Core.Services.GetDataModelForTemplateHandlerResponse> {
    Handler : string;
    __response : EVA.Core.Services.GetDataModelForTemplateHandlerResponse;
  }

  export class GetDataModelForTemplateHandlerResponse extends EVA.Core.ResponseMessage {
    DataModel : any;
  }

  export class ListMessageTemplateLayouts extends EVA.Core.RequestMessageGeneric<EVA.Core.Services.ListMessageTemplateLayoutsResponse> {
    OrganizationUnitID : number; // Int32, nullable
    LanguageID : string;
    CountryID : string;
    Destination : EVA.Core.MessageTemplateDestinations;
    __response : EVA.Core.Services.ListMessageTemplateLayoutsResponse;
  }

  export class ListMessageTemplateLayoutsResponse extends EVA.Core.ResponseMessage {
    Layouts : string[];
  }

  export class ListTemplateHandlers extends EVA.Core.RequestMessageGeneric<EVA.Core.Services.ListTemplateHandlersResponse> {
    __response : EVA.Core.Services.ListTemplateHandlersResponse;
  }

  export class ListTemplateHandlersResponse extends EVA.Core.ResponseMessage {
    Handlers : string[];
  }

  export class GetMessageTemplateByID extends EVA.Core.RequestMessageGeneric<EVA.Core.Services.GetMessageTemplateByIDResponse> {
    ID : number; // Int32
    __response : EVA.Core.Services.GetMessageTemplateByIDResponse;
  }

  export class GetMessageTemplateByIDResponse extends EVA.Core.ResponseMessage {
    ID : number; // Int32
    Name : string;
    OrganizationUnitID : number; // Int32, nullable
    LanguageID : string;
    CountryID : string;
    Template : string;
    Helpers : string;
    Type : EVA.Core.MessageTemplateTypes;
    Layout : string;
    Destination : EVA.Core.MessageTemplateDestinations;
    PaperProperties : EVA.Core.PaperProperties;
  }

  export class CreateMessageTemplate extends EVA.Core.RequestMessageGeneric<EVA.Core.Services.CreateMessageTemplateResponse> {
    Name : string;
    OrganizationUnitID : number; // Int32, nullable
    LanguageID : string;
    CountryID : string;
    Template : string;
    Helpers : string;
    Type : EVA.Core.MessageTemplateTypes;
    Layout : string;
    Destination : EVA.Core.MessageTemplateDestinations;
    PaperProperties : EVA.Core.PaperProperties;
    __response : EVA.Core.Services.CreateMessageTemplateResponse;
  }

  export class CreateMessageTemplateResponse extends EVA.Core.ResponseMessage {
    ID : number; // Int32
  }

  export class UpdateMessageTemplate extends EVA.Core.RequestMessageWithEmptyResponse {
    ID : number; // Int32
    Name : string;
    OrganizationUnitID : number; // Int32, nullable
    LanguageID : string;
    CountryID : string;
    Template : string;
    Helpers : string;
    Layout : string;
    Destination : EVA.Core.MessageTemplateDestinations;
    PaperProperties : EVA.Core.PaperProperties;
    __response : EVA.Core.EmptyResponseMessage;
  }

  export class DeleteMessageTemplate extends EVA.Core.RequestMessageWithEmptyResponse {
    ID : number; // Int32
    __response : EVA.Core.EmptyResponseMessage;
  }

  export class ListMessageTemplates extends EVA.Core.PagedResultRequest<EVA.Core.Services.ListMessageTemplatesResponse> {
    __response : EVA.Core.Services.ListMessageTemplatesResponse;
  }

  export class ListMessageTemplatesResponse extends EVA.Core.PagedResultResponse<EVA.Core.Services.ListMessageTemplatesResponseMessageTemplateDto> {
  }

  export class ListMessageTemplatesResponseMessageTemplateDto {
    ID : number; // Int32
    Name : string;
    OrganizationUnitID : number; // Int32, nullable
    OrganizationUnitName : string;
    LanguageID : string;
    CountryID : string;
    Type : EVA.Core.MessageTemplateTypes;
    Layout : string;
    Destination : EVA.Core.MessageTemplateDestinations;
    PaperProperties : EVA.Core.PaperProperties;
  }

  export class PreviewMessageTemplate extends EVA.Core.RequestMessageGeneric<EVA.Core.ResourceResponseMessage> {
    Name : string;
    OrganizationUnitID : number; // Int32, nullable
    LanguageID : string;
    CountryID : string;
    Template : string;
    Helpers : string;
    Type : EVA.Core.MessageTemplateTypes;
    Layout : string;
    Destination : EVA.Core.MessageTemplateDestinations;
    PaperProperties : EVA.Core.PaperProperties;
    TargetContentType : EVA.Core.MessageTargetContentTypes;
    __response : EVA.Core.ResourceResponseMessage;
  }

  export class SendSampleMailMessageTemplate extends EVA.Core.RequestMessageWithEmptyResponse {
    Name : string;
    OrganizationUnitID : number; // Int32, nullable
    LanguageID : string;
    CountryID : string;
    Template : string;
    Helpers : string;
    Type : EVA.Core.MessageTemplateTypes;
    Layout : string;
    Destination : EVA.Core.MessageTemplateDestinations;
    EmailAddress : string;
    __response : EVA.Core.EmptyResponseMessage;
  }

  export class ListMessageQueueErrors extends EVA.Core.PagedResultRequest<EVA.Core.Services.ListMessageQueueErrorsResponse> {
    __response : EVA.Core.Services.ListMessageQueueErrorsResponse;
  }

  export class ListMessageQueueErrorsResponse extends EVA.Core.PagedResultResponse<EVA.Core.MessageQueueErrorDto> {
  }

  export class RequeueErrorMessage extends EVA.Core.RequestMessageWithEmptyResponse {
    MessageQueueErrorID : number; // Int32
    MessageQueueErrorIDs : number[];
    __response : EVA.Core.EmptyResponseMessage;
  }

  export class ListLedgerClass extends EVA.Core.GetRequestGeneric<EVA.Core.Services.ListLedgerClassResponse> {
    __response : EVA.Core.Services.ListLedgerClassResponse;
  }

  export class ListLedgerClassResponse extends EVA.Core.GetResponse<EVA.Core.Services.LedgerClassDto[]> {
  }

  export class LedgerClassDto {
    ID : string;
  }

  export class ListProductLedger extends EVA.Core.RequestMessageGeneric<EVA.Core.Services.ListProductLedgerResponse> {
    ProductID : number; // Int32
    StockLabel : number; // Int32, nullable
    OrganizationUnitID : number; // Int32, nullable
    ResourceID : number; // Int32, nullable
    Type : EVA.Core.ProductLedgerTypes;
    PageConfig : EVA.Core.PageConfig;
    __response : EVA.Core.Services.ListProductLedgerResponse;
  }

  export class ListProductLedgerResponse extends EVA.Core.ResponseMessage {
    Results : EVA.Core.PagedResultGeneric<EVA.Core.ProductLedgerDto>;
  }

  export class BookInvoice extends EVA.Core.RequestMessageWithEmptyResponse {
    ID : number; // Int32
    __response : EVA.Core.EmptyResponseMessage;
  }

  export class CreateInvoice extends EVA.Core.RequestMessageGeneric<EVA.Core.Services.CreateInvoiceResponse> {
    OrganizationUnitID : number; // Int32
    SupplierOrganizationUnitID : number; // Int32
    InvoiceDate : string; // DateTime
    InvoiceNumber : string;
    Description : string;
    TaxAmounts : EVA.Core.Services.InvoiceTaxAmountDto[];
    AdditionalAmounts : EVA.Core.Services.InvoiceAdditionalAmountDto[];
    Blobs : EVA.Core.Services.InvoiceBlobDto[];
    TotalAmount : number; // Decimal
    Type : EVA.Core.InvoiceTypes;
    __response : EVA.Core.Services.CreateInvoiceResponse;
  }

  export class CreateInvoiceResponse extends EVA.Core.ResponseMessage {
    ID : number; // Int32
  }

  export class InvoiceTaxAmountDto {
    TaxCodeID : number; // Int32
    Amount : number; // Decimal
  }

  export class InvoiceAdditionalAmountDto {
    Type : EVA.Core.InvoiceAdditionalAmountTypes;
    Amount : number; // Decimal
    Description : string;
  }

  export class InvoiceBlobDto {
    BlobID : string;
  }

  export class GetInvoice extends EVA.Core.RequestMessageGeneric<EVA.Core.Services.GetInvoiceResponse> {
    ID : number; // Int32
    __response : EVA.Core.Services.GetInvoiceResponse;
  }

  export class GetInvoiceResponse extends EVA.Core.ResponseMessage {
    Invoice : EVA.Core.Services.InvoiceDetailsDto;
  }

  export class InvoiceDetailsDto {
    OrganizationUnitID : number; // Int32
    ID : number; // Int32
    InvoiceDate : string; // DateTime, nullable
    InvoiceNumber : string;
    Description : string;
    TaxAmounts : EVA.Core.Services.InvoiceTaxAmountDto[];
    AdditionalAmounts : EVA.Core.Services.InvoiceAdditionalAmountDto[];
    Lines : EVA.Core.Services.InvoiceDetailLineDto[];
    Blobs : EVA.Core.Services.InvoiceBlobDto[];
    Status : EVA.Core.InvoiceStatuses;
    SupplierOrganizationUnitID : number; // Int32, nullable
    TotalAmount : number; // Decimal, nullable
  }

  export class InvoiceDetailLineDto {
    ID : number; // Int32
    QuantityInvoiced : number; // Int32
    OrderLine : EVA.Core.Services.InvoiceDetailsOrderLineDto;
    ShipmentLineID : number; // Int32, nullable
    InvoiceDate : string; // DateTime, nullable
    UnitCost : number; // Decimal, nullable
    QuantityToInvoice : number; // Int32
  }

  export class InvoiceDetailsOrderLineDto {
    Description : string;
    UnitCost : number; // Decimal
    UnitPrice : number; // Decimal
    ID : number; // Int32
    OrderID : number; // Int32
    ProductID : number; // Int32, nullable
  }

  export class ListInvoices extends EVA.Core.PagedResultRequest<EVA.Core.Services.ListInvoicesResponse> {
    InvoiceNumber : string;
    Type : EVA.Core.InvoiceTypes;
    StartDate : string; // DateTime, nullable
    EndDate : string; // DateTime, nullable
    __response : EVA.Core.Services.ListInvoicesResponse;
  }

  export class ListInvoicesResponse extends EVA.Core.PagedResultResponse<EVA.Core.ListInvoicesDto> {
  }

  export class UpdateInvoiceLines extends EVA.Core.RequestMessageWithEmptyResponse {
    InvoiceID : number; // Int32
    Lines : EVA.Core.Services.UpdateInvoiceLine[];
    __response : EVA.Core.EmptyResponseMessage;
  }

  export class UpdateInvoiceLine {
    ShipmentLineID : number; // Int32
    QuantityToInvoice : number; // Int32
    InvoicePrice : number; // Decimal
  }

  export class UpdateInvoice extends EVA.Core.RequestMessageWithEmptyResponse {
    ID : number; // Int32
    InvoiceDate : string; // DateTime
    InvoiceNumber : string;
    Description : string;
    TotalAmount : number; // Decimal, nullable
    OrganizationUnitID : number; // Int32
    SupplierOrganizationUnitID : number; // Int32
    TaxAmounts : EVA.Core.Services.InvoiceTaxAmountDto[];
    AdditionalAmounts : EVA.Core.Services.InvoiceAdditionalAmountDto[];
    Blobs : EVA.Core.Services.InvoiceBlobDto[];
    __response : EVA.Core.EmptyResponseMessage;
  }

  export class ListInterbranchOrganizationUnitForOrder extends EVA.Core.RequestMessageGeneric<EVA.Core.Services.ListInterbranchOrganizationUnitForOrderResponse> {
    OrderID : number; // Int32, nullable
    SessionID : string;
    __response : EVA.Core.Services.ListInterbranchOrganizationUnitForOrderResponse;
  }

  export class ListInterbranchOrganizationUnitForOrderResponse extends EVA.Core.ResponseMessage {
    OrganizationUnits : EVA.Core.Services.InterbranchOrganizationUnit[];
  }

  export class InterbranchOrganizationUnit {
    ID : number; // Int32
    Name : string;
  }

  export class SetInterbranchOrganizationUnitOnOrder extends EVA.Core.RequestMessageWithEmptyResponse {
    OrderID : number; // Int32, nullable
    SessionID : string;
    OrganizationUnitID : number; // Int32, nullable
    __response : EVA.Core.EmptyResponseMessage;
  }

  export class ListInsurancesForProduct extends EVA.Core.RequestMessageGeneric<EVA.Core.Services.ListInsurancesForProductResponse> {
    ProductID : number; // Int32
    __response : EVA.Core.Services.ListInsurancesForProductResponse;
  }

  export class ListInsurancesForProductResponse extends EVA.Core.ResponseMessage {
    Insurances : EVA.Core.InsuranceItemDto[];
  }

  export class ProduceInsuranceDocuments extends EVA.Core.RequestMessageGeneric<EVA.Core.Services.ProduceInsuranceDocumentsResponse> {
    EmailDocuments : boolean;
    DownloadDocuments : boolean;
    PrintDocuments : boolean;
    IncludeTerms : boolean;
    OrderID : number; // Int32, nullable
    OrderLineID : number; // Int32, nullable
    Copies : number; // Int32, nullable
    StationID : number; // Int32, nullable
    EmailAddress : string;
    __response : EVA.Core.Services.ProduceInsuranceDocumentsResponse;
  }

  export class ProduceInsuranceDocumentsResponse extends EVA.Core.ResponseMessage {
    ContractUrl : string;
    TermsUrl : string;
  }

  export class RequestInsurancesForOrder extends EVA.Core.RequestMessageWithEmptyResponse {
    OrderID : number; // Int32
    __response : EVA.Core.EmptyResponseMessage;
  }

  export class CreateDevice extends EVA.Core.CreateRequest<EVA.Core.DeviceDto> implements EVA.Core.IRequestRespondsAs<EVA.Core.CreateResponse> {
    __response : EVA.Core.CreateResponse;
  }

  export class CreateStation extends EVA.Core.CreateRequest<EVA.Core.StationDto> implements EVA.Core.IRequestRespondsAs<EVA.Core.CreateResponse> {
    __response : EVA.Core.CreateResponse;
  }

  export class DeleteDevice extends EVA.Core.DeleteRequest implements EVA.Core.IRequestRespondsAs<EVA.Core.EmptyResponseMessage> {
    __response : EVA.Core.EmptyResponseMessage;
  }

  export class DeleteStation extends EVA.Core.DeleteRequest implements EVA.Core.IRequestRespondsAs<EVA.Core.EmptyResponseMessage> {
    __response : EVA.Core.EmptyResponseMessage;
  }

  export class GetDevice extends EVA.Core.RequestMessageGeneric<EVA.Core.Services.GetDeviceResponse> {
    ID : number; // Int32
    __response : EVA.Core.Services.GetDeviceResponse;
  }

  export class GetDeviceResponse extends EVA.Core.GetResponse<EVA.Core.DeviceDto> {
  }

  export class GetStation extends EVA.Core.RequestMessageGeneric<EVA.Core.Services.GetStationResponse> {
    ID : number; // Int32
    __response : EVA.Core.Services.GetStationResponse;
  }

  export class GetStationResponse extends EVA.Core.ResponseMessage {
    Result : EVA.Core.StationDto;
  }

  export class ListDevices extends EVA.Core.PagedResultRequest<EVA.Core.Services.ListDevicesResponse> {
    __response : EVA.Core.Services.ListDevicesResponse;
  }

  export class ListDevicesResponse extends EVA.Core.PagedResultResponse<EVA.Core.DeviceDto> {
  }

  export class ListDeviceTypes extends EVA.Core.RequestMessageGeneric<EVA.Core.Services.ListDeviceTypesResponse> {
    __response : EVA.Core.Services.ListDeviceTypesResponse;
  }

  export class ListDeviceTypesResponse extends EVA.Core.ResponseMessage {
    DeviceTypes : EVA.Core.EnumDtoBase[];
  }

  export class ListStationsForOrganizationUnit extends EVA.Core.PagedResultRequest<EVA.Core.Services.ListStationsForOrganizationUnitResponse> {
    OrganizationUnitID : number; // Int32
    __response : EVA.Core.Services.ListStationsForOrganizationUnitResponse;
  }

  export class ListStationsForOrganizationUnitResponse extends EVA.Core.PagedResultResponse<EVA.Core.StationDto> {
  }

  export class ScanStation extends EVA.Core.RequestMessageGeneric<EVA.Core.Services.SelectStationResponse> {
    Barcode : string;
    __response : EVA.Core.Services.SelectStationResponse;
  }

  export class SelectStationResponse extends EVA.Core.ResponseMessage {
    Station : EVA.Core.StationDto;
    HasPrinterDevice : boolean;
    HasPinDevice : boolean;
    HasReceiptPrinterDevice : boolean;
  }

  export class SelectStation extends EVA.Core.RequestMessageGeneric<EVA.Core.Services.SelectStationResponse> {
    StationID : number; // Int32
    __response : EVA.Core.Services.SelectStationResponse;
  }

  export class SendConfigurationPage extends EVA.Core.RequestMessageWithEmptyResponse {
    OrganizationUnitID : number; // Int32, nullable
    __response : EVA.Core.EmptyResponseMessage;
  }

  export class UpdateDevice extends EVA.Core.UpdateRequest<EVA.Core.DeviceDto> implements EVA.Core.IRequestRespondsAs<EVA.Core.Services.UpdateDeviceResponse> {
    __response : EVA.Core.Services.UpdateDeviceResponse;
  }

  export class UpdateDeviceResponse extends EVA.Core.ResponseMessage {
    Success : boolean;
  }

  export class UpdateStation extends EVA.Core.UpdateRequest<EVA.Core.StationDto> implements EVA.Core.IRequestRespondsAs<EVA.Core.EmptyResponseMessage> {
    __response : EVA.Core.EmptyResponseMessage;
  }

  export class CardBalanceCheck extends EVA.Core.RequestMessageGeneric<EVA.Core.Services.CardBalanceCheckResponse> {
    Barcode : string;
    CardType : string;
    CardNumber : string;
    CardPin : string;
    __response : EVA.Core.Services.CardBalanceCheckResponse;
  }

  export class CardBalanceCheckResponse extends EVA.Core.ResponseMessage {
    CardID : string;
    Status : string;
    Balance : number; // Decimal
    ResultCode : number; // Int32
  }

  export class GetFraudItem extends EVA.Core.RequestMessageGeneric<EVA.Core.Services.GetFraudItemResponse> {
    ID : number; // Int32
    __response : EVA.Core.Services.GetFraudItemResponse;
  }

  export class GetFraudItemResponse extends EVA.Core.ResponseMessage {
    ID : number; // Int32
    TypeID : number; // Int32
    Data : string;
    Object : any;
  }

  export class UpdateFraudItem extends EVA.Core.RequestMessageWithEmptyResponse {
    ID : number; // Int32
    Data : string;
    Object : any;
    __response : EVA.Core.EmptyResponseMessage;
  }

  export class CreateFraudItem extends EVA.Core.RequestMessageGeneric<EVA.Core.Services.CreateFraudItemResponse> {
    TypeID : number; // Int32
    Data : string;
    Object : any;
    __response : EVA.Core.Services.CreateFraudItemResponse;
  }

  export class CreateFraudItemResponse extends EVA.Core.ResponseMessage {
    ID : number; // Int32
  }

  export class DeleteFraudItem extends EVA.Core.RequestMessageWithEmptyResponse {
    ID : number; // Int32
    __response : EVA.Core.EmptyResponseMessage;
  }

  export class ListFraudItems extends EVA.Core.PagedResultRequest<EVA.Core.Services.ListFraudItemsResponse> {
    __response : EVA.Core.Services.ListFraudItemsResponse;
  }

  export class ListFraudItemsResponse extends EVA.Core.PagedResultResponse<EVA.Core.Services.FraudItemDto> {
  }

  export class FraudItemDto {
    ID : number; // Int32
    TypeID : number; // Int32
    Data : string;
    Object : any;
  }

  export class DownloadFraudItems extends EVA.Core.RequestMessageGeneric<EVA.Core.ResourceResponseMessage> {
    __response : EVA.Core.ResourceResponseMessage;
  }

  export class UploadFraudItems extends EVA.Core.RequestMessageWithEmptyResponse {
    Data : number[];
    __response : EVA.Core.EmptyResponseMessage;
  }

  export class DownloadFinancialPeriodDeposit extends EVA.Core.RequestMessageGeneric<EVA.Core.ResourceResponseMessage> {
    FinancialPeriodID : number; // Int32
    __response : EVA.Core.ResourceResponseMessage;
  }

  export class GetCurrentFinancialPeriodSummary extends EVA.Core.RequestMessageGeneric<EVA.Core.Services.GetCurrentFinancialPeriodSummaryResponse> {
    __response : EVA.Core.Services.GetCurrentFinancialPeriodSummaryResponse;
  }

  export class GetCurrentFinancialPeriodSummaryResponse extends EVA.Core.ResponseMessage {
    FinancialPeriodID : number; // Int32
    FinancialPeriodStatus : EVA.Core.FinancialPeriodStatus;
  }

  export class GetFinancialPeriodAccountsSummary extends EVA.Core.RequestMessageGeneric<EVA.Core.Services.GetFinancialPeriodAccountsSummaryResponse> {
    FinancialPeriodID : number; // Int32
    __response : EVA.Core.Services.GetFinancialPeriodAccountsSummaryResponse;
  }

  export class GetFinancialPeriodAccountsSummaryResponse extends EVA.Core.ResponseMessage {
    Accounts : EVA.Core.AccountSummary[];
  }

  export class GetFinancialPeriodDetails extends EVA.Core.RequestMessageGeneric<EVA.Core.Services.GetFinancialPeriodDetailsResponse> {
    FinancialPeriodID : number; // Int32
    __response : EVA.Core.Services.GetFinancialPeriodDetailsResponse;
  }

  export class GetFinancialPeriodDetailsResponse extends EVA.Core.ResponseMessage {
    Details : EVA.Core.FinancialPeriodDetailsDto;
  }

  export class ListBookings extends EVA.Core.PagedResultRequest<EVA.Core.Services.ListBookingsResponse> {
    __response : EVA.Core.Services.ListBookingsResponse;
  }

  export class ListBookingsResponse extends EVA.Core.PagedResultResponse<EVA.Core.GeneralLedgerDto> {
  }

  export class ListFinancialPeriods extends EVA.Core.PagedResultRequest<EVA.Core.Services.ListFinancialPeriodsResponse> {
    __response : EVA.Core.Services.ListFinancialPeriodsResponse;
  }

  export class ListFinancialPeriodsResponse extends EVA.Core.PagedResultResponse<EVA.Core.FinancialPeriodDto> {
  }

  export class ListGeneralLedgers extends EVA.Core.PagedResultRequest<EVA.Core.Services.ListGeneralLedgersResponse> {
    __response : EVA.Core.Services.ListGeneralLedgersResponse;
  }

  export class ListGeneralLedgersResponse extends EVA.Core.PagedResultResponse<EVA.Core.GeneralLedgerDto> {
  }

  export class ListHistoricFinancialPeriods extends EVA.Core.PagedResultRequest<EVA.Core.Services.ListHistoricFinancialPeriodsResponse> {
    From : string; // DateTime, nullable
    Till : string; // DateTime, nullable
    __response : EVA.Core.Services.ListHistoricFinancialPeriodsResponse;
  }

  export class ListHistoricFinancialPeriodsResponse extends EVA.Core.PagedResultResponse<EVA.Core.FinancialPeriodDto> {
  }

  export class ProcessPeriodClosing extends EVA.Core.RequestMessageWithEmptyResponse {
    WorkSet : EVA.Core.PeriodClosingWorkSet;
    __response : EVA.Core.EmptyResponseMessage;
  }

  export class ProcessPeriodOpening extends EVA.Core.RequestMessageWithEmptyResponse {
    WorkSet : EVA.Core.PeriodOpeningWorkSet;
    __response : EVA.Core.EmptyResponseMessage;
  }

  export class RepostFinancialPeriod extends EVA.Core.RequestMessageWithEmptyResponse {
    FinancialPeriodID : number; // Int32
    __response : EVA.Core.EmptyResponseMessage;
  }

  export class StartPeriodClosing extends EVA.Core.RequestMessageGeneric<EVA.Core.Services.StartPeriodClosingResponse> {
    __response : EVA.Core.Services.StartPeriodClosingResponse;
  }

  export class StartPeriodClosingResponse extends EVA.Core.ResponseMessage {
    WorkSet : EVA.Core.PeriodClosingWorkSet;
  }

  export class StartPeriodOpening extends EVA.Core.RequestMessageGeneric<EVA.Core.Services.StartPeriodOpeningResponse> {
    __response : EVA.Core.Services.StartPeriodOpeningResponse;
  }

  export class StartPeriodOpeningResponse extends EVA.Core.ResponseMessage {
    WorkSet : EVA.Core.PeriodOpeningWorkSet;
  }

  export class ValidatePeriodClosing extends EVA.Core.RequestMessageGeneric<EVA.Core.Services.ValidatePeriodClosingResponse> {
    WorkSet : EVA.Core.PeriodClosingWorkSet;
    __response : EVA.Core.Services.ValidatePeriodClosingResponse;
  }

  export class ValidatePeriodClosingResponse extends EVA.Core.ResponseMessage {
    ValidationErrors : { [ key : string ] : string[] };
  }

  export class ListEnumValues extends EVA.Core.RequestMessageGeneric<EVA.Core.Services.ListEnumValuesResponse> {
    Name : string;
    __response : EVA.Core.Services.ListEnumValuesResponse;
  }

  export class ListEnumValuesResponse extends EVA.Core.ResponseMessage {
    Values : EVA.Core.Services.ListEnumValuesResponseEnumValue[];
    IsFlags : boolean;
  }

  export class ListEnumValuesResponseEnumValue {
    Name : string;
    Value : number; // Int32
    Description : string;
  }

  export class CreateDiscountBatch extends EVA.Core.RequestMessageWithEmptyResponse {
    Amount : number; // Int32
    DiscountID : number; // Int32
    __response : EVA.Core.EmptyResponseMessage;
  }

  export class CreateUpdateDiscountCoupon extends EVA.Core.CreateRequest<EVA.Core.DiscountCouponDto> implements EVA.Core.IRequestRespondsAs<EVA.Core.CreateResponse> {
    __response : EVA.Core.CreateResponse;
  }

  export class CreateUpdateDiscount extends EVA.Core.RequestMessageGeneric<EVA.Core.Services.CreateUpdateDiscountResponse> {
    Discount : EVA.Core.DiscountDto;
    CouponCodeLength : number; // Int32, nullable
    __response : EVA.Core.Services.CreateUpdateDiscountResponse;
  }

  export class CreateUpdateDiscountResponse extends EVA.Core.ResponseMessage {
    ID : number; // Int32
  }

  export class GetDiscountByID extends EVA.Core.RequestMessageGeneric<EVA.Core.Services.GetDiscountByIDResponse> {
    ID : number; // Int32
    __response : EVA.Core.Services.GetDiscountByIDResponse;
  }

  export class GetDiscountByIDResponse extends EVA.Core.ResponseMessage {
    Discount : EVA.Core.DiscountDto;
  }

  export class GetDiscountCoupons extends EVA.Core.PagedResultRequest<EVA.Core.Services.GetDiscountCouponsResponse> {
    DiscountID : number; // Int32
    __response : EVA.Core.Services.GetDiscountCouponsResponse;
  }

  export class GetDiscountCouponsResponse extends EVA.Core.PagedResultResponse<EVA.Core.DiscountCouponDto> {
  }

  export class ListAvailableDiscountActionsAndConditions extends EVA.Core.RequestMessageGeneric<EVA.Core.Services.ListAvailableDiscountActionsAndConditionsResponse> {
    __response : EVA.Core.Services.ListAvailableDiscountActionsAndConditionsResponse;
  }

  export class ListAvailableDiscountActionsAndConditionsResponse extends EVA.Core.ResponseMessage {
    Conditions : string[];
    Actions : string[];
  }

  export class ListManualDiscounts extends EVA.Core.RequestMessageGeneric<EVA.Core.Services.ListManualDiscountsResponse> {
    __response : EVA.Core.Services.ListManualDiscountsResponse;
  }

  export class ListManualDiscountsResponse extends EVA.Core.ResponseMessage {
    Result : EVA.Core.Services.ListManualDiscountsResponseManualDiscountDto[];
  }

  export class ListManualDiscountsResponseManualDiscountDto {
    ID : number; // Int32
    Description : string;
    Type : string;
    NeedsReason : boolean;
    FixedAmount : number; // Decimal, nullable
    MaxAmount : number; // Decimal, nullable
  }

  export class GetPickProductDiscountOptionsForOrderLine extends EVA.Core.RequestMessageGeneric<EVA.Core.Services.GetPickProductDiscountOptionsForOrderLineResponse> {
    OrderLineID : number; // Int32
    __response : EVA.Core.Services.GetPickProductDiscountOptionsForOrderLineResponse;
  }

  export class GetPickProductDiscountOptionsForOrderLineResponse extends EVA.Core.ResponseMessage {
    Options : number[];
    CurrentSelection : number; // Int32, nullable
  }

  export class SetPickProductDiscountOptionsForOrderLine extends EVA.Core.RequestMessageWithEmptyResponse {
    OrderLineID : number; // Int32
    Selection : number; // Int32, nullable
    __response : EVA.Core.EmptyResponseMessage;
  }

  export class SearchDiscountsByQuery extends EVA.Core.PagedResultRequest<EVA.Core.Services.SearchDiscountsByQueryResponse> {
    IsActive : boolean;
    DiscountTriggerID : number; // Int32
    Description : string;
    CouponCode : string;
    CreatedBy : string;
    __response : EVA.Core.Services.SearchDiscountsByQueryResponse;
  }

  export class SearchDiscountsByQueryResponse extends EVA.Core.PagedResultResponse<EVA.Core.DiscountDto> {
  }

  export class VerifyDiscount extends EVA.Core.RequestMessageGeneric<EVA.Core.EmptyResponseMessage> {
    DiscountID : number; // Int32
    __response : EVA.Core.EmptyResponseMessage;
  }

  export class GetCurrency extends EVA.Core.RequestMessageGeneric<EVA.Core.Services.GetCurrencyResponse> {
    ID : string;
    __response : EVA.Core.Services.GetCurrencyResponse;
  }

  export class GetCurrencyResponse extends EVA.Core.ResponseMessage {
    ID : string;
    Name : string;
  }

  export class UpdateCurrency extends EVA.Core.RequestMessageWithEmptyResponse {
    ID : string;
    Name : string;
    ExchangeRate : number; // Decimal, nullable
    __response : EVA.Core.EmptyResponseMessage;
  }

  export class CreateCurrency extends EVA.Core.RequestMessageWithEmptyResponse {
    ID : string;
    Name : string;
    __response : EVA.Core.EmptyResponseMessage;
  }

  export class DeleteCurrency extends EVA.Core.RequestMessageWithEmptyResponse {
    ID : string;
    __response : EVA.Core.EmptyResponseMessage;
  }

  export class AttachApplicationToCurrency extends EVA.Core.RequestMessageWithEmptyResponse {
    ID : string;
    ExchangeRate : number; // Decimal
    __response : EVA.Core.EmptyResponseMessage;
  }

  export class DettachApplicationFromCurrency extends EVA.Core.RequestMessageWithEmptyResponse {
    ID : string;
    __response : EVA.Core.EmptyResponseMessage;
  }

  export class DetachApplicationFromCurrency extends EVA.Core.RequestMessageWithEmptyResponse {
    ID : string;
    __response : EVA.Core.EmptyResponseMessage;
  }

  export class GetAvailableCurrencies extends EVA.Core.RequestMessageGeneric<EVA.Core.Services.GetAvailableCurrenciesResponse> {
    __response : EVA.Core.Services.GetAvailableCurrenciesResponse;
  }

  export class GetAvailableCurrenciesResponse extends EVA.Core.ResponseMessage {
    Currencies : EVA.Core.Services.CurrencyDto[];
  }

  export class CurrencyDto {
    ID : string;
    Name : string;
    ExchangeRate : number; // Decimal
    IsBaseCurrency : boolean;
  }

  export class ListCurrencies extends EVA.Core.PagedResultRequest<EVA.Core.Services.ListCurrenciesResponse> {
    __response : EVA.Core.Services.ListCurrenciesResponse;
  }

  export class ListCurrenciesResponse extends EVA.Core.PagedResultResponse<EVA.Core.CurrencyWithExchangeRate> {
  }

  export class GetCommunicationMessage extends EVA.Core.GetRequestGeneric<EVA.Core.Services.GetCommunicationMessageResponse> {
    MarkAsRead : boolean;
    __response : EVA.Core.Services.GetCommunicationMessageResponse;
  }

  export class GetCommunicationMessageResponse extends EVA.Core.GetResponse<EVA.Core.Services.CommunicationMessageDto> {
  }

  export class CommunicationMessageDto {
    ID : number; // Int32
    Document : string;
    Subject : string;
    UserID : number; // Int32, nullable
    EmailFrom : string;
    EmailFromName : string;
    EmailTo : string;
    EmailToName : string;
    SmsTo : string;
    SmsToName : string;
    Type : EVA.Core.CommunicationMessageTypes;
    Processed : boolean;
    Note : string;
    Read : boolean;
    CreationTime : string; // DateTime
    UniqueCode : string;
    ProcessedDocument : string;
  }

  export class ListCommunicationMessage extends EVA.Core.PagedResultRequest<EVA.Core.Services.ListCommunicationMessageResponse> {
    UserID : number; // Int32
    UnreadOnly : boolean;
    __response : EVA.Core.Services.ListCommunicationMessageResponse;
  }

  export class ListCommunicationMessageResponse extends EVA.Core.PagedResultResponse<EVA.Core.Services.CommunicationMessageDto> {
  }

  export class GetShoppingCartInfo extends EVA.Core.RequestMessageGeneric<EVA.Core.Services.GetShoppingCartInfoResponse> {
    SessionID : string;
    __response : EVA.Core.Services.GetShoppingCartInfoResponse;
  }

  export class GetShoppingCartInfoResponse extends EVA.Core.ResponseMessage {
    QuantityOrdered : number; // Int32
    TotalAmount : number; // Decimal
    ForeignTotalAmount : number; // Decimal
    CurrencyID : string;
  }

  export class GetShoppingCart extends EVA.Core.RequestMessageGeneric<EVA.Core.ShoppingCartResponse> {
    SessionID : string;
    CartID : number; // Int32, nullable
    ProductProperties : string[];
    __response : EVA.Core.ShoppingCartResponse;
  }

  export class RecoverShoppingCart extends EVA.Core.RequestMessageGeneric<EVA.Core.ShoppingCartResponse> {
    ReminderToken : string;
    SessionID : string;
    __response : EVA.Core.ShoppingCartResponse;
  }

  export class FlushCache extends EVA.Core.RequestMessageGeneric<EVA.Core.Services.FlushCacheResponse> {
    Pattern : string;
    __response : EVA.Core.Services.FlushCacheResponse;
  }

  export class FlushCacheResponse extends EVA.Core.ResponseMessage {
  }

  export class AttachBlobToOrder extends EVA.Core.RequestMessageWithEmptyResponse {
    BlobID : string;
    Name : string;
    OrderID : number; // Int32, nullable
    OrderLineID : number; // Int32, nullable
    __response : EVA.Core.EmptyResponseMessage;
  }

  export class ListBlobsForFinancialPeriod extends EVA.Core.RequestMessageGeneric<EVA.Core.Services.ListBlobsForFinancialPeriodResponse> {
    FinancialPeriodID : number; // Int32
    __response : EVA.Core.Services.ListBlobsForFinancialPeriodResponse;
  }

  export class ListBlobsForFinancialPeriodResponse extends EVA.Core.ResponseMessage {
    Result : EVA.Core.Services.FinancialPeriodBlobDto[];
  }

  export class FinancialPeriodBlobDto {
    FinancialPeriodID : number; // Int32
    Name : string;
    MimeType : string;
    BlobID : string;
  }

  export class ListBlobsForOrder extends EVA.Core.RequestMessageGeneric<EVA.Core.Services.ListBlobsForOrderResponse> {
    OrderID : number; // Int32
    __response : EVA.Core.Services.ListBlobsForOrderResponse;
  }

  export class ListBlobsForOrderResponse extends EVA.Core.ResponseMessage {
    Result : EVA.Core.Services.OrderBlobDto[];
  }

  export class OrderBlobDto {
    OrderID : number; // Int32
    OrderLineID : number; // Int32, nullable
    Name : string;
    MimeType : string;
    BlobID : string;
    CreationTime : string; // DateTime
  }

  export class StoreAndAttachBlobToOrder extends EVA.Core.RequestMessageGeneric<EVA.Core.Services.StoreAndAttachBlobToOrderResponse> {
    Name : string;
    OrderID : number; // Int32, nullable
    OrderLineID : number; // Int32, nullable
    Category : string;
    OriginalName : string;
    MimeType : string;
    Data : number[];
    __response : EVA.Core.Services.StoreAndAttachBlobToOrderResponse;
  }

  export class StoreAndAttachBlobToOrderResponse extends EVA.Core.ResponseMessage {
    Guid : string;
    Url : string;
  }

  export class ParseBarcode extends EVA.Core.RequestMessageGeneric<EVA.Core.Services.ParseBarcodeResponse> {
    Barcode : string;
    __response : EVA.Core.Services.ParseBarcodeResponse;
  }

  export class ParseBarcodeResponse extends EVA.Core.ResponseMessage {
    Value : string;
    Type : string;
    Data : { [ key : string ] : any };
  }

  export class ListBadges extends EVA.Core.PagedResultRequest<EVA.Core.Services.ListBadgesResponse> {
    __response : EVA.Core.Services.ListBadgesResponse;
  }

  export class ListBadgesResponse extends EVA.Core.PagedResultResponse<EVA.Core.Services.BadgeDto> {
  }

  export class BadgeDto {
    ID : number; // Int32
    Name : string;
    Description : string;
    TypeID : number; // Int32
    Type : EVA.Core.BadgeTypes;
  }

  export class SaveBadge extends EVA.Core.RequestMessageWithEmptyResponse {
    Badge : EVA.Core.Services.BadgeDto;
    __response : EVA.Core.EmptyResponseMessage;
  }

  export class AuthenticateWithThirdPartyLogin extends EVA.Core.RequestMessageGeneric<EVA.Core.Services.AuthenticateWithThirdPartyLoginResponse> {
    Code : string;
    Data : { [ key : string ] : string };
    __response : EVA.Core.Services.AuthenticateWithThirdPartyLoginResponse;
  }

  export class AuthenticateWithThirdPartyLoginResponse extends EVA.Core.ResponseMessage {
    Authentication : EVA.Core.AuthenticationResults;
    AuthenticationToken : string;
  }

  export class GetAvailableThirdPartiesForLogin extends EVA.Core.RequestMessageGeneric<EVA.Core.Services.GetAvailableThirdPartiesForLoginResponse> {
    __response : EVA.Core.Services.GetAvailableThirdPartiesForLoginResponse;
  }

  export class GetAvailableThirdPartiesForLoginResponse extends EVA.Core.ResponseMessage {
    AuthenticationMethods : string[];
  }

  export class Login extends EVA.Core.RequestMessageGeneric<EVA.Core.Services.LoginResponse> implements EVA.Core.ILoginRequest {
    Username : string;
    Password : string;
    OrganizationUnitID : number; // Int32, nullable
    ApplicationID : number; // Int32
    ConfirmationToken : string;
    AuthenticationToken : string;
    IdentificationCode : string;
    Client : EVA.Core.Clients;
    RegisterApiKey : boolean;
    SelectOrganizationByApplicationID : boolean;
    LanguageID : string;
    CountryID : string;
    CustomAuthenticatorType : string;
    CustomAuthenticateData : any;
    ClientVersion : string;
    Context : string;
    PublicLogin : boolean;
    UserType : EVA.Core.UserTypes;
    __response : EVA.Core.Services.LoginResponse;
  }

  export class LoginResponse extends EVA.Core.ResponseMessage {
    Authentication : EVA.Core.AuthenticationResults;
    OrganizationUnits : EVA.Core.OrganizationUnitDto[];
    User : EVA.Core.LoggedInUserDto;
    LoggedInOrganizationID : number; // Int32, nullable
    IsCustomAuthenticateResult : boolean;
    AuthenticationToken : string;
    OrganizationUnitCurrencyID : string;
  }

  export class Logout extends EVA.Core.RequestMessageGeneric<EVA.Core.Services.LogoutResponse> {
    AuthenticationToken : string;
    ClockOut : boolean;
    Client : EVA.Core.Clients;
    __response : EVA.Core.Services.LogoutResponse;
  }

  export class LogoutResponse extends EVA.Core.ResponseMessage {
    LogoutSuccesful : boolean;
  }

  export class Ping extends EVA.Core.RequestMessageGeneric<EVA.Core.EmptyResponseMessage> {
    __response : EVA.Core.EmptyResponseMessage;
  }

  export class RequestThirdPartyLogin extends EVA.Core.RequestMessageGeneric<EVA.Core.Services.RequestThirdPartyLoginResponse> {
    Code : string;
    ReturnUrlSuccess : string;
    ReturnUrlError : string;
    __response : EVA.Core.Services.RequestThirdPartyLoginResponse;
  }

  export class RequestThirdPartyLoginResponse extends EVA.Core.ResponseMessage {
    RedirectUrl : string;
  }

  export class GetAssortmentByID extends EVA.Core.RequestMessageGeneric<EVA.Core.Services.GetAssortmentByIDResponse> {
    ID : number; // Int32
    __response : EVA.Core.Services.GetAssortmentByIDResponse;
  }

  export class GetAssortmentByIDResponse extends EVA.Core.ResponseMessage {
    ID : number; // Int32
    Name : string;
    StartDateTime : string; // DateTime
    EndDateTime : string; // DateTime, nullable
  }

  export class CreateAssortment extends EVA.Core.RequestMessageGeneric<EVA.Core.Services.CreateAssortmentResponse> {
    Name : string;
    StartDateTime : string; // DateTime
    EndDateTime : string; // DateTime, nullable
    __response : EVA.Core.Services.CreateAssortmentResponse;
  }

  export class CreateAssortmentResponse extends EVA.Core.ResponseMessage {
    ID : number; // Int32
  }

  export class UpdateAssortment extends EVA.Core.RequestMessageWithEmptyResponse {
    ID : number; // Int32
    Name : string;
    StartDateTime : string; // DateTime
    EndDateTime : string; // DateTime, nullable
    __response : EVA.Core.EmptyResponseMessage;
  }

  export class DeleteAssortment extends EVA.Core.RequestMessageWithEmptyResponse {
    ID : number; // Int32
    __response : EVA.Core.EmptyResponseMessage;
  }

  export class ListAssortments extends EVA.Core.PagedResultRequest<EVA.Core.Services.ListAssortmentsResponse> {
    __response : EVA.Core.Services.ListAssortmentsResponse;
  }

  export class ListAssortmentsResponse extends EVA.Core.PagedResultResponse<EVA.Core.Services.ListAssortmentsResponseAssortmentDto> {
  }

  export class ListAssortmentsResponseAssortmentDto {
    ID : number; // Int32
    Name : string;
    StartDateTime : string; // DateTime
    EndDateTime : string; // DateTime, nullable
  }

  export class GetOrganizationUnitAssortmentProductByID extends EVA.Core.RequestMessageGeneric<EVA.Core.Services.GetOrganizationUnitAssortmentProductByIDResponse> {
    ID : number; // Int32
    __response : EVA.Core.Services.GetOrganizationUnitAssortmentProductByIDResponse;
  }

  export class GetOrganizationUnitAssortmentProductByIDResponse extends EVA.Core.ResponseMessage {
    ID : number; // Int32
    ProductID : number; // Int32
    OrganizationUnitID : number; // Int32, nullable
    OrganizationUnitTypeID : number; // Int32, nullable
    AssortmentID : number; // Int32
  }

  export class CreateOrganizationUnitAssortmentProduct extends EVA.Core.RequestMessageGeneric<EVA.Core.Services.CreateOrganizationUnitAssortmentProductResponse> {
    ProductID : number; // Int32
    OrganizationUnitID : number; // Int32, nullable
    OrganizationUnitTypeID : number; // Int32, nullable
    AssortmentID : number; // Int32
    __response : EVA.Core.Services.CreateOrganizationUnitAssortmentProductResponse;
  }

  export class CreateOrganizationUnitAssortmentProductResponse extends EVA.Core.ResponseMessage {
    ID : number; // Int32
  }

  export class UpdateOrganizationUnitAssortmentProduct extends EVA.Core.RequestMessageWithEmptyResponse {
    ID : number; // Int32
    ProductID : number; // Int32
    OrganizationUnitID : number; // Int32, nullable
    OrganizationUnitTypeID : number; // Int32, nullable
    AssortmentID : number; // Int32
    __response : EVA.Core.EmptyResponseMessage;
  }

  export class DeleteOrganizationUnitAssortmentProduct extends EVA.Core.RequestMessageWithEmptyResponse {
    ID : number; // Int32
    __response : EVA.Core.EmptyResponseMessage;
  }

  export class ListOrganizationUnitAssortmentProducts extends EVA.Core.PagedResultRequest<EVA.Core.Services.ListOrganizationUnitAssortmentProductsResponse> {
    __response : EVA.Core.Services.ListOrganizationUnitAssortmentProductsResponse;
  }

  export class ListOrganizationUnitAssortmentProductsResponse extends EVA.Core.PagedResultResponse<EVA.Core.Services.ListOrganizationUnitAssortmentProductsResponseOrganizationUnitAssortmentProductDto> {
  }

  export class ListOrganizationUnitAssortmentProductsResponseOrganizationUnitAssortmentProductDto {
    ID : number; // Int32
    ProductID : number; // Int32
    OrganizationUnitID : number; // Int32, nullable
    OrganizationUnitTypeID : number; // Int32, nullable
    AssortmentID : number; // Int32
  }

  export class GetApplicationConfiguration extends EVA.Core.RequestMessageGeneric<EVA.Core.Services.GetApplicationConfigurationResponse> {
    __response : EVA.Core.Services.GetApplicationConfigurationResponse;
  }

  export class GetApplicationConfigurationResponse extends EVA.Core.ResponseMessage {
    Configuration : { [ key : string ] : any };
  }

  export class GetCurrentApplication extends EVA.Core.RequestMessageGeneric<EVA.Core.Services.GetCurrentApplicationResponse> {
    __response : EVA.Core.Services.GetCurrentApplicationResponse;
  }

  export class GetCurrentApplicationResponse extends EVA.Core.ResponseMessage {
    ID : number; // Int32
    Name : string;
    OrganizationUnitID : number; // Int32
    AssetsBaseUrl : string;
    PluginConfigurations : EVA.Core.Services.ApplicationPluginConfigurationDto[];
    RequiredUserTypeID : number; // Int32, nullable
    BaseUrl : string;
  }

  export class ApplicationPluginConfigurationDto {
    PluginCategory : string;
    IsEnabled : boolean;
  }

  export class ListApplicationsForCatalog extends EVA.Core.RequestMessageGeneric<EVA.Core.Services.ListApplicationsForCatalogResponse> {
    __response : EVA.Core.Services.ListApplicationsForCatalogResponse;
  }

  export class ListApplicationsForCatalogResponse extends EVA.Core.ResponseMessage {
    Result : EVA.Core.Services.ApplicationDto[];
  }

  export class ApplicationDto {
    ID : number; // Int32
    Name : string;
    OrganizationUnitID : number; // Int32
    AuthenticationToken : string;
    AssetsBaseUrl : string;
    PluginConfigurations : EVA.Core.Services.ApplicationPluginConfigurationDto[];
    RequiredUserTypeID : number; // Int32, nullable
    BaseUrl : string;
  }

  export class ListApplications extends EVA.Core.RequestMessageGeneric<EVA.Core.Services.ListApplicationsResponse> {
    __response : EVA.Core.Services.ListApplicationsResponse;
  }

  export class ListApplicationsResponse extends EVA.Core.GetResponse<EVA.Core.Services.ApplicationDto[]> {
  }

  export class ListAddressBook extends EVA.Core.PagedResultRequest<EVA.Core.Services.ListAddressBookResponse> {
    UserID : number; // Int32, nullable
    __response : EVA.Core.Services.ListAddressBookResponse;
  }

  export class ListAddressBookResponse extends EVA.Core.PagedResultResponse<EVA.Core.Services.AddressBookDto> {
  }

  export class AddressBookDto {
    ID : number; // Int32
    Address : EVA.Core.AddressDto;
    Description : string;
    DefaultShippingAddress : boolean;
    DefaultBillingAddress : boolean;
  }

  export class CreateAddressBookItem extends EVA.Core.RequestMessageGeneric<EVA.Core.CreateResponse> {
    UserID : number; // Int32, nullable
    Description : string;
    Address : EVA.Core.AddressDto;
    __response : EVA.Core.CreateResponse;
  }

  export class UpdateAddressBookItem extends EVA.Core.RequestMessageWithEmptyResponse {
    ID : number; // Int32
    Description : string;
    Address : EVA.Core.AddressDto;
    __response : EVA.Core.EmptyResponseMessage;
  }

  export class DeleteAddressBookItem extends EVA.Core.RequestMessageWithEmptyResponse {
    ID : number; // Int32
    __response : EVA.Core.EmptyResponseMessage;
  }

  export class SetDefaultShippingAddress extends EVA.Core.RequestMessageWithEmptyResponse {
    AddressBookID : number; // Int32
    __response : EVA.Core.EmptyResponseMessage;
  }

  export class SetDefaultBillingAddress extends EVA.Core.RequestMessageWithEmptyResponse {
    AddressBookID : number; // Int32
    __response : EVA.Core.EmptyResponseMessage;
  }

  export class AutocompleteAddress extends EVA.Core.RequestMessageGeneric<EVA.Core.Services.AutocompleteAddressResponse> {
    Query : string;
    __response : EVA.Core.Services.AutocompleteAddressResponse;
  }

  export class AutocompleteAddressResponse extends EVA.Core.ResponseMessage {
    Result : EVA.Core.AddressSuggestion[];
  }

  export class GetAddressForZipCode extends EVA.Core.RequestMessageGeneric<EVA.Core.Services.GetAddressForZipCodeResponse> {
    ZipCode : string;
    HouseNumber : string;
    __response : EVA.Core.Services.GetAddressForZipCodeResponse;
  }

  export class GetAddressForZipCodeResponse extends EVA.Core.GetResponse<EVA.Core.AddressDto> {
  }

  export class GetAutocompleteAddressByReference extends EVA.Core.RequestMessageGeneric<EVA.Core.Services.GetAutocompleteAddressByReferenceResponse> {
    Suggestion : EVA.Core.AddressSuggestion;
    __response : EVA.Core.Services.GetAutocompleteAddressByReferenceResponse;
  }

  export class GetAutocompleteAddressByReferenceResponse extends EVA.Core.ResponseMessage {
    Result : EVA.Core.AddressSuggestionDetails;
  }

  export class ListCountries extends EVA.Core.RequestMessageGeneric<EVA.Core.Services.ListCountriesResponse> {
    __response : EVA.Core.Services.ListCountriesResponse;
  }

  export class ListCountriesResponse extends EVA.Core.ResponseMessage {
    Result : EVA.Core.Services.CountryDto[];
  }

  export class CountryDto {
    ID : string;
    Name : string;
  }

  export class UpdateAddress extends EVA.Core.RequestMessageWithEmptyResponse {
    UserID : number; // Int32
    BillToShipping : boolean;
    ShipToAddress : EVA.Core.AddressDto;
    BillToAddress : EVA.Core.AddressDto;
    __response : EVA.Core.EmptyResponseMessage;
  }

  export class DeleteAccountingRule extends EVA.Core.DeleteRequest implements EVA.Core.IRequestRespondsAs<EVA.Core.EmptyResponseMessage> {
    __response : EVA.Core.EmptyResponseMessage;
  }

  export class DeleteAccount extends EVA.Core.DeleteRequest implements EVA.Core.IRequestRespondsAs<EVA.Core.EmptyResponseMessage> {
    __response : EVA.Core.EmptyResponseMessage;
  }

  export class CreateAccount extends EVA.Core.CreateRequest<EVA.Core.Services.AccountDto> implements EVA.Core.IRequestRespondsAs<EVA.Core.CreateResponse> {
    __response : EVA.Core.CreateResponse;
  }

  export class AccountDto {
    ID : number; // Int32
    Name : string;
    ObjectAccount : string;
    Subsidiary : string;
    AccountStyleID : number; // Int32
    AccountStyle : EVA.Core.AccountStyle;
    VisibleByApplicationID : number; // Int32
    BookOnOrganizationUnitID : number; // Int32, nullable
    BookOnOrganizationUnit : EVA.Core.OrganizationUnitDto;
    BookingFlagsID : number; // Int32
    BookingFlags : EVA.Core.BookingFlags;
  }

  export class GetAccount extends EVA.Core.RequestMessageGeneric<EVA.Core.Services.GetAccountResponse> {
    Id : number; // Int32
    __response : EVA.Core.Services.GetAccountResponse;
  }

  export class GetAccountResponse extends EVA.Core.ResponseMessage {
    Result : EVA.Core.Services.AccountDto;
  }

  export class ListAccounts extends EVA.Core.RequestMessageGeneric<EVA.Core.Services.ListAccountsResponse> {
    StyleFilter : EVA.Core.AccountStyle;
    PageConfig : EVA.Core.PageConfig;
    __response : EVA.Core.Services.ListAccountsResponse;
  }

  export class ListAccountsResponse extends EVA.Core.ResponseMessage {
    Result : EVA.Core.PagedResultGeneric<EVA.Core.Services.AccountDto>;
  }

  export class UpdateAccount extends EVA.Core.UpdateRequest<EVA.Core.Services.AccountDto> implements EVA.Core.IRequestRespondsAs<EVA.Core.EmptyResponseMessage> {
    __response : EVA.Core.EmptyResponseMessage;
  }

  export class ListAccountingBookings extends EVA.Core.RequestMessageGeneric<EVA.Core.Services.ListAccountingBookingsResponse> {
    PageConfig : EVA.Core.PageConfig;
    BookingFilter : EVA.Core.Bookings;
    OrganizationUnitIDFilter : number; // Int32, nullable
    LedgerClassFilter : string;
    FilterFallbacks : boolean;
    __response : EVA.Core.Services.ListAccountingBookingsResponse;
  }

  export class ListAccountingBookingsResponse extends EVA.Core.ResponseMessage {
    Result : EVA.Core.PagedResultGeneric<EVA.Core.Services.AccountingBookingDto>;
  }

  export class AccountingBookingDto {
    ID : number; // Int32
    ParentID : number; // Int32, nullable
    Booking : EVA.Core.Bookings;
    OrganizationUnitTypes : EVA.Core.OrganizationUnitTypes;
    OrganizationUnitID : number; // Int32, nullable
    LedgerClassID : string;
    BookOnOrganizationUnitID : number; // Int32, nullable
    BookWithLedgerClassID : string;
    AccountingInstructionID : number; // Int32
    BalanceAccountingInstructionID : number; // Int32, nullable
    BookingFunction : string;
    Children : EVA.Core.Services.AccountingBookingDto[];
  }

  export class ListAccountingRules extends EVA.Core.PagedResultRequest<EVA.Core.Services.ListAccountingRulesResponse> {
    __response : EVA.Core.Services.ListAccountingRulesResponse;
  }

  export class ListAccountingRulesResponse extends EVA.Core.PagedResultResponse<EVA.Core.Services.AccountingRuleDto> {
  }

  export class AccountingRuleDto {
    ID : number; // Int32
    AccountingInstructionID : number; // Int32
    AccountID : number; // Int32
    Account : EVA.Core.Services.AccountDtoWithAccountingRules;
    VisibleByApplicationID : number; // Int32
    LedgerClassID : string;
    OrganizationUnitID : number; // Int32, nullable
    OrganizationUnit : EVA.Core.OrganizationUnitDto;
  }

  export class AccountDtoWithAccountingRules {
    ID : number; // Int32
    Name : string;
    ObjectAccount : string;
    Subsidiary : string;
    AccountStyleID : number; // Int32
    AccountStyle : EVA.Core.AccountStyle;
    VisibleByApplicationID : number; // Int32
    BookOnOrganizationUnitID : number; // Int32, nullable
    BookOnOrganizationUnit : EVA.Core.OrganizationUnitDto;
    BookingFlagsID : number; // Int32
    BookingFlags : EVA.Core.BookingFlags;
    AccountingRules : EVA.Core.Services.AccountingRuleDto[];
  }

  export class CreateAccountingBooking extends EVA.Core.CreateRequest<EVA.Core.Services.AccountingBookingDto> implements EVA.Core.IRequestRespondsAs<EVA.Core.CreateResponse> {
    __response : EVA.Core.CreateResponse;
  }

  export class CreateAccountingRule extends EVA.Core.CreateRequest<EVA.Core.Services.AccountingRuleDto> implements EVA.Core.IRequestRespondsAs<EVA.Core.CreateResponse> {
    __response : EVA.Core.CreateResponse;
  }

  export class UpdateAccountingBooking extends EVA.Core.UpdateRequest<EVA.Core.Services.AccountingBookingDto> implements EVA.Core.IRequestRespondsAs<EVA.Core.EmptyResponseMessage> {
    __response : EVA.Core.EmptyResponseMessage;
  }

  export class UpdateAccountingRule extends EVA.Core.UpdateRequest<EVA.Core.Services.AccountingRuleDto> implements EVA.Core.IRequestRespondsAs<EVA.Core.EmptyResponseMessage> {
    __response : EVA.Core.EmptyResponseMessage;
  }

}
