/* tslint:disable */
declare module EVA.Core {
  
  export enum MessageQueueProfile {
    SendOnly = 0,
    SendAndReceive = 1,
  }
  
  export enum RedisIntents {
    Default = 0,
    Cache = 1,
  }
  
  export enum RequiredFor {
    PlaceOrder = 1,
    Payment = 2,
    Ship = 4,
    Invoice = 8,
    All = 15,
  }
  
  export enum UsernameFields {
    EmailAddress = 1,
    Nickname = 2,
    PhoneNumber = 3,
  }
  
  export enum InvalidStockMutationReasons {
    DestinationLabelEqualsSourceLabel = 0,
    InvalidSourceLabel = 1,
    InvalidDestinationLabel = 2,
    InvalidQuantity = 3,
    InvalidLabelForAdjustment = 4,
    RemarkRequired = 5,
    ReasonRequired = 6,
    NonStockProduct = 7,
    InvalidProduct = 8,
    InvalidResourceID = 9,
    InvalidOrganizationUnitID = 10,
    TypeRequired = 11,
  }
  
  export enum Functionalities {
    Login = 0,
    PerformCycleCount = 1,
    ApprovePayment = 2,
    ViewCustomers = 3,
    ViewReports = 4,
    PerformInitialCycleCount = 5,
    PerformPreCount = 6,
    ManageStoreTypes = 7,
    ExternalLogin = 8,
    MailReports = 9,
    ProductsBaseFeed = 10,
    OrganizationUnitsBaseFeed = 11,
  }
  
  export enum PasswordValidationResults {
    Valid = 0,
    TooShort = 1,
    NoMatchWithOldPassword = 2,
    TooLong = 3,
  }
  
  export enum UrlSafetyResult {
    Safe = 0,
    Unsafe = 1,
    InvalidUrl = 2,
  }
  
  export enum GeocodeResultStatus {
    OK = 0,
    NoResults = 1,
    InvalidRequest = 2,
    UnknownError = 3,
  }
  
  export enum ExcludedFieldOptions {
    UseDefaultExcludes = 0,
    AdditionalExcludes = 1,
    ReplaceDefaultExcludes = 2,
    NoExcludes = 3,
  }
  
  export enum BrandNameSearchSortOption {
    NameAscending = 0,
    NameDescending = 1,
    Hits = 2,
  }
  
  export enum ProductStatus {
    None = 0,
    PreRelease = 1,
    DeliveryOnly = 4,
    DisableDelivery = 8,
    DisablePickup = 16,
    DisableBackorder = 32,
    UseUp = 34,
  }
  
  export enum ProductPropertyNames {
    ProductID = 0,
    Barcodes = 1,
    VendorIDs = 2,
  }
  
  export enum PriceListAdjustmentTargets {
    Price = 0,
    SalesRules = 1,
    PurchaseRules = 2,
  }
  
  export enum FactorType {
    Amount = 0,
    Percentage = 1,
  }
  
  export enum BankAccountAuthorizationResultTypes {
    NoPaymentFound = 1,
    NoPaymentDetails = 2,
    NoBankAccountInDetails = 3,
    NoMatchWithCustomerBankAccount = 4,
    Success = 5,
    NoMatchWithCustomerName = 6,
  }
  
  export enum CancellationInitiator {
    System = 1,
    User = 2,
    External = 5,
  }
  
  export enum ReservedOrderLineAction {
    RemoveStockAndQuantity = 0,
    OnlyRemoveQuantity = 1,
    ForcedRemoveStock = 2,
  }
  
  export enum DefaultOrderShipperFunctionalities {
    ForcedManualShipment = 0,
  }
  
  export enum LineActionTypeChangeInitiator {
    System = 1,
    User = 2,
  }
  
  export enum MomentOfCommitment {
    None = 0,
    Creation = 1,
    Payment = 2,
  }
  
  export enum OrderLineCloneIntent {
    Split = 0,
    Derived = 1,
  }
  
  export enum OrderShipmentValidationResults {
    Unknown = 0,
    Valid = 1,
    Invalid = 2,
  }
  
  export enum OrderLineCommitmentResultTypes {
    Committed = 0,
    NoCommitmentNecessary = 1,
    InsuffientStock = 2,
  }
  
  export enum OrderCancellationOptions {
    CanBeCancelled = 0,
    AlreadyCancelled = 1,
    ShouldBeRequested = 2,
    MustBeRequested = 3,
    CannotBeCancelled = 4,
  }
  
  export enum OrderLineWithStockProcessAction {
    None = 0,
    CreateStockReservationTask = 1,
    Export = 2,
  }
  
  export enum ReturnableStatuses {
    Returnable = 1,
    NotReturnable = 2,
    SelfAndChildrenNotReturnable = 4,
    SelfAndParentsNotReturnable = 8,
    HierarchyNotReturnable = 12,
    ReturnableWithParent = 16,
  }
  
  export enum OrderLineCancellationResultReasons {
    Cancelled = 0,
    CouldNoLongerCancel = 1,
    CancellationNotSupported = 2,
    OrderLineNotFoundInExternalSystem = 3,
    InProgress = 4,
  }
  
  export enum OrderExportValidationResults {
    Unknown = 0,
    Valid = 1,
    Invalid = 2,
    NothingToBeExported = 3,
  }
  
  export enum NotificationPriority {
    Normal = 0,
    Low = 1,
  }
  
  export enum ClientNotificationType {
    Info = 1,
    Success = 2,
    Error = 3,
    Warning = 4,
  }
  
  export enum PushNotificationPriority {
    Low = 1,
    High = 2,
  }
  
  export enum MessageTargetContentTypes {
    Html = 0,
    Pdf = 1,
    Plain = 2,
  }
  
  export enum SystemQueues {
    Default = 0,
    Mails = 1,
  }
  
  export enum MappingProfiles {
    Get = 0,
    Update = 1,
    Create = 2,
  }
  
  export enum SortDirection {
    Ascending = 0,
    Descending = 1,
    NotSorted = 2,
  }
  
  export enum GravatarRating {
    G = 0,
    PG = 1,
    R = 2,
    X = 3,
  }
  
  export enum GiftCardFunctionalities {
    ForceProcessCards = 0,
  }
  
  export enum Bookings {
    Sales = 100,
    Purchase = 101,
    SalesDiscounts = 110,
    SalesTax = 130,
    COGS = 140,
    Payment = 200,
    PaymentRoundings = 201,
    CashDifferences = 218,
    CashDifferenceCorrections = 219,
    CashExpenses = 220,
    CashDeposits = 221,
    GeneralAccounting = 300,
    Kickbacks = 400,
    Shipment = 500,
    StockAdjustment = 501,
    StockCorrection = 503,
    StockCorrectionAutomatic = 504,
    StockRevaluation = 505,
    StockReceipt = 506,
    StockReceiptDeviations = 507,
    StockInTransit = 508,
    StockCycleCount = 509,
    StockInterbranch = 510,
  }
  
  export enum AccountingInstructions {
    Sales = 1000,
    SalesDiscounts = 1100,
    SalesTaxes = 1300,
    CostOfGoodsSold = 1600,
    AR = 2000,
    CurrentAccount = 2001,
    GenericBooking = 2002,
    Payment = 2100,
    CashDeposits = 2110,
    CashExpenses = 2111,
    AP = 2300,
    Stock = 3000,
    StockDifferences = 3001,
    StockRevaluations = 3002,
    StockInterbranch = 3003,
    GoodsToBeInvoiced = 4770,
    PurchasedGoodsToBeInvoiced = 4771,
    PurchaseInvoice = 4772,
    CashDifferenceCorrection = 5000,
  }
  
  export enum FinancialEventProcessStatuses {
    Success = 0,
    SuccessWithWarnings = 1,
    Failure = 2,
  }
  
  export enum ServiceExceptionTypes {
    General = 0,
    Unknown = 1,
    Unauthorized = 2,
    PasswordPolicyViolation = 3,
    UserPhoneNumberRequired = 4,
    ProductNotOnPurchaseOrder = 5,
    ProductOnPurchaseOrderAlreadyReceived = 6,
    ReceivedMoreThanIsOpenOnOrder = 7,
    CannotReceivePurchaseOrdersFromMultipleVendors = 8,
    SpecifiedFunctionalityNotPresentOnUser = 9,
    PasswordResetTokenInvalid = 10,
    SubscribeTokenInvalid = 11,
    PasswordResetOldPasswordInvalid = 12,
    CannotReceiveNegativeQuantityOnPurchaseOrder = 13,
    EmailAddressInUse = 14,
    MustBeAnEmployeeToScanStation = 15,
    UnknownStation = 16,
    UnknownDevice = 17,
    AddingToShoppingCartNotAllowed = 18,
    NoShoppingCart = 19,
    ProductNotInShoppingCart = 20,
    LineNotInShoppingCart = 21,
    ProductNotFound = 22,
    ProductNotFoundWithBarcode = 23,
    CannotChangeStationWhilePaymentInProgress = 24,
    CustomerMissing = 25,
    UnknownOrganization = 26,
    NoOrganization = 27,
    PaymentValidationError = 28,
    NoGiftWrapProduct = 29,
    UserNotAttachedToTask = 30,
    ObjectNotCheckedForVisibility = 31,
    LoyaltyCardNotFound = 32,
    UserContainerNotFound = 33,
    IncompleteLogin = 34,
    IncompleteConfirmation = 35,
    InvalidEmailAddress = 36,
    AppSettingNotDefined = 37,
    SecurityException = 38,
    StationRequired = 39,
    OrderContainsPayments = 40,
    OrderAlreadyFullyPaid = 41,
    BarcodeNotFound = 42,
    ScanStationBeforeInitiatingPayment = 43,
    AdjustStockRemarkRequired = 44,
    InvalidEan13Barcode = 45,
    NoReasonSupplied = 46,
    ShippingAddressRequired = 47,
    DeliveryRequiresAddress = 48,
    AttachCustomerNotAllowed = 49,
    FinanceException = 50,
    NoOpenFinancePeriod = 51,
    FinancePeriodUnavailable = 52,
    FinancePeriodAlreadyOpened = 53,
    AmountExceedsStationCashLimit = 54,
    AmountExceedsSafeCashLimit = 55,
    CannotChangeChildLines = 56,
    ReceiptClosed = 57,
    OrderCompleted = 58,
    PrintFailed = 59,
    NotFound = 60,
    DeletingOrderLineNotAllowed = 61,
    UpdateLineActionTypeNotAllowed = 62,
    OrderLineAlreadyCompleted = 63,
    AddLineNotAllowed = 64,
    RemoveLineNotAllowed = 65,
    CannotDeleteOrder = 66,
    CannotModifyQuantity = 67,
    InvalidAddress = 68,
    InvalidPickupOrder = 69,
    UnknownProduct = 70,
    OrderLineAlreadyExported = 71,
    InvalidOpeningHours = 72,
    NoLinesForConfirmShipment = 73,
    InvalidRequest = 74,
    UserNotFound = 75,
    PeriodClosingCashDifference = 76,
    UnknownPaymentType = 77,
    ShoppingCartNotFound = 78,
    InvalidStockLabel = 79,
    InsufficientStock = 80,
    ModifyLineNotAllowed = 81,
    IncreaseCmaNotAllowed = 82,
    LineNotInBackorder = 83,
    InvalidBarcode = 84,
    OpenCycleCountsRemanining = 85,
    OrderHasHoldStatus = 86,
    OrderAlreadyExported = 87,
    CycleCountAlreadyCompleted = 88,
    NonStockReservation = 89,
    PendingPayment = 90,
    CreditcardDisabled = 91,
    InvalidOrder = 92,
    InvalidSerial = 93,
    InvalidBankAccount = 94,
    CustomerRequired = 95,
    ObsoleteProductCannotBeOrdered = 96,
    CardActivationFailure = 97,
    CardCancellationFailure = 98,
    UnknownItemNumber = 99,
    UnknownShopNumber = 100,
    InvalidCustomer = 101,
    InvalidWebOrderNumber = 102,
    InvalidZipCode = 103,
    ReservationFailed = 104,
    DetachCustomerNotAllowed = 105,
    CannotAddLineToPaidOrderWithDiscount = 106,
    CannotAddDiscountToPaidOrder = 107,
    NotImplemented = 108,
    NoCountedQuantitiesSpecified = 109,
    UnknownStockReservationTask = 110,
    CannotIncreaseQuantityOnReservedLine = 111,
    TaskAlreadyCompleted = 112,
    InvalidQuantityToCancel = 113,
    InvalidTaxRate = 114,
    BillingAddressRequired = 115,
    InvalidCountry = 116,
    ParseFailure = 117,
    InvalidPurchaseDate = 118,
    EmptyDeliveryNoteNumber = 119,
    RmaReferenceAlreadyUsed = 120,
    CannotMoveBackMoreToSellableThanWasRequested = 121,
    RmaLineCannotBeDeleted = 122,
    InvalidClientVersion = 123,
    RmaReferenceIsRequired = 124,
    ScanInitialCycleCountLabel = 125,
    InitialCycleCountAlreadyExists = 126,
    CannotCreateInitialCycleCount = 127,
    CannotCreateInitialCycleCountWithOpenRmaRemaining = 128,
    CannotCreateInitialCycleCountWithOpenCmaRemaining = 129,
    CannotCountNonStockProduct = 130,
    CannotRecoverOtherCart = 131,
    CannotRecoverOrderFromOtherOrganization = 132,
    PaymentReturnActionBlocked = 133,
    CannotCreateInitialCycleCountWithoutOpenPeriod = 134,
    CouponCodeAlreadyInUse = 135,
    TransactionAlreadyConfirmed = 136,
    CannotChangeShippingMethod = 137,
    ReservationCleanupNoProductsMoved = 138,
    CannotRemovePrePaymentStatus = 139,
    ReservationCleanupWrongNumberOfProductsMoved = 140,
    OrganizationUnitUnavailableForPickup = 141,
    PasswordResetTokenAlreadyUsed = 142,
    ValidationFailed = 143,
    CannotCancelOrderLine = 144,
    InvalidStockMutation = 145,
    InvalidVerificationCode = 146,
    OrderCannotBeShipped = 147,
    PolicyOrReferenceNumberNotValid = 148,
    PolicyAndReferenceNumberRequired = 149,
    OpeningCashDrawerDisabled = 150,
    UsersStillClockedIn = 151,
    UserTaskNotActive = 152,
    UserTaskAlreadyCompleted = 153,
    UserTaskNotAttached = 154,
    UserNotAttachedToUserTask = 155,
    CannotCancelOrder = 156,
    StockResourceInvalid = 157,
    OrderFlaggedForFraud = 158,
  }
  
  export enum StartupPriority {
    Normal = 0,
    Later = 1,
    AsLateAsPossible = 2,
    Deferred = 3,
    AsSoonAsPossible = -2,
    Sooner = -1,
  }
  
  export enum StartupType {
    Normal = 0,
    Always = 1,
  }
  
  export enum AuthenticationResults {
    NotAuthenticated = 0,
    NotAuthorized = 1,
    Authenticated = 2,
    NeedsTwoStepAuthentication = 3,
    NeedsOrganizationUnitID = 4,
  }
  
  export enum Clients {
    Unknown = 0,
    Website = 1,
    Ipod = 2,
    Backend = 3,
    ManagementApplication = 4,
    ThirdParty = 5,
  }
  
  export enum CustomActionTypes {
    Pre = 0,
    Post = 1,
  }
  
  export enum EventLogStatus {
    New = 0,
    InProgress = 1,
    Solved = 2,
    Incidental = 3,
    WontFix = 4,
  }
  
  export enum LineActionTypes {
    None = 0,
    ReserveLine = 1,
    OrderLine = 2,
    ShipLine = 3,
    Delivery = 4,
  }
  
  export enum PaymentLogType {
    EJournal = 0,
    Receipt = 1,
    CustomerReceipt = 2,
    MerchantReceipt = 3,
  }
  
  export enum StockMutationDirection {
    None = 0,
    Positive = 1,
    Negative = 2,
    Both = 3,
  }
  
  export enum DiscountInvalidReasons {
    None = 0,
    NotExist = 1,
    NotValidYet = 2,
    Expired = 3,
    HasAlreadyBeenUsed = 4,
    CouponCodeAlreadyAdded = 5,
    ManualValueIsInvalid = 6,
    UserCardNotFound = 7,
    UserCardIsInvalid = 8,
    UserCardInsufficientBalance = 9,
    UserCardInvalidPassword = 10,
  }
  
  export enum POSPrinterFont {
    FontA = 0,
    FontB = 1,
    FontC = 2,
  }
  
  export enum POSPrinterOrientation {
    Landscape = 0,
    Portrait = 1,
  }
  
  export enum POSImageSize {
    Normal = 0,
    DoubleWidth = 1,
    DoubleHeight = 2,
  }
  
  export enum Drawer {
    DrawerA = 0,
    DrawerB = 1,
  }
  
  export enum POSPrinterAlignment {
    Left = 0,
    Center = 1,
    Right = 2,
  }
  
  export enum POSBarcodeHRI {
    NotPrinted = 0,
    AboveBarcode = 1,
    BelowBarcode = 2,
  }
  
  export enum POSBarcodeType {
    UpcA = 0,
    UpcE = 1,
    Jan13 = 2,
    Jan8 = 3,
    Code39 = 4,
    Itf = 5,
    Codabar = 6,
    TriopticCode39 = -12,
    BooklandEAN = -11,
    EAN128 = -10,
    MSI = -9,
    Code11 = -8,
    Discrete = -7,
    Interleaved = -6,
    Code93 = -5,
    Code128 = -4,
    Ean13 = -3,
    Ean8 = -2,
    Unknown = -1,
  }
  
  export enum LineSize {
    Regular = 0,
    Double = 1,
    Half = 2,
  }
  
  export enum OpenCashDrawerResults {
    Failure = 0,
    Opened = 1,
    AlreadyOpen = 2,
  }
  
  export enum OverallPinResultStatus {
    None = 0,
    TimeoutFromPinDevice = 1,
    TransactionStillInProgressForPayment = 2,
    Success = 3,
    Aborted = 4,
    Failure = 5,
    DeviceUnavailable = 6,
    PrintLastTicket = 7,
    TimedOut = 8,
    TransactionAlreadyInProgressForUser = 9,
    UserMustScanStationToAbort = 10,
    PaymentValidationError = 11,
    InProgress = 12,
    ClientFailure = 13,
    SelectPaymentMethod = 14,
    MustRevalidate = 16,
    ConnectToTerminal = 17,
  }
  
  export enum BookingFlags {
    None = 0,
    WithTaxInformation = 1,
    WithoutOffsets = 2,
    BookWithOrderNumber = 4,
    BookWithReference = 8,
    BookWithInvoiceNumber = 16,
  }
  
  export enum AccountStyle {
    Balance = 0,
    ProfitLoss = 1,
  }
  
  export enum BadgeTypes {
    Role = 1,
    Capability = 2,
    Achievement = 3,
  }
  
  export enum CardActionTypes {
    Activate = 0,
    Cancel = 1,
    PreventActivation = 2,
    Purchase = 3,
  }
  
  export enum CashJournalTypes {
    Register = 0,
    Safe = 1,
  }
  
  export enum CommunicationMessageTypes {
    Email = 0,
    SMS = 1,
  }
  
  export enum LegalForms {
    BV = 1,
    NV = 2,
    VoF = 3,
    Eenmanszaak = 4,
    Stichting = 5,
    VrijBeroep = 6,
    Vereniging = 7,
    CV = 8,
    Maatschap = 9,
    Anders = 10,
  }
  
  export enum DiscountTriggers {
    Automatic = 0,
    Manual = 1,
    Coupon = 2,
    UserCard = 3,
    PriceBuilding = 4,
    SystemManaged = -1,
  }
  
  export enum DiscountConditionTypes {
    OneOf = 0,
    All = 1,
  }
  
  export enum DiscountObjectTypes {
    Discount = 0,
    Condition = 1,
    Action = 2,
    Coupon = 3,
  }
  
  export enum FinancialEventStatuses {
    Unprocessed = 0,
    Processed = 1,
    Ignored = 2,
    NoProcessingRequired = 3,
    NoMatchingRecipe = 4,
  }
  
  export enum FinancialEventTypes {
    Sales = 10,
    SalesTax = 11,
    SalesDiscounts = 12,
    Purchase = 20,
    CostOfGoods = 30,
    Payment = 40,
    PaymentRoundings = 41,
    CashAdjustment = 50,
    StockMutation = 60,
    StockMutationAutomaticCorrection = 61,
  }
  
  export enum FinancialPeriodStatus {
    Open = 0,
    Closing = 1,
    Closed = 2,
    Processed = 3,
    Pending = -1,
  }
  
  export enum FraudDataType {
    Address = 1,
    IBAN = 2,
    IdentificationDocument = 3,
  }
  
  export enum IdentificationTypes {
    DiplomaticPassport = 1,
    DriverLicense = 2,
    EuropeanIdentification = 3,
    ForeignPassport = 4,
    INDSticker = 5,
    NatoPassport = 6,
    Passport = 7,
    PermanentResidencyDocument = 8,
    PrivilegedDocument = 9,
    ResidencePermitTypeEuEea = 10,
    ResidencePermitTypeI = 11,
    ResidencePermitTypeII = 12,
    ResidencePermitTypeIII = 13,
    ResidencePermitTypeIV = 14,
    ResidencePermitTypeW = 15,
    VNGCard = 16,
    ResidencePermitTypeV = 17,
  }
  
  export enum InvoiceTypes {
    Sales = 0,
    Purchase = 1,
  }
  
  export enum InvoiceStatuses {
    Open = 0,
    Closed = 1,
  }
  
  export enum InvoiceAdditionalAmountTypes {
    ShippingCosts = 0,
    AdministrativeCosts = 1,
    OtherCosts = 2,
  }
  
  export enum MessageQueueErrorStatuses {
    New = 0,
    Republished = 1,
    SuccessAfterRetry = 2,
    FailureAfterRetry = 3,
    Ignored = 4,
  }
  
  export enum MessageTemplateTypes {
    Template = 1,
    Partial = 2,
    Layout = 3,
  }
  
  export enum MessageTemplateDestinations {
    Mail = 1,
    Sms = 2,
    Pdf = 4,
    Thermal = 8,
    Notification = 16,
  }
  
  export enum PaperFormats {
    A3 = 1,
    A4 = 2,
    A5 = 3,
    Legal = 4,
    Letter = 5,
    Tabloid = 6,
  }
  
  export enum PaperOrientations {
    Portrait = 1,
    Landscape = 2,
  }
  
  export enum OrderTypes {
    Sales = 0,
    Purchase = 1,
  }
  
  export enum OrderCharacteristics {
    None = 0,
    IsPickup = 1,
    CreatedByEmployee = 2,
    IsInterbranch = 4,
    IsB2b = 8,
  }
  
  export enum OrderStatus {
    Cart = 0,
    Order = 1,
  }
  
  export enum OrderProperties {
    None = 0,
    IgnoreDiscounts = 1,
    IgnoreShippingCosts = 2,
    UseAlternateTaxCalculationMethod = 4,
    DisableAutomaticLineCreation = 11,
    IgnoreOrderLineValidation = 16,
    SystemGenerated = 59,
    DoNotCommitStock = 64,
    DisableAutoReceiveShipment = 128,
  }
  
  export enum CardTransactionStatus {
    NotActivated = 0,
    Activating = 1,
    Activated = 2,
    Cancelled = 99,
  }
  
  export enum ExternalModificationStatuses {
    None = 0,
    CancellationRequested = 1,
    QuantityChangeRequested = 2,
    CancellationRequestDenied = 4,
    CancellationRequestApproved = 8,
    QuantityChangeRequestDenied = 16,
    QuantityChangeRequestApproved = 32,
  }
  
  export enum OrderExportStatuses {
    NotExported = 0,
    ShouldBeExported = 1,
    Exporting = 2,
    Exported = 3,
    WillNotBeExported = 4,
  }
  
  export enum OrderLineTypes {
    NormalProduct = 0,
    Discount = 1,
    ExtraCosts = 2,
    Contract = 3,
    SubscriptionContract = 4,
    ShippingCosts = 5,
    ReturnCosts = 6,
  }
  
  export enum OrganizationUnitTypes {
    None = 0,
    Shop = 1,
    WebShop = 2,
    Container = 4,
    Pickup = 8,
    Warehouse = 16,
    Franchise = 64,
    EVA = 128,
    TestOrganizationUnit = 256,
    DisableLogin = 512,
    Supplier = 1024,
    Consignment = 3072,
    B2b = 4096,
  }
  
  export enum OrganizationUnitStatus {
    Default = 0,
    Open = 1,
    Closed = 2,
    OpeningSoon = 4,
    TemporarilyClosed = 8,
    Sale = 16,
    Hidden = 32,
  }
  
  export enum PaymentStatuses {
    New = 0,
    Pending = 1,
    Confirmed = 10,
    Failed = -1,
  }
  
  export enum PaymentTypeCategory {
    EFT = 1,
    Ideal = 2,
  }
  
  export enum PaymentReturnActions {
    Default = 0,
    Blocked = 1,
    Forced = 2,
  }
  
  export enum ProductTypes {
    None = 0,
    Stock = 1,
    Marketing = 4,
    GiftCard = 8,
    Service = 16,
    CustomPricing = 64,
    External = 128,
    OrderCosts = 256,
    SystemGenerated = 512,
    ProductSet = 1024,
    Configurable = 16384,
    SupplierProduct = 32768,
  }
  
  export enum ProductPromisedDeliveryStatuses {
    Unknown = 0,
    KnownUnSure = 1,
    KnownQuiteSure = 2,
    KnownSure = 3,
    OnDay = 4,
    Stock = 5,
  }
  
  export enum ProductChangeMutationTypes {
    Created = 1,
    Updated = 2,
    Deleted = 3,
  }
  
  export enum ProductLedgerTypes {
    Adjustment = 0,
    AutomaticCorrection = 3,
    MoveFrom = 4,
    MoveTo = 5,
    Summary = 6,
    Commit = 7,
    Uncommit = 8,
    ExternalModification = 9,
  }
  
  export enum PurchaseOrderExportStatuses {
    NotExported = 0,
    Exported = 1,
  }
  
  export enum ReturnRequestStatus {
    New = 0,
    Exported = 1,
    Completed = 2,
  }
  
  export enum ReturnRequestTypes {
    CMA = 0,
    RMA = 1,
  }
  
  export enum SettingSensitivityTypes {
    Normal = 0,
    Sensitive = 1,
  }
  
  export enum SettingExposureTypes {
    Normal = 0,
    ApplicationConfiguration = 1,
  }
  
  export enum StockMutationTypes {
    Unknown = 0,
    Move = 1,
    Adjust = 2,
  }
  
  export enum StockMutationReasons {
    Unknown = 0,
    ChangeOrganizationUnit = 2,
    Correction = 3,
    Damage = 4,
    Theft = 5,
    Movement = 6,
    CycleCountDeviation = 7,
    Sold = 8,
    Received = 10,
    Returned = 11,
    DOA = 12,
    Scrap = 13,
    InternalUse = 14,
    Demo = 15,
    SentToVendor = 16,
    InitialInventory = 17,
    UndoOrderReservation = 18,
    CreateOrderReservation = 20,
    CreateReturnRequestStock = 21,
    InTransit = 22,
    ReceiptSurplus = 23,
    ReceiptDeficiency = 24,
    Revaluation = 26,
    InventoryReset = 27,
    CancelReturnRequestLine = 28,
    ReservationSurplus = 29,
    ShopClosingReturns = 31,
    NonReturnedProducts = 32,
    SentBySupplier = 33,
  }
  
  export enum SubscriptionTypes {
    None = 0,
    Newsletter = 1,
    Sms = 2,
    EmailDisabled = 8,
  }
  
  export enum UserTypes {
    None = 0,
    Employee = 1,
    Customer = 2,
    Anonymous = 4,
    Business = 8,
    System = 17,
    Migrated = 32,
    Debtor = 64,
    Incomplete = 128,
    LimitedTrust = 256,
    Tester = 512,
  }
  
  export enum UserCardAmountTypes {
    Currency = 0,
    Points = 1,
  }
  
  export enum UserCardMutationStatuses {
    Pending = 0,
    Completed = 1,
    Cancelled = 2,
  }
  
  export enum UserCardMutationTypes {
    Deposit = 0,
    Withdraw = 1,
  }
  
  export enum UserLedgerTypes {
    None = 0,
    Deleted = 1,
    EmailAddressChanged = 2,
    NameChanged = 3,
    DOBChanged = 4,
    CocNumberChanged = 5,
    CompanyNameChanged = 6,
    VatNumberChanged = 7,
    BankAccountChanged = 8,
    TypeChanged = 9,
    PasswordChanged = 10,
    PasswordResetRequested = 11,
    FunctionalitiesUpdated = 12,
    ShippingAddressChanged = 13,
    BillingAddressChanged = 14,
    PasswordResetFailed = 15,
    SubscriptionChanged = 16,
  }
  
  export enum ZipCodeHouseNumber {
    Uneven = 0,
    Even = 1,
    Sequential = 2,
  }
  
  export enum AfterCommitType {
    Insert = 1,
    Update = 2,
    Delete = 3,
  }
  
  export enum ConcurrencyControl {
    None = 0,
    Optimistic = 1,
    OptimisticModifiedColumnsOnly = 2,
  }
  
  export enum RunStartupComponentSideEffectsSettings {
    DoNotRun = 0,
    Prompt = 1,
    AlwaysRun = 2,
  }
  
  export enum AppScanTargets {
    Details = 0,
    Cart = 1,
  }
  
  export enum AppSearchMethods {
    Query = 0,
    CustomID = 1,
  }
  
  export enum AppStockReservationActions {
    ForceComplete = 1,
    Order = 2,
    SetAside = 4,
    Cancel = 8,
    All = 15,
  }
  
  export enum CommunicationMessageResults {
    Found = 0,
    Fallback = 1,
    Missing = 2,
  }
  
  export enum SendMode {
    Immediate = 0,
    Deferred = 1,
  }
  
  export enum PhoneNumberType {
    FixedLine = 0,
    Mobile = 1,
    FixedLineOrMobile = 2,
    TollFree = 3,
    PremiumRate = 4,
    SharedCost = 5,
    Voip = 6,
    PersonalNumber = 7,
    Pager = 8,
    UniversalAccessNumber = 9,
    VoiceMail = 10,
    Unknown = 11,
  }
  
  export enum SmsPriority {
    Normal = 0,
    High = 1,
  }
  
  export enum InvalidationPatternType {
    WildcardPostfix = 0,
    WildcardPrefix = 1,
    WildcardPreAndPostfix = 2,
    NoWildcard = 3,
  }
  
  export enum DocumentType {
    BankAccountCard = 0,
    ID = 1,
  }
  
  export enum EVAExecutionContextType {
    Unknown = 0,
    WebService = 1,
    MessageConsumer = 2,
    Task = 3,
  }
  
  export class RequestMessage {
  }
  
  export class CreateRequest<TModel> extends EVA.Core.RequestMessage {
    ToCreate : TModel; 
  }
  
  export class DeleteRequest extends EVA.Core.RequestMessage {
    ID : number; // Int32
  }
  
  export class RequestMessageGeneric<T extends ResponseMessage> extends EVA.Core.RequestMessage implements EVA.Core.IRequestRespondsAs<T> {
__response : T;
    }
  
  export class GetRequestGeneric<T extends EVA.Core.ResponseMessage> extends EVA.Core.RequestMessageGeneric<T> {
    ID : number; // Int32
  }
  
  export class ResponseMessage {
    Exception : EVA.Core.ServiceExceptionResult; 
  }
  
  export class ServiceExceptionResult {
    ExceptionMessage : string; 
    Type : string; 
    ErrorCode : string; 
  }
  
  export interface IRequestRespondsAs<TResponse extends EVA.Core.ResponseMessage> {
    __response : TResponse;
  }
  
  export class GetRequest extends EVA.Core.RequestMessage {
    ID : number; // Int32
  }
  
  export class PagedResultRequest<TResponse extends EVA.Core.ResponseMessage> extends EVA.Core.RequestMessageGeneric<TResponse> {
    PageConfig : EVA.Core.PageConfig; 
  }
  
  export class PageConfig {
    Start : number; // Int32
    Limit : number; // Int32
    SortProperty : string; 
    SortDirection : EVA.Core.SortDirection; 
    Filter : { [ key : string ] : string }; 
  }
  
  export class RequestMessageWithEmptyResponse extends EVA.Core.RequestMessageGeneric<EVA.Core.EmptyResponseMessage> {
  }
  
  export class EmptyResponseMessage extends EVA.Core.ResponseMessage {
  }
  
  export class RequestMessageWithResourceResponse extends EVA.Core.RequestMessageGeneric<EVA.Core.ResourceResponseMessage> {
  }
  
  export class ResourceResponseMessage extends EVA.Core.ResponseMessage {
    Url : string; 
  }
  
  export class UpdateRequest<TModel> extends EVA.Core.RequestMessage {
    ToUpdate : TModel; 
  }
  
  export enum MessageTypeKinds {
    Request = 0,
    Response = 1,
  }
  
  export class GetResponse<TResult> extends EVA.Core.ResponseMessage {
    Result : TResult; 
  }
  
  export class EnumDtoBase {
    ID : number; // Int32
    Name : string; 
    Description : string; 
    ApplicationID : number; // Int32, nullable
  }
  
  export class CreateResponse extends EVA.Core.ResponseMessage {
    Success : boolean; 
    ID : number; // Int32
  }
  
  export class PagedResultResponse<TModel> extends EVA.Core.ResponseMessage {
    Result : EVA.Core.PagedResultGeneric<TModel>; 
  }
  
  export class PagedResult {
  }
  
  export class PagedResultGeneric<TModel> extends EVA.Core.PagedResult {
    PageConfig : EVA.Core.PageConfig; 
    Page : TModel[]; 
    Offset : number; // Int32
    Limit : number; // Int32
    Total : number; // Int32
    SortProperty : string; 
    SortDirection : EVA.Core.SortDirection; 
    Filters : { [ key : string ] : string }; 
    NumberOfPages : number; // Int32
    CurrentPage : number; // Int32
  }
  
  export class OrganizationUnitDto {
    ID : number; // Int32
    ParentID : number; // Int32, nullable
    Name : string; 
    Description : string; 
    AddressID : number; // Int32, nullable
    Address : EVA.Core.AddressDto; 
    EmailAddress : string; 
    PhoneNumber : string; 
    Type : EVA.Core.OrganizationUnitTypes; 
    Status : EVA.Core.OrganizationUnitStatus; 
    OpeningHours : EVA.Core.OpeningHoursDto[]; 
    VisibleByApplicationID : number; // Int32
    Latitude : number; // Double, nullable
    Longitude : number; // Double, nullable
  }
  
  export class AddressDto {
    ID : number; // Int32
    ZipCode : string; 
    HouseNumber : string; 
    Street : string; 
    City : string; 
    AddressedTo : string; 
    CountryID : string; 
    CountryName : string; 
    Latitude : number; // Double, nullable
    Longitude : number; // Double, nullable
    Region : string; 
  }
  
  export class OpeningHoursDto {
    ID : number; // Int32
    OrganizationUnitID : number; // Int32
    DayOfWeek : System.Private.CoreLib.DayOfWeek; 
    ClosedForReceipts : boolean; 
    StartTime : any; // TimeSpan, nullable
    EndTime : any; // TimeSpan, nullable
    Date : string; // DateTime, nullable
    Description : string; 
    IsSpecial : boolean; 
    IsClosed : boolean; 
  }
  
  export class ShoppingCartResponse extends EVA.Core.ResponseMessage {
    ShoppingCart : EVA.Core.OrderDto; 
    OpenAmount : number; // Decimal
    ForeignOpenAmount : number; // Decimal
    TotalAmountInTax : number; // Decimal
    ForeignTotalAmountInTax : number; // Decimal
    TotalAmount : number; // Decimal
    ForeignTotalAmount : number; // Decimal
  }
  
  export class OrderDto {
    ID : number; // Int32
    BackendID : string; 
    CustomerID : number; // Int32, nullable
    Customer : EVA.Core.UserDto; 
    CreatedByID : number; // Int32
    CreatedBy : EVA.Core.UserDto; 
    CreationTime : string; // DateTime
    Payments : EVA.Core.PaymentTransactionDto[]; 
    ShippingAddressID : number; // Int32, nullable
    BillingAddressID : number; // Int32, nullable
    ShippingAddress : EVA.Core.AddressDto; 
    BillingAddress : EVA.Core.AddressDto; 
    Lines : EVA.Core.OrderLineDto[]; 
    IsActive : boolean; 
    OfferExpirationDate : string; // DateTime, nullable
    TotalAmountInTax : number; // Decimal
    ForeignTotalAmountInTax : number; // Decimal
    TaxTable : EVA.Core.TaxAmount[]; 
    StateDescription : string; 
    IsCompleted : boolean; 
    IsShipped : boolean; 
    IsPaid : boolean; 
    IsInvoiced : boolean; 
    IsCancelled : boolean; 
    Status : EVA.Core.OrderStatus; 
    HoldStatusID : number; // Int32, nullable
    Remark : string; 
    CustomerReference : string; 
    TotalItems : number; // Int32
    Messages : EVA.Core.DiscountInvalidReasons[]; 
    NeedsExtendedCustomerInformation : boolean; 
    InvoiceDate : string; // DateTime, nullable
    HasDelivery : boolean; 
    IdentificationID : number; // Int32, nullable
    SessionID : string; 
    Characteristics : EVA.Core.OrderCharacteristics; 
    OriginatingOrganizationUnitID : number; // Int32
    DestinationOrganizationUnitID : number; // Int32, nullable
    OrganizationUnitID : number; // Int32
    PickupOrganizationUnitID : number; // Int32
    SoldFromOrganizationUnitID : number; // Int32
    ShipFromOrganizationUnitID : number; // Int32, nullable
    SoldToOrganizationUnitID : number; // Int32, nullable
    CurrencyID : string; 
    OrderStatus : string; 
  }
  
  export class UserDto {
    ID : number; // Int32
    BackendRelationID : string; 
    EmailAddress : string; 
    Initials : string; 
    FirstName : string; 
    LastName : string; 
    FullName : string; 
    DateOfBirth : string; // DateTime, nullable
    PlaceOfBirth : string; 
    Gender : string; 
    ShippingAddressID : number; // Int32, nullable
    ShippingAddress : EVA.Core.AddressDto; 
    BillingAddressID : number; // Int32, nullable
    BillingAddress : EVA.Core.AddressDto; 
    Type : EVA.Core.UserTypes; 
    LanguageID : string; 
    IsDeleted : boolean; 
    Nickname : string; 
    Company : EVA.Core.CompanyDto; 
    BankAccount : string; 
    IsDebtor : boolean; 
    SubscriptionType : EVA.Core.SubscriptionTypes; 
    PhoneNumber : string; 
    GravatarHash : string; 
    Data : { [ key : string ] : string }; 
    TimeZone : string; 
  }
  
  export class CompanyDto {
    Name : string; 
    RegistrationNumber : string; 
    RegistrationCity : string; 
    RegistrationCountryID : string; 
    VatNumber : string; 
    LegalFormID : number; // Int32
    VisitorsAddress : EVA.Core.AddressDto; 
    DeliveryAddress : EVA.Core.AddressDto; 
    ReturnsAddress : EVA.Core.AddressDto; 
    InvoiceAddress : EVA.Core.AddressDto; 
    InvoiceEmailAddress : string; 
    EstablishedDate : string; // DateTime, nullable
    ContactEmailAddress : string; 
    ContactPhoneNumber : string; 
    AccountHolderName : string; 
    IBAN : string; 
    BIC : string; 
    LogoID : string; 
  }
  
  export class PaymentTransactionDto {
    ID : number; // Int32
    OrderID : number; // Int32
    PaymentDetails : string; 
    ErrorDetails : string; 
    PaymentDate : string; // DateTime, nullable
    Amount : number; // Decimal
    Status : EVA.Core.PaymentStatuses; 
    IsConfirmed : boolean; 
    IsSuccess : boolean; 
    PendingOrConfirmed : boolean; 
    StatusID : number; // Int32
    PaidAmount : number; // Decimal
    PaymentName : string; 
    Change : number; // Decimal
    TypeID : number; // Int32
    Type : EVA.Core.PaymentTypeDto; 
    CurrencyID : string; 
    ExchangeRate : number; // Decimal
    ForeignAmount : number; // Decimal
    ForeignPaidAmount : number; // Decimal
    Description : string; 
  }
  
  export class PaymentTypeDto {
    Code : string; 
    Name : string; 
    IsRoundingType : boolean; 
    PrintOnDocuments : boolean; 
  }
  
  export class OrderLineDto {
    ID : number; // Int32
    OrderID : number; // Int32, nullable
    Parent : EVA.Core.OrderLineDto; 
    ParentID : number; // Int32, nullable
    Type : EVA.Core.OrderLineTypes; 
    StockLabel : number; // Int32
    ResourceID : number; // Int32, nullable
    Description : string; 
    AdditionalDescription : string; 
    QuantityOrdered : number; // Int32
    QuantityCommitted : number; // Int32
    QuantityShipped : number; // Int32
    QuantityReserved : number; // Int32
    QuantityBackordered : number; // Int32
    QuantityReturned : number; // Int32
    QuantityCancelled : number; // Int32
    OrderStatus : string; 
    ProductID : number; // Int32, nullable
    Product : EVA.Core.ProductDto; 
    UnitPrice : number; // Decimal
    TaxRate : number; // Decimal
    ShowTaxInfo : boolean; 
    SerialNumber : string; 
    InsuranceItemID : number; // Int32, nullable
    InsuranceItem : EVA.Core.InsuranceItemDto; 
    IsCancelled : boolean; 
    TotalQuantityToShip : number; // Int32
    TotalAmountInTax : number; // Decimal
    TotalAmount : number; // Decimal
    CanModifyPrice : boolean; 
    ModificationAllowed : boolean; 
    Remark : string; 
    ReturnStockLabel : number; // Int32
    LineActionType : EVA.Core.LineActionTypes; 
    ReturnedOrderLineID : number; // Int32, nullable
    ExportStatusID : number; // Int32
    ContractNumber : string; 
    IsCompleted : boolean; 
    IsShipped : boolean; 
    ExpectedAvailabilityDate : string; // DateTime, nullable
    RequestedDate : string; // DateTime, nullable
    CreationTime : string; // DateTime
    LastModificationTime : string; // DateTime, nullable
    DiscountID : number; // Int32, nullable
    DiscountCouponID : number; // Int32, nullable
    DiscountAmount : number; // Decimal
    ShippingMethodID : number; // Int32, nullable
    ExternalModificationStatus : EVA.Core.ExternalModificationStatuses; 
    CustomOrderLineType : string; 
    CurrencyID : string; 
    ExchangeRate : number; // Decimal
    ForeignUnitPrice : number; // Decimal
    ForeignUnitPriceInTax : number; // Decimal
    ForeignTotalAmountInTax : number; // Decimal
    ProductVariation : { [ key : string ] : string }; 
  }
  
  export class ProductDto {
    ID : number; // Int32
    BackendID : string; 
    CustomID : string; 
    BrandID : number; // Int32, nullable
    BrandName : string; 
    PrimitiveName : string; 
    Type : EVA.Core.ProductTypes; 
    CatalogID : number; // Int32
    LedgerClassID : string; 
    OrganizationUnitID : number; // Int32, nullable
    Properties : any; 
  }
  
  export class InsuranceItemDto {
    ID : number; // Int32
    ProductID : number; // Int32
    Code : string; 
    Description : string; 
    DefaultServicePeriod : string; 
    InvoicePeriod : string; 
    PolicyCost : number; // Decimal, nullable
    InvoicePeriodAmount : number; // Decimal, nullable
    OwnRiskDamage : number; // Decimal, nullable
    Accessoires : boolean; 
    AbuseTelephoneConversation : boolean; 
    LoanCellPhone : boolean; 
    Stealing : boolean; 
    Damage : boolean; 
    Electrical : boolean; 
    ManufacturingErrors : boolean; 
    DataRecovery : boolean; 
    InvoicePeriodText : string; 
    DisplayText : string; 
    SinglePremium : boolean; 
  }
  
  export class TaxAmount {
    Rate : number; // Decimal
    Amount : number; // Decimal
    ForeignAmount : number; // Decimal
  }
  
  export class UserCardBalance {
    CardBalance : number; // Decimal
    CurrencyBalance : number; // Decimal
    CurrencyID : string; 
  }
  
  export class UserCardDto {
    ID : number; // Int32
    UserID : number; // Int32
    User : EVA.Core.UserDto; 
    Barcode : string; 
    IsActive : boolean; 
    CurrentBalance : EVA.Core.UserCardBalance; 
    TypeID : number; // Int32
    Type : EVA.Core.UserCardTypeDto; 
    AvailableDiscounts : EVA.Core.UserCardDiscountDto[]; 
    CurrencyID : string; 
  }
  
  export class UserCardTypeDto extends EVA.Core.EnumDtoBase {
    AmountType : EVA.Core.UserCardAmountTypes; 
  }
  
  export class DiscountDto {
    ID : number; // Int32
    IsActive : boolean; 
    Description : string; 
    NeedsReason : boolean; 
    CreatedByID : number; // Int32
    CreatedBy : EVA.Core.UserDto; 
    VerifiedByID : number; // Int32, nullable
    VerifiedBy : EVA.Core.UserDto; 
    VerificationTime : string; // DateTime, nullable
    TotalDiscountGiven : number; // Decimal
    LedgerClassID : string; 
    MaximumUsage : number; // Int32
    UsageCount : number; // Int32
    IsExclusive : boolean; 
    MaximumUsagePerOrder : number; // Int32, nullable
    Actions : EVA.Core.DiscountActionDto[]; 
    Conditions : EVA.Core.DiscountConditionDto[]; 
    Coupons : EVA.Core.DiscountCouponDto[]; 
    ConditionType : EVA.Core.DiscountConditionTypes; 
    Trigger : EVA.Core.DiscountTriggers; 
  }
  
  export class UserCardDiscountDto extends EVA.Core.DiscountDto {
    Balance : EVA.Core.UserCardBalance; 
  }
  
  export class DiscountActionDto {
    ID : number; // Int32
    DiscountID : number; // Int32
    DiscountConditionID : number; // Int32, nullable
    Type : string; 
    Data : any; 
  }
  
  export class DiscountConditionDto {
    ID : number; // Int32
    DiscountID : number; // Int32
    Type : string; 
    Data : any; 
  }
  
  export class DiscountCouponDto {
    ID : number; // Int32
    CouponCode : string; 
    DiscountID : number; // Int32
    IsActive : boolean; 
    UsageCount : number; // Int32
  }
  
  export interface IUserTaskResult {
    Name : string; 
    Description : string; 
    Type : string; 
    Value : string; 
    Data : number[]; 
  }
  
  export class UserTaskTypeDto extends EVA.Core.EnumDtoBase {
    Configuration : string; 
    ExpectedTimeToComplete : any; // TimeSpan, nullable
  }
  
  export class FinancialPeriodDto {
    ID : number; // Int32
    OpeningTime : string; // DateTime, nullable
    ClosingTime : string; // DateTime, nullable
    Status : EVA.Core.FinancialPeriodStatus; 
    OrganizationUnitID : number; // Int32
    UserID : number; // Int32, nullable
    CurrencyID : string; 
  }
  
  export class UserTaskDto {
    ID : number; // Int32
    UserID : number; // Int32, nullable
    User : EVA.Core.UserDto; 
    OrganizationUnitID : number; // Int32
    OrganizationUnit : EVA.Core.OrganizationUnitDto; 
    FinancialPeriodID : number; // Int32, nullable
    FinancialPeriod : EVA.Core.FinancialPeriodDto; 
    Type : EVA.Core.UserTaskTypeDto; 
    Priority : number; // Int32
    IsCompleted : boolean; 
    IsActive : boolean; 
    CreationTime : string; // DateTime
    Deadline : string; // DateTime, nullable
    ExpectedTimeToComplete : any; // TimeSpan, nullable
    CompletionTime : string; // DateTime, nullable
    Description : string; 
  }
  
  export class FilterModel {
    Values : any[]; 
    From : string; 
    To : string; 
    Negation : boolean; 
    ExactMatch : boolean; 
    IncludeMissing : boolean; 
  }
  
  export class AggregationFilterModel extends EVA.Core.FilterModel {
    MaxAggregationTerms : number; // Int32, nullable
    TermsAggregation : boolean; 
    StatsAggregation : boolean; 
    AggregationOptions : { [ key : string ] : EVA.Core.AggregationFilterModel }; 
  }
  
  export class SortFieldDescriptor {
    FieldName : string; 
    Direction : EVA.Core.SortDirection; 
  }
  
  export class ConfirmShipmentResultMessage {
    Code : string; 
    Message : string; 
  }
  
  export class RefundAttemptMessage {
    Code : string; 
    Message : string; 
  }
  
  export class InvoiceTotalsModel {
    Total : number; // Decimal
    SubTotal : number; // Decimal
    Taxes : EVA.Core.InvoiceTaxModel[]; 
    OpenAmount : number; // Decimal
  }
  
  export class InvoiceTaxModel {
    Rate : number; // Decimal
    Amount : number; // Decimal
  }
  
  export class LoggedInUserDto extends EVA.Core.UserDto {
    OrganizationUnitIDs : number[]; 
    CurrentOrganizationID : number; // Int32, nullable
    CurrentOrganizationName : string; 
    CurrentApplicationID : number; // Int32
    CurrentCurrencyID : string; 
    AuthenticationToken : string; 
    Functionalities : string[]; 
    SessionID : string; 
    CurrentOrganizationUnitType : EVA.Core.OrganizationUnitTypes; 
  }
  
  export class StockMutationDto {
    ID : number; // Int32
    CreationTime : string; // DateTime
    SourceOrganizationUnitID : number; // Int32
    SourceOrganizationUnit : EVA.Core.OrganizationUnitDto; 
    SourceStockLabelID : number; // Int32
    SourceStockLabel : number; // Int32
    DestinationOrganizationUnitID : number; // Int32
    DestinationOrganizationUnit : EVA.Core.OrganizationUnitDto; 
    DestinationStockLabelID : number; // Int32
    DestinationStockLabel : number; // Int32
    ReasonID : number; // Int32
    Reason : EVA.Core.StockMutationReasons; 
    ProductID : number; // Int32
    Product : EVA.Core.ProductDto; 
    OrderLine : EVA.Core.OrderLineDto; 
    ResourceID : number; // Int32, nullable
    MutationQuantity : number; // Int32
    Remark : string; 
    SourceUnitCost : number; // Decimal
    DestinationUnitCost : number; // Decimal
  }
  
  export interface IStockResourceType {
    Name : string; 
    IsUnique : boolean; 
  }
  
  export class ProductAvailabilityIndication {
    ProductID : number; // Int32
    PickupIndications : EVA.Core.PickupAvailabilityIndication[]; 
    DeliveryIndication : string; // DateTime, nullable
    StoreAvailabilityCount : number; // Int32
    StoreCount : number; // Int32
    DeliveryQuantityOnHand : number; // Int32
    AvailabilityDateIsExact : boolean; 
    ProductStatus : EVA.Core.ProductStatus; 
    ExpectedAvailabilityStatus : EVA.Core.ProductPromisedDeliveryStatuses; 
    DeliveryText : string; 
    PickupText : string; 
  }
  
  export class PickupAvailabilityIndication {
    PickupOrganizationUnit : EVA.Core.OrganizationUnitDto; 
    PickupIndicationDate : string; // DateTime
    QuantityOnHand : number; // Int32
    QuantityAvailable : number; // Int32
  }
  
  export class ProductQuantityDto {
    ProductID : number; // Int32
    QuantityRequested : number; // Int32
    ShippingMethodID : number; // Int32, nullable
  }
  
  export class PurchaseOrderShipmentDto {
    ID : number; // Int32
    OrganizationUnitID : number; // Int32
    OrganizationUnitName : string; 
    ShipmentDate : string; // DateTime
    ExpectedDeliveryDate : string; // DateTime, nullable
    BackendID : string; 
    BackendSystemID : string; 
    TrackingCode : string; 
    TrackingLink : string; 
    CreationTime : string; // DateTime
    TotalQuantityShipped : number; // Int32
    TotalQuantityDelivered : number; // Int32
  }
  
  export class PurchaseOrderShipmentLineDto {
    ID : number; // Int32
    ProductID : number; // Int32
    Description : string; 
    QuantityShipped : number; // Int32
    QuantityDelivered : number; // Int32
    IsCompleted : boolean; 
    CurrencyID : string; 
    UnitPrice : number; // Decimal
    ExchangeRate : number; // Decimal
    ForeignUnitPrice : number; // Decimal
    ForeignTotalAmount : number; // Decimal
    ShipmentDate : string; // DateTime
  }
  
  export class RecurringTask {
    Cron : string; 
    ID : string; 
    LastExecution : string; // DateTime, nullable
    NextExecution : string; // DateTime, nullable
    IsDeleted : boolean; 
    Type : any; 
    TypeName : string; 
    Args : any[]; 
  }
  
  export class ReceiveShipmentResult {
    ValidationResult : EVA.Core.ValidationResult; 
    ReservedOrdersCount : number; // Int32
  }
  
  export class ValidationResult {
    Success : boolean; 
    Code : string; 
    Message : string; 
  }
  
  export class SuggestionModel {
    Score : number; // Double
    Text : string; 
    Highlighted : string; 
    Payload : any; 
  }
  
  export class ProductAvailabilityDataDto {
    ID : number; // Int32
    PromisedDeliveryStatusID : number; // Int32, nullable
    PromisedDeliveryStatus : EVA.Core.ProductPromisedDeliveryStatuses; 
    MinDeviationDays : number; // Int32
    MaxDeviationDays : number; // Int32
    DeliveryText : string; 
    PickupNoStoresText : string; 
    PickupSomeStoresText : string; 
    PickupAllStoresText : string; 
    ProductID : number; // Int32, nullable
    Product : EVA.Core.ProductDto; 
    ValidThrough : string; // DateTime, nullable
  }
  
  export class BrandNameInfo {
    Name : string; 
    ProductCount : number; // Int32
  }
  
  export class OpeningClosingHourPair {
    StartTime : any; // TimeSpan, nullable
    EndTime : any; // TimeSpan, nullable
    SpecialReason : string; 
    DayOfWeek : System.Private.CoreLib.DayOfWeek; 
  }
  
  export class OrderLineWithQuantity {
    OrderLineID : number; // Int32
    Quantity : number; // Int32
  }
  
  export class OrderStatistics {
    GrossMargin : number; // Decimal
    OrderLines : { [ key : number ] : EVA.Core.OrderStatisticsOrderLineStatistics }; 
  }
  
  export class OrderStatisticsOrderLineStatistics {
    UnitPrice : number; // Decimal
    UnitCost : number; // Decimal
    DiscountAmount : number; // Decimal
    KickbackAmount : number; // Decimal
  }
  
  export class RequiredData {
    Order : EVA.Core.Requirement[]; 
    OrderLines : { [ key : number ] : EVA.Core.Requirement[] }; 
    Customer : EVA.Core.Requirement[]; 
  }
  
  export class Requirement {
    Name : string; 
    IsValid : boolean; 
    Message : string; 
    Type : string; 
    ValidationRule : string; 
    DataType : string; 
    RequiredFor : EVA.Core.RequiredFor; 
  }
  
  export class ShippingMethodDto {
    ID : number; // Int32
    CarrierID : number; // Int32
    Carrier : EVA.Core.CarrierDto; 
    Name : string; 
    Description : string; 
    Code : string; 
    ExtraCosts : number; // Decimal, nullable
  }
  
  export class ShippingMethodByOrderLineDto extends EVA.Core.ShippingMethodDto {
    AppliesToOrderLineIDs : number[]; 
    RequestedDeliveryDates : EVA.Core.RequestedDateByOrderLineID[]; 
  }
  
  export class CarrierDto {
    ID : number; // Int32
    Name : string; 
    Code : string; 
  }
  
  export class RequestedDateByOrderLineID {
    OrderLineID : number; // Int32
    RequestedDate : string; // DateTime, nullable
  }
  
  export class OrderWithReference {
    ID : number; // Int32
    CustomerReference : string; 
    CreationTime : string; // DateTime
  }
  
  export class OrderExportValidationResult {
    Result : EVA.Core.OrderExportValidationResults; 
    Messages : EVA.Core.OrderExportValidationResultMessage[]; 
  }
  
  export class OrderExportValidationResultMessage {
    Code : string; 
    Message : string; 
  }
  
  export class OrderSearchResultItem {
    Customer : EVA.Core.OrderSearchResultItemCustomer; 
    OrganizationUnits : EVA.Core.OrderSearchResultItemOrganizationUnit[]; 
    SoldFromOrganizationUnit : EVA.Core.OrderSearchResultItemOrganizationUnit; 
    SoldToOrganizationUnit : EVA.Core.OrderSearchResultItemOrganizationUnit; 
    ShipFromOrganizationUnit : EVA.Core.OrderSearchResultItemOrganizationUnit; 
    OriginatingOrganizationUnit : EVA.Core.OrderSearchResultItemOrganizationUnit; 
    PickupOrganizationUnitID : EVA.Core.OrderSearchResultItemOrganizationUnit; 
    IsCompleted : boolean; 
    IsPaid : boolean; 
    IsShipped : boolean; 
    IsReserved : boolean; 
    IsInvoiced : boolean; 
    OpenAmountInTax : number; // Decimal
    ForeignOpenAmountInTax : number; // Decimal
    ID : number; // Int32
    BackendID : string; 
    PaidAmount : number; // Decimal
    ForeignPaidAmount : number; // Decimal
    TotalAmountInTax : number; // Decimal
    ForeignTotalAmountInTax : number; // Decimal
    LastModificationTime : string; // DateTime
    CreationTime : string; // DateTime
    CurrencyID : string; 
    Type : EVA.Core.OrderTypes; 
    CustomerReference : string; 
    HasReturns : boolean; 
    TotalQuantityToShip : number; // Int32
    TotalQuantityShipped : number; // Int32
    Properties : EVA.Core.OrderCharacteristics; 
    PropertiesIDs : number[]; 
    CustomStatus : number; // Int32
    CustomStatusIDs : number[]; 
  }
  
  export class OrderSearchResultItemCustomer {
    ID : number; // Int32
    FullName : string; 
  }
  
  export class OrderSearchResultItemOrganizationUnit {
    ID : number; // Int32
    Name : string; 
  }
  
  export class RequiredDataValidationResult {
    Requirements : EVA.Core.RequiredData; 
    ValidationErrors : EVA.Core.ValidationError[]; 
  }
  
  export class ValidationError {
    Field : string; 
    Message : string; 
    Context : string; 
  }
  
  export class PaperProperties {
    Format : EVA.Core.PaperFormats; 
    Orientation : EVA.Core.PaperOrientations; 
  }
  
  export class MessageQueueErrorDto {
    ID : number; // Int32
    MessageID : string; 
    MessageBody : string; 
    MessageTypeName : string; 
    ExceptionMessage : string; 
    StackTrace : string; 
    ErrorCode : string; 
    HostInfo : string; 
    Headers : string; 
    Addresses : string; 
    StatusID : number; // Int32
    Status : EVA.Core.MessageQueueErrorStatuses; 
    CreationTime : string; // DateTime
  }
  
  export class ProductLedgerDto {
    ID : number; // Int32
    Type : EVA.Core.ProductLedgerTypes; 
    StockMutationReason : EVA.Core.StockMutationReasons; 
    ProductID : number; // Int32
    Product : EVA.Core.ProductDto; 
    OrganizationUnitID : number; // Int32
    OrganizationUnit : EVA.Core.OrganizationUnitDto; 
    Quantity : number; // Int32
    QuantityCommitted : number; // Int32
    Remark : string; 
    StockLabel : number; // Int32
    IsSummary : boolean; 
    StockMutationID : number; // Int32, nullable
    OrderLineID : number; // Int32, nullable
    OrderLine : EVA.Core.OrderLineDto; 
    ResourceID : number; // Int32, nullable
    CreatedByID : number; // Int32
    CreationTime : string; // DateTime
    CreatedBy : EVA.Core.UserDto; 
    UnitCost : number; // Decimal
  }
  
  export class ListInvoicesDto {
    ID : number; // Int32
    InvoiceDate : string; // DateTime, nullable
    InvoiceNumber : string; 
    OrganizationUnitID : string; 
    OrganizationUnitName : string; 
    SupplierOrganizationUnitID : number; // Int32, nullable
    SupplierOrganizationUnitName : string; 
    Description : string; 
    TotalAmount : number; // Decimal, nullable
    Status : EVA.Core.InvoiceStatuses; 
  }
  
  export class DeviceDto {
    ID : number; // Int32
    Name : string; 
    Type : EVA.Core.DeviceTypeDto; 
    TypeID : number; // Int32
    NetworkName : string; 
    IpAddress : string; 
    Station : EVA.Core.StationDto; 
    StationID : number; // Int32, nullable
    AssemblyName : string; 
    EcrID : string; 
    HardwareID : string; 
    UserID : number; // Int32, nullable
    User : EVA.Core.UserDto; 
    OrganizationUnitID : number; // Int32, nullable
    OrganizationUnit : EVA.Core.OrganizationUnitDto; 
    IsActive : boolean; 
  }
  
  export class DeviceTypeDto extends EVA.Core.EnumDtoBase {
  }
  
  export class StationDto {
    ID : number; // Int32
    Name : string; 
    OrganizationUnitID : number; // Int32
    OrganizationUnit : EVA.Core.OrganizationUnitDto; 
    OrganizationUnitDescription : string; 
    Devices : EVA.Core.DeviceDto[]; 
    HasPrinterDevice : boolean; 
    HasPinDevice : boolean; 
    HasThermalPrinterDevice : boolean; 
    HasCashDrawerDevice : boolean; 
  }
  
  export class AccountSummary {
    AccountID : number; // Int32
    Name : string; 
    Amount : number; // Decimal
    ObjectAccount : string; 
    Subsidiary : string; 
  }
  
  export class FinancialPeriodDetailsDto {
    PreviousPeriodID : number; // Int32, nullable
    OpeningTime : string; // DateTime
    ClosingTime : string; // DateTime, nullable
    Status : EVA.Core.FinancialPeriodStatus; 
    CurrencyID : string; 
    CashDeposit : EVA.Core.CashDepositDto; 
    CashJournals : EVA.Core.CashJournalDto[]; 
    LedgerBookings : EVA.Core.GeneralLedgerDto[]; 
    Expenses : EVA.Core.ExpenseDto[]; 
    Corrections : EVA.Core.GeneralLedgerDto[]; 
    LastModifiedByFullName : string; 
    CreatedByFullName : string; 
    ApprovedByFullName : string; 
    LastModifiedByID : number; // Int32
    CreatedByID : number; // Int32
    PaymentTotalPerTypes : EVA.Core.PaymentTotalPerPaymentTypeDto[]; 
    Stations : EVA.Core.StationClosing[]; 
    AmountOfRoundingDifference : number; // Decimal
    AmountOfOpeningDifference : number; // Decimal
    AmountOfCashDifference : number; // Decimal
    CashDepositTotal : number; // Decimal
    TotalAmountOfExpenses : number; // Decimal
    TotalAmountOfCorrections : number; // Decimal
    DiscountStatistics : EVA.Core.DiscountStatisticsDto[]; 
  }
  
  export class CashDepositDto {
    Number : string; 
    Description : string; 
    Total : number; // Decimal
    Lines : EVA.Core.CashDepositLineDto[]; 
  }
  
  export class CashDepositLineDto {
    Currency : number; // Decimal
    Quantity : number; // Int32
  }
  
  export class CashJournalDto {
    OpeningAmount : number; // Decimal
    ClosingAmount : number; // Decimal, nullable
    ApprovedByID : number; // Int32, nullable
    ApprovedByFullName : string; 
    CreatedByID : number; // Int32
    CreatedByFullName : string; 
    StationID : number; // Int32, nullable
    StationName : string; 
    TypeID : number; // Int32
    Type : EVA.Core.CashJournalTypes; 
  }
  
  export class GeneralLedgerDto {
    ID : number; // Int32
    OrganizationUnitID : number; // Int32
    OrganizationUnit : EVA.Core.OrganizationUnitDto; 
    Amount : number; // Decimal
    Remark : string; 
    PaymentTransactionID : number; // Int32, nullable
    PaymentTransaction : EVA.Core.PaymentTransactionDto; 
    CreationTime : string; // DateTime
    OrderID : number; // Int32, nullable
    AccountName : string; 
    AccountObjectAccount : string; 
    AccountingID : number; // Int32
    StockMutationID : number; // Int32, nullable
    StockMutation : EVA.Core.StockMutationDto; 
  }
  
  export class ExpenseDto {
    ID : number; // Int32
    TypeID : number; // Int32
    TypeDescription : string; 
    TaxRate : number; // Decimal
    Amount : number; // Decimal
    Description : string; 
    CreationTime : string; // DateTime
  }
  
  export class PaymentTotalPerPaymentTypeDto {
    Total : number; // Decimal
    TypeName : string; 
  }
  
  export class StationClosing {
    InitialAmount : number; // Decimal
    Name : string; 
    Type : EVA.Core.CashJournalTypes; 
    TypeName : string; 
    StationID : number; // Int32, nullable
    ClosingAmount : number; // Decimal
    Currencies : EVA.Core.StationCashResult[]; 
  }
  
  export class StationCashResult {
    Currency : number; // Decimal
    Quantity : number; // Int32
  }
  
  export class DiscountStatisticsDto {
    User : EVA.Core.UserDto; 
    Statistics : EVA.Core.DiscountStatisticDto[]; 
  }
  
  export class DiscountStatisticDto {
    Discount : EVA.Core.DiscountDto; 
    Amount : number; // Decimal
  }
  
  export class PeriodClosingWorkSet {
    FinancialPeriodID : number; // Int32
    OrganizationUnitID : number; // Int32
    AvailableExpenseTypes : EVA.Core.ExpenseTypeDto[]; 
    UserID : number; // Int32
    OrganizationUnit : EVA.Core.PeriodClosingOrganizationUnitDto; 
    CashJournalPaymentsTotal : number; // Decimal
    RoundingDifference : number; // Decimal
    OpeningsDifference : number; // Decimal
    DiscountStatistics : EVA.Core.DiscountStatisticsDto[]; 
    OpenOrders : EVA.Core.OrderDto[]; 
    CurrencyID : string; 
    Coins : number[]; 
    BankNotes : number[]; 
    CashDeposits : EVA.Core.CashDepositDto[]; 
    Expenses : EVA.Core.PeriodClosingExpense[]; 
    Corrections : EVA.Core.CashDifferenceCorrection[]; 
    Stations : EVA.Core.StationClosing[]; 
    Payments : EVA.Core.PaymentTypeResult[]; 
    NumberOfOpenTasks : number; // Int32
    OpenTasks : EVA.Core.UserTaskDto[]; 
  }
  
  export class ExpenseTypeDto {
    ID : number; // Int32
    Description : string; 
  }
  
  export class PeriodClosingOrganizationUnitDto {
    Name : string; 
    RegisterCashLimit : number; // Decimal
    SafeCashLimit : number; // Decimal
  }
  
  export class PeriodClosingExpense {
    TypeID : number; // Int32
    TaxCodeID : number; // Int32, nullable
    AmountInTax : number; // Decimal
    Description : string; 
  }
  
  export class CashDifferenceCorrection {
    Remark : string; 
    Amount : number; // Decimal
  }
  
  export class PaymentTypeResult {
    Name : string; 
    TotalAmount : number; // Decimal
  }
  
  export class PeriodOpeningWorkSet {
    OrganizationUnitID : number; // Int32
    PreviousAmount : number; // Decimal, nullable
    Stations : EVA.Core.StationToCount[]; 
    CurrencyID : string; 
    Coins : number[]; 
    BankNotes : number[]; 
  }
  
  export class StationToCount {
    StationID : number; // Int32, nullable
    StationName : string; 
    Type : EVA.Core.CashJournalTypes; 
    InitialAmount : number; // Decimal
  }
  
  export class CurrencyWithExchangeRate {
    ID : string; 
    Name : string; 
    ExchangeRate : number; // Decimal, nullable
  }
  
  export interface ILoginRequest {
    Username : string; 
    OrganizationUnitID : number; // Int32, nullable
    ApplicationID : number; // Int32
  }
  
  export class AddressSuggestion {
    ID : string; 
    Reference : string; 
    Description : string; 
  }
  
  export class AddressSuggestionDetails {
    Formatted : string; 
    Components : EVA.Core.AddressSuggestionDetailsComponent[]; 
    Geometry : EVA.Core.AddressSuggestionDetailsGeometryDetails; 
    UtcOffset : number; // Double
    HouseNumber : EVA.Core.AddressSuggestionDetailsComponent; 
    Street : EVA.Core.AddressSuggestionDetailsComponent; 
    City : EVA.Core.AddressSuggestionDetailsComponent; 
    Region : EVA.Core.AddressSuggestionDetailsComponent; 
    Country : EVA.Core.AddressSuggestionDetailsComponent; 
    PostalCode : EVA.Core.AddressSuggestionDetailsComponent; 
  }
  
  export class AddressSuggestionDetailsComponent {
    LongName : string; 
    ShortName : string; 
    Types : string[]; 
  }
  
  export class AddressSuggestionDetailsGeometryDetails {
    Location : EVA.Core.GeometryLocation; 
  }
  
  export class GeometryLocation {
    Latitude : number; // Double
    Longitude : number; // Double
  }
  
}