/* tslint:disable */
declare module EVA.DMS {
  
  export class DmsCreateWidgetType extends EVA.Core.CreateRequest<EVA.DMS.WidgetTypeDto> implements EVA.Core.IRequestRespondsAs<EVA.Core.CreateResponse> {
    __response : EVA.Core.CreateResponse;
  }
  
  export class WidgetTypeDto {
    ID : number; // Int32
    Name : string; 
    Description : string; 
    Template : string; 
    StyleSheet : string; 
    Columns : number; // Int32
    MaxEntries : number; // Int32
    ContentTypeID : number; // Int32
    ContentType : EVA.DMS.ContentTypeDto; 
  }
  
  export class ContentTypeDto {
    ID : number; // Int32
    Name : string; 
    Description : string; 
    Fields : EVA.DMS.ContentTypeFieldDto[]; 
  }
  
  export class ContentTypeFieldDto {
    ID : number; // Int32
    Name : string; 
    DataType : EVA.DMS.ContentDataType; 
    ContentTypeID : number; // Int32
  }
  
  export enum ContentDataType {
    Text = 0,
    Number = 1,
    Boolean = 2,
    Datetime = 3,
    Image = 4,
    Product = 5,
    ProductGroup = 6,
  }
  
  export class DmsGetWidgetTypePreview extends EVA.Core.RequestMessageGeneric<EVA.DMS.DmsGetWidgetTypePreviewResponse> {
    Model : EVA.DMS.WidgetTypeDto; 
    __response : EVA.DMS.DmsGetWidgetTypePreviewResponse;
  }
  
  export class DmsGetWidgetTypePreviewResponse extends EVA.Core.GetResponse<string> {
    Success : boolean; 
    Message : string; 
  }
  
  export class DmsGetWidgetType extends EVA.Core.GetRequestGeneric<EVA.DMS.DmsGetWidgetTypeResponse> {
    __response : EVA.DMS.DmsGetWidgetTypeResponse;
  }
  
  export class DmsGetWidgetTypeResponse extends EVA.Core.GetResponse<EVA.DMS.WidgetTypeDto> {
  }
  
  export class DmsListWidgetTypes extends EVA.Core.PagedResultRequest<EVA.DMS.DmsListWidgetTypesResponse> {
    __response : EVA.DMS.DmsListWidgetTypesResponse;
  }
  
  export class DmsListWidgetTypesResponse extends EVA.Core.PagedResultResponse<EVA.DMS.WidgetTypeDto> {
  }
  
  export class DmsUpdateWidgetType extends EVA.Core.UpdateRequest<EVA.DMS.WidgetTypeDto> implements EVA.Core.IRequestRespondsAs<EVA.Core.EmptyResponseMessage> {
    __response : EVA.Core.EmptyResponseMessage;
  }
  
  export class DmsCreateWidget extends EVA.Core.CreateRequest<EVA.DMS.WidgetDto> implements EVA.Core.IRequestRespondsAs<EVA.Core.CreateResponse> {
    ViewID : number; // Int32
    __response : EVA.Core.CreateResponse;
  }
  
  export class WidgetDto {
    ID : number; // Int32
    Name : string; 
    IsActive : boolean; 
    SizeX : number; // Int32
    SizeY : number; // Int32
    Row : number; // Int32
    Col : number; // Int32
    Selector : EVA.DMS.SelectorGroupDto; 
    Data : string; 
    WidgetTypeID : number; // Int32, nullable
    WidgetType : EVA.DMS.WidgetTypeDto; 
    ViewID : number; // Int32
    View : EVA.DMS.ViewDto; 
    TypeID : number; // Int32
    Type : EVA.DMS.DefaultWidgetTypes; 
  }
  
  export class SelectorGroupDto {
    operator : string; 
    rules : EVA.DMS.SelectorRuleDto[]; 
  }
  
  export class SelectorRuleDto {
    condition : string; 
    field : number; // Int32
    data : string; 
    group : EVA.DMS.SelectorGroupDto; 
  }
  
  export class ViewDto {
    ID : number; // Int32
    Name : string; 
    Background : string; 
    StartDate : string; // DateTime, nullable
    EndDate : string; // DateTime, nullable
    PageID : number; // Int32
    IsActive : boolean; 
    Widgets : EVA.DMS.WidgetDto[]; 
  }
  
  export enum DefaultWidgetTypes {
    Custom = 0,
    Html = 1,
    Image = 2,
    ProductList = 3,
  }
  
  export class DmsDeleteWidget extends EVA.Core.RequestMessageWithEmptyResponse {
    ID : number; // Int32
    __response : EVA.Core.EmptyResponseMessage;
  }
  
  export class DmsGetWidgetByID extends EVA.Core.GetRequestGeneric<EVA.DMS.DmsGetWidgetByIDResponse> {
    __response : EVA.DMS.DmsGetWidgetByIDResponse;
  }
  
  export class DmsGetWidgetByIDResponse extends EVA.Core.GetResponse<EVA.DMS.WidgetDto> {
  }
  
  export class DmsGetWidgetPreview extends EVA.Core.RequestMessageGeneric<EVA.DMS.DmsGetWidgetPreviewResponse> {
    Group : EVA.DMS.SelectorGroupDto; 
    WidgetTypeID : number; // Int32
    __response : EVA.DMS.DmsGetWidgetPreviewResponse;
  }
  
  export class DmsGetWidgetPreviewResponse extends EVA.Core.GetResponse<string> {
    Success : boolean; 
    Message : string; 
  }
  
  export class DmsUpdateWidget extends EVA.Core.UpdateRequest<EVA.DMS.WidgetDto> implements EVA.Core.IRequestRespondsAs<EVA.Core.EmptyResponseMessage> {
    __response : EVA.Core.EmptyResponseMessage;
  }
  
  export class DmsCreateView extends EVA.Core.CreateRequest<EVA.DMS.ViewDto> implements EVA.Core.IRequestRespondsAs<EVA.Core.CreateResponse> {
    ObjectType : string; 
    ObjectID : number; // Int32
    __response : EVA.Core.CreateResponse;
  }
  
  export class DmsGetViewByID extends EVA.Core.GetRequestGeneric<EVA.DMS.DmsGetViewByIDResponse> {
    __response : EVA.DMS.DmsGetViewByIDResponse;
  }
  
  export class DmsGetViewByIDResponse extends EVA.Core.GetResponse<EVA.DMS.ViewDto> {
  }
  
  export class DmsGetViewLayout extends EVA.Core.RequestMessage implements EVA.Core.IRequestRespondsAs<EVA.DMS.DmsGetViewLayoutResponse> {
    ID : number; // Int32
    __response : EVA.DMS.DmsGetViewLayoutResponse;
  }
  
  export class DmsGetViewLayoutResponse extends EVA.Core.ResponseMessage {
    Blocks : EVA.DMS.WidgetLayoutBlockDto[]; 
  }
  
  export class WidgetLayoutBlockDto {
    widgetID : number; // Int32
    typeID : number; // Int32
    name : string; 
    sizeX : number; // Int32
    sizeY : number; // Int32
    row : number; // Int32
    col : number; // Int32
  }
  
  export class DmsUpdateViewLayout extends EVA.Core.RequestMessageWithEmptyResponse {
    Blocks : EVA.DMS.WidgetLayoutBlockDto[]; 
    __response : EVA.Core.EmptyResponseMessage;
  }
  
  export class DmsUpdateView extends EVA.Core.UpdateRequest<EVA.DMS.ViewDto> implements EVA.Core.IRequestRespondsAs<EVA.Core.EmptyResponseMessage> {
    __response : EVA.Core.EmptyResponseMessage;
  }
  
  export class DmsCreateProductPage extends EVA.Core.CreateRequest<EVA.DMS.ProductPageDto> implements EVA.Core.IRequestRespondsAs<EVA.Core.CreateResponse> {
    __response : EVA.Core.CreateResponse;
  }
  
  export class ProductPageDto {
    ID : number; // Int32
    Title : string; 
    BrowserTitle : string; 
    TitleOverride : boolean; 
    MetaDescription : string; 
    ProductID : number; // Int32
    Product : EVA.Core.ProductDto; 
    IsActive : boolean; 
    Views : EVA.DMS.ViewDto[]; 
    ObjectType : string; 
  }
  
  export class DmsDeleteProductPage extends EVA.Core.RequestMessageWithEmptyResponse {
    ID : number; // Int32
    __response : EVA.Core.EmptyResponseMessage;
  }
  
  export class DmsGetProductPageByID extends EVA.Core.GetRequestGeneric<EVA.DMS.DmsGetProductPageByIDResponse> {
    __response : EVA.DMS.DmsGetProductPageByIDResponse;
  }
  
  export class DmsGetProductPageByIDResponse extends EVA.Core.GetResponse<EVA.DMS.ProductPageDto> {
  }
  
  export class DmsListProductPages extends EVA.Core.PagedResultRequest<EVA.DMS.DmsListProductPagesResponse> {
    __response : EVA.DMS.DmsListProductPagesResponse;
  }
  
  export class DmsListProductPagesResponse extends EVA.Core.PagedResultResponse<EVA.DMS.ProductPageDto> {
  }
  
  export class DmsUpdateProductPage extends EVA.Core.UpdateRequest<EVA.DMS.ProductPageDto> implements EVA.Core.IRequestRespondsAs<EVA.Core.EmptyResponseMessage> {
    __response : EVA.Core.EmptyResponseMessage;
  }
  
  export class DmsCreatePage extends EVA.Core.CreateRequest<EVA.DMS.PageDto> implements EVA.Core.IRequestRespondsAs<EVA.Core.CreateResponse> {
    __response : EVA.Core.CreateResponse;
  }
  
  export class PageDto {
    ID : number; // Int32
    Title : string; 
    BrowserTitle : string; 
    TitleOverride : boolean; 
    MetaDescription : string; 
    Slug : string; 
    RequestPath : string; 
    ParentID : number; // Int32, nullable
    Parent : EVA.DMS.PageDto; 
    Depth : number; // Int32
    Lineage : string; 
    Position : number; // Int32
    ShowInMenu : boolean; 
    IsActive : boolean; 
    Views : EVA.DMS.ViewDto[]; 
    Children : EVA.DMS.PageDto[]; 
    ObjectType : string; 
  }
  
  export class DmsDeletePage extends EVA.Core.RequestMessageWithEmptyResponse {
    ID : number; // Int32
    __response : EVA.Core.EmptyResponseMessage;
  }
  
  export class DmsGetPageByID extends EVA.Core.GetRequestGeneric<EVA.DMS.DmsGetPageByIDResponse> {
    __response : EVA.DMS.DmsGetPageByIDResponse;
  }
  
  export class DmsGetPageByIDResponse extends EVA.Core.GetResponse<EVA.DMS.PageDto> {
  }
  
  export class DmsGetSiteMap extends EVA.Core.RequestMessageGeneric<EVA.DMS.DmsGetSiteMapResponse> {
    __response : EVA.DMS.DmsGetSiteMapResponse;
  }
  
  export class DmsGetSiteMapResponse extends EVA.Core.GetResponse<EVA.DMS.SiteMapNode[]> {
  }
  
  export class SiteMapNode {
    PageID : number; // Int32
    Title : string; 
    IsActive : boolean; 
    RequestPath : string; 
    Children : EVA.DMS.SiteMapNode[]; 
  }
  
  export class DmsMovePage extends EVA.Core.RequestMessageWithEmptyResponse {
    ID : number; // Int32
    ParentID : number; // Int32
    Position : number; // Int32
    __response : EVA.Core.EmptyResponseMessage;
  }
  
  export class DmsUpdatePage extends EVA.Core.UpdateRequest<EVA.DMS.PageDto> implements EVA.Core.IRequestRespondsAs<EVA.DMS.DmsUpdatePageResponse> {
    __response : EVA.DMS.DmsUpdatePageResponse;
  }
  
  export class DmsUpdatePageResponse extends EVA.Core.GetResponse<EVA.DMS.PageDto> {
  }
  
  export class DmsCreateBlock extends EVA.Core.CreateRequest<EVA.DMS.BlockDto> implements EVA.Core.IRequestRespondsAs<EVA.Core.CreateResponse> {
    __response : EVA.Core.CreateResponse;
  }
  
  export class BlockDto {
    ID : number; // Int32
    Identifier : string; 
    IsActive : boolean; 
    Views : EVA.DMS.ViewDto[]; 
    ObjectType : string; 
  }
  
  export class DmsDeleteBlock extends EVA.Core.RequestMessageWithEmptyResponse {
    ID : number; // Int32
    __response : EVA.Core.EmptyResponseMessage;
  }
  
  export class DmsGetBlockByID extends EVA.Core.GetRequestGeneric<EVA.DMS.DmsGetBlockByIDResponse> {
    __response : EVA.DMS.DmsGetBlockByIDResponse;
  }
  
  export class DmsGetBlockByIDResponse extends EVA.Core.GetResponse<EVA.DMS.BlockDto> {
  }
  
  export class DmsListBlocks extends EVA.Core.PagedResultRequest<EVA.DMS.DmsListBlocksResponse> {
    __response : EVA.DMS.DmsListBlocksResponse;
  }
  
  export class DmsListBlocksResponse extends EVA.Core.PagedResultResponse<EVA.DMS.BlockDto> {
  }
  
  export class DmsUpdateBlock extends EVA.Core.UpdateRequest<EVA.DMS.BlockDto> implements EVA.Core.IRequestRespondsAs<EVA.Core.EmptyResponseMessage> {
    __response : EVA.Core.EmptyResponseMessage;
  }
  
  export class DmsCreateUrlRewrite extends EVA.Core.CreateRequest<EVA.DMS.UrlRewriteDto> implements EVA.Core.IRequestRespondsAs<EVA.Core.CreateResponse> {
    __response : EVA.Core.CreateResponse;
  }
  
  export class UrlRewriteDto {
    ID : number; // Int32
    RequestPath : string; 
    TargetPath : string; 
    UrlRewriteType : EVA.DMS.UrlRewriteTypes; 
    Description : string; 
    IsActive : boolean; 
    IsRegex : boolean; 
  }
  
  export enum UrlRewriteTypes {
    MovedPermanently = 301,
    MovedTemporarily = 302,
    TemporaryRedirect = 307,
    PermanentRedirect = 308,
    Gone = 410,
    Silent = 999,
  }
  
  export class DmsDeleteUrlRewrite extends EVA.Core.RequestMessageWithEmptyResponse {
    ID : number; // Int32
    __response : EVA.Core.EmptyResponseMessage;
  }
  
  export class DmsGetUrlRewriteByID extends EVA.Core.GetRequestGeneric<EVA.DMS.DmsGetUrlRewriteByIDResponse> {
    __response : EVA.DMS.DmsGetUrlRewriteByIDResponse;
  }
  
  export class DmsGetUrlRewriteByIDResponse extends EVA.Core.GetResponse<EVA.DMS.UrlRewriteDto> {
  }
  
  export class DmsListUrlRewrites extends EVA.Core.PagedResultRequest<EVA.DMS.DmsListUrlRewritesResponse> {
    __response : EVA.DMS.DmsListUrlRewritesResponse;
  }
  
  export class DmsListUrlRewritesResponse extends EVA.Core.PagedResultResponse<EVA.DMS.UrlRewriteDto> {
  }
  
  export class DmsUpdateUrlRewrite extends EVA.Core.UpdateRequest<EVA.DMS.UrlRewriteDto> implements EVA.Core.IRequestRespondsAs<EVA.Core.EmptyResponseMessage> {
    __response : EVA.Core.EmptyResponseMessage;
  }
  
  export class DmsGetPageByViewID extends EVA.Core.RequestMessageGeneric<EVA.DMS.DmsGetPageByViewIDResponse> {
    ID : number; // Int32
    __response : EVA.DMS.DmsGetPageByViewIDResponse;
  }
  
  export class DmsGetPageByViewIDResponse extends EVA.Core.GetResponse<EVA.DMS.LivePageDto> {
  }
  
  export class LivePageDto {
    ID : number; // Int32
    Title : string; 
    BrowserTitle : string; 
    TitleOverride : boolean; 
    MetaDescription : string; 
    Slug : string; 
    RequestPath : string; 
    ActiveVersionID : number; // Int32
    Data : string; 
  }
  
  export class DmsListViewsForPage extends EVA.Core.RequestMessageGeneric<EVA.DMS.DmsListViewsForPageResponse> {
    ID : number; // Int32
    __response : EVA.DMS.DmsListViewsForPageResponse;
  }
  
  export class DmsListViewsForPageResponse extends EVA.Core.GetResponse<EVA.DMS.ViewDto[]> {
  }
  
  export class DmsGetCompiledWidgetByID extends EVA.Core.GetRequestGeneric<EVA.DMS.DmsGetCompiledWidgetByIDResponse> {
    __response : EVA.DMS.DmsGetCompiledWidgetByIDResponse;
  }
  
  export class DmsGetCompiledWidgetByIDResponse extends EVA.Core.GetResponse<EVA.DMS.LiveWidgetDto> {
  }
  
  export class LiveWidgetDto {
    ID : number; // Int32
    Html : string; 
    Css : string; 
    Js : string; 
    Data : string; 
  }
  
  export class DmsGetLiveBlock extends EVA.Core.RequestMessageGeneric<EVA.DMS.DmsGetLiveBlockResponse> {
    Identifier : string; 
    __response : EVA.DMS.DmsGetLiveBlockResponse;
  }
  
  export class DmsGetLiveBlockResponse extends EVA.Core.GetResponse<EVA.DMS.LiveBlockDto> {
  }
  
  export class LiveBlockDto {
    ID : number; // Int32
    ActiveVersionID : number; // Int32
    Data : string; 
  }
  
  export class DmsGetLivePage extends EVA.Core.RequestMessageGeneric<EVA.DMS.DmsGetLivePageResponse> {
    ID : number; // Int32, nullable
    Path : string; 
    __response : EVA.DMS.DmsGetLivePageResponse;
  }
  
  export class DmsGetLivePageResponse extends EVA.Core.GetResponse<EVA.DMS.LivePageDto> {
  }
  
  export class DmsGetLiveProductPage extends EVA.Core.RequestMessageGeneric<EVA.DMS.DmsGetLiveProductPageResponse> {
    ProductID : number; // Int32
    __response : EVA.DMS.DmsGetLiveProductPageResponse;
  }
  
  export class DmsGetLiveProductPageResponse extends EVA.Core.GetResponse<EVA.DMS.LivePageDto> {
  }
  
  export class DmsGetMenuByIdentifier extends EVA.Core.RequestMessageGeneric<EVA.DMS.DmsGetMenuByIdentifierResponse> {
    Path : string; 
    Depth : number; // Int32, nullable
    __response : EVA.DMS.DmsGetMenuByIdentifierResponse;
  }
  
  export class DmsGetMenuByIdentifierResponse extends EVA.Core.GetResponse<EVA.DMS.MenuDto> {
  }
  
  export class MenuDto {
    ID : number; // Int32
    Children : EVA.DMS.MenuItem[]; 
  }
  
  export class MenuItem {
    ID : number; // Int32
    Title : string; 
    Position : number; // Int32
    Url : string; 
    Children : EVA.DMS.MenuItem[]; 
  }
  
  export class DmsRewriteUrl extends EVA.Core.RequestMessageGeneric<EVA.DMS.DmsRewriteUrlResponse> {
    Url : string; 
    __response : EVA.DMS.DmsRewriteUrlResponse;
  }
  
  export class DmsRewriteUrlResponse extends EVA.Core.ResponseMessage {
    Url : string; 
  }
  
  export class DmsCreateContentEntry extends EVA.Core.CreateRequest<EVA.DMS.ContentEntryDto> implements EVA.Core.IRequestRespondsAs<EVA.Core.CreateResponse> {
    __response : EVA.Core.CreateResponse;
  }
  
  export class ContentEntryDto {
    ID : number; // Int32
    Name : string; 
    ContentTypeID : number; // Int32
    ContentType : EVA.DMS.ContentTypeDto; 
    Fields : EVA.DMS.ContentEntryFieldDto[]; 
  }
  
  export class ContentEntryFieldDto {
    ID : number; // Int32
    Name : string; 
    Value : string; 
    ContentEntryID : number; // Int32
    ContentEntry : EVA.DMS.ContentEntryDto; 
    ContentTypeField : EVA.DMS.ContentTypeFieldDto; 
    ContentTypeFieldID : number; // Int32
  }
  
  export class DmsCreateContentType extends EVA.Core.CreateRequest<EVA.DMS.ContentTypeDto> implements EVA.Core.IRequestRespondsAs<EVA.Core.CreateResponse> {
    __response : EVA.Core.CreateResponse;
  }
  
  export class DmsDeleteContentEntry extends EVA.Core.RequestMessageWithEmptyResponse {
    ID : number; // Int32
    __response : EVA.Core.EmptyResponseMessage;
  }
  
  export class DmsDeleteContentType extends EVA.Core.RequestMessageWithEmptyResponse {
    ID : number; // Int32
    __response : EVA.Core.EmptyResponseMessage;
  }
  
  export class DmsGetCompiledPage extends EVA.Core.RequestMessageGeneric<EVA.DMS.DmsGetCompiledPageResponse> {
    ID : number; // Int32, nullable
    Path : string; 
    __response : EVA.DMS.DmsGetCompiledPageResponse;
  }
  
  export class DmsGetCompiledPageResponse extends EVA.Core.ResponseMessage {
    Result : EVA.DMS.CompiledPageDto; 
  }
  
  export class CompiledPageDto {
    ID : number; // Int32
    Title : string; 
    BrowserTitle : string; 
    TitleOverride : boolean; 
    MetaDescription : string; 
    Slug : string; 
    RequestPath : string; 
    Widgets : EVA.DMS.CompiledPageWidgetDto[]; 
  }
  
  export class CompiledPageWidgetDto {
    ID : number; // Int32
    TypeID : number; // Int32
    Name : string; 
    SizeX : number; // Int32
    SizeY : number; // Int32
    Row : number; // Int32
    Column : number; // Int32
    Data : EVA.DMS.CompiledPageWidgetDataDto; 
  }
  
  export class CompiledPageWidgetDataDto {
    Html : string; 
    Js : string; 
    Css : string; 
    Data : string; 
  }
  
  export class DmsGetContentEntry extends EVA.Core.GetRequestGeneric<EVA.DMS.DmsGetContentEntryResponse> {
    __response : EVA.DMS.DmsGetContentEntryResponse;
  }
  
  export class DmsGetContentEntryResponse extends EVA.Core.GetResponse<EVA.DMS.ContentEntryDto> {
  }
  
  export class DmsGetContentType extends EVA.Core.GetRequestGeneric<EVA.DMS.DmsGetContentTypeResponse> {
    __response : EVA.DMS.DmsGetContentTypeResponse;
  }
  
  export class DmsGetContentTypeResponse extends EVA.Core.GetResponse<EVA.DMS.ContentTypeDto> {
  }
  
  export class DmsListContentEntries extends EVA.Core.PagedResultRequest<EVA.DMS.DmsListContentEntriesResponse> {
    __response : EVA.DMS.DmsListContentEntriesResponse;
  }
  
  export class DmsListContentEntriesResponse extends EVA.Core.PagedResultResponse<EVA.DMS.ContentEntryDto> {
  }
  
  export class DmsListContentTypes extends EVA.Core.PagedResultRequest<EVA.DMS.DmsListContentTypesResponse> {
    __response : EVA.DMS.DmsListContentTypesResponse;
  }
  
  export class DmsListContentTypesResponse extends EVA.Core.PagedResultResponse<EVA.DMS.ContentTypeDto> {
  }
  
  export class DmsUpdateContentEntry extends EVA.Core.UpdateRequest<EVA.DMS.ContentEntryDto> implements EVA.Core.IRequestRespondsAs<EVA.Core.EmptyResponseMessage> {
    __response : EVA.Core.EmptyResponseMessage;
  }
  
  export class DmsUpdateContentType extends EVA.Core.UpdateRequest<EVA.DMS.ContentTypeDto> implements EVA.Core.IRequestRespondsAs<EVA.Core.EmptyResponseMessage> {
    __response : EVA.Core.EmptyResponseMessage;
  }
  
}