/* tslint:disable */
declare module EVA.DocumentSigning {
  
  export enum Fields {
    Signature = 0,
    Name = 1,
    Date = 2,
    Place = 3,
    Image = 4,
  }
  
  export class CompleteSignDocumentTask extends EVA.Core.RequestMessageGeneric<EVA.Core.EmptyResponseMessage> {
    TaskID : number; // Int32
    Location : string; 
    Signatures : EVA.DocumentSigning.Signature[]; 
    __response : EVA.Core.EmptyResponseMessage;
  }
  
  export class Signature {
    Description : string; 
    SignatureData : number[]; 
    SignatureHash : string; 
    SignatureText : string; 
  }
  
  export class GetSigningCodeForOrder extends EVA.Core.RequestMessageGeneric<EVA.DocumentSigning.GetSigningCodeForOrderResponse> {
    OrderID : number; // Int32
    __response : EVA.DocumentSigning.GetSigningCodeForOrderResponse;
  }
  
  export class GetSigningCodeForOrderResponse extends EVA.Core.ResponseMessage {
    Code : string; 
    IsAlreadySigned : boolean; 
  }
  
  export class GetSigningDataForOrder extends EVA.Core.RequestMessageGeneric<EVA.DocumentSigning.GetSigningDataForOrderResponse> {
    Hash : string; 
    __response : EVA.DocumentSigning.GetSigningDataForOrderResponse;
  }
  
  export class GetSigningDataForOrderResponse extends EVA.Core.ResponseMessage {
    OrderID : number; // Int32
    CustomerReference : string; 
    CreationTime : string; // DateTime
    ShippingAddress : EVA.Core.AddressDto; 
    CustomerName : string; 
    CustomerPhonenumber : string; 
    CustomerEmailAddress : string; 
    ItemCount : number; // Int32
    TotalAmount : number; // Decimal
    TotalAmountInTax : number; // Decimal
    CurrencyID : string; 
    IsAlreadySigned : boolean; 
  }
  
  export class SignOrder extends EVA.Core.RequestMessageWithEmptyResponse {
    Hash : string; 
    Signature : number[]; 
    MimeType : string; 
    __response : EVA.Core.EmptyResponseMessage;
  }
  
  export class StartSignDocumentTask extends EVA.Core.RequestMessageGeneric<EVA.DocumentSigning.StartSignDocumentResponse> {
    TaskID : number; // Int32, nullable
    OrderLineID : number; // Int32, nullable
    __response : EVA.DocumentSigning.StartSignDocumentResponse;
  }
  
  export class StartSignDocumentResponse extends EVA.Core.ResponseMessage {
    WorkSet : EVA.DocumentSigning.StartSignDocumentWorkSet; 
  }
  
  export class StartSignDocumentWorkSet {
    DocumentID : string; 
    DocumentUrl : string; 
    SignatureHashSalt : string; 
    UserTaskID : number; // Int32
    Signatures : EVA.DocumentSigning.Signature[]; 
  }
  
}