/* tslint:disable */
declare module EVA.Kijkshop {
  
  export class KijkupProcessEmailExporterResult extends EVA.Core.RequestMessageWithEmptyResponse {
    Data : number[]; 
    FileName : string; 
    __response : EVA.Core.EmptyResponseMessage;
  }
  
  export class KijkshopGetProductGroups extends EVA.Core.RequestMessageGeneric<EVA.Kijkshop.KijkshopGetProductGroupsResponse> {
    __response : EVA.Kijkshop.KijkshopGetProductGroupsResponse;
  }
  
  export class KijkshopGetProductGroupsResponse extends EVA.Core.ResponseMessage {
    ProductGroups : EVA.Kijkshop.ProductGroupDto[]; 
  }
  
  export class ProductGroupDto {
    ID : number; // Int32
    ParentID : number; // Int32, nullable
    Slug : string; 
    Level : number; // Int32
    Sequence : number; // Int32
    Name : string; 
    SubProductGroups : EVA.Kijkshop.ProductGroupDto[]; 
    Count : number; // Int32
    ImageID : string; 
  }
  
  export class KijkshopGetProductGroup extends EVA.Core.RequestMessageGeneric<EVA.Kijkshop.KijkshopGetProductGroupResponse> {
    ID : number; // Int32
    __response : EVA.Kijkshop.KijkshopGetProductGroupResponse;
  }
  
  export class KijkshopGetProductGroupResponse extends EVA.Core.ResponseMessage {
    ImageID : string; 
  }
  
  export class KijkshopUpdateProductGroup extends EVA.Core.RequestMessageWithEmptyResponse {
    ID : number; // Int32
    ImageID : string; 
    __response : EVA.Core.EmptyResponseMessage;
  }
  
  export class ReplenishStoresExcelSample extends EVA.Core.RequestMessageGeneric<EVA.Core.ResourceResponseMessage> {
    __response : EVA.Core.ResourceResponseMessage;
  }
  
  export class UploadReplenishStoresExcel extends EVA.Core.RequestMessageWithEmptyResponse {
    Data : number[]; 
    __response : EVA.Core.EmptyResponseMessage;
  }
  
  export class KijkBijMijGetAvailability extends EVA.Core.RequestMessageGeneric<EVA.Kijkshop.KijkBijMijAvailabilityResponse> {
    UserID : number; // Int32
    __response : EVA.Kijkshop.KijkBijMijAvailabilityResponse;
  }
  
  export class KijkBijMijAvailabilityResponse extends EVA.Core.ResponseMessage {
    Sunday : EVA.Kijkshop.KijkBijMijAvailabilitySlot[]; 
    Monday : EVA.Kijkshop.KijkBijMijAvailabilitySlot[]; 
    Tuesday : EVA.Kijkshop.KijkBijMijAvailabilitySlot[]; 
    Wednesday : EVA.Kijkshop.KijkBijMijAvailabilitySlot[]; 
    Thursday : EVA.Kijkshop.KijkBijMijAvailabilitySlot[]; 
    Friday : EVA.Kijkshop.KijkBijMijAvailabilitySlot[]; 
    Saturday : EVA.Kijkshop.KijkBijMijAvailabilitySlot[]; 
    OtherDays : EVA.Kijkshop.KijkBijMijAvailabilitySlot[]; 
  }
  
  export class KijkBijMijAvailabilitySlot {
    ID : number; // Int32
    Date : string; // DateTime, nullable
    StartTime : any; // TimeSpan
    EndTime : any; // TimeSpan
  }
  
  export class KijkBijMijSetAvailability extends EVA.Core.RequestMessageWithEmptyResponse {
    Sunday : EVA.Kijkshop.KijkBijMijAvailabilitySlot[]; 
    Monday : EVA.Kijkshop.KijkBijMijAvailabilitySlot[]; 
    Tuesday : EVA.Kijkshop.KijkBijMijAvailabilitySlot[]; 
    Wednesday : EVA.Kijkshop.KijkBijMijAvailabilitySlot[]; 
    Thursday : EVA.Kijkshop.KijkBijMijAvailabilitySlot[]; 
    Friday : EVA.Kijkshop.KijkBijMijAvailabilitySlot[]; 
    Saturday : EVA.Kijkshop.KijkBijMijAvailabilitySlot[]; 
    OtherDays : EVA.Kijkshop.KijkBijMijAvailabilitySlot[]; 
    __response : EVA.Core.EmptyResponseMessage;
  }
  
  export class KijkBijMijBlockUser extends EVA.Core.RequestMessageWithEmptyResponse {
    UserID : number; // Int32
    __response : EVA.Core.EmptyResponseMessage;
  }
  
  export class KijkBijMijBlocksUser extends EVA.Core.RequestMessageGeneric<EVA.Kijkshop.KijkBijMijBlocksUserResponse> {
    UserID : number; // Int32
    __response : EVA.Kijkshop.KijkBijMijBlocksUserResponse;
  }
  
  export class KijkBijMijBlocksUserResponse extends EVA.Core.ResponseMessage {
    Blocks : boolean; 
  }
  
  export class KijkBijMijUnblockUser extends EVA.Core.RequestMessageWithEmptyResponse {
    UserID : number; // Int32
    __response : EVA.Core.EmptyResponseMessage;
  }
  
  export class KijkBijMijBlockedUsers extends EVA.Core.RequestMessageGeneric<EVA.Kijkshop.KijkBijMijBlockedUsersResponse> {
    __response : EVA.Kijkshop.KijkBijMijBlockedUsersResponse;
  }
  
  export class KijkBijMijBlockedUsersResponse extends EVA.Core.ResponseMessage {
    UserIDs : number[]; 
  }
  
  export class KijkBijMijCallExpert extends EVA.Core.RequestMessageGeneric<EVA.Kijkshop.KijkBijMijCallResponse> {
    UserID : number; // Int32
    ProductID : number; // Int32, nullable
    ProductGroupID : number; // Int32, nullable
    __response : EVA.Kijkshop.KijkBijMijCallResponse;
  }
  
  export class KijkBijMijCallResponse extends EVA.Core.ResponseMessage {
    SessionID : string; 
    Token : string; 
  }
  
  export class KijkBijMijJoinCall extends EVA.Core.RequestMessageGeneric<EVA.Kijkshop.KijkBijMijCallResponse> {
    SessionID : string; 
    __response : EVA.Kijkshop.KijkBijMijCallResponse;
  }
  
  export class KijkBijMijDeclineCall extends EVA.Core.RequestMessageWithEmptyResponse {
    SessionID : string; 
    __response : EVA.Core.EmptyResponseMessage;
  }
  
  export class KijkBijMijTotalExpertCount extends EVA.Core.RequestMessageGeneric<EVA.Kijkshop.KijkBijMijTotalExpertCountResponse> {
    __response : EVA.Kijkshop.KijkBijMijTotalExpertCountResponse;
  }
  
  export class KijkBijMijTotalExpertCountResponse extends EVA.Core.ResponseMessage {
    ExpertCount : number; // Int32
  }
  
  export class KijkBijMijAddProductExpertise extends EVA.Core.RequestMessageWithEmptyResponse {
    ProductID : number; // Int32
    __response : EVA.Core.EmptyResponseMessage;
  }
  
  export class KijkBijMijRemoveProductExpertise extends EVA.Core.RequestMessageWithEmptyResponse {
    ProductID : number; // Int32
    __response : EVA.Core.EmptyResponseMessage;
  }
  
  export class KijkBijMijAddProductGroupExpertise extends EVA.Core.RequestMessageWithEmptyResponse {
    ProductGroupID : number; // Int32
    __response : EVA.Core.EmptyResponseMessage;
  }
  
  export class KijkBijMijRemoveProductGroupExpertise extends EVA.Core.RequestMessageWithEmptyResponse {
    ProductGroupID : number; // Int32
    __response : EVA.Core.EmptyResponseMessage;
  }
  
  export class KijkBijMijIsExpertOnProduct extends EVA.Core.RequestMessageGeneric<EVA.Kijkshop.KijkBijMijIsExpertResponse> {
    ProductID : number; // Int32
    __response : EVA.Kijkshop.KijkBijMijIsExpertResponse;
  }
  
  export class KijkBijMijIsExpertResponse extends EVA.Core.ResponseMessage {
    IsExpert : boolean; 
  }
  
  export class KijkBijMijIsExpertOnProductGroup extends EVA.Core.RequestMessageGeneric<EVA.Kijkshop.KijkBijMijIsExpertResponse> {
    ProductGroupID : number; // Int32
    __response : EVA.Kijkshop.KijkBijMijIsExpertResponse;
  }
  
  export class KijkBijMijIsExpertOnProducts extends EVA.Core.RequestMessageGeneric<EVA.Kijkshop.KijkBijMijIsExpertsResponse> {
    ProductIDs : number[]; 
    __response : EVA.Kijkshop.KijkBijMijIsExpertsResponse;
  }
  
  export class KijkBijMijIsExpertsResponse extends EVA.Core.ResponseMessage {
    IsExpert : { [ key : number ] : boolean }; 
  }
  
  export class KijkBijMijIsExpertOnProductGroups extends EVA.Core.RequestMessageGeneric<EVA.Kijkshop.KijkBijMijIsExpertsResponse> {
    ProductGroupIDs : number[]; 
    __response : EVA.Kijkshop.KijkBijMijIsExpertsResponse;
  }
  
  export class KijkBijMijProductExperts extends EVA.Core.RequestMessageGeneric<EVA.Kijkshop.KijkBijMijProductExpertsResponse> {
    ProductID : number; // Int32
    __response : EVA.Kijkshop.KijkBijMijProductExpertsResponse;
  }
  
  export class KijkBijMijProductExpertsResponse extends EVA.Core.ResponseMessage {
    ProductExperts : number[]; 
    ProductGroupExperts : number[]; 
  }
  
  export class KijkBijMijGetProductsStats extends EVA.Core.RequestMessageGeneric<EVA.Kijkshop.KijkBijMijGetProductsStatsResponse> {
    ProductIDs : number[]; 
    __response : EVA.Kijkshop.KijkBijMijGetProductsStatsResponse;
  }
  
  export class KijkBijMijGetProductsStatsResponse extends EVA.Core.ResponseMessage {
    Stats : { [ key : number ] : EVA.Kijkshop.KijkBijMijProductStats }; 
  }
  
  export class KijkBijMijProductStats {
    BrandExperts : number; // Int32
    ProductExperts : number; // Int32
    ProductGroupExperts : number; // Int32
    TotalExperts : number; // Int32
    IsCurrentUserBrandExpert : boolean; 
    IsCurrentUserProductExpert : boolean; 
    IsCurrentUserProductGroupExpert : boolean; 
    Likes : number; // Int32
  }
  
  export class KijkBijMijProductGroupExperts extends EVA.Core.RequestMessageGeneric<EVA.Kijkshop.KijkBijMijProductGroupExpertsResponse> {
    ProductGroupID : number; // Int32
    __response : EVA.Kijkshop.KijkBijMijProductGroupExpertsResponse;
  }
  
  export class KijkBijMijProductGroupExpertsResponse extends EVA.Core.ResponseMessage {
    ProductGroupExperts : number[]; 
  }
  
  export class KijkBijMijProductGroupExpertsPaged extends EVA.Core.PagedResultRequest<EVA.Kijkshop.KijkBijMijProductGroupExpertsPagedResponse> {
    ProductGroupID : number; // Int32
    __response : EVA.Kijkshop.KijkBijMijProductGroupExpertsPagedResponse;
  }
  
  export class KijkBijMijProductGroupExpertsPagedResponse extends EVA.Core.PagedResultResponse<number> {
  }
  
  export class KijkBijMijListHall extends EVA.Core.PagedResultRequest<EVA.Kijkshop.KijkBijMijListHallResponse> {
    __response : EVA.Kijkshop.KijkBijMijListHallResponse;
  }
  
  export class KijkBijMijListHallResponse extends EVA.Core.PagedResultResponse<EVA.Kijkshop.RankedUser> {
    CurrentUser : EVA.Kijkshop.RankedUser; 
  }
  
  export class RankedUser {
    UserID : number; // Int32
    UserFirstName : string; 
    AvatarID : string; 
    Ranking : number; // Int32
    Scans : number; // Int32
  }
  
  export class KijkBijMijLikeProduct extends EVA.Core.RequestMessageWithEmptyResponse {
    ProductID : number; // Int32
    __response : EVA.Core.EmptyResponseMessage;
  }
  
  export class KijkBijMijLikesProduct extends EVA.Core.RequestMessageGeneric<EVA.Kijkshop.KijkBijMijLikesProductResponse> {
    ProductID : number; // Int32
    __response : EVA.Kijkshop.KijkBijMijLikesProductResponse;
  }
  
  export class KijkBijMijLikesProductResponse extends EVA.Core.ResponseMessage {
    Likes : boolean; 
  }
  
  export class KijkBijMijLikesProducts extends EVA.Core.RequestMessageGeneric<EVA.Kijkshop.KijkBijMijLikesProductsResponse> {
    ProductIDs : number[]; 
    __response : EVA.Kijkshop.KijkBijMijLikesProductsResponse;
  }
  
  export class KijkBijMijLikesProductsResponse extends EVA.Core.ResponseMessage {
    Likes : { [ key : number ] : boolean }; 
  }
  
  export class KijkBijMijUnlikeProduct extends EVA.Core.RequestMessageWithEmptyResponse {
    ProductID : number; // Int32
    __response : EVA.Core.EmptyResponseMessage;
  }
  
  export class KijkBijMijLikedProducts extends EVA.Core.RequestMessageGeneric<EVA.Kijkshop.KijkBijMijLikedProductsResponse> {
    __response : EVA.Kijkshop.KijkBijMijLikedProductsResponse;
  }
  
  export class KijkBijMijLikedProductsResponse extends EVA.Core.ResponseMessage {
    ProductIDs : number[]; 
  }
  
  export class KijkBijMijSubscribeToNotificationType extends EVA.Core.RequestMessageWithEmptyResponse {
    TypeID : number; // Int32
    __response : EVA.Core.EmptyResponseMessage;
  }
  
  export class KijkBijMijUnsubscribeFromNotificationType extends EVA.Core.RequestMessageWithEmptyResponse {
    TypeID : number; // Int32
    __response : EVA.Core.EmptyResponseMessage;
  }
  
  export class KijkBijMijGetNotificationSubscriptions extends EVA.Core.RequestMessageGeneric<EVA.Kijkshop.KijkBijMijNotificationSubscriptionsResponse> {
    __response : EVA.Kijkshop.KijkBijMijNotificationSubscriptionsResponse;
  }
  
  export class KijkBijMijNotificationSubscriptionsResponse extends EVA.Core.ResponseMessage {
    Subscriptions : EVA.Kijkshop.KijkBijMijNotificationType[]; 
  }
  
  export class KijkBijMijNotificationType {
    ID : number; // Int32
    Name : string; 
    Description : string; 
  }
  
  export class KijkBijMijListNotifications extends EVA.Core.PagedResultRequest<EVA.Kijkshop.KijkBijMijListNotificationsResponse> {
    __response : EVA.Kijkshop.KijkBijMijListNotificationsResponse;
  }
  
  export class KijkBijMijListNotificationsResponse extends EVA.Core.PagedResultResponse<EVA.Kijkshop.KijkBijMijNotification> {
  }
  
  export class KijkBijMijNotification {
    ID : number; // Int32
    TypeID : number; // Int32
    Type : EVA.Kijkshop.KijkBijMijNotificationType; 
    Text : string; 
    Read : boolean; 
    CreationTime : string; // DateTime
  }
  
  export class KijkBijMijGetUnreadNotificationCount extends EVA.Core.RequestMessageGeneric<EVA.Kijkshop.KijkBijMijUnreadNotificationCountResponse> {
    __response : EVA.Kijkshop.KijkBijMijUnreadNotificationCountResponse;
  }
  
  export class KijkBijMijUnreadNotificationCountResponse extends EVA.Core.ResponseMessage {
    Count : number; // Int32
  }
  
  export class KijkBijMijMarkNotificationAsRead extends EVA.Core.RequestMessageWithEmptyResponse {
    ID : number; // Int32
    __response : EVA.Core.EmptyResponseMessage;
  }
  
  export class KijkBijMijDeleteNotification extends EVA.Core.RequestMessageWithEmptyResponse {
    ID : number; // Int32
    __response : EVA.Core.EmptyResponseMessage;
  }
  
  export class KijkBijMijRateCaller extends EVA.Core.RequestMessageWithEmptyResponse {
    UserID : number; // Int32
    SessionID : string; 
    Rating : number; // Int32
    __response : EVA.Core.EmptyResponseMessage;
  }
  
  export class KijkBijMijRateExpert extends EVA.Core.RequestMessageWithEmptyResponse {
    UserID : number; // Int32
    SessionID : string; 
    Rating1 : number; // Int32
    Rating2 : number; // Int32
    Rating3 : number; // Int32
    __response : EVA.Core.EmptyResponseMessage;
  }
  
  export class KijkBijMijListRatings extends EVA.Core.PagedResultRequest<EVA.Kijkshop.KijkBijMijListRatingsResponse> {
    UserID : number; // Int32
    __response : EVA.Kijkshop.KijkBijMijListRatingsResponse;
  }
  
  export class KijkBijMijListRatingsResponse extends EVA.Core.PagedResultResponse<EVA.Kijkshop.KijkBijMijRating> {
  }
  
  export class KijkBijMijRating {
    ProductID : number; // Int32, nullable
    ProductGroupID : number; // Int32, nullable
    ProductDisplayValue : string; 
    Rating1 : number; // Int32
    Rating2 : number; // Int32
    Rating3 : number; // Int32
    UserID : number; // Int32
    UserFirstName : string; 
    AvatarID : string; 
    CreationTime : string; // DateTime
  }
  
  export class KijkBijMijReportUser extends EVA.Core.RequestMessageWithEmptyResponse {
    UserID : number; // Int32
    Reason : EVA.Kijkshop.KijkBijMijReportReasons; 
    ReasonDescription : string; 
    __response : EVA.Core.EmptyResponseMessage;
  }
  
  export enum KijkBijMijReportReasons {
    Harassment = 1,
    OffTopic = 2,
    Other = 3,
  }
  
  export class SetExpertForOrderLine extends EVA.Core.RequestMessageWithEmptyResponse {
    OrderLineID : number; // Int32
    ExpertID : number; // Int32
    __response : EVA.Core.EmptyResponseMessage;
  }
  
  export class KijkBijMijGetExpertDetails extends EVA.Core.RequestMessageGeneric<EVA.Kijkshop.KijkBijMijGetExpertDetailsResponse> {
    UserIDs : number[]; 
    __response : EVA.Kijkshop.KijkBijMijGetExpertDetailsResponse;
  }
  
  export class KijkBijMijGetExpertDetailsResponse extends EVA.Core.ResponseMessage {
    Details : EVA.Kijkshop.ExpertDetails[]; 
  }
  
  export class ExpertDetails {
    ID : number; // Int32
    FirstName : string; 
    LastName : string; 
    Gender : string; 
    AdvisorDescription : string; 
    AvatarID : string; 
    IsAvailable : boolean; 
    AverageRating : number; // Decimal, nullable
    LanguageProficiencies : { [ key : string ] : number }; 
  }
  
  export class KijkBijMijGetProfile extends EVA.Core.RequestMessageGeneric<EVA.Kijkshop.KijkBijMijGetProfileResponse> {
    __response : EVA.Kijkshop.KijkBijMijGetProfileResponse;
  }
  
  export class KijkBijMijGetProfileResponse extends EVA.Core.ResponseMessage {
    AdvisorDescription : string; 
    AvatarID : string; 
    LanguageProficiencies : { [ key : string ] : number }; 
  }
  
  export class KijkBijMijUpdateProfile extends EVA.Core.RequestMessageWithEmptyResponse {
    AdvisorDescription : string; 
    AvatarID : string; 
    LanguageProficiencies : { [ key : string ] : number }; 
    __response : EVA.Core.EmptyResponseMessage;
  }
  
  export enum KijkBijMijUserCardTypes {
    Normal = 1,
    Payout = 2,
  }
  
  export class KijkBijMijGetCreditTotalsForUser extends EVA.Core.RequestMessageGeneric<EVA.Kijkshop.KijkBijMijGetCreditTotalsForUserResponse> {
    __response : EVA.Kijkshop.KijkBijMijGetCreditTotalsForUserResponse;
  }
  
  export class KijkBijMijGetCreditTotalsForUserResponse extends EVA.Core.ResponseMessage {
    NormalCreditsTotal : number; // Decimal
    PayoutCreditsTotal : number; // Decimal
    NormalIncludingFutureCreditsTotal : number; // Decimal
    PayoutIncludingFutureCreditsTotal : number; // Decimal
  }
  
  export class KijkBijMijListCreditTransactions extends EVA.Core.PagedResultRequest<EVA.Kijkshop.KijkBijMijListCreditTransactionsResponse> {
    __response : EVA.Kijkshop.KijkBijMijListCreditTransactionsResponse;
  }
  
  export class KijkBijMijListCreditTransactionsResponse extends EVA.Core.PagedResultResponse<EVA.Kijkshop.KijkBijMijCreditTransaction> {
  }
  
  export class KijkBijMijCreditTransaction {
    CreationTime : string; // DateTime
    Amount : number; // Decimal
    Description : string; 
    Status : EVA.Core.UserCardMutationStatuses; 
    StartDate : string; // DateTime, nullable
    CreditType : EVA.Kijkshop.KijkBijMijUserCardTypes; 
    SessionID : string; 
    ProductID : number; // Int32
    ProductGroupID : number; // Int32, nullable
    AdvisedUserID : number; // Int32
  }
  
  export class KijkBijMijPayoutCredits extends EVA.Core.RequestMessageWithEmptyResponse {
    Amount : number; // Decimal
    __response : EVA.Core.EmptyResponseMessage;
  }
  
  export class KijkBijMijScanMe extends EVA.Core.RequestMessageGeneric<EVA.Kijkshop.KijkBijMijScanMeResponse> {
    ScannedUserID : number; // Int32
    __response : EVA.Kijkshop.KijkBijMijScanMeResponse;
  }
  
  export class KijkBijMijScanMeResponse extends EVA.Core.ResponseMessage {
    CreditsAlreadyReceived : boolean; 
  }
  
  export class KijkBijMijScanNewApp extends EVA.Core.RequestMessageGeneric<EVA.Kijkshop.KijkBijMijScanNewAppResponse> {
    ScannedUserID : number; // Int32
    __response : EVA.Kijkshop.KijkBijMijScanNewAppResponse;
  }
  
  export class KijkBijMijScanNewAppResponse extends EVA.Core.ResponseMessage {
    CreditsAlreadyReceived : boolean; 
  }
  
  export class FreeBeesGetCardBalance extends EVA.Core.RequestMessageGeneric<EVA.Kijkshop.FreeBeesGetCardBalanceResponse> {
    CardNumber : string; 
    __response : EVA.Kijkshop.FreeBeesGetCardBalanceResponse;
  }
  
  export class FreeBeesGetCardBalanceResponse extends EVA.Core.ResponseMessage {
    FreeBeesCount : number; // Int32
    Balance : number; // Decimal
    Status : EVA.Kijkshop.FreeBeesStatusCodes; 
  }
  
  export enum FreeBeesStatusCodes {
    Valid = 0,
    InvalidCardNumber = 1,
    InvalidCombination = 2,
    CardNotRegistered = 3,
    CardAlreadyRegistered = 4,
    NewsLetterNotSet = 5,
    InputParseError = 15,
    InvalidPassword = 16,
    InvalidActivationCode = 17,
    NoTransactionHistory = 18,
    InvalidNewPassword = 19,
    NotEnoughPoints = 20,
    NoValidTransactionID = 21,
    InvalidEmail = 22,
    NoEmailInDatabase = 23,
    CardNotUsedOnSite = 24,
    OperationRejected = 25,
    InvalidLocationCode = 26,
  }
  
  export enum KijkBijMijReportStatuses {
    New = 0,
    ContentRemoved = 1,
    Ignored = 2,
  }
  
}