/* tslint:disable */
declare module EVA.Makeup {
  
  export class MakeupCreateBlock extends EVA.Core.RequestMessageGeneric<EVA.Makeup.MakeupCreateBlockResponse> {
    Block : EVA.Makeup.BlockDto; 
    __response : EVA.Makeup.MakeupCreateBlockResponse;
  }
  
  export class MakeupCreateBlockResponse extends EVA.Core.ResponseMessage {
    ID : string; 
  }
  
  export class BlockDto {
    ID : string; 
    Type : string; 
    Input : { [ key : string ] : EVA.Makeup.BlockInputDto }; 
    CssClasses : string[]; 
    Name : string; 
    Template : string; 
    Content : string; 
    Width : string; 
    Height : string; 
    CssStyles : string; 
    IsCurrent : boolean; 
    Version : number; // Int32
    VersionDescription : string; 
  }
  
  export class BlockInputDto {
    Value : any; 
    Description : string; 
    Type : string; 
    IsOptional : boolean; 
  }
  
  export class MakeupDeleteBlock extends EVA.Core.RequestMessageWithEmptyResponse {
    ID : string; 
    Version : number; // Int32, nullable
    __response : EVA.Core.EmptyResponseMessage;
  }
  
  export class MakeupGetBlockByID extends EVA.Core.RequestMessageGeneric<EVA.Makeup.MakeupGetBlockByIDResponse> {
    ID : string; 
    Version : number; // Int32, nullable
    __response : EVA.Makeup.MakeupGetBlockByIDResponse;
  }
  
  export class MakeupGetBlockByIDResponse extends EVA.Core.ResponseMessage {
    Block : EVA.Makeup.BlockDto; 
  }
  
  export class MakeupGetRenderedBlockByID extends EVA.Core.RequestMessageGeneric<EVA.Makeup.MakeupGetRenderedBlockByIDResponse> {
    ID : string; 
    Version : number; // Int32, nullable
    __response : EVA.Makeup.MakeupGetRenderedBlockByIDResponse;
  }
  
  export class MakeupGetRenderedBlockByIDResponse extends EVA.Core.ResponseMessage {
    Block : EVA.Makeup.BlockDto; 
  }
  
  export class MakeupListBlocks extends EVA.Core.PagedResultRequest<EVA.Makeup.MakeupListBlocksResponse> {
    Type : string; 
    __response : EVA.Makeup.MakeupListBlocksResponse;
  }
  
  export class MakeupListBlocksResponse extends EVA.Core.PagedResultResponse<EVA.Makeup.BlockDto> {
  }
  
  export class MakeupUpdateBlock extends EVA.Core.RequestMessageWithEmptyResponse {
    Block : EVA.Makeup.BlockDto; 
    __response : EVA.Core.EmptyResponseMessage;
  }
  
  export class MakeupReplaceConfigurationProfile extends EVA.Core.RequestMessageWithEmptyResponse {
    Configuration : EVA.Makeup.ConfigurationProfileDto; 
    LanguageID : string; 
    __response : EVA.Core.EmptyResponseMessage;
  }
  
  export class ConfigurationProfileDto {
    SiteID : number; // Int32
    LanguageID : string; 
    AggregationConfigs : EVA.Makeup.ConfigurationProfileAggregationConfigDto[]; 
    DefaultAggregationOptions : { [ key : string ] : EVA.Core.AggregationFilterModel }; 
    ProductPropertyTypeMappings : EVA.Makeup.ProductPropertyTypeMappingDto[]; 
    DefaultFilters : { [ key : string ] : EVA.Core.FilterModel }; 
    DefaultPageLimit : EVA.Makeup.ConfigurationProfilePageLimitDto; 
    DefaultSort : EVA.Makeup.ConfigurationProfileSortOptionsDto[]; 
    DefaultIncludedFields : string[]; 
    AvailableSortOptions : EVA.Makeup.ConfigurationProfileSortOptionsDto[]; 
    AvailablePageLimits : EVA.Makeup.ConfigurationProfilePageLimitDto[]; 
  }
  
  export class ConfigurationProfileAggregationConfigDto {
    TypeID : string; 
    Type : string; 
    InitialShownItems : number; // Int32
    Sorting : string[][]; 
  }
  
  export class ProductPropertyTypeMappingDto {
    Key : string; 
    ProductPropertyTypeID : string; 
  }
  
  export class ConfigurationProfilePageLimitDto {
    Limit : number; // Int32
    LimitDisplay : string; 
  }
  
  export class ConfigurationProfileSortOptionsDto {
    FieldName : string; 
    SortDisplay : string; 
    Direction : EVA.Makeup.ConfigurationProfileSortOptionsDirection; 
  }
  
  export enum ConfigurationProfileSortOptionsDirection {
    Ascending = 0,
    Descending = 1,
  }
  
  export class MakeupGetPageMap extends EVA.Core.RequestMessageGeneric<EVA.Makeup.MakeupGetPageMapResponse> {
    LanguageID : string; 
    __response : EVA.Makeup.MakeupGetPageMapResponse;
  }
  
  export class MakeupGetPageMapResponse extends EVA.Core.ResponseMessage {
    PageMap : { [ key : string ] : EVA.Makeup.MakeupPageMapSection }; 
  }
  
  export class MakeupPageMapSection {
    Name : string; 
    Sections : EVA.Makeup.MakeupPageMapSection[]; 
    Description : string; 
    IsBase : boolean; 
    Pages : EVA.Makeup.MakeupPageMapSectionPage[]; 
  }
  
  export class MakeupPageMapSectionPage {
    ID : string; 
    Name : string; 
    Path : string; 
    IsBase : boolean; 
  }
  
  export class MakeupCreateMenu extends EVA.Core.RequestMessageGeneric<EVA.Makeup.MakeupCreateMenuResponse> {
    Menu : EVA.Makeup.MenuDto; 
    __response : EVA.Makeup.MakeupCreateMenuResponse;
  }
  
  export class MakeupCreateMenuResponse extends EVA.Core.ResponseMessage {
    ID : string; 
  }
  
  export class MenuDto {
    ID : string; 
    Name : string; 
    LanguageID : string; 
    Types : EVA.Makeup.MenuTypeDto[]; 
  }
  
  export class MenuTypeDto {
    Type : string; 
    Items : EVA.Makeup.MenuItemDto[]; 
  }
  
  export class MenuItemDto {
    Name : string; 
    Path : string; 
    ImageBlobID : string; 
    Items : EVA.Makeup.MenuItemDto[]; 
  }
  
  export class MakeupReplaceMenu extends EVA.Core.RequestMessageWithEmptyResponse {
    ID : string; 
    Menu : EVA.Makeup.MenuDto; 
    __response : EVA.Core.EmptyResponseMessage;
  }
  
  export class MakeupCreatePage extends EVA.Core.RequestMessageGeneric<EVA.Makeup.MakeupCreatePageResponse> {
    Page : EVA.Makeup.PageDto; 
    __response : EVA.Makeup.MakeupCreatePageResponse;
  }
  
  export class MakeupCreatePageResponse extends EVA.Core.ResponseMessage {
    ID : string; 
  }
  
  export class PageDto {
    ID : string; 
    LanguageID : string; 
    Name : string; 
    Description : string; 
    Type : string; 
    SearchProductsRequest : EVA.Core.Services.SearchProducts; 
    Path : string; 
    Containers : EVA.Makeup.ContainerDto[]; 
    CssClasses : string[]; 
    MetaTags : EVA.Makeup.MetaTagDto[]; 
    Version : number; // Int32
    VersionDescription : string; 
    IsCurrent : boolean; 
    CssStyles : string; 
    StyleSheetBlobID : string; 
    Slug : string; 
    Blocks : EVA.Makeup.PageBlockDto[]; 
    Event : EVA.Makeup.EventDto; 
    EventID : number; // Int32, nullable
    RequiresAuthentication : boolean; 
    RequiredFunctionality : string; 
  }
  
  export class ContainerDto {
    CssClasses : string[]; 
    Children : EVA.Makeup.ContainerChildDto[]; 
    Width : string; 
    Height : string; 
  }
  
  export class ContainerChildDto {
    CssClasses : string[]; 
    Blocks : EVA.Makeup.PageBlockDto[]; 
    Width : string; 
    Height : string; 
  }
  
  export class PageBlockDto implements EVA.Makeup.IPageBlock {
    ID : string; 
    Type : string; 
    Input : { [ key : string ] : EVA.Makeup.BlockInputDto }; 
    CssClasses : string[]; 
    CssStyles : string; 
    Name : string; 
    Content : string; 
    Template : string; 
    Width : string; 
    Height : string; 
    Version : number; // Int32, nullable
  }
  
  export interface IPageBlock {
    ID : string; 
    Type : string; 
    CssClasses : string[]; 
    Name : string; 
    Template : string; 
    Width : string; 
    Height : string; 
    Version : number; // Int32, nullable
  }
  
  export class MetaTagDto {
    Attribute : string; 
    Content : string; 
    Type : string; 
  }
  
  export class EventDto {
    ID : number; // Int32
    Name : string; 
    StartDate : string; // DateTime, nullable
    EndDate : string; // DateTime, nullable
    IsActive : boolean; 
  }
  
  export class MakeupDeletePage extends EVA.Core.RequestMessageWithEmptyResponse {
    ID : string; 
    LanguageID : string; 
    Version : number; // Int32, nullable
    __response : EVA.Core.EmptyResponseMessage;
  }
  
  export class MakeupGetPageByID extends EVA.Core.RequestMessageGeneric<EVA.Makeup.MakeupGetPageByIdResponse> {
    ID : string; 
    LanguageID : string; 
    Version : number; // Int32, nullable
    __response : EVA.Makeup.MakeupGetPageByIdResponse;
  }
  
  export class MakeupGetPageByIdResponse extends EVA.Core.ResponseMessage {
    Page : EVA.Makeup.PageDto; 
  }
  
  export class MakeupGetPageByPath extends EVA.Core.RequestMessageGeneric<EVA.Makeup.MakeupGetPageByPathResponse> {
    Path : string; 
    LanguageID : string; 
    __response : EVA.Makeup.MakeupGetPageByPathResponse;
  }
  
  export class MakeupGetPageByPathResponse extends EVA.Core.ResponseMessage {
    Page : EVA.Makeup.PageDto; 
    PathContext : EVA.Makeup.PathContext; 
  }
  
  export class PathContext {
    Path : string; 
    Parameters : EVA.Makeup.PathParameter[]; 
  }
  
  export class PathParameter {
    Key : string; 
    Value : any; 
  }
  
  export class MakeupGetRenderedPageByID extends EVA.Core.RequestMessageGeneric<EVA.Makeup.MakeupGetRenderedPageByIDResponse> {
    ID : string; 
    LanguageID : string; 
    Version : number; // Int32, nullable
    __response : EVA.Makeup.MakeupGetRenderedPageByIDResponse;
  }
  
  export class MakeupGetRenderedPageByIDResponse extends EVA.Core.ResponseMessage {
    Page : EVA.Makeup.RenderedPageDto; 
  }
  
  export class RenderedPageDto {
    ID : string; 
    LanguageID : string; 
    Name : string; 
    Description : string; 
    Type : string; 
    SearchProductsRequest : EVA.Core.Services.SearchProducts; 
    Path : string; 
    Containers : EVA.Makeup.ContainerDto[]; 
    CssClasses : string[]; 
    MetaTags : EVA.Makeup.MetaTagDto[]; 
    StyleSheetBlobID : string; 
    Slug : string; 
    RequiresAuthentication : boolean; 
    RequiredFunctionality : string; 
  }
  
  export class MakeupGetRenderedPageByPath extends EVA.Core.RequestMessageGeneric<EVA.Makeup.MakeupGetRenderedPageByPathResponse> {
    Path : string; 
    LanguageID : string; 
    __response : EVA.Makeup.MakeupGetRenderedPageByPathResponse;
  }
  
  export class MakeupGetRenderedPageByPathResponse extends EVA.Core.ResponseMessage {
    Page : EVA.Makeup.RenderedPageDto; 
  }
  
  export class MakeupReplacePage extends EVA.Core.RequestMessageWithEmptyResponse {
    ID : string; 
    Page : EVA.Makeup.PageDto; 
    __response : EVA.Core.EmptyResponseMessage;
  }
  
  export class MakeupGetCurrentPageVersion extends EVA.Core.RequestMessageGeneric<EVA.Makeup.MakeupGetCurrentPageVersionResponse> {
    ID : string; 
    LanguageID : string; 
    __response : EVA.Makeup.MakeupGetCurrentPageVersionResponse;
  }
  
  export class MakeupGetCurrentPageVersionResponse extends EVA.Core.ResponseMessage {
    Version : number; // Int32
    VersionDescription : string; 
  }
  
  export class MakeupGetRenderedPagesByPartialPath extends EVA.Core.RequestMessageGeneric<EVA.Makeup.MakeupGetRenderedPagesByPartialPathResponse> {
    PartialPath : string; 
    LanguageID : string; 
    __response : EVA.Makeup.MakeupGetRenderedPagesByPartialPathResponse;
  }
  
  export class MakeupGetRenderedPagesByPartialPathResponse extends EVA.Core.ResponseMessage {
    Pages : EVA.Makeup.RenderedPageDto[]; 
  }
  
  export class MakeupListPageVersions extends EVA.Core.PagedResultRequest<EVA.Makeup.MakeupListPageVersionsResponse> {
    ID : string; 
    LanguageID : string; 
    __response : EVA.Makeup.MakeupListPageVersionsResponse;
  }
  
  export class MakeupListPageVersionsResponse extends EVA.Core.PagedResultResponse<EVA.Makeup.PageVersionDto> {
  }
  
  export class PageVersionDto {
    ID : string; 
    Version : number; // Int32
    IsCurrent : boolean; 
    VersionDescription : string; 
  }
  
  export class MakeupPublishPageVersion extends EVA.Core.RequestMessageWithEmptyResponse {
    ID : string; 
    LanguageID : string; 
    Version : number; // Int32
    __response : EVA.Core.EmptyResponseMessage;
  }
  
  export class MakeupDeleteMenu extends EVA.Core.RequestMessageWithEmptyResponse {
    ID : string; 
    LanguageID : string; 
    __response : EVA.Core.EmptyResponseMessage;
  }
  
  export class MakeupGetMenuByID extends EVA.Core.RequestMessageGeneric<EVA.Makeup.MakeupGetMenuByIDResponse> {
    ID : string; 
    LanguageID : string; 
    __response : EVA.Makeup.MakeupGetMenuByIDResponse;
  }
  
  export class MakeupGetMenuByIDResponse extends EVA.Core.ResponseMessage {
    Menu : EVA.Makeup.MenuDto; 
  }
  
  export class MakeupListMenus extends EVA.Core.PagedResultRequest<EVA.Makeup.MakeupListMenusResponse> {
    LanguageID : string; 
    __response : EVA.Makeup.MakeupListMenusResponse;
  }
  
  export class MakeupListMenusResponse extends EVA.Core.PagedResultResponse<EVA.Makeup.MenuDto> {
  }
  
  export class MakeupActivateEvent extends EVA.Core.RequestMessageWithEmptyResponse {
    EventID : number; // Int32
    __response : EVA.Core.EmptyResponseMessage;
  }
  
  export class MakeupCreateEvent extends EVA.Core.RequestMessageGeneric<EVA.Makeup.MakeupCreateEventResponse> {
    Event : EVA.Makeup.CreateEventModel; 
    __response : EVA.Makeup.MakeupCreateEventResponse;
  }
  
  export class MakeupCreateEventResponse extends EVA.Core.ResponseMessage {
    ID : number; // Int32
  }
  
  export class CreateEventModel {
    Name : string; 
    StartDate : string; // DateTime, nullable
    EndDate : string; // DateTime, nullable
    IsActive : boolean; 
  }
  
  export class MakeupDeactivateEvent extends EVA.Core.RequestMessageWithEmptyResponse {
    EventID : number; // Int32
    __response : EVA.Core.EmptyResponseMessage;
  }
  
  export class MakeupDeleteEvent extends EVA.Core.RequestMessageWithEmptyResponse {
    EventID : number; // Int32
    __response : EVA.Core.EmptyResponseMessage;
  }
  
  export class MakeupGetEventByID extends EVA.Core.RequestMessageGeneric<EVA.Makeup.MakeupGetEventByIDResponse> {
    ID : number; // Int32
    __response : EVA.Makeup.MakeupGetEventByIDResponse;
  }
  
  export class MakeupGetEventByIDResponse extends EVA.Core.ResponseMessage {
    Event : EVA.Makeup.EventDto; 
  }
  
  export class MakeupListEvents extends EVA.Core.PagedResultRequest<EVA.Makeup.MakeupListEventsResponse> {
    IsActive : boolean; 
    __response : EVA.Makeup.MakeupListEventsResponse;
  }
  
  export class MakeupListEventsResponse extends EVA.Core.PagedResultResponse<EVA.Makeup.EventDto> {
  }
  
  export class MakeupGetConfigurationProfile extends EVA.Core.RequestMessageGeneric<EVA.Makeup.MakeupGetConfigurationProfileResponse> {
    LanguageID : string; 
    __response : EVA.Makeup.MakeupGetConfigurationProfileResponse;
  }
  
  export class MakeupGetConfigurationProfileResponse extends EVA.Core.ResponseMessage {
    Configuration : EVA.Makeup.ConfigurationProfileDto; 
  }
  
  export class MakeupGetCurrentBlockVersion extends EVA.Core.RequestMessageGeneric<EVA.Makeup.MakeupGetCurrentBlockVersionResponse> {
    ID : string; 
    __response : EVA.Makeup.MakeupGetCurrentBlockVersionResponse;
  }
  
  export class MakeupGetCurrentBlockVersionResponse extends EVA.Core.ResponseMessage {
    Version : number; // Int32
    VersionDescription : string; 
  }
  
  export class MakeupListBlockVersions extends EVA.Core.PagedResultRequest<EVA.Makeup.MakeupListBlockVersionsResponse> {
    ID : string; 
    __response : EVA.Makeup.MakeupListBlockVersionsResponse;
  }
  
  export class MakeupListBlockVersionsResponse extends EVA.Core.PagedResultResponse<EVA.Makeup.BlockVersionDto> {
  }
  
  export class BlockVersionDto {
    ID : string; 
    Version : number; // Int32
    IsCurrent : boolean; 
    VersionDescription : string; 
  }
  
  export class MakeupPublishBlockVersion extends EVA.Core.RequestMessageWithEmptyResponse {
    ID : string; 
    Version : number; // Int32
    __response : EVA.Core.EmptyResponseMessage;
  }
  
}