/* tslint:disable */
declare module EVA.PIM.Core {
  
  export class ApplyRevision extends EVA.Core.RequestMessageWithEmptyResponse {
    RevisionID : number; // Int32, nullable
    __response : EVA.Core.EmptyResponseMessage;
  }
  
  export class CreateRevision extends EVA.Core.RequestMessageGeneric<EVA.PIM.Core.CreateRevisionResponse> {
    ApplicationID : number; // Int32, nullable
    Name : string; 
    __response : EVA.PIM.Core.CreateRevisionResponse;
  }
  
  export class CreateRevisionResponse extends EVA.Core.ResponseMessage {
    Result : EVA.PIM.Core.CreatedRevision; 
  }
  
  export class CreatedRevision {
    ID : number; // Int32
    Name : string; 
    ApplicationID : number; // Int32, nullable
  }
  
  export class GetRevisionStatus extends EVA.Core.RequestMessageGeneric<EVA.PIM.Core.GetRevisionStatusResponse> {
    RevisionID : number; // Int32
    __response : EVA.PIM.Core.GetRevisionStatusResponse;
  }
  
  export class GetRevisionStatusResponse extends EVA.Core.ResponseMessage {
    Status : EVA.PIM.Core.RevisionProgress; 
  }
  
  export class RevisionProgress {
    TotalItems : number; // Int32
    HandledItems : number; // Int32
    ValidationErrors : number; // Int64
  }
  
  export class ListRevisions extends EVA.Core.PagedResultRequest<EVA.PIM.Core.ListRevisionsResponse> {
    __response : EVA.PIM.Core.ListRevisionsResponse;
  }
  
  export class ListRevisionsResponse extends EVA.Core.PagedResultResponse<EVA.PIM.Core.RevisionDto> {
  }
  
  export class RevisionDto {
    ID : number; // Int32
    Name : string; 
    ApplicationID : number; // Int32, nullable
    Status : EVA.PIM.Core.RevisionStatus; 
    AppliedOn : string; // DateTime, nullable
    CreatedBy : EVA.PIM.Core.ListRevisionUser; 
    CreationTime : string; // DateTime
  }
  
  export enum RevisionStatus {
    Open = 1,
    Applied = 2,
    Inactive = 4,
    InProgress = 8,
  }
  
  export class ListRevisionUser {
    FullName : string; 
  }
  
  export class ListRevisionValidationErrors extends EVA.Core.RequestMessageGeneric<EVA.PIM.Core.ListRevisionValidationErrorsResponse> {
    RevisionID : number; // Int32
    Offset : number; // Int32, nullable
    Cursor : number; // Int32, nullable
    __response : EVA.PIM.Core.ListRevisionValidationErrorsResponse;
  }
  
  export class ListRevisionValidationErrorsResponse extends EVA.Core.ResponseMessage {
    Offset : number; // Int32, nullable
    Cursor : number; // Int32, nullable
    Errors : any[]; 
  }
  
  export class CreateNewSearchDataIndex extends EVA.Core.RequestMessageWithEmptyResponse {
    DeleteOldIndex : boolean; 
    __response : EVA.Core.EmptyResponseMessage;
  }
  
  export class RequestReindexSearchData extends EVA.Core.RequestMessageGeneric<EVA.PIM.Core.RequestReindexSearchDataResponse> {
    Script : string; 
    __response : EVA.PIM.Core.RequestReindexSearchDataResponse;
  }
  
  export class RequestReindexSearchDataResponse extends EVA.Core.ResponseMessage {
  }
  
  export class AddReferenceDataToProduct extends EVA.Core.RequestMessageWithEmptyResponse {
    ProductID : number; // Int32
    Data : any; 
    Name : string; 
    __response : EVA.Core.EmptyResponseMessage;
  }
  
  export class CreateProduct extends EVA.Core.RequestMessageGeneric<EVA.PIM.Core.CreateProductResponse> {
    PrimitiveName : string; 
    ProductType : EVA.Core.ProductTypes; 
    TaxCodeID : number; // Int32
    BrandID : number; // Int32, nullable
    BackendID : string; 
    BackendSystemID : string; 
    OrganizationUnitID : number; // Int32, nullable
    CustomID : string; 
    __response : EVA.PIM.Core.CreateProductResponse;
  }
  
  export class CreateProductResponse extends EVA.Core.ResponseMessage {
    ID : number; // Int32
  }
  
  export class EditProduct extends EVA.Core.RequestMessageGeneric<EVA.PIM.Core.EditProductResponse> {
    ID : number; // Int32
    RevisionID : number; // Int32, nullable
    Edits : EVA.PIM.Core.ProductEdit[]; 
    __response : EVA.PIM.Core.EditProductResponse;
  }
  
  export class EditProductResponse extends EVA.Core.ResponseMessage {
  }
  
  export class ProductEdit {
    LayerID : number; // Int32, nullable
    Content : any; 
    LanguageID : string; 
    CountryID : string; 
  }
  
  export class GetProductForEditByID extends EVA.Core.RequestMessageGeneric<EVA.PIM.Core.GetProductForEditByIDResponse> {
    ID : number; // Int32
    RevisionID : number; // Int32
    __response : EVA.PIM.Core.GetProductForEditByIDResponse;
  }
  
  export class GetProductForEditByIDResponse extends EVA.Core.ResponseMessage {
    ID : number; // Int32
    CatalogID : number; // Int32
    DisplayValue : string; 
    LayersWithContent : EVA.PIM.Core.LayerWithContentDto[]; 
    Types : { [ key : string ] : any }; 
  }
  
  export class LayerWithContentDto {
    ID : number; // Int32
    Name : string; 
    Level : number; // Int32
    ApplicationID : number; // Int32, nullable
    LanguageID : string; 
    CountryID : string; 
    Content : any; 
    Description : string; 
    DisplayValue : string; 
  }
  
  export class GetProductForQuickEditByID extends EVA.Core.RequestMessageGeneric<EVA.PIM.Core.GetProductForQuickEditByIDResponse> {
    ID : number; // Int32
    __response : EVA.PIM.Core.GetProductForQuickEditByIDResponse;
  }
  
  export class GetProductForQuickEditByIDResponse extends EVA.Core.ResponseMessage {
    ID : number; // Int32
    CatalogID : number; // Int32
    DisplayValue : string; 
    Content : any; 
    Types : { [ key : string ] : any }; 
  }
  
  export class GetReferenceDataForProduct extends EVA.Core.RequestMessageGeneric<EVA.PIM.Core.GetReferenceDataForProductResponse> {
    ProductID : number; // Int32
    __response : EVA.PIM.Core.GetReferenceDataForProductResponse;
  }
  
  export class GetReferenceDataForProductResponse extends EVA.Core.ResponseMessage {
    Data : { [ key : string ] : any }; 
  }
  
  export class PreviewProduct extends EVA.Core.RequestMessageGeneric<EVA.PIM.Core.PreviewProductResponse> {
    ID : number; // Int32
    RevisionID : number; // Int32, nullable
    Edits : EVA.PIM.Core.PreviewProductEdit[]; 
    DoPostProcessing : boolean; 
    __response : EVA.PIM.Core.PreviewProductResponse;
  }
  
  export class PreviewProductResponse extends EVA.Core.ResponseMessage {
    Result : any; 
    Types : { [ key : string ] : any }; 
  }
  
  export class PreviewProductEdit {
    LayerID : number; // Int32
    Content : any; 
  }
  
  export class ReindexProduct extends EVA.Core.RequestMessageWithEmptyResponse {
    ID : number; // Int32
    __response : EVA.Core.EmptyResponseMessage;
  }
  
  export class CreateProductPropertyType extends EVA.Core.RequestMessageGeneric<EVA.PIM.Core.CreateProductPropertyTypeResponse> {
    TypeID : string; 
    CategoryID : string; 
    Intent : EVA.PIM.Core.ProductPropertyTypeIntents; 
    DataType : EVA.PIM.Core.ProductPropertyTypeDataTypes; 
    SearchType : EVA.PIM.Core.ProductPropertyTypeSearchTypes; 
    IsArray : boolean; 
    IsEnum : boolean; 
    EditFunctionality : string; 
    __response : EVA.PIM.Core.CreateProductPropertyTypeResponse;
  }
  
  export class CreateProductPropertyTypeResponse extends EVA.Core.ResponseMessage {
  }
  
  export enum ProductPropertyTypeIntents {
    RichAttribute = 0,
    SimpleField = 1,
    RootLevelOnly = 2,
  }
  
  export enum ProductPropertyTypeDataTypes {
    None = 0,
    Integer = 1,
    Double = 2,
    Boolean = 3,
    String = 4,
    Blob = 5,
    Date = 6,
    RichText = 7,
  }
  
  export enum ProductPropertyTypeSearchTypes {
    None = 0,
    Keyword = 1,
    Text = 2,
    IsHidden = 4,
    IsAggregatable = 9,
    IncludeInAll = 16,
  }
  
  export class EditProductPropertyType extends EVA.Core.RequestMessageGeneric<EVA.PIM.Core.EditProductPropertyTypeResponse> {
    ID : string; 
    RevisionID : number; // Int32, nullable
    Edits : EVA.PIM.Core.ProductPropertyTypeEdit[]; 
    SearchType : EVA.PIM.Core.ProductPropertyTypeSearchTypes; 
    __response : EVA.PIM.Core.EditProductPropertyTypeResponse;
  }
  
  export class EditProductPropertyTypeResponse extends EVA.Core.ResponseMessage {
  }
  
  export class ProductPropertyTypeEdit {
    LayerID : number; // Int32
    Content : any; 
  }
  
  export class GetAvailableEnumValuesForProductPropertyType extends EVA.Core.RequestMessageGeneric<EVA.PIM.Core.GetAvailableEnumValuesForProductPropertyTypeResponse> {
    TypeID : string; 
    __response : EVA.PIM.Core.GetAvailableEnumValuesForProductPropertyTypeResponse;
  }
  
  export class GetAvailableEnumValuesForProductPropertyTypeResponse extends EVA.Core.ResponseMessage {
    Values : { [ key : number ] : string }; 
  }
  
  export class GetProductPropertyTypeByID extends EVA.Core.RequestMessageGeneric<EVA.PIM.Core.GetProductPropertyTypeByIDResponse> {
    ID : string; 
    RevisionID : number; // Int32
    __response : EVA.PIM.Core.GetProductPropertyTypeByIDResponse;
  }
  
  export class GetProductPropertyTypeByIDResponse extends EVA.Core.ResponseMessage {
    ID : string; 
    CatalogID : number; // Int32
    LayersWithContent : EVA.PIM.Core.LayerWithContentDto[]; 
    CategoryID : string; 
  }
  
  export class ListProductPropertyTypes extends EVA.Core.PagedResultRequest<EVA.PIM.Core.ListProductPropertyTypesResponse> {
    __response : EVA.PIM.Core.ListProductPropertyTypesResponse;
  }
  
  export class ListProductPropertyTypesResponse extends EVA.Core.PagedResultResponse<EVA.PIM.Core.ListProductPropertyTypesDto> {
  }
  
  export class ListProductPropertyTypesDto {
    ID : string; 
    DisplayName : string; 
    CategoryID : string; 
    CategoryDisplayName : string; 
    DataType : EVA.PIM.Core.ProductPropertyTypeDataTypes; 
  }
  
  export class PreviewProductPropertyType extends EVA.Core.RequestMessageGeneric<EVA.PIM.Core.PreviewProductPropertyTypeResponse> {
    ID : string; 
    RevisionID : number; // Int32
    Edits : EVA.PIM.Core.ProductPropertyTypeEdit[]; 
    __response : EVA.PIM.Core.PreviewProductPropertyTypeResponse;
  }
  
  export class PreviewProductPropertyTypeResponse extends EVA.Core.ResponseMessage {
    Result : any; 
  }
  
  export class GetProductPropertyTypeEnumValueByID extends EVA.Core.RequestMessageGeneric<EVA.PIM.Core.GetProductPropertyTypeEnumValueByIDResponse> {
    ID : number; // Int32
    __response : EVA.PIM.Core.GetProductPropertyTypeEnumValueByIDResponse;
  }
  
  export class GetProductPropertyTypeEnumValueByIDResponse extends EVA.Core.ResponseMessage {
    ID : number; // Int32
    ProductPropertyTypeID : string; 
    CatalogID : number; // Int32
    Identifier : number; // Int32
    Value : string; 
    LanguageID : string; 
    CountryID : string; 
  }
  
  export class CreateProductPropertyTypeEnumValue extends EVA.Core.RequestMessageGeneric<EVA.PIM.Core.CreateProductPropertyTypeEnumValueResponse> {
    ProductPropertyTypeID : string; 
    Identifier : number; // Int32
    Value : string; 
    LanguageID : string; 
    CountryID : string; 
    __response : EVA.PIM.Core.CreateProductPropertyTypeEnumValueResponse;
  }
  
  export class CreateProductPropertyTypeEnumValueResponse extends EVA.Core.ResponseMessage {
    ID : number; // Int32
  }
  
  export class UpdateProductPropertyTypeEnumValue extends EVA.Core.RequestMessageWithEmptyResponse {
    ID : number; // Int32
    Identifier : number; // Int32
    Value : string; 
    LanguageID : string; 
    CountryID : string; 
    __response : EVA.Core.EmptyResponseMessage;
  }
  
  export class DeleteProductPropertyTypeEnumValue extends EVA.Core.RequestMessageWithEmptyResponse {
    ID : number; // Int32
    __response : EVA.Core.EmptyResponseMessage;
  }
  
  export class ListProductPropertyTypeEnumValues extends EVA.Core.PagedResultRequest<EVA.PIM.Core.ListProductPropertyTypeEnumValuesResponse> {
    __response : EVA.PIM.Core.ListProductPropertyTypeEnumValuesResponse;
  }
  
  export class ListProductPropertyTypeEnumValuesResponse extends EVA.Core.PagedResultResponse<EVA.PIM.Core.ListProductPropertyTypeEnumValuesResponseProductPropertyTypeEnumValueDto> {
  }
  
  export class ListProductPropertyTypeEnumValuesResponseProductPropertyTypeEnumValueDto {
    ID : number; // Int32
    ProductPropertyTypeID : string; 
    Identifier : number; // Int32
    Value : string; 
    LanguageID : string; 
    CountryID : string; 
  }
  
  export class SearchProductPropertyTypes extends EVA.Core.PagedResultRequest<EVA.PIM.Core.SearchProductPropertyTypesResponse> {
    Query : string; 
    __response : EVA.PIM.Core.SearchProductPropertyTypesResponse;
  }
  
  export class SearchProductPropertyTypesResponse extends EVA.Core.PagedResultResponse<any> {
  }
  
  export class CreateProductPropertyCategory extends EVA.Core.RequestMessageGeneric<EVA.PIM.Core.CreateProductPropertyCategoryResponse> {
    CategoryID : string; 
    EditFunctionality : string; 
    __response : EVA.PIM.Core.CreateProductPropertyCategoryResponse;
  }
  
  export class CreateProductPropertyCategoryResponse extends EVA.Core.ResponseMessage {
  }
  
  export class EditProductPropertyCategory extends EVA.Core.RequestMessageGeneric<EVA.PIM.Core.EditProductPropertyCategoryResponse> {
    ID : string; 
    RevisionID : number; // Int32
    Edits : EVA.PIM.Core.ProductPropertyCategoryEdit[]; 
    __response : EVA.PIM.Core.EditProductPropertyCategoryResponse;
  }
  
  export class EditProductPropertyCategoryResponse extends EVA.Core.ResponseMessage {
  }
  
  export class ProductPropertyCategoryEdit {
    LayerID : number; // Int32
    Content : any; 
  }
  
  export class GetProductPropertyCategoryByID extends EVA.Core.RequestMessageGeneric<EVA.PIM.Core.GetProductPropertyCategoryByIDResponse> {
    ID : string; 
    RevisionID : number; // Int32
    __response : EVA.PIM.Core.GetProductPropertyCategoryByIDResponse;
  }
  
  export class GetProductPropertyCategoryByIDResponse extends EVA.Core.ResponseMessage {
    ID : string; 
    CatalogID : number; // Int32
    LayersWithContent : EVA.PIM.Core.LayerWithContentDto[]; 
  }
  
  export class ListProductPropertyCategories extends EVA.Core.PagedResultRequest<EVA.PIM.Core.ListProductPropertyCategoriesResponse> {
    __response : EVA.PIM.Core.ListProductPropertyCategoriesResponse;
  }
  
  export class ListProductPropertyCategoriesResponse extends EVA.Core.PagedResultResponse<EVA.PIM.Core.ListProductPropertyCategoriesDto> {
  }
  
  export class ListProductPropertyCategoriesDto {
    ID : string; 
    DisplayName : string; 
  }
  
  export class PreviewProductPropertyCategory extends EVA.Core.RequestMessageGeneric<EVA.PIM.Core.PreviewProductPropertyCategoryResponse> {
    ID : string; 
    RevisionID : number; // Int32
    Edits : EVA.PIM.Core.ProductPropertyCategoryEdit[]; 
    __response : EVA.PIM.Core.PreviewProductPropertyCategoryResponse;
  }
  
  export class PreviewProductPropertyCategoryResponse extends EVA.Core.ResponseMessage {
    Result : any; 
  }
  
  export class ListApplicationCultures extends EVA.Core.RequestMessageGeneric<EVA.PIM.Core.ListApplicationCulturesResponse> {
    __response : EVA.PIM.Core.ListApplicationCulturesResponse;
  }
  
  export class ListApplicationCulturesResponse extends EVA.Core.ResponseMessage {
    Result : EVA.PIM.Core.ListApplicationContentCulture[]; 
  }
  
  export class ListApplicationContentCulture {
    ApplicationID : number; // Int32
    LanguageID : string; 
    CountryID : string; 
    Culture : string; 
  }
  
  export class CreateLayer extends EVA.Core.RequestMessageGeneric<EVA.PIM.Core.CreateLayerResponse> {
    ApplicationID : number; // Int32, nullable
    CountryID : string; 
    Description : string; 
    LanguageID : string; 
    Level : number; // Int32
    Name : string; 
    __response : EVA.PIM.Core.CreateLayerResponse;
  }
  
  export class CreateLayerResponse extends EVA.Core.ResponseMessage {
    Result : EVA.PIM.Core.CreatedLayer; 
  }
  
  export class CreatedLayer {
    ID : number; // Int32
    Name : string; 
    ApplicationID : number; // Int32, nullable
    Description : string; 
    Level : number; // Int32
    CountryID : string; 
  }
  
  export class GetLayerByID extends EVA.Core.RequestMessageGeneric<EVA.PIM.Core.GetLayerByIDResponse> {
    ID : number; // Int32
    __response : EVA.PIM.Core.GetLayerByIDResponse;
  }
  
  export class GetLayerByIDResponse extends EVA.Core.ResponseMessage {
    Layer : EVA.PIM.Core.LayerDto; 
  }
  
  export class LayerDto {
    ID : number; // Int32
    Description : string; 
    Level : number; // Int32
    ApplicationID : number; // Int32, nullable
    LanguageID : string; 
    CatalogID : number; // Int32
    RevisionID : number; // Int32, nullable
    Name : string; 
    CountryID : string; 
    Type : EVA.PIM.Core.ContentLayerTypes; 
  }
  
  export enum ContentLayerTypes {
    UserLayer = 0,
    SystemLayer = 1,
  }
  
  export class ListLayers extends EVA.Core.PagedResultRequest<EVA.PIM.Core.ListLayersResponse> {
    __response : EVA.PIM.Core.ListLayersResponse;
  }
  
  export class ListLayersResponse extends EVA.Core.PagedResultResponse<EVA.PIM.Core.LayerDto> {
  }
  
  export class UpdateLayer extends EVA.Core.RequestMessageWithEmptyResponse {
    ID : number; // Int32
    Name : string; 
    Description : string; 
    Level : number; // Int32
    __response : EVA.Core.EmptyResponseMessage;
  }
  
  export class CreateBrand extends EVA.Core.RequestMessageWithEmptyResponse {
    BackendID : string; 
    Name : string; 
    __response : EVA.Core.EmptyResponseMessage;
  }
  
  export class GetBrand extends EVA.Core.GetRequestGeneric<EVA.PIM.Core.GetBrandResponse> {
    __response : EVA.PIM.Core.GetBrandResponse;
  }
  
  export class GetBrandResponse extends EVA.Core.ResponseMessage {
    Result : EVA.PIM.Core.BrandDto; 
  }
  
  export class BrandDto {
    ID : number; // Int32
    Name : string; 
    BackendID : string; 
  }
  
  export class UpdateBrand extends EVA.Core.UpdateRequest<EVA.PIM.Core.BrandDto> implements EVA.Core.IRequestRespondsAs<EVA.Core.EmptyResponseMessage> {
    __response : EVA.Core.EmptyResponseMessage;
  }
  
  export enum ContentEditTypes {
    Product = 1,
    ProductPropertyType = 2,
    ProductPropertyCategory = 3,
  }
  
  export enum ContentMergeTypes {
    MergeRevisions = 0,
    MergeArrays = 1,
    MergeLayers = 2,
  }
  
  export enum ProductPropertyTypeInheritanceTypes {
    NormalInheritance = 0,
    NoInheritance = 1,
  }
  
  export enum ProductPropertyTypeRequired {
    NotRequired = 0,
    RequiredOnEdit = 1,
    RequireOnApplyRevision = 2,
  }
  
  export enum RevisionTypes {
    UserRevision = 0,
    SystemRevision = 1,
  }
  
  export class ConfigurableProductDto {
    ProductID : number; // Int32
    Type : EVA.Core.ProductTypes; 
    Status : EVA.Core.ProductStatus; 
    LogicalLevel : string; 
    ConfigurableProperty : string; 
    Value : any; 
    Values : any[]; 
    Children : EVA.PIM.Core.ConfigurableProductDto[]; 
    Properties : any; 
  }
  
}