/* tslint:disable */
declare module EVA.Payment.UserCard {
  
  export class CancelPendingUserCardPayment extends EVA.Core.RequestMessageWithEmptyResponse {
    PaymentTransactionID : number; // Int32
    __response : EVA.Core.EmptyResponseMessage;
  }
  
  export class CreateUserCardMutation extends EVA.Core.RequestMessageWithEmptyResponse {
    UserCardID : number; // Int32
    Amount : number; // Decimal
    Description : string; 
    __response : EVA.Core.EmptyResponseMessage;
  }
  
  export class CreateUserCard extends EVA.Core.RequestMessageGeneric<EVA.Payment.UserCard.CreateUserCardResponse> {
    UserID : number; // Int32, nullable
    CurrencyID : string; 
    UserCardTypeID : number; // Int32
    __response : EVA.Payment.UserCard.CreateUserCardResponse;
  }
  
  export class CreateUserCardResponse extends EVA.Core.ResponseMessage {
    ID : number; // Int32
  }
  
  export class GetUserCardBalance extends EVA.Core.RequestMessageGeneric<EVA.Payment.UserCard.GetUserCardBalanceResponse> {
    UserCardID : number; // Int32
    CurrencyID : string; 
    __response : EVA.Payment.UserCard.GetUserCardBalanceResponse;
  }
  
  export class GetUserCardBalanceResponse extends EVA.Core.ResponseMessage {
    CurrentBalance : EVA.Core.UserCardBalance; 
  }
  
  export class GetUserCardDetails extends EVA.Core.RequestMessageGeneric<EVA.Payment.UserCard.GetUserCardDetailsResponse> {
    UserCardID : number; // Int32, nullable
    CardNumber : string; 
    CurrencyID : string; 
    __response : EVA.Payment.UserCard.GetUserCardDetailsResponse;
  }
  
  export class GetUserCardDetailsResponse extends EVA.Core.ResponseMessage {
    UserCard : EVA.Core.UserCardDto; 
  }
  
  export class GetUserCardDiscounts extends EVA.Core.RequestMessageGeneric<EVA.Payment.UserCard.GetUserCardDiscountsResponse> {
    UserID : number; // Int32
    __response : EVA.Payment.UserCard.GetUserCardDiscountsResponse;
  }
  
  export class GetUserCardDiscountsResponse extends EVA.Core.ResponseMessage {
    UserCard : EVA.Core.DiscountDto[]; 
  }
  
  export class GetUserCardTypes extends EVA.Core.RequestMessageGeneric<EVA.Payment.UserCard.GetUserCardTypesResponse> {
    __response : EVA.Payment.UserCard.GetUserCardTypesResponse;
  }
  
  export class GetUserCardTypesResponse extends EVA.Core.ResponseMessage {
    Types : EVA.Core.UserCardTypeDto[]; 
  }
  
  export class ListUserCardMutations extends EVA.Core.PagedResultRequest<EVA.Payment.UserCard.ListUserCardMutationsResponse> {
    UserCardID : number; // Int32
    __response : EVA.Payment.UserCard.ListUserCardMutationsResponse;
  }
  
  export class ListUserCardMutationsResponse extends EVA.Core.PagedResultResponse<EVA.Payment.UserCard.ListUserCardMutationsDto> {
  }
  
  export class ListUserCardMutationsDto {
    Amount : number; // Decimal
    CreationTime : string; // DateTime
    Description : string; 
    Status : EVA.Core.UserCardMutationStatuses; 
  }
  
  export class ListUserCardsForUser extends EVA.Core.RequestMessageGeneric<EVA.Payment.UserCard.ListUserCardsForUserResponse> {
    UserID : number; // Int32, nullable
    CurrencyID : string; 
    __response : EVA.Payment.UserCard.ListUserCardsForUserResponse;
  }
  
  export class ListUserCardsForUserResponse extends EVA.Core.ResponseMessage {
    UserCards : EVA.Core.UserCardDto[]; 
  }
  
  export class ListUserCards extends EVA.Core.PagedResultRequest<EVA.Payment.UserCard.ListUserCardsResponse> {
    __response : EVA.Payment.UserCard.ListUserCardsResponse;
  }
  
  export class ListUserCardsResponse extends EVA.Core.PagedResultResponse<EVA.Payment.UserCard.ListUserCardDto> {
  }
  
  export class ListUserCardDto {
    Barcode : string; 
    ID : number; // Int32
    Type : EVA.Core.UserCardTypeDto; 
    UserFullName : string; 
  }
  
}