/* tslint:disable */
declare module EVA.Replenishment {
  
  export class ExportShelfTemplate extends EVA.Core.RequestMessageGeneric<EVA.Core.ResourceResponseMessage> {
    ShelfIDs : number[]; 
    __response : EVA.Core.ResourceResponseMessage;
  }
  
  export class ImportShelfTemplate extends EVA.Core.RequestMessageWithEmptyResponse {
    Data : number[]; 
    __response : EVA.Core.EmptyResponseMessage;
  }
  
  export class GetOrganizationUnitDistributionTree extends EVA.Core.RequestMessageGeneric<EVA.Replenishment.GetOrganizationUnitDistributionTreeResponse> {
    __response : EVA.Replenishment.GetOrganizationUnitDistributionTreeResponse;
  }
  
  export class GetOrganizationUnitDistributionTreeResponse extends EVA.Core.ResponseMessage {
    Tree : EVA.Replenishment.TreeNode; 
  }
  
  export class TreeNode {
    Fraction : number; // Decimal, nullable
    OrganizationUnitIDs : number[]; 
    OrganizationUnitTypeID : number; // Int32, nullable
    Negation : boolean; 
    Nodes : EVA.Replenishment.TreeNode[]; 
  }
  
  export class UpdateOrganizationUnitDistributionTree extends EVA.Core.RequestMessageWithEmptyResponse {
    Tree : EVA.Replenishment.TreeNode; 
    __response : EVA.Core.EmptyResponseMessage;
  }
  
  export class GetOrganizationUnitShelfByID extends EVA.Core.RequestMessageGeneric<EVA.Replenishment.GetOrganizationUnitShelfByIDResponse> {
    ID : number; // Int32
    __response : EVA.Replenishment.GetOrganizationUnitShelfByIDResponse;
  }
  
  export class GetOrganizationUnitShelfByIDResponse extends EVA.Core.ResponseMessage {
    ID : number; // Int32
    ShelfID : number; // Int32
    OrganizationUnitID : number; // Int32, nullable
    OrganizationUnitTypeID : number; // Int32, nullable
  }
  
  export class CreateOrganizationUnitShelf extends EVA.Core.RequestMessageGeneric<EVA.Replenishment.CreateOrganizationUnitShelfResponse> {
    ShelfID : number; // Int32
    OrganizationUnitID : number; // Int32, nullable
    OrganizationUnitTypeID : number; // Int32, nullable
    __response : EVA.Replenishment.CreateOrganizationUnitShelfResponse;
  }
  
  export class CreateOrganizationUnitShelfResponse extends EVA.Core.ResponseMessage {
    ID : number; // Int32
  }
  
  export class UpdateOrganizationUnitShelf extends EVA.Core.RequestMessageWithEmptyResponse {
    ID : number; // Int32
    ShelfID : number; // Int32
    OrganizationUnitID : number; // Int32, nullable
    OrganizationUnitTypeID : number; // Int32, nullable
    __response : EVA.Core.EmptyResponseMessage;
  }
  
  export class DeleteOrganizationUnitShelf extends EVA.Core.RequestMessageWithEmptyResponse {
    ID : number; // Int32
    __response : EVA.Core.EmptyResponseMessage;
  }
  
  export class ListOrganizationUnitShelves extends EVA.Core.PagedResultRequest<EVA.Replenishment.ListOrganizationUnitShelvesResponse> {
    __response : EVA.Replenishment.ListOrganizationUnitShelvesResponse;
  }
  
  export class ListOrganizationUnitShelvesResponse extends EVA.Core.PagedResultResponse<EVA.Replenishment.ListOrganizationUnitShelvesResponseOrganizationUnitShelfDto> {
  }
  
  export class ListOrganizationUnitShelvesResponseOrganizationUnitShelfDto {
    ID : number; // Int32
    ShelfID : number; // Int32
    Shelf : EVA.Replenishment.ListOrganizationUnitShelvesResponseShelfDto; 
    OrganizationUnitID : number; // Int32, nullable
    OrganizationUnit : EVA.Core.OrganizationUnitDto; 
    OrganizationUnitTypeID : number; // Int32, nullable
  }
  
  export class ListOrganizationUnitShelvesResponseShelfDto {
    ID : number; // Int32
    Name : string; 
    Description : string; 
    StartDateTime : string; // DateTime
    EndDateTime : string; // DateTime, nullable
    TypeID : number; // Int32
    Type : EVA.Core.EnumDtoBase; 
    Height : number; // Int32
    Width : number; // Int32
    Depth : number; // Int32
  }
  
  export class GetProductRestrictionByID extends EVA.Core.RequestMessageGeneric<EVA.Replenishment.GetProductRestrictionByIDResponse> {
    ID : number; // Int32
    __response : EVA.Replenishment.GetProductRestrictionByIDResponse;
  }
  
  export class GetProductRestrictionByIDResponse extends EVA.Core.ResponseMessage {
    ID : number; // Int32
    ProductID : number; // Int32
    OrganizationUnitID : number; // Int32, nullable
    OrganizationUnitTypeID : number; // Int32, nullable
    MaximumReplenismentQuantity : number; // Int32, nullable
    MaximumStockQuantity : number; // Int32, nullable
  }
  
  export class CreateProductRestriction extends EVA.Core.RequestMessageGeneric<EVA.Replenishment.CreateProductRestrictionResponse> {
    ProductID : number; // Int32
    OrganizationUnitID : number; // Int32, nullable
    OrganizationUnitTypeID : number; // Int32, nullable
    MaximumReplenismentQuantity : number; // Int32, nullable
    MaximumStockQuantity : number; // Int32, nullable
    __response : EVA.Replenishment.CreateProductRestrictionResponse;
  }
  
  export class CreateProductRestrictionResponse extends EVA.Core.ResponseMessage {
    ID : number; // Int32
  }
  
  export class UpdateProductRestriction extends EVA.Core.RequestMessageWithEmptyResponse {
    ID : number; // Int32
    ProductID : number; // Int32
    OrganizationUnitID : number; // Int32, nullable
    OrganizationUnitTypeID : number; // Int32, nullable
    MaximumReplenismentQuantity : number; // Int32, nullable
    MaximumStockQuantity : number; // Int32, nullable
    __response : EVA.Core.EmptyResponseMessage;
  }
  
  export class DeleteProductRestriction extends EVA.Core.RequestMessageWithEmptyResponse {
    ID : number; // Int32
    __response : EVA.Core.EmptyResponseMessage;
  }
  
  export class ListProductRestrictions extends EVA.Core.PagedResultRequest<EVA.Replenishment.ListProductRestrictionsResponse> {
    __response : EVA.Replenishment.ListProductRestrictionsResponse;
  }
  
  export class ListProductRestrictionsResponse extends EVA.Core.PagedResultResponse<EVA.Replenishment.ListProductRestrictionsResponseProductRestrictionDto> {
  }
  
  export class ListProductRestrictionsResponseProductRestrictionDto {
    ID : number; // Int32
    ProductID : number; // Int32
    Product : EVA.Replenishment.ListProductRestrictionsResponseProductDto; 
    OrganizationUnitID : number; // Int32, nullable
    OrganizationUnitTypeID : number; // Int32, nullable
    MaximumReplenismentQuantity : number; // Int32, nullable
    MaximumStockQuantity : number; // Int32, nullable
  }
  
  export class ListProductRestrictionsResponseProductDto {
    BackendID : string; 
    DisplayValue : string; 
  }
  
  export class GetShelfBlobByID extends EVA.Core.RequestMessageGeneric<EVA.Replenishment.GetShelfBlobByIDResponse> {
    ID : number; // Int32
    __response : EVA.Replenishment.GetShelfBlobByIDResponse;
  }
  
  export class GetShelfBlobByIDResponse extends EVA.Core.ResponseMessage {
    ID : number; // Int32
    ShelfID : number; // Int32
    BlobID : string; 
  }
  
  export class CreateShelfBlob extends EVA.Core.RequestMessageGeneric<EVA.Replenishment.CreateShelfBlobResponse> {
    ShelfID : number; // Int32
    BlobID : string; 
    __response : EVA.Replenishment.CreateShelfBlobResponse;
  }
  
  export class CreateShelfBlobResponse extends EVA.Core.ResponseMessage {
    ID : number; // Int32
  }
  
  export class UpdateShelfBlob extends EVA.Core.RequestMessageWithEmptyResponse {
    ID : number; // Int32
    ShelfID : number; // Int32
    BlobID : string; 
    __response : EVA.Core.EmptyResponseMessage;
  }
  
  export class DeleteShelfBlob extends EVA.Core.RequestMessageWithEmptyResponse {
    ID : number; // Int32
    __response : EVA.Core.EmptyResponseMessage;
  }
  
  export class ListShelfBlobs extends EVA.Core.PagedResultRequest<EVA.Replenishment.ListShelfBlobsResponse> {
    __response : EVA.Replenishment.ListShelfBlobsResponse;
  }
  
  export class ListShelfBlobsResponse extends EVA.Core.PagedResultResponse<EVA.Replenishment.ListShelfBlobsResponseShelfBlobDto> {
  }
  
  export class ListShelfBlobsResponseShelfBlobDto {
    ID : number; // Int32
    ShelfID : number; // Int32
    BlobID : string; 
  }
  
  export class GetShelfByID extends EVA.Core.RequestMessageGeneric<EVA.Replenishment.GetShelfByIDResponse> {
    ID : number; // Int32
    __response : EVA.Replenishment.GetShelfByIDResponse;
  }
  
  export class GetShelfByIDResponse extends EVA.Core.ResponseMessage {
    ID : number; // Int32
    Name : string; 
    Description : string; 
    StartDateTime : string; // DateTime
    EndDateTime : string; // DateTime, nullable
    TypeID : number; // Int32
    Height : number; // Int32
    Width : number; // Int32
    Depth : number; // Int32
  }
  
  export class CreateShelf extends EVA.Core.RequestMessageGeneric<EVA.Replenishment.CreateShelfResponse> {
    Name : string; 
    Description : string; 
    StartDateTime : string; // DateTime
    EndDateTime : string; // DateTime, nullable
    TypeID : number; // Int32
    Height : number; // Int32
    Width : number; // Int32
    Depth : number; // Int32
    __response : EVA.Replenishment.CreateShelfResponse;
  }
  
  export class CreateShelfResponse extends EVA.Core.ResponseMessage {
    ID : number; // Int32
  }
  
  export class UpdateShelf extends EVA.Core.RequestMessageWithEmptyResponse {
    ID : number; // Int32
    Name : string; 
    Description : string; 
    StartDateTime : string; // DateTime
    EndDateTime : string; // DateTime, nullable
    TypeID : number; // Int32
    Height : number; // Int32
    Width : number; // Int32
    Depth : number; // Int32
    __response : EVA.Core.EmptyResponseMessage;
  }
  
  export class DeleteShelf extends EVA.Core.RequestMessageWithEmptyResponse {
    ID : number; // Int32
    __response : EVA.Core.EmptyResponseMessage;
  }
  
  export class ListShelves extends EVA.Core.PagedResultRequest<EVA.Replenishment.ListShelvesResponse> {
    __response : EVA.Replenishment.ListShelvesResponse;
  }
  
  export class ListShelvesResponse extends EVA.Core.PagedResultResponse<EVA.Replenishment.ListShelvesResponseShelfDto> {
  }
  
  export class ListShelvesResponseShelfDto {
    ID : number; // Int32
    Name : string; 
    Description : string; 
    StartDateTime : string; // DateTime
    EndDateTime : string; // DateTime, nullable
    TypeID : number; // Int32
    Type : EVA.Core.EnumDtoBase; 
    Height : number; // Int32
    Width : number; // Int32
    Depth : number; // Int32
  }
  
  export class DuplicateShelf extends EVA.Core.RequestMessageGeneric<EVA.Replenishment.DuplicateShelfResponse> {
    ShelfID : number; // Int32
    Name : string; 
    StartDateTime : string; // DateTime
    EndDateTime : string; // DateTime, nullable
    __response : EVA.Replenishment.DuplicateShelfResponse;
  }
  
  export class DuplicateShelfResponse extends EVA.Core.ResponseMessage {
    ID : number; // Int32
  }
  
  export class GetShelfLocationBlobByID extends EVA.Core.RequestMessageGeneric<EVA.Replenishment.GetShelfLocationBlobByIDResponse> {
    ID : number; // Int32
    __response : EVA.Replenishment.GetShelfLocationBlobByIDResponse;
  }
  
  export class GetShelfLocationBlobByIDResponse extends EVA.Core.ResponseMessage {
    ID : number; // Int32
    ShelfLocationID : number; // Int32
    BlobID : string; 
  }
  
  export class CreateShelfLocationBlob extends EVA.Core.RequestMessageGeneric<EVA.Replenishment.CreateShelfLocationBlobResponse> {
    ShelfLocationID : number; // Int32
    BlobID : string; 
    __response : EVA.Replenishment.CreateShelfLocationBlobResponse;
  }
  
  export class CreateShelfLocationBlobResponse extends EVA.Core.ResponseMessage {
    ID : number; // Int32
  }
  
  export class UpdateShelfLocationBlob extends EVA.Core.RequestMessageWithEmptyResponse {
    ID : number; // Int32
    ShelfLocationID : number; // Int32
    BlobID : string; 
    __response : EVA.Core.EmptyResponseMessage;
  }
  
  export class DeleteShelfLocationBlob extends EVA.Core.RequestMessageWithEmptyResponse {
    ID : number; // Int32
    __response : EVA.Core.EmptyResponseMessage;
  }
  
  export class ListShelfLocationBlobs extends EVA.Core.PagedResultRequest<EVA.Replenishment.ListShelfLocationBlobsResponse> {
    __response : EVA.Replenishment.ListShelfLocationBlobsResponse;
  }
  
  export class ListShelfLocationBlobsResponse extends EVA.Core.PagedResultResponse<EVA.Replenishment.ListShelfLocationBlobsResponseShelfLocationBlobDto> {
  }
  
  export class ListShelfLocationBlobsResponseShelfLocationBlobDto {
    ID : number; // Int32
    ShelfLocationID : number; // Int32
    BlobID : string; 
  }
  
  export class GetShelfLocationByID extends EVA.Core.RequestMessageGeneric<EVA.Replenishment.GetShelfLocationByIDResponse> {
    ID : number; // Int32
    __response : EVA.Replenishment.GetShelfLocationByIDResponse;
  }
  
  export class GetShelfLocationByIDResponse extends EVA.Core.ResponseMessage {
    ID : number; // Int32
    ShelfID : number; // Int32
    ParentID : number; // Int32, nullable
    TemplateID : number; // Int32
    Name : string; 
  }
  
  export class CreateShelfLocation extends EVA.Core.RequestMessageGeneric<EVA.Replenishment.CreateShelfLocationResponse> {
    ShelfID : number; // Int32
    ParentID : number; // Int32, nullable
    TemplateID : number; // Int32
    Name : string; 
    __response : EVA.Replenishment.CreateShelfLocationResponse;
  }
  
  export class CreateShelfLocationResponse extends EVA.Core.ResponseMessage {
    ID : number; // Int32
  }
  
  export class UpdateShelfLocation extends EVA.Core.RequestMessageWithEmptyResponse {
    ID : number; // Int32
    ParentID : number; // Int32, nullable
    TemplateID : number; // Int32
    Name : string; 
    __response : EVA.Core.EmptyResponseMessage;
  }
  
  export class DeleteShelfLocation extends EVA.Core.RequestMessageWithEmptyResponse {
    ID : number; // Int32
    __response : EVA.Core.EmptyResponseMessage;
  }
  
  export class ListShelfLocations extends EVA.Core.PagedResultRequest<EVA.Replenishment.ListShelfLocationsResponse> {
    __response : EVA.Replenishment.ListShelfLocationsResponse;
  }
  
  export class ListShelfLocationsResponse extends EVA.Core.PagedResultResponse<EVA.Replenishment.ListShelfLocationsResponseShelfLocationDto> {
  }
  
  export class ListShelfLocationsResponseShelfLocationDto {
    ID : number; // Int32
    ShelfID : number; // Int32
    ParentID : number; // Int32, nullable
    TemplateID : number; // Int32
    Name : string; 
  }
  
  export class GetShelfLocationProductByID extends EVA.Core.RequestMessageGeneric<EVA.Replenishment.GetShelfLocationProductByIDResponse> {
    ID : number; // Int32
    __response : EVA.Replenishment.GetShelfLocationProductByIDResponse;
  }
  
  export class GetShelfLocationProductByIDResponse extends EVA.Core.ResponseMessage {
    ID : number; // Int32
    ShelfLocationID : number; // Int32
    ProductID : number; // Int32
    MinimumQuantity : number; // Int32
    MaximumQuantity : number; // Int32
  }
  
  export class CreateShelfLocationProduct extends EVA.Core.RequestMessageGeneric<EVA.Replenishment.CreateShelfLocationProductResponse> {
    ShelfLocationID : number; // Int32
    ProductID : number; // Int32
    MinimumQuantity : number; // Int32
    MaximumQuantity : number; // Int32
    __response : EVA.Replenishment.CreateShelfLocationProductResponse;
  }
  
  export class CreateShelfLocationProductResponse extends EVA.Core.ResponseMessage {
    ID : number; // Int32
  }
  
  export class CreateShelfLocationProducts extends EVA.Core.RequestMessageGeneric<EVA.Replenishment.CreateShelfLocationProductsResponse> {
    ShelfLocationID : number; // Int32
    Products : EVA.Replenishment.CreateShelfLocationProductsProduct[]; 
    __response : EVA.Replenishment.CreateShelfLocationProductsResponse;
  }
  
  export class CreateShelfLocationProductsResponse extends EVA.Core.ResponseMessage {
    IDs : number[]; 
  }
  
  export class CreateShelfLocationProductsProduct {
    ProductID : number; // Int32
    MinimumQuantity : number; // Int32
    MaximumQuantity : number; // Int32
  }
  
  export class UpdateShelfLocationProduct extends EVA.Core.RequestMessageWithEmptyResponse {
    ID : number; // Int32
    MinimumQuantity : number; // Int32
    MaximumQuantity : number; // Int32
    __response : EVA.Core.EmptyResponseMessage;
  }
  
  export class DeleteShelfLocationProduct extends EVA.Core.RequestMessageWithEmptyResponse {
    ID : number; // Int32
    __response : EVA.Core.EmptyResponseMessage;
  }
  
  export class ListShelfLocationProducts extends EVA.Core.PagedResultRequest<EVA.Replenishment.ListShelfLocationProductsResponse> {
    __response : EVA.Replenishment.ListShelfLocationProductsResponse;
  }
  
  export class ListShelfLocationProductsResponse extends EVA.Core.PagedResultResponse<EVA.Replenishment.ListShelfLocationProductsResponseShelfLocationProductDto> {
  }
  
  export class ListShelfLocationProductsResponseShelfLocationProductDto {
    ID : number; // Int32
    ShelfLocationID : number; // Int32
    ProductID : number; // Int32
    Product : EVA.Replenishment.ListShelfLocationProductsResponseShelfProductDto; 
    MinimumQuantity : number; // Int32
    MaximumQuantity : number; // Int32
  }
  
  export class ListShelfLocationProductsResponseShelfProductDto {
    BackendID : string; 
    CustomID : string; 
    DisplayValue : string; 
    DisplayPrice : number; // Decimal, nullable
  }
  
  export class UploadShelfLocationProducts extends EVA.Core.RequestMessageWithEmptyResponse {
    ShelfLocationID : number; // Int32
    Data : number[]; 
    __response : EVA.Core.EmptyResponseMessage;
  }
  
  export class DownloadShelfLocationProducts extends EVA.Core.RequestMessageGeneric<EVA.Core.ResourceResponseMessage> {
    ShelfLocationID : number; // Int32
    __response : EVA.Core.ResourceResponseMessage;
  }
  
  export class GetShelfLocationTemplateByID extends EVA.Core.RequestMessageGeneric<EVA.Replenishment.GetShelfLocationTemplateByIDResponse> {
    ID : number; // Int32
    __response : EVA.Replenishment.GetShelfLocationTemplateByIDResponse;
  }
  
  export class GetShelfLocationTemplateByIDResponse extends EVA.Core.ResponseMessage {
    ID : number; // Int32
    TypeID : number; // Int32
    Name : string; 
    ProductLimit : number; // Int32, nullable
    Height : number; // Int32
    Width : number; // Int32
    Depth : number; // Int32
  }
  
  export class CreateShelfLocationTemplate extends EVA.Core.RequestMessageGeneric<EVA.Replenishment.CreateShelfLocationTemplateResponse> {
    TypeID : number; // Int32
    Name : string; 
    ProductLimit : number; // Int32, nullable
    Height : number; // Int32
    Width : number; // Int32
    Depth : number; // Int32
    __response : EVA.Replenishment.CreateShelfLocationTemplateResponse;
  }
  
  export class CreateShelfLocationTemplateResponse extends EVA.Core.ResponseMessage {
    ID : number; // Int32
  }
  
  export class UpdateShelfLocationTemplate extends EVA.Core.RequestMessageWithEmptyResponse {
    ID : number; // Int32
    TypeID : number; // Int32
    Name : string; 
    ProductLimit : number; // Int32, nullable
    Height : number; // Int32
    Width : number; // Int32
    Depth : number; // Int32
    __response : EVA.Core.EmptyResponseMessage;
  }
  
  export class DeleteShelfLocationTemplate extends EVA.Core.RequestMessageWithEmptyResponse {
    ID : number; // Int32
    __response : EVA.Core.EmptyResponseMessage;
  }
  
  export class ListShelfLocationTemplates extends EVA.Core.PagedResultRequest<EVA.Replenishment.ListShelfLocationTemplatesResponse> {
    __response : EVA.Replenishment.ListShelfLocationTemplatesResponse;
  }
  
  export class ListShelfLocationTemplatesResponse extends EVA.Core.PagedResultResponse<EVA.Replenishment.ListShelfLocationTemplatesResponseShelfLocationTemplateDto> {
  }
  
  export class ListShelfLocationTemplatesResponseShelfLocationTemplateDto {
    ID : number; // Int32
    TypeID : number; // Int32
    Name : string; 
    ProductLimit : number; // Int32, nullable
    Height : number; // Int32
    Width : number; // Int32
    Depth : number; // Int32
  }
  
  export class GetShelfLocationTemplateTypeByID extends EVA.Core.RequestMessageGeneric<EVA.Replenishment.GetShelfLocationTemplateTypeByIDResponse> {
    ID : number; // Int32
    __response : EVA.Replenishment.GetShelfLocationTemplateTypeByIDResponse;
  }
  
  export class GetShelfLocationTemplateTypeByIDResponse extends EVA.Core.ResponseMessage {
    ID : number; // Int32
    Name : string; 
    Description : string; 
  }
  
  export class CreateShelfLocationTemplateType extends EVA.Core.RequestMessageGeneric<EVA.Replenishment.CreateShelfLocationTemplateTypeResponse> {
    Name : string; 
    Description : string; 
    __response : EVA.Replenishment.CreateShelfLocationTemplateTypeResponse;
  }
  
  export class CreateShelfLocationTemplateTypeResponse extends EVA.Core.ResponseMessage {
    ID : number; // Int32
  }
  
  export class UpdateShelfLocationTemplateType extends EVA.Core.RequestMessageWithEmptyResponse {
    ID : number; // Int32
    Description : string; 
    __response : EVA.Core.EmptyResponseMessage;
  }
  
  export class DeleteShelfLocationTemplateType extends EVA.Core.RequestMessageWithEmptyResponse {
    ID : number; // Int32
    __response : EVA.Core.EmptyResponseMessage;
  }
  
  export class GetShelfLocationTemplateTypes extends EVA.Core.RequestMessageGeneric<EVA.Replenishment.GetShelfLocationTemplateTypesResponse> {
    __response : EVA.Replenishment.GetShelfLocationTemplateTypesResponse;
  }
  
  export class GetShelfLocationTemplateTypesResponse extends EVA.Core.ResponseMessage {
    ShelfLocationTemplateTypes : EVA.Replenishment.GetShelfLocationTemplateTypesResponseShelfLocationTemplateTypeDto[]; 
  }
  
  export class GetShelfLocationTemplateTypesResponseShelfLocationTemplateTypeDto {
    ID : number; // Int32
    Name : string; 
    Description : string; 
  }
  
  export class GetShelfTypeByID extends EVA.Core.RequestMessageGeneric<EVA.Replenishment.GetShelfTypeByIDResponse> {
    ID : number; // Int32
    __response : EVA.Replenishment.GetShelfTypeByIDResponse;
  }
  
  export class GetShelfTypeByIDResponse extends EVA.Core.ResponseMessage {
    ID : number; // Int32
    Name : string; 
    Description : string; 
  }
  
  export class CreateShelfType extends EVA.Core.RequestMessageGeneric<EVA.Replenishment.CreateShelfTypeResponse> {
    Name : string; 
    Description : string; 
    __response : EVA.Replenishment.CreateShelfTypeResponse;
  }
  
  export class CreateShelfTypeResponse extends EVA.Core.ResponseMessage {
    ID : number; // Int32
  }
  
  export class UpdateShelfType extends EVA.Core.RequestMessageWithEmptyResponse {
    ID : number; // Int32
    Description : string; 
    __response : EVA.Core.EmptyResponseMessage;
  }
  
  export class DeleteShelfType extends EVA.Core.RequestMessageWithEmptyResponse {
    ID : number; // Int32
    __response : EVA.Core.EmptyResponseMessage;
  }
  
  export class GetShelfTypes extends EVA.Core.RequestMessageGeneric<EVA.Replenishment.GetShelfTypesResponse> {
    __response : EVA.Replenishment.GetShelfTypesResponse;
  }
  
  export class GetShelfTypesResponse extends EVA.Core.ResponseMessage {
    ShelfTypes : EVA.Replenishment.GetShelfTypesResponseShelfTypeDto[]; 
  }
  
  export class GetShelfTypesResponseShelfTypeDto {
    ID : number; // Int32
    Name : string; 
    Description : string; 
  }
  
}