/* tslint:disable */
declare module EVA.Rituals {
  
  export class RitualsCreateCustomerReturn extends EVA.Core.RequestMessageGeneric<EVA.Rituals.RitualsCreateCustomerReturnResponse> {
    OrderID : number; // Int32
    Email : string; 
    SessionID : string; 
    Lines : EVA.Rituals.RitualsCreateCustomerReturnLineModel[]; 
    __response : EVA.Rituals.RitualsCreateCustomerReturnResponse;
  }
  
  export class RitualsCreateCustomerReturnResponse extends EVA.Core.ResponseMessage {
    OrderID : number; // Int32
  }
  
  export class RitualsCreateCustomerReturnLineModel {
    ID : number; // Int32
    QuantityToReturn : number; // Int32
    Reason : string; 
  }
  
  export class RitualsGetBlobsForReturn extends EVA.Core.RequestMessageGeneric<EVA.Rituals.RitualsGetBlobsForReturnResponse> {
    OrderID : number; // Int32
    Email : string; 
    __response : EVA.Rituals.RitualsGetBlobsForReturnResponse;
  }
  
  export class RitualsGetBlobsForReturnResponse extends EVA.Core.ResponseMessage {
    Result : EVA.Rituals.RitualsGetBlobsForReturnResponseModel[]; 
  }
  
  export class RitualsGetBlobsForReturnResponseModel {
    Name : string; 
    MimeType : string; 
    BlobID : string; 
    Url : string; 
  }
  
  export class RitualsGetOrderForReturn extends EVA.Core.RequestMessageGeneric<EVA.Rituals.RitualsGetOrderForReturnResponse> {
    OrderID : string; 
    Email : string; 
    __response : EVA.Rituals.RitualsGetOrderForReturnResponse;
  }
  
  export class RitualsGetOrderForReturnResponse extends EVA.Core.ResponseMessage {
    Result : EVA.Rituals.RitualsGetOrderForReturnResponseOrderModel; 
  }
  
  export class RitualsGetOrderForReturnResponseOrderModel {
    ID : number; // Int32
    Lines : EVA.Rituals.RitualsGetOrderForReturnResponseOrderLineModel[]; 
    CustomerID : number; // Int32
    CreationTime : string; // DateTime
    InvoiceNumbers : string[]; 
  }
  
  export class RitualsGetOrderForReturnResponseOrderLineModel extends EVA.Core.OrderLineDto {
    ReturnableQuantity : number; // Int32
    IsReturnable : boolean; 
  }
  
  export class RitualsListAvailablePickupStores extends EVA.Core.PagedResultRequest<EVA.Rituals.RitualsListAvailablePickupStoresResponse> {
    Products : EVA.Rituals.RitualsListAvailablePickupStoresProduct[]; 
    __response : EVA.Rituals.RitualsListAvailablePickupStoresResponse;
  }
  
  export class RitualsListAvailablePickupStoresResponse extends EVA.Core.PagedResultResponse<EVA.Rituals.RitualsListAvailablePickupStoresResponseModel> {
  }
  
  export class RitualsListAvailablePickupStoresResponseModel {
    ID : number; // Int32
    BackendID : string; 
    Name : string; 
    Address : EVA.Core.AddressDto; 
    Latitude : number; // Double
    Longitude : number; // Double
    EmailAddress : string; 
    PhoneNumber : string; 
    EstimatedPickupTime : string; // DateTime
    MerchantID : string; 
    OpeningHours : EVA.Rituals.RitualsListAvailablePickupStoresResponseOpeningHour[]; 
    DistanceInKm : number; // Double
    DistanceInMiles : number; // Double
  }
  
  export class RitualsListAvailablePickupStoresResponseOpeningHour {
    DayOfWeek : string; 
    StartTime : any; // TimeSpan
    EndTime : any; // TimeSpan
    Date : string; // DateTime, nullable
  }
  
  export class RitualsListAvailablePickupStoresProduct {
    Consumercode : string; 
    Quantity : number; // Int32
  }
  
  export class RitualsScanLoyaltyCard extends EVA.Core.RequestMessageGeneric<EVA.Rituals.RitualsScanLoyaltyCardResponse> {
    LoyaltyID : string; 
    __response : EVA.Rituals.RitualsScanLoyaltyCardResponse;
  }
  
  export class RitualsScanLoyaltyCardResponse extends EVA.Core.ResponseMessage {
    User : EVA.Core.UserDto; 
  }
  
  export class RitualsUpdateLoyalty extends EVA.Core.RequestMessageWithEmptyResponse {
    UserID : number; // Int32
    Enabled : boolean; 
    __response : EVA.Core.EmptyResponseMessage;
  }
  
  export class CreateDemandwareOrders extends EVA.Core.RequestMessageGeneric<EVA.Rituals.CreateDemandwareOrdersResponse> {
    Orders : EVA.Rituals.DemandwareOrders; 
    __response : EVA.Rituals.CreateDemandwareOrdersResponse;
  }
  
  export class CreateDemandwareOrdersResponse extends EVA.Core.ResponseMessage {
    OrderSets : EVA.Rituals.CreateDemandwareOrdersResponseOrderSetsModel; 
  }
  
  export class CreateDemandwareOrdersResponseOrderSetsModel {
    OrderSet : EVA.Rituals.CreateDemandwareOrdersResponseOrderSetModel[]; 
  }
  
  export class CreateDemandwareOrdersResponseOrderSetModel {
    EVAOrderID : number; // Int32
    DemandwareOrderNo : string; 
  }
  
  export class DemandwareOrders {
    Order : EVA.Rituals.Order[]; 
  }
  
  export class Order {
    Orderdate : string; 
    Createdby : string; 
    Originalorderno : string; 
    Currency : string; 
    Customerlocale : string; 
    Taxation : string; 
    Invoiceno : string; 
    Customer : EVA.Rituals.Customer; 
    Status : EVA.Rituals.Status; 
    Currentorderno : string; 
    Productlineitems : EVA.Rituals.Productlineitems; 
    Shippinglineitems : EVA.Rituals.Shippinglineitems; 
    Shipments : EVA.Rituals.Shipments; 
    Totals : EVA.Rituals.Totals; 
    Payments : EVA.Rituals.Payments; 
    Notes : EVA.Rituals.Notes; 
    Customattributes : EVA.Rituals.Customattributes; 
    Orderno : string; 
  }
  
  export class Customer {
    CustomerNo : string; 
    Customername : string; 
    Customeremail : string; 
    Billingaddress : EVA.Rituals.Billingaddress; 
  }
  
  export class Billingaddress implements EVA.Rituals.IDemandwareAddress {
    Salutation : string; 
    Firstname : string; 
    Secondname : string; 
    Lastname : string; 
    Companyname : string; 
    Address1 : string; 
    Address2 : string; 
    City : string; 
    Postalcode : string; 
    Statecode : string; 
    Countrycode : string; 
    Phone : string; 
    Customattributes : EVA.Rituals.Customattributes; 
  }
  
  export class Customattributes {
    Customattribute : EVA.Rituals.Customattribute[]; 
  }
  
  export class Customattribute {
    Attributeid : string; 
    Text : string; 
  }
  
  export interface IDemandwareAddress {
    Salutation : string; 
    Firstname : string; 
    Lastname : string; 
    Secondname : string; 
    Address1 : string; 
    Address2 : string; 
    City : string; 
    Postalcode : string; 
    Statecode : string; 
    Countrycode : string; 
    Phone : string; 
    Companyname : string; 
    Customattributes : EVA.Rituals.Customattributes; 
  }
  
  export class Status {
    Orderstatus : string; 
    Shippingstatus : string; 
    Confirmationstatus : string; 
    Paymentstatus : string; 
  }
  
  export class Productlineitems {
    Productlineitem : EVA.Rituals.Productlineitem[]; 
  }
  
  export class Productlineitem {
    Netprice : string; 
    Tax : string; 
    Grossprice : string; 
    Baseprice : string; 
    Lineitemtext : string; 
    Taxbasis : string; 
    Position : string; 
    Productid : string; 
    Productname : string; 
    Quantity : EVA.Rituals.Quantity; 
    Taxrate : string; 
    Shipmentid : string; 
    Options : EVA.Rituals.Optionlineitems; 
    Gift : string; 
    GiftMessage : string; 
    Customattributes : EVA.Rituals.Customattributes; 
    Priceadjustments : EVA.Rituals.Priceadjustments; 
  }
  
  export class Quantity {
    Unit : string; 
    Text : string; 
  }
  
  export class Optionlineitems {
    Items : EVA.Rituals.OptionLineItem[]; 
  }
  
  export class OptionLineItem {
    Netprice : string; 
    Tax : string; 
    Grossprice : string; 
    Baseprice : string; 
    Lineitemtext : string; 
    Taxbasis : string; 
    OptionId : string; 
    ValueId : string; 
    ProductId : string; 
    Customattributes : EVA.Rituals.Customattributes; 
  }
  
  export class Priceadjustments {
    Priceadjustment : EVA.Rituals.Priceadjustment[]; 
  }
  
  export class Priceadjustment {
    Netprice : string; 
    Tax : string; 
    Grossprice : string; 
    Baseprice : string; 
    Lineitemtext : string; 
    Taxbasis : string; 
    Promotionid : string; 
    Campaignid : string; 
    Customattributes : EVA.Rituals.Customattributes; 
  }
  
  export class Shippinglineitems {
    Shippinglineitem : EVA.Rituals.Shippinglineitem[]; 
  }
  
  export class Shippinglineitem {
    Netprice : string; 
    Tax : string; 
    Grossprice : string; 
    Baseprice : string; 
    Lineitemtext : string; 
    Taxbasis : string; 
    Itemid : string; 
    Shipmentid : string; 
    Taxrate : string; 
    Priceadjustments : EVA.Rituals.Priceadjustments; 
  }
  
  export class Shipments {
    Shipment : EVA.Rituals.Shipment[]; 
  }
  
  export class Shipment {
    Status : EVA.Rituals.Status; 
    Shippingmethod : string; 
    Shippingaddress : EVA.Rituals.Shippingaddress; 
    Gift : string; 
    GiftMessage : string; 
    Totals : EVA.Rituals.Totals; 
    Shipmentid : string; 
  }
  
  export class Shippingaddress implements EVA.Rituals.IDemandwareAddress {
    Salutation : string; 
    Firstname : string; 
    Secondname : string; 
    Lastname : string; 
    Companyname : string; 
    Address1 : string; 
    Address2 : string; 
    City : string; 
    Postalcode : string; 
    Statecode : string; 
    Countrycode : string; 
    Phone : string; 
    Customattributes : EVA.Rituals.Customattributes; 
  }
  
  export class Totals {
    Merchandizetotal : EVA.Rituals.Merchandizetotal; 
    Adjustedmerchandizetotal : EVA.Rituals.Adjustedmerchandizetotal; 
    Shippingtotal : EVA.Rituals.Shippingtotal; 
    Adjustedshippingtotal : EVA.Rituals.Adjustedshippingtotal; 
    Shipmenttotal : EVA.Rituals.Shipmenttotal; 
    Ordertotal : EVA.Rituals.Ordertotal; 
  }
  
  export class Merchandizetotal {
    Netprice : string; 
    Tax : string; 
    Grossprice : string; 
    Priceadjustments : EVA.Rituals.Priceadjustments; 
  }
  
  export class Adjustedmerchandizetotal {
    Netprice : string; 
    Tax : string; 
    Grossprice : string; 
  }
  
  export class Shippingtotal {
    Netprice : string; 
    Tax : string; 
    Grossprice : string; 
  }
  
  export class Adjustedshippingtotal {
    Netprice : string; 
    Tax : string; 
    Grossprice : string; 
  }
  
  export class Shipmenttotal {
    Netprice : string; 
    Tax : string; 
    Grossprice : string; 
  }
  
  export class Ordertotal {
    Netprice : string; 
    Tax : string; 
    Grossprice : string; 
  }
  
  export class Payments {
    Payment : EVA.Rituals.Payment[]; 
  }
  
  export class Payment {
    Custommethod : EVA.Rituals.Custommethod; 
    Amount : string; 
    Processorid : string; 
    Transactionid : string; 
  }
  
  export class Custommethod {
    Methodname : string; 
  }
  
  export class Notes {
    Note : EVA.Rituals.Note[]; 
  }
  
  export class Note {
    Subject : string; 
    Text : string; 
  }
  
  export class ArvatoCreatePurchaseOrderReceipt extends EVA.Core.RequestMessageWithEmptyResponse {
    BackendOrderID : string; 
    PurchaseOrderLines : EVA.Rituals.ArvatoCreatePurchaseOrderReceiptLine[]; 
    __response : EVA.Core.EmptyResponseMessage;
  }
  
  export class ArvatoCreatePurchaseOrderReceiptLine {
    BackendPurchaseOrderLineID : string; 
    Receipts : EVA.Rituals.ArvatoCreatePurchaseOrderReceiptLineReceipt[]; 
  }
  
  export class ArvatoCreatePurchaseOrderReceiptLineReceipt {
    QuantityReceived : number; // Int32
    StockLocationID : string; 
  }
  
  export class ArvatoCreateStockMutation extends EVA.Core.RequestMessageWithEmptyResponse {
    WarehouseID : string; 
    Mutations : EVA.Rituals.ArvatoStockMutation[]; 
    __response : EVA.Core.EmptyResponseMessage;
  }
  
  export class ArvatoStockMutation {
    EAN : string; 
    Quantity : number; // Int32
    Type : EVA.Rituals.ArvatoStockMovement; 
    SourceStorageLocation : string; 
    DestinationStorageLocation : string; 
  }
  
  export enum ArvatoStockMovement {
    Inbound = 101,
    Movement = 311,
    Outbound = 601,
    ReturnReceipt = 653,
    NegativeCycleCount = 711,
    PositiveCycleCount = 712,
  }
  
  export class ArvatoShipOrder extends EVA.Core.RequestMessageWithEmptyResponse {
    ShippingConfirmations : EVA.Rituals.ArvatoShipOrderArvatoShipOrderConfirmation[]; 
    __response : EVA.Core.EmptyResponseMessage;
  }
  
  export class ArvatoShipOrderArvatoShipOrderConfirmation {
    EvaOrderID : number; // Int32
    BackendOrderLineID : string; 
    DeliveryNumber : string; 
    DateShipped : string; // DateTime
    Packages : EVA.Rituals.ArvatoShipOrderArvatoShipOrderPackage[]; 
  }
  
  export class ArvatoShipOrderArvatoShipOrderPackage {
    TrackingCode : string; 
    TrackingUrl : string; 
    CarrierCode : string; 
    OrderLines : EVA.Rituals.ArvatoShipOrderArvatoShipOrderPackageOrderLine[]; 
  }
  
  export class ArvatoShipOrderArvatoShipOrderPackageOrderLine {
    EvaOrderLineID : number; // Int32
    BackendOrderLineID : string; 
    QuantityShipped : number; // Int32
    SerialNumber : string; 
  }
  
  export class ArvatoUpdateOrder extends EVA.Core.RequestMessageWithEmptyResponse {
    EvaOrderID : number; // Int32
    OrderLines : EVA.Rituals.ArvatoUpdateOrderLine[]; 
    __response : EVA.Core.EmptyResponseMessage;
  }
  
  export class ArvatoUpdateOrderLine {
    EvaOrderLineID : number; // Int32
    IsCancelled : boolean; 
    IsPicked : boolean; 
    IsPacked : boolean; 
  }
  
  export class ArvatoUpdateStock extends EVA.Core.RequestMessageWithEmptyResponse {
    WarehouseID : string; 
    Stock : EVA.Rituals.ArvatoUpdateStockLine[]; 
    __response : EVA.Core.EmptyResponseMessage;
  }
  
  export class ArvatoUpdateStockLine {
    BackendProductID : string; 
    EAN : string; 
    QuantityAvailable : number; // Int32
  }
  
}