/* tslint:disable */
declare module EVA.Social {
  
  export enum ActivityLedgerDirections {
    Creator = 0,
    Receiver = 1,
  }
  
  export class SocialGetProgressionByID extends EVA.Core.RequestMessageGeneric<EVA.Social.SocialGetProgressionByIDResponse> {
    ID : number; // Int32
    __response : EVA.Social.SocialGetProgressionByIDResponse;
  }
  
  export class SocialGetProgressionByIDResponse extends EVA.Core.ResponseMessage {
    Progression : EVA.Social.ProgressionDto; 
  }
  
  export class ProgressionDto {
    Level : number; // Int32, nullable
    Type : EVA.Social.SocialProgressionType; 
    Name : string; 
    ImageBlobID : string; 
    Steps : EVA.Social.ProgressionStepDto[]; 
    IsAchieved : boolean; 
    Rewards : EVA.Social.ProgressionRewardDto[]; 
  }
  
  export enum SocialProgressionType {
    Level = 0,
    Achievement = 1,
  }
  
  export class ProgressionStepDto {
    Description : string; 
    RequiredQuantity : number; // Int32
    CurrentQuantity : number; // Int32
    IsAchieved : boolean; 
  }
  
  export class ProgressionRewardDto {
    Category : string; 
    Description : string; 
    Type : string; 
    Capability : string; 
    Name : string; 
    BlobID : string; 
  }
  
  export class SocialGetProgressions extends EVA.Core.RequestMessageGeneric<EVA.Social.SocialGetProgressionsResponse> {
    UserID : number; // Int32
    Type : EVA.Social.SocialProgressionType; 
    __response : EVA.Social.SocialGetProgressionsResponse;
  }
  
  export class SocialGetProgressionsResponse extends EVA.Core.ResponseMessage {
    Progressions : EVA.Social.ProgressionDto[]; 
  }
  
}