/* tslint:disable */
declare module EVA.UserTasks {
  
  export class CompleteValueAddedLogisticTask extends EVA.Core.RequestMessageWithEmptyResponse {
    UserTaskID : number; // Int32
    __response : EVA.Core.EmptyResponseMessage;
  }
  
  export class GetValueAddedLogisticTasks extends EVA.Core.RequestMessageGeneric<EVA.UserTasks.GetValueAddedLogisticTasksResponse> {
    OrderID : number; // Int32, nullable
    OrderLineIDs : number[]; 
    __response : EVA.UserTasks.GetValueAddedLogisticTasksResponse;
  }
  
  export class GetValueAddedLogisticTasksResponse extends EVA.Core.ResponseMessage {
    OrderTasks : EVA.UserTasks.GetValueAddedLogisticTasksResponseModel[]; 
    OrderLineTasks : EVA.UserTasks.GetValueAddedLogisticTasksResponseModel[]; 
  }
  
  export class GetValueAddedLogisticTasksResponseModel {
    OrderLineID : number; // Int32, nullable
    UserTaskID : number; // Int32
    Type : string; 
    Description : string; 
    Data : any; 
  }
  
  export class CancelUserTask extends EVA.Core.RequestMessageGeneric<EVA.UserTasks.CancelUserTaskResponse> {
    TaskID : number; // Int32
    UserID : number; // Int32, nullable
    __response : EVA.UserTasks.CancelUserTaskResponse;
  }
  
  export class CancelUserTaskResponse extends EVA.Core.ResponseMessage {
    Success : boolean; 
  }
  
  export class CompleteUserTask extends EVA.Core.RequestMessageGeneric<EVA.Core.EmptyResponseMessage> {
    WorkSet : EVA.UserTasks.UserTaskWorkSet; 
    __response : EVA.Core.EmptyResponseMessage;
  }
  
  export class UserTaskWorkSet {
    UserTaskID : number; // Int32
    StartTime : string; // DateTime
    Name : string; 
    Description : string; 
    CanBeIgnored : boolean; 
    Configuration : string; 
    ExpectedTimeToComplete : any; // TimeSpan, nullable
    Results : EVA.UserTasks.UserTaskResultDto[]; 
  }
  
  export class UserTaskResultDto implements EVA.Core.IUserTaskResult {
    Name : string; 
    Description : string; 
    Type : string; 
    Value : string; 
    Data : number[]; 
  }
  
  export class CreateUserTaskSchedule extends EVA.Core.RequestMessageWithEmptyResponse {
    TypeID : number; // Int32
    OrganizationUnitTypeID : number; // Int32, nullable
    OrganizationUnitID : number; // Int32, nullable
    Description : string; 
    Deadline : any; // TimeSpan
    CronExpression : string; 
    AttachToFinancialPeriod : boolean; 
    ApplicationID : number; // Int32, nullable
    __response : EVA.Core.EmptyResponseMessage;
  }
  
  export class CreateUserTask extends EVA.Core.RequestMessageWithEmptyResponse {
    UserID : number; // Int32, nullable
    OrganizationUnitID : number; // Int32
    AttachFinancialPeriod : boolean; 
    TypeID : number; // Int32
    Deadline : string; // DateTime, nullable
    ExpectedTimeToComplete : any; // TimeSpan, nullable
    __response : EVA.Core.EmptyResponseMessage;
  }
  
  export class CreateUserTaskType extends EVA.Core.RequestMessageGeneric<EVA.UserTasks.CreateUserTaskTypeResponse> {
    Name : string; 
    Description : string; 
    Configuration : string; 
    __response : EVA.UserTasks.CreateUserTaskTypeResponse;
  }
  
  export class CreateUserTaskTypeResponse extends EVA.Core.ResponseMessage {
    UserTaskType : EVA.Core.UserTaskTypeDto; 
  }
  
  export class GetUserTaskDetails extends EVA.Core.RequestMessageGeneric<EVA.UserTasks.GetUserTaskDetailsResponse> {
    UserTaskID : number; // Int32
    __response : EVA.UserTasks.GetUserTaskDetailsResponse;
  }
  
  export class GetUserTaskDetailsResponse extends EVA.Core.ResponseMessage {
    Details : EVA.UserTasks.UserTaskDetails; 
  }
  
  export class UserTaskSummary {
    ID : number; // Int32
    Description : string; 
    UserID : number; // Int32, nullable
    UserFullname : string; 
    IsCompleted : boolean; 
    Type : EVA.Core.UserTaskTypeDto; 
    FinancialPeriodID : number; // Int32, nullable
    FinancialPeriod : EVA.Core.FinancialPeriodDto; 
    IsActive : boolean; 
    ExpectedTimeToComplete : any; // TimeSpan, nullable
    StartTime : string; // DateTime, nullable
    CompletionTime : string; // DateTime, nullable
    Deadline : string; // DateTime, nullable
    Priority : number; // Int32
  }
  
  export class UserTaskDetails extends EVA.UserTasks.UserTaskSummary {
    Results : EVA.UserTasks.UserTaskResultDto[]; 
  }
  
  export class IgnoreUserTask extends EVA.Core.RequestMessageWithEmptyResponse {
    UserTaskID : number; // Int32
    __response : EVA.Core.EmptyResponseMessage;
  }
  
  export class ListAvailableUserTasks extends EVA.Core.RequestMessageGeneric<EVA.UserTasks.ListAvailableUserTasksResponse> {
    __response : EVA.UserTasks.ListAvailableUserTasksResponse;
  }
  
  export class ListAvailableUserTasksResponse extends EVA.Core.ResponseMessage {
    AvailableTasks : EVA.UserTasks.AvailableUserTask[]; 
  }
  
  export class AvailableUserTask {
    ID : number; // Int32
    Description : string; 
    TypeID : number; // Int32
    Type : EVA.Core.UserTaskTypeDto; 
    ExpectedTimeToComplete : any; // TimeSpan, nullable
    Deadline : string; // DateTime, nullable
    CanBeIgnored : boolean; 
    CreationTime : string; // DateTime
  }
  
  export class ListTasksForOrganization extends EVA.Core.PagedResultRequest<EVA.UserTasks.ListTasksForOrganizationResponse> {
    UserTaskTypes : string[]; 
    __response : EVA.UserTasks.ListTasksForOrganizationResponse;
  }
  
  export class ListTasksForOrganizationResponse extends EVA.Core.PagedResultResponse<EVA.Core.UserTaskDto> {
  }
  
  export class ListTasksThatBlockPeriodClosing extends EVA.Core.RequestMessageGeneric<EVA.UserTasks.ListTasksThatBlockPeriodClosingResponse> {
    __response : EVA.UserTasks.ListTasksThatBlockPeriodClosingResponse;
  }
  
  export class ListTasksThatBlockPeriodClosingResponse extends EVA.Core.ResponseMessage {
    Tasks : EVA.Core.UserTaskDto[]; 
  }
  
  export class ListUserTaskTypes extends EVA.Core.RequestMessageGeneric<EVA.UserTasks.ListUserTaskTypesResponse> {
    __response : EVA.UserTasks.ListUserTaskTypesResponse;
  }
  
  export class ListUserTaskTypesResponse extends EVA.Core.ResponseMessage {
    Types : EVA.Core.UserTaskTypeDto[]; 
  }
  
  export class PollTasks extends EVA.Core.RequestMessageGeneric<EVA.UserTasks.PollTasksResponse> {
    UserTaskTypes : string[]; 
    __response : EVA.UserTasks.PollTasksResponse;
  }
  
  export class PollTasksResponse extends EVA.Core.ResponseMessage {
    NumberOfTasks : number; // Int32
  }
  
  export class SearchUserTasks extends EVA.Core.RequestMessageGeneric<EVA.UserTasks.SearchUserTasksResponse> {
    Start : number; // Int32
    Limit : number; // Int32
    OrganizationUnitID : number; // Int32
    Filters : EVA.UserTasks.SearchUserTasksFilters; 
    __response : EVA.UserTasks.SearchUserTasksResponse;
  }
  
  export class SearchUserTasksResponse extends EVA.Core.ResponseMessage {
    Results : EVA.UserTasks.UserTaskSummary[]; 
  }
  
  export class SearchUserTasksFilters {
    ShowCompleted : boolean; 
  }
  
  export class StartUserTask extends EVA.Core.RequestMessageGeneric<EVA.UserTasks.StartUserTaskResponse> {
    UserTaskID : number; // Int32
    __response : EVA.UserTasks.StartUserTaskResponse;
  }
  
  export class StartUserTaskResponse extends EVA.Core.ResponseMessage {
    WorkSet : EVA.UserTasks.UserTaskWorkSet; 
  }
  
  export class UpdateUserTask extends EVA.Core.RequestMessageGeneric<EVA.Core.EmptyResponseMessage> {
    ID : number; // Int32
    UserID : number; // Int32
    TypeID : number; // Int32
    Deadline : string; // DateTime
    ExpectedTimeToComplete : any; // TimeSpan
    __response : EVA.Core.EmptyResponseMessage;
  }
  
  export class UpdateUserTaskType extends EVA.Core.RequestMessageGeneric<EVA.Core.EmptyResponseMessage> {
    ID : number; // Int32
    Name : string; 
    Description : string; 
    Configuration : string; 
    __response : EVA.Core.EmptyResponseMessage;
  }
  
  export class CompleteStockReservationTask extends EVA.Core.RequestMessageWithEmptyResponse {
    Task : EVA.UserTasks.StockReservationTaskDto; 
    __response : EVA.Core.EmptyResponseMessage;
  }
  
  export class StockReservationTaskDto {
    UserTaskID : number; // Int32
    OrderID : number; // Int32
    Order : EVA.Core.OrderDto; 
    Lines : EVA.UserTasks.StockReservationTaskLineDto[]; 
  }
  
  export class StockReservationTaskLineDto {
    IsCancelled : boolean; 
    IsReserved : boolean; 
    Barcodes : string[]; 
    Product : EVA.Core.ProductDto; 
    ProductID : number; // Int32
    OrderLineID : number; // Int32
    QuantityOnHand : number; // Int32
    ForceComplete : boolean; 
    MustBeOrdered : boolean; 
    RequiredResourceTypes : EVA.Core.Services.StockResourceTypeDto[]; 
    ResourceID : number; // Int32, nullable
    Resources : { [ key : string ] : string }; 
  }
  
  export class StartStockReservation extends EVA.Core.RequestMessageGeneric<EVA.UserTasks.StartStockReservationResponse> {
    TaskID : number; // Int32
    Force : boolean; 
    __response : EVA.UserTasks.StartStockReservationResponse;
  }
  
  export class StartStockReservationResponse extends EVA.Core.ResponseMessage {
    WorkSet : EVA.UserTasks.StockReservationWorkSet; 
  }
  
  export class StockReservationWorkSet {
    UserTaskID : number; // Int32
    OrderID : number; // Int32
    Order : EVA.Core.OrderDto; 
    Lines : EVA.UserTasks.StockReservationTaskLineDto[]; 
  }
  
  export class CompleteReservationDeviationTask extends EVA.Core.RequestMessageGeneric<EVA.UserTasks.CompleteReservationDeviationTaskResponse> {
    WorkSet : EVA.UserTasks.ReservationDeviationWorkSet; 
    __response : EVA.UserTasks.CompleteReservationDeviationTaskResponse;
  }
  
  export class CompleteReservationDeviationTaskResponse extends EVA.Core.ResponseMessage {
    Retry : boolean; 
  }
  
  export class ReservationDeviationWorkSet {
    TaskID : number; // Int32
    ProductID : number; // Int32
    Orders : EVA.Core.OrderDto[]; 
    OrderLineIDs : number[]; 
    QuantityToCancel : number; // Int32
    Product : EVA.Core.ProductDto; 
    QuantityToMoveToSellable : number; // Int32
    OrderLinesToCancel : EVA.UserTasks.OrderLineToCancel[]; 
    OrderLinesToOrder : EVA.UserTasks.OrderLineToOrder[]; 
    QuantityMovedBack : number; // Int32
  }
  
  export class OrderLineToCancel {
    OrderLineID : number; // Int32
    QuantityToCancel : number; // Int32
  }
  
  export class OrderLineToOrder {
    OrderLineID : number; // Int32
    QuantityToOrder : number; // Int32
  }
  
  export class StartReservationDeviationTask extends EVA.Core.RequestMessageGeneric<EVA.UserTasks.StartReservationDeviationTaskResponse> {
    TaskID : number; // Int32
    Force : boolean; 
    __response : EVA.UserTasks.StartReservationDeviationTaskResponse;
  }
  
  export class StartReservationDeviationTaskResponse extends EVA.Core.ResponseMessage {
    WorkSet : EVA.UserTasks.ReservationDeviationWorkSet; 
  }
  
  export class CompleteReservationCleanup extends EVA.Core.RequestMessageGeneric<EVA.UserTasks.CompleteReservationCleanupResponse> {
    Task : EVA.UserTasks.ReservationCleanupWorkSet; 
    __response : EVA.UserTasks.CompleteReservationCleanupResponse;
  }
  
  export class CompleteReservationCleanupResponse extends EVA.Core.ResponseMessage {
  }
  
  export class ReservationCleanupWorkSet {
    UserTaskID : number; // Int32
    ReservationCleanupTaskID : number; // Int32
    Order : EVA.Core.OrderDto; 
    Lines : EVA.UserTasks.ReservationCleanupWorkSetOrderLine[]; 
  }
  
  export class ReservationCleanupWorkSetOrderLine {
    QuantityToReturn : number; // Int32
    QuantityReturned : number; // Int32
    NothingToReturn : boolean; 
    ReservationExpirationOverride : string; // DateTime, nullable
    OrderLine : EVA.Core.OrderLineDto; 
  }
  
  export class StartReservationCleanup extends EVA.Core.RequestMessageGeneric<EVA.UserTasks.StartReservationCleanupResponse> {
    UserTaskID : number; // Int32
    __response : EVA.UserTasks.StartReservationCleanupResponse;
  }
  
  export class StartReservationCleanupResponse extends EVA.Core.ResponseMessage {
    Task : EVA.UserTasks.ReservationCleanupWorkSet; 
  }
  
  export class CompletePriceChange extends EVA.Core.RequestMessageWithEmptyResponse {
    Task : EVA.UserTasks.PriceChangeWorkSet; 
    __response : EVA.Core.EmptyResponseMessage;
  }
  
  export class PriceChangeWorkSet {
    UserTaskID : number; // Int32
    PriceChangeTaskID : number; // Int32
    ProductID : number; // Int32
    ProductBackendID : string; 
    ProductName : string; 
    OriginalPrice : number; // Decimal
    CurrentPrice : number; // Decimal
    ProductCustomID : string; 
  }
  
  export class StartPriceChange extends EVA.Core.RequestMessageGeneric<EVA.UserTasks.StartPriceChangeResponse> {
    UserTaskID : number; // Int32
    __response : EVA.UserTasks.StartPriceChangeResponse;
  }
  
  export class StartPriceChangeResponse extends EVA.Core.ResponseMessage {
    Task : EVA.UserTasks.PriceChangeWorkSet; 
  }
  
  export class CanProcessInitialCycleCount extends EVA.Core.RequestMessageGeneric<EVA.UserTasks.CanProcessInitialCycleCountResponse> {
    InitialCycleCountID : number; // Int32
    __response : EVA.UserTasks.CanProcessInitialCycleCountResponse;
  }
  
  export class CanProcessInitialCycleCountResponse extends EVA.Core.ResponseMessage {
    CanProcess : boolean; 
  }
  
  export class CountProductForInitialCycleCount extends EVA.Core.RequestMessageGeneric<EVA.Core.EmptyResponseMessage> {
    LabelID : number; // Int32
    ProductID : number; // Int32
    Quantity : number; // Int32
    Resources : { [ key : string ] : string }; 
    __response : EVA.Core.EmptyResponseMessage;
  }
  
  export class CreateInitialCycleCount extends EVA.Core.RequestMessageGeneric<EVA.UserTasks.CreateInitialCycleCountResponse> {
    __response : EVA.UserTasks.CreateInitialCycleCountResponse;
  }
  
  export class CreateInitialCycleCountResponse extends EVA.Core.ResponseMessage {
    Result : EVA.UserTasks.InitialCycleCountDto; 
  }
  
  export class InitialCycleCountDto {
    ID : number; // Int32
    Status : EVA.UserTasks.InitialCycleCountStatus; 
    OrganizationUnitID : number; // Int32
  }
  
  export enum InitialCycleCountStatus {
    New = 0,
    DetailCount = 1,
    Finished = 2,
  }
  
  export class DeleteInitialCycleCountResult extends EVA.Core.RequestMessageGeneric<EVA.Core.EmptyResponseMessage> {
    ProductID : number; // Int32
    StockLabel : number; // Int32
    ResourceID : number; // Int32, nullable
    LabelID : number; // Int32
    __response : EVA.Core.EmptyResponseMessage;
  }
  
  export class GetCurrentInitialCycleCount extends EVA.Core.RequestMessageGeneric<EVA.UserTasks.GetCurrentInitialCycleCountResponse> {
    __response : EVA.UserTasks.GetCurrentInitialCycleCountResponse;
  }
  
  export class GetCurrentInitialCycleCountResponse extends EVA.Core.ResponseMessage {
    Result : EVA.UserTasks.InitialCycleCountDto; 
  }
  
  export class GetInitialCycleCountLabel extends EVA.Core.RequestMessageGeneric<EVA.UserTasks.GetInitialCycleCountLabelResponse> {
    LabelID : number; // Int32
    __response : EVA.UserTasks.GetInitialCycleCountLabelResponse;
  }
  
  export class GetInitialCycleCountLabelResponse extends EVA.Core.ResponseMessage {
    Label : EVA.UserTasks.InitialCycleCountLabelDto; 
  }
  
  export class InitialCycleCountLabelDto {
    ID : number; // Int32
    Number : number; // Int32
    Status : EVA.UserTasks.InitialCycleCountLabelStatus; 
    StockLabel : number; // Int32, nullable
    ItemPreCount : number; // Int32, nullable
    ItemEndCount : number; // Int32, nullable
    CreatedByID : number; // Int32
    CreationTime : string; // DateTime
    InitialCycleCount : EVA.UserTasks.InitialCycleCountDto; 
    PreCountedByFullName : string; 
    CountedByFullName : string; 
  }
  
  export enum InitialCycleCountLabelStatus {
    New = 0,
    PreCounted = 1,
    Counted = 2,
  }
  
  export class ListInitialCycleCountLabels extends EVA.Core.RequestMessageGeneric<EVA.UserTasks.ListInitialCycleCountLabelsResponse> {
    InitialCycleCountID : number; // Int32
    Start : number; // Int32
    Limit : number; // Int32
    __response : EVA.UserTasks.ListInitialCycleCountLabelsResponse;
  }
  
  export class ListInitialCycleCountLabelsResponse extends EVA.Core.ResponseMessage {
    Result : EVA.UserTasks.InitialCycleCountLabelDto[]; 
    Total : number; // Int32
  }
  
  export class ListInitialCycleCountResults extends EVA.Core.RequestMessageGeneric<EVA.UserTasks.ListInitialCycleCountResultsResponse> {
    Start : number; // Int32
    Limit : number; // Int32
    ShowAll : boolean; 
    ProductID : number; // Int32, nullable
    CustomItemNumber : string; 
    StockLabel : number; // Int32, nullable
    ResourceID : number; // Int32, nullable
    LabelID : number; // Int32, nullable
    __response : EVA.UserTasks.ListInitialCycleCountResultsResponse;
  }
  
  export class ListInitialCycleCountResultsResponse extends EVA.Core.ResponseMessage {
    Results : EVA.UserTasks.StockWithInitialCycleCountResultDto[]; 
    Total : number; // Int32
  }
  
  export class StockWithInitialCycleCountResultDto {
    ProductID : number; // Int32
    OrganizationUnitID : number; // Int32
    QuantityOnHand : number; // Int32
    StockLabelID : number; // Int32
    StockLabel : number; // Int32
    ResourceID : number; // Int32, nullable
    Quantity : number; // Int32
    BackendID : string; 
    LabelID : string; 
    LabelNumber : string; 
    ShortDescription : string; 
  }
  
  export class MissingProductForInitialCycleCount extends EVA.Core.RequestMessageGeneric<EVA.Core.EmptyResponseMessage> {
    LabelID : number; // Int32
    Barcode : string; 
    Quantity : number; // Int32
    Photo : number[]; 
    PhotoMimeType : string; 
    __response : EVA.Core.EmptyResponseMessage;
  }
  
  export class PreCountInitialCycleCountLabel extends EVA.Core.RequestMessageWithEmptyResponse {
    LabelID : number; // Int32
    Quantity : number; // Int32
    StockLabel : number; // Int32
    __response : EVA.Core.EmptyResponseMessage;
  }
  
  export class ProcessInitialCycleCountResults extends EVA.Core.RequestMessageGeneric<EVA.Core.EmptyResponseMessage> {
    __response : EVA.Core.EmptyResponseMessage;
  }
  
  export class ProduceInitialCycleCountLabels extends EVA.Core.RequestMessageGeneric<EVA.UserTasks.ProduceInitialCycleCountLabelsResponse> {
    Count : number; // Int32
    StationID : number; // Int32, nullable
    AsPDF : boolean; 
    ReprintLabels : boolean; 
    __response : EVA.UserTasks.ProduceInitialCycleCountLabelsResponse;
  }
  
  export class ProduceInitialCycleCountLabelsResponse extends EVA.Core.ResponseMessage {
    Count : number; // Int32
    Success : boolean; 
    PdfDownloadUrl : string; 
  }
  
  export class ValidatePreCount extends EVA.Core.RequestMessageGeneric<EVA.UserTasks.ValidatePreCountResponse> {
    LabelID : number; // Int32
    ConfirmedQuantity : number; // Int32, nullable
    __response : EVA.UserTasks.ValidatePreCountResponse;
  }
  
  export class ValidatePreCountResponse extends EVA.Core.ResponseMessage {
    Result : EVA.UserTasks.ValidatePreCountResults; 
  }
  
  export enum ValidatePreCountResults {
    None = 0,
    Correct = 1,
    Deviation = 2,
    RedoDetailCount = 3,
  }
  
  export class CompleteCycleCount extends EVA.Core.RequestMessageGeneric<EVA.UserTasks.CompleteCycleCountResponse> {
    WorkSet : EVA.UserTasks.CycleCountWorkSet; 
    __response : EVA.UserTasks.CompleteCycleCountResponse;
  }
  
  export class CompleteCycleCountResponse extends EVA.Core.ResponseMessage {
    Results : EVA.UserTasks.CompleteCycleCountStockLabelResult[]; 
  }
  
  export class CompleteCycleCountStockLabelResult {
    OverallResult : EVA.UserTasks.CycleCountAttemptResult; 
    StockLabel : number; // Int32
    ExpectedQuantity : number; // Int32, nullable
    CountedQuantity : number; // Int32
    Lines : EVA.UserTasks.CompleteCycleCountStockLabelResultLine[]; 
  }
  
  export enum CycleCountAttemptResult {
    None = 0,
    CountAgain = 1,
    Finished = 2,
    FinishedWithDeviation = 3,
    FinishedWithInvalidResources = 4,
    CompleteResource = 5,
  }
  
  export class CompleteCycleCountStockLabelResultLine {
    StockLabel : number; // Int32
    Result : EVA.UserTasks.CycleCountAttemptResult; 
    ExpectedQuantity : number; // Int32
    CountedQuantity : number; // Int32
    ResourceID : number; // Int32, nullable
  }
  
  export class CycleCountWorkSet {
    UserTaskID : number; // Int32
    ProductID : number; // Int32
    Product : EVA.Core.ProductDto; 
    OrganizationUnitID : number; // Int32
    OrganizationUnit : EVA.Core.OrganizationUnitDto; 
    RequiredResourceTypes : EVA.Core.Services.StockResourceTypeDto[]; 
    StockLabels : EVA.UserTasks.StockLabelToCycleCount[]; 
  }
  
  export class StockLabelToCycleCount {
    StockLabel : number; // Int32
    Lines : EVA.UserTasks.CycleCountWorkSetLine[]; 
  }
  
  export class CycleCountWorkSetLine {
    CountedQuantity : number; // Int32
    Resource : EVA.UserTasks.ResourceToCycleCount; 
    NewResources : { [ key : string ] : string }; 
  }
  
  export class ResourceToCycleCount {
    ResourceID : number; // Int32
    Resources : { [ key : string ] : string }; 
  }
  
  export class CreateManualCycleCount extends EVA.Core.RequestMessageGeneric<EVA.Core.EmptyResponseMessage> {
    ProductID : number; // Int32
    __response : EVA.Core.EmptyResponseMessage;
  }
  
  export class GetCycleCountDetail extends EVA.Core.GetRequestGeneric<EVA.UserTasks.GetCycleCountDetailResponse> {
    __response : EVA.UserTasks.GetCycleCountDetailResponse;
  }
  
  export class GetCycleCountDetailResponse extends EVA.Core.ResponseMessage {
    Result : EVA.UserTasks.GetCycleCountDetailResponseCycleCountDto; 
  }
  
  export class GetCycleCountDetailResponseCycleCountDto {
    ID : number; // Int32
    StockLabel : number; // Int32
    ProductID : number; // Int32, nullable
    Product : EVA.Core.ProductDto; 
    UserTaskID : number; // Int32
    UserTask : EVA.Core.UserTaskDto; 
    IsCompleted : boolean; 
    UserID : number; // Int32, nullable
    ResourceID : number; // Int32, nullable
    Results : EVA.UserTasks.CycleCountResultDto[]; 
    Result : EVA.UserTasks.CycleCountResults; 
    IsActive : boolean; 
    CreationTime : string; // DateTime
  }
  
  export class CycleCountResultDto {
    CycleCountID : number; // Int32
    ExpectedQuantity : number; // Int32
    CountedQuantity : number; // Int32
    ResourceID : number; // Int32, nullable
    StockLabelID : number; // Int32
    StockLabel : number; // Int32
    ID : number; // Int32
    CreatedByID : number; // Int32, nullable
    CreatedBy : EVA.Core.UserDto; 
    CreationTime : string; // DateTime
    StockLabelDescription : string; 
  }
  
  export enum CycleCountResults {
    New = 0,
    InProgress = 1,
    Deviated = 2,
    Correct = 3,
    Unknown = 4,
  }
  
  export class ListCycleCounts extends EVA.Core.RequestMessageGeneric<EVA.UserTasks.ListCycleCountsResponse> {
    ProductID : number; // Int32, nullable
    StockLabel : number; // Int32, nullable
    ResourceID : number; // Int32, nullable
    OrganizationUnitID : number; // Int32, nullable
    BackendID : string; 
    CreatedBy : string; 
    FromDate : string; // DateTime, nullable
    ToDate : string; // DateTime, nullable
    Result : EVA.UserTasks.CycleCountResults; 
    IsCompleted : boolean; 
    PageConfig : EVA.Core.PageConfig; 
    CustomID : string; 
    __response : EVA.UserTasks.ListCycleCountsResponse;
  }
  
  export class ListCycleCountsResponse extends EVA.Core.ResponseMessage {
    CycleCounts : EVA.Core.PagedResultGeneric<EVA.UserTasks.ListCycleCountsResponseCycleCountDto>; 
  }
  
  export class ListCycleCountsResponseCycleCountDto {
    ID : number; // Int32
    StockLabel : number; // Int32
    ProductID : number; // Int32, nullable
    Product : EVA.Core.ProductDto; 
    UserTaskID : number; // Int32
    UserTask : EVA.Core.UserTaskDto; 
    IsCompleted : boolean; 
    UserID : number; // Int32, nullable
    ResourceID : number; // Int32, nullable
    Results : EVA.UserTasks.CycleCountResultDto[]; 
    Result : EVA.UserTasks.CycleCountResults; 
    IsActive : boolean; 
    CreationTime : string; // DateTime
  }
  
  export class ListUsersWithCycleCountResults extends EVA.Core.RequestMessageGeneric<EVA.UserTasks.ListUsersWithCycleCountResultsResponse> {
    __response : EVA.UserTasks.ListUsersWithCycleCountResultsResponse;
  }
  
  export class ListUsersWithCycleCountResultsResponse extends EVA.Core.ResponseMessage {
    Users : EVA.Core.UserDto[]; 
  }
  
  export class StartCycleCount extends EVA.Core.RequestMessageGeneric<EVA.UserTasks.StartCycleCountResponse> {
    TaskID : number; // Int32
    __response : EVA.UserTasks.StartCycleCountResponse;
  }
  
  export class StartCycleCountResponse extends EVA.Core.ResponseMessage {
    WorkSet : EVA.UserTasks.CycleCountWorkSet; 
  }
  
}