/* tslint:disable */
declare module EVA.Workforce {
  
  export class ListAvailabilityForTimeslot extends EVA.Core.RequestMessageGeneric<EVA.Workforce.ListAvailabilityForTimeslotResponse> {
    OrganizationUnitID : number; // Int32
    StartDateTime : string; // DateTime
    EndDateTime : string; // DateTime
    __response : EVA.Workforce.ListAvailabilityForTimeslotResponse;
  }
  
  export class ListAvailabilityForTimeslotResponse extends EVA.Core.ResponseMessage {
    Availability : EVA.Workforce.ConsecutiveTimeChunkWithUser[]; 
  }
  
  export class ConsecutiveTimeChunkWithUser {
    UserID : number; // Int32
    FullName : string; 
    Date : string; // DateTime
    StartTime : any; // TimeSpan
    EndTime : any; // TimeSpan
    IsAvailable : boolean; 
    BadgeIDs : number[]; 
    Duration : any; // TimeSpan
    StartDateTime : string; // DateTime
    EndDateTime : string; // DateTime
  }
  
  export class ListPlanning extends EVA.Core.RequestMessageGeneric<EVA.Workforce.ListPlanningResponse> {
    OrganizationUnitID : number; // Int32, nullable
    StartDate : string; // DateTime
    EndDate : string; // DateTime
    __response : EVA.Workforce.ListPlanningResponse;
  }
  
  export class ListPlanningResponse extends EVA.Core.ResponseMessage {
    Items : EVA.Workforce.ListPlanningResponsePlanning[]; 
  }
  
  export class ListPlanningResponsePlanning {
    OrganizationUnit : EVA.Core.OrganizationUnitDto; 
    DateTime : string; // DateTime
    Result : number; // Int32
  }
  
  export class ClockEmployeeOutAsAbsent extends EVA.Core.RequestMessageGeneric<EVA.Core.EmptyResponseMessage> {
    UserID : number; // Int32
    FinancialPeriodID : number; // Int32, nullable
    AbsentFrom : string; // DateTime
    __response : EVA.Core.EmptyResponseMessage;
  }
  
  export class CorrectWorkedHours extends EVA.Core.RequestMessageWithEmptyResponse {
    ID : number; // Int32
    ClockInDateTime : string; // DateTime, nullable
    ClockOutDateTime : string; // DateTime, nullable
    __response : EVA.Core.EmptyResponseMessage;
  }
  
  export class CreateWorkedHours extends EVA.Core.RequestMessageWithEmptyResponse {
    UserID : number; // Int32
    Date : string; // DateTime
    ClockInTime : any; // TimeSpan
    ClockOutTime : any; // TimeSpan
    OrganizationUnitID : number; // Int32
    __response : EVA.Core.EmptyResponseMessage;
  }
  
  export class ListClockedInEmployeesForFinancialPeriod extends EVA.Core.RequestMessageGeneric<EVA.Workforce.ListClockedInEmployeesForFinancialPeriodResponse> {
    PeriodID : number; // Int32
    __response : EVA.Workforce.ListClockedInEmployeesForFinancialPeriodResponse;
  }
  
  export class ListClockedInEmployeesForFinancialPeriodResponse extends EVA.Core.ResponseMessage {
    Employees : EVA.Workforce.ListClockedInEmployeesForFinancialPeriodResponseClockedInUser[]; 
  }
  
  export class ListClockedInEmployeesForFinancialPeriodResponseClockedInUser {
    User : EVA.Core.UserDto; 
    ClockedIn : string; // DateTime
    ClockedOut : string; // DateTime, nullable
    IsAbsent : boolean; 
  }
  
  export class ListUnrosteredWorkedHours extends EVA.Core.RequestMessageGeneric<EVA.Workforce.ListUnrosteredWorkedHoursResponse> {
    UserID : number; // Int32
    StartDate : string; // DateTime
    EndDate : string; // DateTime
    OrganizationUnitID : number; // Int32, nullable
    __response : EVA.Workforce.ListUnrosteredWorkedHoursResponse;
  }
  
  export class ListUnrosteredWorkedHoursResponse extends EVA.Core.ResponseMessage {
    WorkedHours : EVA.Workforce.WorkedPeriod[]; 
  }
  
  export class WorkedPeriod {
    StartDate : string; // DateTime
    EndDate : string; // DateTime, nullable
  }
  
  export class ListWorkedHoursForCurrentEmployee extends EVA.Core.RequestMessageGeneric<EVA.Workforce.ListWorkedHoursForCurrentEmployeeResponse> {
    __response : EVA.Workforce.ListWorkedHoursForCurrentEmployeeResponse;
  }
  
  export class ListWorkedHoursForCurrentEmployeeResponse extends EVA.Core.ResponseMessage {
    WorkedHours : EVA.Workforce.WorkedHoursDto[]; 
  }
  
  export class WorkedHoursDto {
    ID : number; // Int32
    UserID : number; // Int32
    User : EVA.Core.UserDto; 
    OrganizationUnitID : number; // Int32
    OrganizationUnit : EVA.Core.OrganizationUnitDto; 
    Date : string; // DateTime
    ClockInTime : any; // TimeSpan
    ClockOutTime : any; // TimeSpan, nullable
    ClockInDateTime : string; // DateTime
    ClockOutDateTime : string; // DateTime, nullable
    IsExported : boolean; 
  }
  
  export class ListWorkedHours extends EVA.Core.RequestMessageGeneric<EVA.Workforce.ListWorkedHoursResponse> {
    UserIDs : number[]; 
    StartDate : string; // DateTime
    EndDate : string; // DateTime
    OrganizationUnitID : number; // Int32, nullable
    __response : EVA.Workforce.ListWorkedHoursResponse;
  }
  
  export class ListWorkedHoursResponse extends EVA.Core.ResponseMessage {
    WorkedPeriods : { [ key : number ] : EVA.Workforce.ListWorkedHoursResponseWorkedPeriod[] }; 
  }
  
  export class ListWorkedHoursResponseWorkedPeriod {
    StartDate : string; // DateTime
    StartID : number; // Int32
    EndDate : string; // DateTime, nullable
    ClockedOut : boolean; 
  }
  
  export class DeleteRosterItem extends EVA.Core.RequestMessageGeneric<EVA.Core.EmptyResponseMessage> {
    ID : number; // Int32
    ExpireDate : string; // DateTime, nullable
    __response : EVA.Core.EmptyResponseMessage;
  }
  
  export class ListOccupiedPeriods extends EVA.Core.RequestMessageGeneric<EVA.Workforce.ListOccupiedPeriodsResponse> {
    UserID : number; // Int32
    StartDate : string; // DateTime
    EndDate : string; // DateTime
    __response : EVA.Workforce.ListOccupiedPeriodsResponse;
  }
  
  export class ListOccupiedPeriodsResponse extends EVA.Core.ResponseMessage {
    Absence : EVA.Workforce.ListOccupiedPeriodsResponseOccupiedPeriod[]; 
    Leave : EVA.Workforce.ListOccupiedPeriodsResponseOccupiedPeriod[]; 
  }
  
  export class ListOccupiedPeriodsResponseOccupiedPeriod {
    StartDate : string; // DateTime
    EndDate : string; // DateTime, nullable
    TypeDescription : string; 
    Reason : string; 
  }
  
  export class ListRosterableUsersForOrganizationUnit extends EVA.Core.RequestMessageGeneric<EVA.Workforce.ListRosterableUsersForOrganizationUnitResponse> {
    OrganizationUnitID : number; // Int32
    From : string; // DateTime
    To : string; // DateTime
    __response : EVA.Workforce.ListRosterableUsersForOrganizationUnitResponse;
  }
  
  export class ListRosterableUsersForOrganizationUnitResponse extends EVA.Core.ResponseMessage {
    Users : EVA.Core.UserDto[]; 
  }
  
  export class ListRoster extends EVA.Core.RequestMessageGeneric<EVA.Workforce.ListRosterResponse> {
    Types : number[]; 
    UserID : number; // Int32, nullable
    BadgeID : number; // Int32, nullable
    OrganizationUnitID : number; // Int32, nullable
    StartDate : string; // DateTime
    EndDate : string; // DateTime
    __response : EVA.Workforce.ListRosterResponse;
  }
  
  export class ListRosterResponse extends EVA.Core.ResponseMessage {
    Items : EVA.Workforce.ListRosterResponseRosterItem[]; 
  }
  
  export class ListRosterResponseRosterItem {
    TypeID : number; // Int32
    OrganizationUnitID : number; // Int32, nullable
    OrganizationUnitName : string; 
    UserID : number; // Int32, nullable
    BadgeID : number; // Int32, nullable
    FullName : string; 
    Date : string; // DateTime
    StartTime : any; // TimeSpan, nullable
    EndTime : any; // TimeSpan, nullable
    DayOfWeekID : number; // Int32, nullable
    ID : number; // Int32
    StartDateTime : string; // DateTime, nullable
    EndDateTime : string; // DateTime, nullable
    Description : string; 
    AllDay : boolean; 
  }
  
  export class SaveRosterItem extends EVA.Core.RequestMessageGeneric<EVA.Core.EmptyResponseMessage> {
    ID : number; // Int32
    TypeID : number; // Int32
    OrganizationUnitID : number; // Int32, nullable
    UserID : number; // Int32, nullable
    BadgeID : number; // Int32, nullable
    Date : string; // DateTime, nullable
    DayOfWeekID : number; // Int32, nullable
    AllDay : boolean; 
    AvailabilityID : number; // Int32, nullable
    SlotID : number; // Int32, nullable
    StartDateTime : string; // DateTime, nullable
    EndDateTime : string; // DateTime, nullable
    Description : string; 
    __response : EVA.Core.EmptyResponseMessage;
  }
  
  export class ExportPayrollPeriod extends EVA.Core.RequestMessageWithEmptyResponse {
    PayrollPeriodID : number; // Int32
    __response : EVA.Core.EmptyResponseMessage;
  }
  
  export class GetPayrollPeriodReport extends EVA.Core.RequestMessageGeneric<EVA.Core.ResourceResponseMessage> {
    PayrollPeriodID : number; // Int32
    __response : EVA.Core.ResourceResponseMessage;
  }
  
  export class GetPayrollPeriodWorkedHoursReport extends EVA.Core.RequestMessageGeneric<EVA.Core.ResourceResponseMessage> {
    PayrollPeriodID : number; // Int32
    __response : EVA.Core.ResourceResponseMessage;
  }
  
  export class ListPayrollPeriods extends EVA.Core.PagedResultRequest<EVA.Workforce.ListPayrollPeriodsResponse> {
    __response : EVA.Workforce.ListPayrollPeriodsResponse;
  }
  
  export class ListPayrollPeriodsResponse extends EVA.Core.PagedResultResponse<EVA.Workforce.ListPayrollPeriodsResponsePayrollPeriodDto> {
  }
  
  export class ListPayrollPeriodsResponsePayrollPeriodDto {
    ID : number; // Int32
    PreviousPeriodID : number; // Int32, nullable
    StartDate : string; // DateTime
    EndDate : string; // DateTime
    Weeks : number; // Int32
    IsExported : boolean; 
  }
  
  export class ListSalaryComponents extends EVA.Core.PagedResultRequest<EVA.Workforce.ListSalaryComponentsResponse> {
    __response : EVA.Workforce.ListSalaryComponentsResponse;
  }
  
  export class ListSalaryComponentsResponse extends EVA.Core.PagedResultResponse<EVA.Workforce.ListSalaryComponentsResponseSalaryComponentDto> {
  }
  
  export class ListSalaryComponentsResponseSalaryComponentDto {
    PayrollPeriodID : number; // Int32
    UserID : number; // Int32
    User : EVA.Core.UserDto; 
    TypeID : number; // Int32
    Param1 : number; // Decimal, nullable
    Param2 : number; // Decimal, nullable
    Param3 : number; // Decimal, nullable
    Reason : string; 
    IsExported : boolean; 
  }
  
  export class ListSalaryComponentTypes extends EVA.Core.RequestMessageGeneric<EVA.Workforce.ListSalaryComponentTypesResponse> {
    __response : EVA.Workforce.ListSalaryComponentTypesResponse;
  }
  
  export class ListSalaryComponentTypesResponse extends EVA.Core.ResponseMessage {
    Result : EVA.Workforce.ListSalaryComponentTypesResponseSalaryComponentTypeDto[]; 
  }
  
  export class ListSalaryComponentTypesResponseSalaryComponentTypeDto {
    ID : number; // Int32
    Name : string; 
    Description : string; 
    Code : string; 
    ExportNextPeriod : boolean; 
  }
  
  export class RecalculatePayrollPeriod extends EVA.Core.RequestMessageWithEmptyResponse {
    PayrollPeriodID : number; // Int32
    __response : EVA.Core.EmptyResponseMessage;
  }
  
  export class ListLeaveBalancesForUser extends EVA.Core.RequestMessageGeneric<EVA.Workforce.ListLeaveBalancesForUserResponse> {
    UserID : number; // Int32
    __response : EVA.Workforce.ListLeaveBalancesForUserResponse;
  }
  
  export class ListLeaveBalancesForUserResponse extends EVA.Core.ResponseMessage {
    Items : EVA.Workforce.ListLeaveBalancesForUserResponseLeaveBalanceDto[]; 
  }
  
  export class ListLeaveBalancesForUserResponseLeaveBalanceDto {
    LeaveType : string; 
    Balance : number; // Decimal
  }
  
  export enum FailedClockOutReasons {
    None = 0,
    AfterFinancialPeriod = 1,
    OutsideSubnet = 2,
  }
  
  export enum RosterTypes {
    UserAvailable = 1,
    UserUnavailable = 2,
    TimeSlot = 3,
    Planned = 4,
    AbsenceRequested = 5,
  }
  
  export enum UserTimeLedgerTypes {
    ActualUserTaskTime = 1,
    ExpectedUserTaskTime = 2,
    TimeSpentOnInterruptedUserTask = 3,
    ExpectedSalesTime = 4,
    ActualWorkedHours = 5,
  }
  
  export enum LeaveStatus {
    Requested = 0,
    Approved = 1,
  }
  
  export enum WorkedHoursLedgerType {
    ClockIn = 1,
    ClockOut = 2,
    ClockInCorrection = 3,
    ClockOutCorrection = 4,
    ClockedOutInPeriodClosing = 5,
    DaySplit = 6,
  }
  
}